//******************************************************************************
// MIDIV[PT[\tgwEx
// FIR{{bNXNX
// (C)2002-2012 [ՂMIDIՂ낶Ɓ^
//******************************************************************************

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "winver.h"
#include <afxwin.h>
#include <afxdlgs.h>
#include "ColorSelectComboBox.h"

// bZ[W}bv
IMPLEMENT_DYNCREATE (CColorSelectComboBox, CComboBox)

// bZ[W}bv
BEGIN_MESSAGE_MAP (CColorSelectComboBox, CComboBox)
	ON_CONTROL_REFLECT (CBN_SELCHANGE, OnSelChange)
END_MESSAGE_MAP ()

//------------------------------------------------------------------------------
// \zƔj
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// I[o[Ch
//------------------------------------------------------------------------------

// EBhEX^C̕ύX
BOOL CColorSelectComboBox::PreCreateWindow (CREATESTRUCT& cs) {
	if (!CComboBox::PreCreateWindow (cs)) {
		return FALSE;
	}
	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~(CBS_DROPDOWN | CBS_SIMPLE | CBS_OWNERDRAWVARIABLE | CBS_SORT);
	cs.style |= (CBS_DROPDOWNLIST | CBS_OWNERDRAWFIXED | CBS_HASSTRINGS);
	return TRUE;
}

// ڂ̍
void CColorSelectComboBox::MeasureItem (LPMEASUREITEMSTRUCT lpmis) {
	lpmis->itemHeight = 14;
}

// ڂ̕`
void CColorSelectComboBox::DrawItem (LPDRAWITEMSTRUCT lpdis) {
	CDC dc;
	dc.Attach (lpdis->hDC);
	CRect rect = lpdis->rcItem;
	int nIndex = lpdis->itemID;

	CBrush* pBrush = new CBrush;
	pBrush->CreateSolidBrush (::GetSysColor ((lpdis->itemState &
		ODS_SELECTED) ? COLOR_HIGHLIGHT : COLOR_WINDOW));
	dc.FillRect (rect, pBrush);
	delete pBrush;

	if (lpdis->itemState & ODS_FOCUS) {
		dc.DrawFocusRect (rect);
	}

	if (nIndex != (UINT)-1) {
		COLORREF clrSample = (COLORREF)GetItemData (nIndex);
		if (clrSample == COLORSELECTCOMBOBOX_OTHER) {
			CFont* pFont = CFont::FromHandle 
				((HFONT)(::GetStockObject (DEFAULT_GUI_FONT)));
			CFont* pOldFont = dc.SelectObject (pFont);
			dc.SetBkMode (TRANSPARENT);
			dc.DrawText (_T("Others..."), rect, DT_LEFT | DT_VCENTER | DT_SINGLELINE);
			dc.SelectObject (pOldFont);
		}
		else {
			CRect rcSample (rect);
			rcSample.DeflateRect (3, 3);
			dc.FillSolidRect (rcSample, clrSample);
		}
	}
	else {
		CRect rcSample (rect);
		rcSample.DeflateRect (3, 3);
		dc.FillSolidRect (rcSample, m_clrCurColor);		
	}
	dc.Detach ();
}

//------------------------------------------------------------------------------
// Iy[V
//------------------------------------------------------------------------------

// ݂̐Fݒ肷(̊֐͂łgB)
BOOL CColorSelectComboBox::SetCurColor (COLORREF clr) {
	if (clr < 0x00000000 || clr > 0x00FFFFFF) {
		return FALSE;
	}
	m_clrCurColor = clr;
	if (m_hWnd != NULL) {
		int nCount = GetCount ();
		int i = 0;
		// vJ[TvIԂɂ
		for (i = 0; i <= nCount; i++) {
			COLORREF clrSampleColor = GetItemData (i);
			if (clrSampleColor == m_clrCurColor) {
				SetCurSel (i);
				break;
			}
		}
		// vJ[TvȂ̂őI
		if (i >= nCount) {
			SetCurSel (-1);
		}
		Invalidate ();
	}
	return TRUE;
}

// ׂẴJ[TvNAB
void CColorSelectComboBox::ClearSampleColor () {
	ResetContent ();
}

// J[TvǉB
int CColorSelectComboBox::AddSampleColor (COLORREF clr) {
	int nIndex = AddString (_T(""));
	if (nIndex == CB_ERR || nIndex == CB_ERRSPACE) {
		return nIndex;
	}
	return SetSampleColor (nIndex , (DWORD)clr);
}

// J[Tv擾B
COLORREF CColorSelectComboBox::GetSampleColor (int nIndex) const {
	return (COLORREF)GetItemData (nIndex);
}

// J[Tvݒ肷B
int CColorSelectComboBox::SetSampleColor (int nIndex, COLORREF clr) {
	int nRet = SetItemData (nIndex, (DWORD)clr);
	int nCurSel = GetCurSel ();
	// VJ[TvƃJgJ[̈v`FbN
	if (nCurSel == CB_ERR || nCurSel == nIndex) { 
		COLORREF clrSampleColor = GetItemData (nIndex);
		// VJ[TvƃJgJ[͈v̂őI
		if (clrSampleColor == m_clrCurColor) {
			SetCurSel (nIndex);
		}
		// VJ[TvƃJgJ[͈vȂ̂őI
		else {
			SetCurSel (-1);
		}
	}
	return nRet;
}

//------------------------------------------------------------------------------
// bZ[W}bv
//------------------------------------------------------------------------------

// JgZύXꂽƂ(bZ[WtNV)
void CColorSelectComboBox::OnSelChange () {
	int nCurSel = GetCurSel ();
	if (0 <= nCurSel && nCurSel < GetCount ()) {
		COLORREF clrCurColor = (COLORREF)GetItemData (nCurSel);
		if (clrCurColor == COLORSELECTCOMBOBOX_OTHER) {
			CColorDialog theDlg;
			theDlg.m_cc.Flags |= (CC_FULLOPEN | CC_RGBINIT);
			theDlg.m_cc.rgbResult = m_clrCurColor;
			if (theDlg.DoModal () == IDOK) {
				m_clrCurColor = theDlg.GetColor ();
			}
			SetCurSel (-1);
		}
		else {
			m_clrCurColor = clrCurColor;
		}
		Invalidate ();
	}
}
