//******************************************************************************
// MIDIV[PT[\tgwEx
// Ec[o[NX
// (C)2002-2013 [ՂMIDIՂ낶Ɓ^
//******************************************************************************

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "winver.h"
#include <afxwin.h>
#include <afxext.h>
#include <afxcmn.h>
#include <afxmt.h>
#include <afxThemeHelper.h>
#include <uxtheme.h>
#include "..\\..\\MIDIIO\\MIDIIO.h"
#include "..\\..\\MIDIData\\MIDIData.h"
#include "..\\..\\MIDIClock\\MIDIClock.h"
#include "..\\..\\MIDIStatus\\MIDIStatus.h"
#include "..\\..\\MIDIInstrument\\MIDIInstrument.h"
#include "Resource.h"
#include "HistoryRecord.h"
#include "HistoryUnit.h"
#include "SekaijuApp.h"
#include "SekaijuToolBar.h"
#include "SekaijuStatusBar.h"
#include "MainFrame.h"
#include "SekaijuDoc.h"


#define RP_BACKGROUND 6

// fobOp
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC (CSekaijuToolBar, CToolBar)

// bZ[W}bv
BEGIN_MESSAGE_MAP (CSekaijuToolBar, CToolBar)
	ON_WM_NCPAINT()
	ON_WM_HSCROLL ()
	ON_WM_DRAWITEM ()
	ON_WM_ERASEBKGND ()
	ON_NOTIFY_REFLECT (NM_CUSTOMDRAW, OnCustomDraw)
END_MESSAGE_MAP ()

//------------------------------------------------------------------------------
// \zƔj
//------------------------------------------------------------------------------

// RXgN^
CSekaijuToolBar::CSekaijuToolBar () {
}

// fXgN^
CSekaijuToolBar::~CSekaijuToolBar () {
}

//------------------------------------------------------------------------------
// Iy[V
//------------------------------------------------------------------------------

// http://support.microsoft.com/kb/843490/ja̖ɑΉ
void CSekaijuToolBar::EraseNonClient () {
	CWindowDC dc (this);
	CRect rectClient;
	GetClientRect (rectClient);
	CRect rectWindow;
	GetWindowRect (rectWindow);
	ScreenToClient (rectWindow);
	rectClient.OffsetRect (-rectWindow.left, -rectWindow.top);
	dc.ExcludeClipRect (rectClient);

	// ̈ʒüʒuWM_ERASEBKGND𑗐MقObp[`悳B
	SendMessage (WM_ERASEBKGND, (WPARAM)dc.m_hDC);

	// m_hReBarThemêȂꍇ(NVbN[hȂ)̔wiFݒ肵ĂB
	dc.SetBkColor (::GetSysColor (COLOR_3DFACE));

	// draw borders in non-client area
	rectWindow.OffsetRect (-rectWindow.left, -rectWindow.top);
	DrawBorders (&dc, rectWindow);

	// erase parts not drawn
	dc.IntersectClipRect (rectWindow);
	//SendMessage (WM_ERASEBKGND, (WPARAM)dc.m_hDC);

	// draw gripper in non-client area
	// DrawGripper (&dc, rectWindow);
	DrawNCGripper (&dc, rectWindow);
}

//------------------------------------------------------------------------------
// I[o[Ch
//------------------------------------------------------------------------------

// http://support.microsoft.com/kb/843490/ja̖ɑΉ
void CSekaijuToolBar::DoPaint (CDC* pDC) {
	ASSERT_VALID (this);
	ASSERT_VALID (pDC);
	// Paint inside the client area.
	CRect rect;
	GetClientRect (rect);
	DrawBorders (pDC, rect);
	DrawGripper (pDC, rect);
}

// http://support.microsoft.com/kb/843490/ja̖ɑΉ
void CSekaijuToolBar::DrawGripper (CDC* pDC, const CRect& rect) {
	pDC->FillSolidRect (&rect, ::GetSysColor (COLOR_BTNFACE)); //VC++4.0p
	CToolBar::DrawGripper (pDC,rect); //VC++4.0std(MFC4.0)ł͖Ή
}

// ÊȂc[o[ŃNCAgGAO̔wi`悳Ȃ̂ŃI[o[Ch
void CSekaijuToolBar::DrawBorders (CDC* pDC, CRect& rect) {
	DWORD dwStyle = m_dwStyle;
	if (IsKindOf(RUNTIME_CLASS(CToolBar)) && (dwStyle & TBSTYLE_FLAT) && (dwStyle & CBRS_BORDER_ANY)) {
		CToolBar::DrawBorders (pDC, rect);
		return;
	}
	// ȉACBRS_BORDER_ANYłȂꍇłc[o[̊OɃXy[XmۂĂꍇ̂
	// wi͕`悳Ȃ΂ȂȂB
	CRect rectWindow = rect;
	HRESULT hr = E_FAIL;
	if (m_hReBarTheme) {
		if (CThemeHelper::IsThemeBackgroundPartiallyTransparent
			(m_hReBarTheme, RP_BACKGROUND, 0)) {
			CThemeHelper::DrawThemeParentBackground (m_hWnd, pDC->m_hDC, &rectWindow);
		}
		hr = CThemeHelper::DrawThemeBackground
			(m_hReBarTheme, pDC->m_hDC, RP_BACKGROUND, 0, &rectWindow, NULL);
	}
	if (FAILED(hr)) {
		pDC->FillSolidRect ((LPRECT)rectWindow, pDC->GetBkColor());
	}
	return;
}


//------------------------------------------------------------------------------
// bZ[W}bv
//------------------------------------------------------------------------------

// http://support.microsoft.com/kb/843490/ja̖ɑΉ
void CSekaijuToolBar::OnNcPaint() {
	//Invalidate (TRUE); // VC++4.0std(MFC4.0)Ńc[o[ĕ`悳Ȃ̂h~
	EraseNonClient();
}

// ʒuXN[o[𓮂Ƃ̋(tʒuړ)
void CSekaijuToolBar::OnHScroll (UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CMainFrame* pMainFrame = (CMainFrame*)AfxGetMainWnd ();
	if (pMainFrame == NULL) {
		return;
	}
	CSekaijuDoc* pSekaijuDoc = (CSekaijuDoc*)(pMainFrame->GetActiveFrame ()->GetActiveDocument());
	if (pSekaijuDoc == NULL) {
		return;
	}
	if (pScrollBar == &(pMainFrame->m_wndPositionScroll)) {
		SCROLLINFO si;
		pScrollBar->GetScrollInfo (&si, SIF_ALL);
		switch (nSBCode) {
		case SB_LINELEFT:
			pMainFrame->SendMessage (WM_COMMAND, ID_CONTROL_PREVBEAT, 0);
			break;
		case SB_LINERIGHT:
			pMainFrame->SendMessage (WM_COMMAND, ID_CONTROL_NEXTBEAT, 0);
			break;
		case SB_PAGELEFT:
			pMainFrame->SendMessage (WM_COMMAND, ID_CONTROL_PREVMEASURE, 0);
			break;
		case SB_PAGERIGHT:
			pMainFrame->SendMessage (WM_COMMAND, ID_CONTROL_NEXTMEASURE, 0);
			break;
		case SB_LEFT:
			pMainFrame->SendMessage (WM_COMMAND, ID_CONTROL_TOBEGIN, 0);
			break;
		case SB_RIGHT:
			pMainFrame->SendMessage (WM_COMMAND, ID_CONTROL_TOEND, 0);
			break;
		case SB_THUMBTRACK:
			if (!pSekaijuApp->m_bRecording) {
				pSekaijuDoc->m_theCriticalSection.Lock ();
				pSekaijuApp->SendAllNoteOff ();
				pSekaijuApp->SendAllHold1Off ();
				pSekaijuApp->SendAllSostenutoOff ();
				pSekaijuApp->SendAllHold2Off ();
				pSekaijuApp->SendAllSoundOff ();
				pSekaijuApp->SetPlayPosition (pSekaijuDoc, si.nTrackPos);
				pSekaijuDoc->UpdateAllViews (NULL, SEKAIJUDOC_POSITIONCHANGED);
				pSekaijuDoc->m_theCriticalSection.Unlock ();
			}
			break;
		}

	}
}

// c[o[̃NCAgGA̔wi`v
// ftHgMFCԂłTBCS_TRANSPARENT̔wi`悳ȂB
// ̓Iɂ́Ac[o[̃NCAgGA̔wiCDockBar̉摜A
// NCAgGAOƃObp[wiCReBar̉摜ƂȂB
// ł̓NCAgGA̔wiCRebar̉摜ɍ킹B
BOOL CSekaijuToolBar::OnEraseBkgnd (CDC* pDC) {
	CWindowDC dc (this);
	CRect rectWindow;
	GetWindowRect(rectWindow);
	ScreenToClient(rectWindow);
	HRESULT hr = E_FAIL;
	// m_hReBarThemêȂꍇ(NVbN[hȂ)̔wiFݒ肵ĂB
	pDC->SetBkColor (::GetSysColor (COLOR_3DFACE));
	if (m_hReBarTheme) {
		if (CThemeHelper::IsThemeBackgroundPartiallyTransparent
			(m_hReBarTheme, RP_BACKGROUND, 0)) {
			CThemeHelper::DrawThemeParentBackground (m_hWnd, pDC->m_hDC, &rectWindow);
		}
		hr = CThemeHelper::DrawThemeBackground
			(m_hReBarTheme, pDC->m_hDC, RP_BACKGROUND, 0,&rectWindow, NULL);
	}
	if (FAILED(hr)) {
		pDC->FillSolidRect ((LPRECT)rectWindow, pDC->GetBkColor());
	}
	return TRUE;
}

// c[o[̃JX^h[(KvɉăCvgĂ)
void CSekaijuToolBar::OnCustomDraw (NMHDR* pNMHDR, LRESULT* pResult) {
	LPNMCUSTOMDRAW lpNMCustomDraw = (LPNMCUSTOMDRAW) pNMHDR;
	switch (lpNMCustomDraw->dwDrawStage) {
	case CDDS_PREERASE:
		break;
	case CDDS_POSTERASE:
		break;
	case CDDS_PREPAINT:
		break;
	case CDDS_POSTPAINT:
		break;
	case CDDS_ITEMPREPAINT:
		break;
	default:
		break;
	}
	*pResult = 0;
	*pResult |= CDRF_NOTIFYITEMDRAW;
	*pResult |= CDRF_NOTIFYSUBITEMDRAW;
	*pResult |= CDRF_NOTIFYPOSTPAINT;
	*pResult |= CDRF_NOTIFYPOSTERASE;
}
