//******************************************************************************
// MIDIV[PT[\tgwEx
// gbNXggbN[hr[NX
// (C)2002-2013 [ՂMIDIՂ낶Ɓ^
//******************************************************************************

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "winver.h"
#include <afxwin.h>
#include <afxext.h>
#include <afxmt.h>
#include "common.h"
#include "..\\..\\MIDIIO\\MIDIIO.h"
#include "..\\..\\MIDIData\\MIDIData.h"
#include "..\\..\\MIDIClock\\MIDIClock.h"
#include "..\\..\\MIDIStatus\\MIDIStatus.h"
#include "..\\..\\MIDIInstrument\\MIDIInstrument.h"
#include "mousewheel.h"
#include "HistoryRecord.h"
#include "HistoryUnit.h"
#include "SekaijuApp.h"
#include "SekaijuDoc.h"
#include "SekaijuView.h"
#include "SekaijuToolbar.h"
#include "SekaijuStatusBar.h"
#include "ChildFrame.h"
#include "TrackListFrame.h"
#include "TrackListTrackModeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define IDC_TEXTBOX 3939

IMPLEMENT_DYNCREATE (CTrackListTrackModeView, CSekaijuView)

// bZ[W}bv
BEGIN_MESSAGE_MAP (CTrackListTrackModeView, CSekaijuView)
	ON_WM_CREATE ()
	ON_WM_KILLFOCUS ()
	ON_WM_KEYDOWN ()
	ON_WM_KEYUP ()
	ON_WM_CHAR ()
	ON_WM_LBUTTONDOWN ()	
	ON_WM_RBUTTONDOWN ()	
	ON_WM_LBUTTONUP ()	
	ON_WM_RBUTTONUP ()	
	ON_WM_MOUSEMOVE ()
	ON_WM_LBUTTONDBLCLK ()
	ON_WM_RBUTTONDBLCLK ()
	ON_WM_TIMER ()
	ON_WM_MOUSEWHEEL40 ()
END_MESSAGE_MAP()

//------------------------------------------------------------------------------
// \zƔj
//------------------------------------------------------------------------------

// RXgN^
CTrackListTrackModeView::CTrackListTrackModeView () {
	m_lCurRow = 0;
	m_lCurColumn = 0;
	m_lCurButtonState = 0x00;
	m_lCurButtonInterval = 200;
	m_bSettingCellString = 0;
}

// fXgN^
CTrackListTrackModeView::~CTrackListTrackModeView () {
}

//------------------------------------------------------------------------------
// Iy[V
//------------------------------------------------------------------------------

// (X,Y)WZԍ擾
BOOL CTrackListTrackModeView::GetCellFromPoint 
(CPoint pt, long* pRow, long* pColumn) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParent ();
	_ASSERT (pRow);
	_ASSERT (pColumn);
	*pRow = pTrackListFrame->YtoRow (pt.y);
	*pColumn = pTrackListFrame->XtoColumn (pt.x);
	return TRUE;
}

// wZr[͂ݏoꍇ̃I[gXN[
BOOL CTrackListTrackModeView::AutoScrolltoShowCell (long lRow, long lColumn) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParent ();
	CRect rcClient;
	GetClientRect (&rcClient);
	rcClient += CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
	long lNewPos = 0;
	long lRowZoom = pTrackListFrame->GetRowZoom ();
	// wZr[̍ɂ͂ݏoꍇ̏
	if (pTrackListFrame->GetColumnLeft (lColumn) < rcClient.left) {
		lNewPos = pTrackListFrame->GetColumnLeft (lColumn);
		pTrackListFrame->SetColumnScrollPos (lNewPos);
	}
	// wZr[̉Eɂ͂ݏoꍇ̏
	else if (pTrackListFrame->GetColumnLeft (lColumn) + 
		pTrackListFrame->GetColumnWidth (lColumn) > rcClient.right) {
		lNewPos = pTrackListFrame->GetColumnLeft (lColumn) + 
			pTrackListFrame->GetColumnWidth (lColumn) - rcClient.Width ();
		pTrackListFrame->SetColumnScrollPos (lNewPos);
	}
	// wZr[̏ɂ͂ݏoꍇ̏
	if (lRow * lRowZoom < rcClient.top) {
		lNewPos = lRow * lRowZoom;
		pTrackListFrame->SetRowScrollPos (lNewPos);		
	}
	// wZr[̉ɂ͂ݏoꍇ̏
	else if ((lRow + 1) * lRowZoom > rcClient.bottom) {
		lNewPos = (lRow + 1) * lRowZoom - rcClient.Height ();
		pTrackListFrame->SetRowScrollPos (lNewPos);
	}
	return TRUE;
}

// ݃eLXg{bNXŕҏWǂԂB
BOOL CTrackListTrackModeView::IsTextEditing () {
	return (m_theTextBox.GetStyle () & WS_VISIBLE) ? TRUE : FALSE;
}

// eLXg{bNXł̕ҏWJnB
BOOL CTrackListTrackModeView::BeginTextEditing () {
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;
	long lFormat = MIDIData_GetFormat (pMIDIData);
	ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
	//ASSERT (lFormat == 0 && m_lCurRow == 0 || lFormat == 1 && m_lCurRow != 0);
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	pSekaijuApp->m_bInplaceEditing = 1;
	CString strCellString = GetCellString (m_lCurRow, m_lCurColumn);
	m_theTextBox.SetWindowText (strCellString);
	m_theTextBox.SetSel (0, -1, TRUE);
	m_theTextBox.EmptyUndoBuffer ();
	m_theTextBox.ShowWindow (SW_SHOW);
	m_theTextBox.SetFocus ();
	m_theTextBox.UpdateWindow ();
	return TRUE;
}

// eLXg{bNXł̕ҏWIAVli[B
BOOL CTrackListTrackModeView::EndTextEditingOK () {
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();

	// V̍쐬EsgbN̒ǉEl̐ݒSetCellStringB

	// ݂̃Z̕ҏWeLXg𔽉f
	CString strText;
	m_theTextBox.GetWindowText (strText);
	if (SetCellString (m_lCurRow, m_lCurColumn, strText)) {
		pSekaijuDoc->SetModifiedFlag (TRUE);
		pSekaijuDoc->UpdateAllViews (NULL, SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIEVENTCHANGED);
	}

	// ҏWI
	m_theTextBox.ShowWindow (SW_HIDE);
	this->SetFocus ();
	pSekaijuApp->m_bInplaceEditing = 0;
	return TRUE;
}

// eLXg{bNXł̕ҏWIAVli[ȂB
BOOL CTrackListTrackModeView::EndTextEditingCancel () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	m_theTextBox.ShowWindow (SW_HIDE);
	this->SetFocus ();
	pSekaijuApp->m_bInplaceEditing = 0;
	return TRUE;
}

// l̑Jn
BOOL CTrackListTrackModeView::BeginValueUpDown () {
	_RPTF0 (_CRT_WARN, "BeginValueUpDown\n");
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParent ();
	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;
	ASSERT (m_lCurButtonState == 0x0000);
	long lColumnContent = pTrackListFrame->GetColumnContent (m_lCurColumn);
	long lNumber = lColumnContent >> 16;
	long lFormat = MIDIData_GetFormat (pMIDIData);
	long lTrackCount = MIDIData_CountTrack (pMIDIData);
	//ASSERT (lFormat == 0 && m_lCurRow == 0 || lFormat == 1 && m_lCurRow != 0);
	MIDITrack* pTempTrack = NULL;
	MIDIEvent* pTempEvent = NULL;
	MIDITrack* pCloneTrack = NULL;
	MIDIEvent* pCloneEvent = NULL;
	CHistoryUnit* pCurHistoryUnit = NULL;
	CString strHistoryName;
	long lChannel = 0;


	// ڕʂ
	switch (lColumnContent & 0xFFFF) {
	// ̓|[gԍA̓`lAo̓|[gԍAo̓`l̏ꍇ
	case TRACKLISTFRAME_INPUTPORT:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_INPUTPORT));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbN擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ̃gbNێ邽߂ɒuB
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pTempTrack));
		VERIFY (pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pTempTrack)); 
		break;
	case TRACKLISTFRAME_INPUTCHANNEL:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_INPUTCHANNEL));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbN擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ̃gbNێ邽߂ɒuB
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pTempTrack));
		VERIFY (pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pTempTrack)); 
		break;
	case TRACKLISTFRAME_OUTPUTPORT:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_OUTPUTPORT));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbN擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ̃gbNێ邽߂ɒuB
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pTempTrack));
		VERIFY (pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pTempTrack)); 
		break;
	case TRACKLISTFRAME_OUTPUTCHANNEL:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_OUTPUTCHANNEL));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbN擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ̃gbNێ邽߂ɒuB
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pTempTrack));
		VERIFY (pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pTempTrack)); 
		break;
	// Rg[`FW̏ꍇ
	case TRACKLISTFRAME_CONTROLCHANGE:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_CONTROLCHANGE));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbN擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ̃gbNōŏCC#lNumberCxgTB
		lChannel = MIDITrack_GetOutputChannel (pTempTrack);
		pTempEvent = MIDITrack_GetFirstKindEvent (pTempTrack, MIDIEVENT_CONTROLCHANGE | lChannel);
		while (pTempEvent) {
			if (MIDIEvent_GetNumber (pTempEvent) == lNumber) {
				break;
			}
			pTempEvent = pTempEvent->m_pNextSameKindEvent;
		}
		// ȂꍇARg[`FWCxgVK쐬ăgbNɒǉB
		if (pTempEvent == NULL) {
			lChannel = CLIP (0, lChannel, 15);
			VERIFY (pTempEvent = MIDIEvent_CreateControlChange (0, lChannel, lNumber, 0));
			VERIFY (MIDITrack_InsertEvent (pTempTrack, pTempEvent));
		}
		// ꍇÂ̂ێAVRg[`FWCxgɒuB
		else {
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pTempEvent));
			VERIFY (pCloneEvent = pSekaijuDoc->ReplaceMIDIEvent (pTempEvent));
		}
		break;
	// vO`FW̏ꍇ
	case TRACKLISTFRAME_PROGRAMCHANGE:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_PROGRAMCHANGE));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbN擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ̃gbNōŏ̃vO`FWCxgTB
		lChannel = MIDITrack_GetOutputChannel (pTempTrack);
		pTempEvent = MIDITrack_GetFirstKindEvent (pTempTrack, MIDIEVENT_PROGRAMCHANGE | lChannel);
		// ȂꍇAvO`FWCxgVK쐬ăgbNɒǉB
		if (pTempEvent == NULL) {
			lChannel = CLIP (0, lChannel, 15);
			VERIFY (pTempEvent = MIDIEvent_CreateProgramChange (0, lChannel, 0));
			VERIFY (MIDITrack_InsertEvent (pTempTrack, pTempEvent));
		}
		// ꍇÂ̂ێAVvO`FWCxgɒuB
		else {
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pTempEvent));
			VERIFY (pCloneEvent = pSekaijuDoc->ReplaceMIDIEvent (pTempEvent));
		}
		break;
	// ^C+AL[+AxVeB+̏ꍇ(20091126ǉ)
	case TRACKLISTFRAME_TIMEPLUS:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_TIMEPLUS));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbN擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ̃gbNێ邽߂ɒuB
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pTempTrack));
		VERIFY (pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pTempTrack)); 
		break;
	case TRACKLISTFRAME_KEYPLUS:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_KEYPLUS));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbN擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ̃gbNێ邽߂ɒuB
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pTempTrack));
		VERIFY (pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pTempTrack)); 
		break;
	case TRACKLISTFRAME_VELOCITYPLUS:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_VELPLUS));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbN擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ̃gbNێ邽߂ɒuB
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pTempTrack));
		VERIFY (pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pTempTrack)); 
		break;
	}
	return TRUE;
}

// l̑I
BOOL CTrackListTrackModeView::EndValueUpDown () {
	_RPTF0 (_CRT_WARN, "EndValueUpDown\n");
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParent ();
	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;
	long lColumnContent = pTrackListFrame->GetColumnContent (m_lCurColumn);
	long lNumber = lColumnContent >> 16;
	MIDITrack* pTempTrack = NULL;
	MIDIEvent* pTempEvent = NULL;
	CHistoryUnit* pCurHistoryUnit = NULL;
	// V̗p
	VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
	VERIFY (pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow));
	long lChannel = MIDITrack_GetOutputChannel (pTempTrack);
	lChannel = CLIP (0, lChannel, 15);
	// ڕʂ
	switch (lColumnContent & 0xFFFF) {
	case TRACKLISTFRAME_INPUTPORT:
	case TRACKLISTFRAME_INPUTCHANNEL:
	case TRACKLISTFRAME_OUTPUTPORT:
	case TRACKLISTFRAME_OUTPUTCHANNEL:
		// L^
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pTempTrack));
		break;
	// Rg[`FW
	case TRACKLISTFRAME_CONTROLCHANGE:
		// ̃gbNōŏCC#lNumberCxgTB
		pTempEvent = MIDITrack_GetFirstKindEvent (pTempTrack, MIDIEVENT_CONTROLCHANGE | lChannel);
		while (pTempEvent) {
			if (MIDIEvent_GetNumber (pTempEvent) == lNumber) {
				break;
			}
			pTempEvent = pTempEvent->m_pNextSameKindEvent;
		}
		// ӁFtH[}bg0̍ŏȊÕgbN̓tH[}bg1̍ŏ̃gbNŐݒ肵Ă͂ȂȂB
		ASSERT (pTempEvent);
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pTempEvent));
		break;
	// vO`FW
	case MIDIEVENT_PROGRAMCHANGE:
		// ̃gbNōŏ̃vO`FWCxgTB
		pTempEvent = MIDITrack_GetFirstKindEvent (pTempTrack, MIDIEVENT_PROGRAMCHANGE | lChannel);
		// ӁFtH[}bg0̍ŏȊÕgbN̓tH[}bg1̍ŏ̃gbNŐݒ肵Ă͂ȂȂB
		ASSERT (pTempEvent);
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pTempEvent));
		break;
	// ^C+AL[+AxVeB+̏ꍇ(20091126ǉ)
	case TRACKLISTFRAME_TIMEPLUS:
	case TRACKLISTFRAME_KEYPLUS:
	case TRACKLISTFRAME_VELOCITYPLUS:
		// L^
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pTempTrack));
	}
	return TRUE;
}

// ݂̃Z̒l𑝌
BOOL CTrackListTrackModeView::AddValueOfCurCell (long lDeltaValue) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParent ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;
	long lTrackCount = MIDIData_CountTrack (pMIDIData);
	long lFormat = MIDIData_GetFormat (pMIDIData);
	// ݂̃gbNւ̃|C^擾
	// (YgbN BeginValueUpDownŒǉĂ͂ł)
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	VERIFY (pMIDITrack = pSekaijuDoc->GetTrack (m_lCurRow));
	// l̔f
	long lValue = 0;
	long lNumber = 0;
	ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
	long lColumnContent = pTrackListFrame->GetColumnContent (m_lCurColumn);
	switch (lColumnContent & 0xFFFF) {
	// Rg[`FW(0`127)̏ꍇ
	case TRACKLISTFRAME_CONTROLCHANGE:
		// ӁFtH[}bg0̍ŏȊÕgbN̓tH[}bg1̍ŏ̃gbNł͐ݒ肵Ă͂ȂȂB
		lNumber = pTrackListFrame->GetColumnContent (m_lCurColumn) >> 16;
		VERIFY (pMIDIEvent = pSekaijuDoc->GetTrackFirstControlChange (pMIDITrack, lNumber));
		lValue = MIDIEvent_GetValue (pMIDIEvent);
		// (Bank Select MSB (CC#0)  Bank Select LSB (CC#32)) ̏ꍇpb`T[`ON̂Ƃ
		if ((lNumber == 0 || lNumber == 32) && pSekaijuApp->m_theGeneralOption.m_bPatchSearch) {
			long lRet;
			MIDIEvent* pCC0Event = pSekaijuDoc->FindBankMSB (pMIDIEvent);
			long lBankMSB = 0;
			if (pCC0Event) {
				lBankMSB = MIDIEvent_GetValue (pCC0Event);
			}
			MIDIEvent* pCC32Event = pSekaijuDoc->FindBankLSB (pMIDIEvent);
			long lBankLSB = 0;
			if (pCC32Event) {
				lBankLSB = MIDIEvent_GetValue (pCC32Event);
			}
			MIDIEvent* pPCEvent = pSekaijuDoc->FindProgramChange (pMIDIEvent);
			long lProgramChange = 0;
			if (pPCEvent) {
				lProgramChange = MIDIEvent_GetNumber (pPCEvent);
			}
			long lTrackOutputPort = MIDITrack_GetOutputPort (pMIDITrack);
			long lTrackViewMode = MIDITrack_GetViewMode (pMIDITrack);
			MIDIInstrumentDefinition* pMIDIInstDef = lTrackViewMode ?
				pSekaijuApp->m_pMIDIInstDefDrum[lTrackOutputPort] :
				pSekaijuApp->m_pMIDIInstDefNorm[lTrackOutputPort];
			// CXgDg`ݒ肳Ăꍇ
			if (pMIDIInstDef) {
				MIDIPatchNameTable* pMIDIPatchNameTable = NULL;
				long lBank = 0;
				TCHAR szBuf[256];
				long lNewValue = lValue + (lDeltaValue > 0 ? 1 : -1);
				long lTempNewValue = lValue; // ŌɉFVl
				while (0 <= lNewValue && lNewValue <= 127) {
					if (lNumber == 0) {
						lBank = (lNewValue << 7) | lBankLSB;
					}
					else if (lNumber == 32) {
						lBank = (lBankMSB << 7) | lNewValue;
					}
					// F邩ׂ
					pMIDIPatchNameTable = 
					MIDIInstrumentDefinition_GetPatchNameTable (pMIDIInstDef, lBank);				
					lRet = 0;
					if (pMIDIPatchNameTable) {
						lRet = MIDIPatchNameTable_GetName 
							(pMIDIPatchNameTable, lProgramChange, szBuf, TSIZEOF (szBuf));
					}
					// Fꍇ
					if (lRet > 0) {
						lTempNewValue = lNewValue;
						if (lNewValue - lValue >= lDeltaValue && lDeltaValue > 0 ||
							lNewValue - lValue <= lDeltaValue && lDeltaValue < 0) {
							break;
						}
					}
					lNewValue += (lDeltaValue > 0 ? 1 : -1);
				}
				VERIFY (MIDIEvent_SetValue (pMIDIEvent, CLIP (0, lTempNewValue, 127)));
			}
			// CXgDg`ݒ肳ĂȂꍇ(ʏ̏ꍇƓ)
			else {
				VERIFY (MIDIEvent_SetValue (pMIDIEvent, CLIP (0, lValue + lDeltaValue, 127)));
			}
		}
		// ʏ̏ꍇ
		else {
			VERIFY (MIDIEvent_SetValue (pMIDIEvent, CLIP (0, lValue + lDeltaValue, 127)));
		}
		break;
	// vO`FW(0`127)̏ꍇ
	case TRACKLISTFRAME_PROGRAMCHANGE:
		// ӁFtH[}bg0̍ŏȊÕgbN̓tH[}bg1̍ŏ̃gbNł͐ݒ肵Ă͂ȂȂB
		VERIFY (pMIDIEvent = pSekaijuDoc->GetTrackFirstProgramChange (pMIDITrack));
		lValue = MIDIEvent_GetValue (pMIDIEvent);
		// pb`T[`ON̂Ƃ
		if (pSekaijuApp->m_theGeneralOption.m_bPatchSearch) {
			long lRet;
			MIDIEvent* pCC0Event = pSekaijuDoc->FindBankMSB (pMIDIEvent);
			long lBankMSB = 0;
			if (pCC0Event) {
				lBankMSB = MIDIEvent_GetValue (pCC0Event);
			}
			MIDIEvent* pCC32Event = pSekaijuDoc->FindBankLSB (pMIDIEvent);
			long lBankLSB = 0;
			if (pCC32Event) {
				lBankLSB = MIDIEvent_GetValue (pCC32Event);
			}
			MIDIEvent* pPCEvent = pMIDIEvent;
			long lProgramChange = 0;
			if (pPCEvent) {
				lProgramChange = MIDIEvent_GetNumber (pPCEvent);
			}
			long lTrackOutputPort = MIDITrack_GetOutputPort (pMIDITrack);
			long lTrackViewMode = MIDITrack_GetViewMode (pMIDITrack);
			MIDIInstrumentDefinition* pMIDIInstDef = lTrackViewMode ?
				pSekaijuApp->m_pMIDIInstDefDrum[lTrackOutputPort] :
				pSekaijuApp->m_pMIDIInstDefNorm[lTrackOutputPort];
			// CXgDg`ݒ肳Ăꍇ
			if (pMIDIInstDef) {
				MIDIPatchNameTable* pMIDIPatchNameTable = NULL;
				long lBank = 0;
				TCHAR szBuf[256];
				long lNewValue = lValue + (lDeltaValue > 0 ? 1 : -1);
				long lTempNewValue = lValue; // ŌɉFVl
				while (0 <= lNewValue && lNewValue <= 127) {
					lBank = (lBankMSB << 7) | lBankLSB;
					// F邩ׂ
					pMIDIPatchNameTable = 
					MIDIInstrumentDefinition_GetPatchNameTable (pMIDIInstDef, lBank);				
					lRet = 0;
					if (pMIDIPatchNameTable) {
						lRet = MIDIPatchNameTable_GetName 
							(pMIDIPatchNameTable, lNewValue, szBuf, TSIZEOF (szBuf));
					}
					// Fꍇ
					if (lRet > 0) {
						lTempNewValue = lNewValue;
						if (lNewValue - lValue >= lDeltaValue && lDeltaValue > 0 ||
							lNewValue - lValue <= lDeltaValue && lDeltaValue < 0) {
							break;
						}
					}
					lNewValue += (lDeltaValue > 0 ? 1 : -1);
				}
				VERIFY (MIDIEvent_SetValue (pMIDIEvent, CLIP (0, lTempNewValue, 127)));
			}
			// CXgDg`ݒ肳ĂȂꍇ(ʏ̏ꍇƓ)
			else {
				VERIFY (MIDIEvent_SetValue (pMIDIEvent, CLIP (0, lValue + lDeltaValue, 127)));
			}
		}
		// ʏ̏ꍇ
		else {
			VERIFY (MIDIEvent_SetValue (pMIDIEvent, CLIP (0, lValue + lDeltaValue, 127)));
		}
		break;
	// ̓|[g(0`15)̏ꍇ
	case TRACKLISTFRAME_INPUTPORT:
		lValue = MIDITrack_GetInputPort (pMIDITrack);
		VERIFY (MIDITrack_SetInputPort (pMIDITrack, CLIP (0, lValue + lDeltaValue, 15)));
		break;
	// ̓`l(0`15)̏ꍇ
	case TRACKLISTFRAME_INPUTCHANNEL:
		lValue = MIDITrack_GetInputChannel (pMIDITrack);
		VERIFY (MIDITrack_SetInputChannel (pMIDITrack, CLIP (-1, lValue + lDeltaValue, 15)));
		break;
	// o̓|[g(0`15)̏ꍇ
	case TRACKLISTFRAME_OUTPUTPORT:
		lValue = MIDITrack_GetOutputPort (pMIDITrack);
		VERIFY (MIDITrack_SetOutputPort (pMIDITrack, CLIP (0, lValue + lDeltaValue, 15)));
		break;
	// o̓`l(0`15)̏ꍇ
	case TRACKLISTFRAME_OUTPUTCHANNEL:
		lValue = MIDITrack_GetOutputChannel (pMIDITrack);
		VERIFY (MIDITrack_SetOutputChannel (pMIDITrack, CLIP (-1, lValue + lDeltaValue, 15)));
		break;
	// ^C+(-127`127)̏ꍇ
	case TRACKLISTFRAME_TIMEPLUS:
		lValue = MIDITrack_GetTimePlus (pMIDITrack);
		VERIFY (MIDITrack_SetTimePlus (pMIDITrack, CLIP (-127, lValue + lDeltaValue, 127)));
		break;
	// L[+(-127`127)̏ꍇ
	case TRACKLISTFRAME_KEYPLUS:
		lValue = MIDITrack_GetKeyPlus (pMIDITrack);
		VERIFY (MIDITrack_SetKeyPlus (pMIDITrack, CLIP (-127, lValue + lDeltaValue, 127)));
		break;
	// xVeB+(-127`127)̏ꍇ
	case TRACKLISTFRAME_VELOCITYPLUS:
		lValue = MIDITrack_GetVelocityPlus (pMIDITrack);
		VERIFY (MIDITrack_SetVelocityPlus (pMIDITrack, CLIP (-127, lValue + lDeltaValue, 127)));
		break;
	}

	return TRUE;
}

// Z̒lOn/Off؂ւB
BOOL CTrackListTrackModeView::ToggleValueOfCurCell () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParent ();
	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;
	CHistoryUnit* pCurHistoryUnit = NULL;
	long lTrackCount = MIDIData_CountTrack (pMIDIData);
	long lFormat = MIDIData_GetFormat (pMIDIData);
	long lValue = 0;
	MIDITrack* pTempTrack = NULL;
	MIDITrack* pCloneTrack = NULL;
	MIDIEvent* pTempEvent = NULL;
	CString strHistoryName;
	// ݒ肷鍀ڂ̒l̔f
	long lColumnContent = pTrackListFrame->GetColumnContent (m_lCurColumn);
	switch (lColumnContent & 0xFFFF) {
	// (gp)
	case TRACKLISTFRAME_VISIBLE:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_VISIBLE_ON_OFF));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ێ̂ߌgbNւ
		ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pTempTrack));
		VERIFY (pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pTempTrack));
		// Visible ON/OFF؂ւ
		lValue = pSekaijuDoc->GetTrackVisible (pCloneTrack);
		pSekaijuDoc->SetTrackVisible (pCloneTrack, !lValue);
		// L^
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack));
		break;
	// (gp)
	case TRACKLISTFRAME_ENABLE:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_ENABLE_ON_OFF));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ێ̂ߌgbNւ
		ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pTempTrack));
		VERIFY (pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pTempTrack));
		// Enable ON/OFF؂ւ
		lValue = pSekaijuDoc->GetTrackEnable (pCloneTrack);
		pSekaijuDoc->SetTrackEnable (pCloneTrack, !lValue);
		// L^
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack));
		break;
	// MIDION/OFF
	case TRACKLISTFRAME_INPUTON:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_INPUT_ON_OFF));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ێ̂ߌgbNւ
		ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pTempTrack));
		VERIFY (pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pTempTrack));
		// ON/OFF؂ւ
		lValue = MIDITrack_GetInputOn (pCloneTrack);
		MIDITrack_SetInputOn (pCloneTrack, !lValue);
		// L^
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack));
		break;
	// MIDIoON/OFF
	case TRACKLISTFRAME_OUTPUTON:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_OUTPUT_ON_OFF));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ێ̂ߌgbNւ
		ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pTempTrack));
		VERIFY (pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pTempTrack));
		// oON/OFF؂ւ
		lValue = MIDITrack_GetOutputOn (pCloneTrack);
		MIDITrack_SetOutputOn (pCloneTrack, !lValue);
		lValue = MIDITrack_GetOutputOn (pCloneTrack);
		// L^
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack));
		// oONOFFɂȂꍇ
		if (lValue == 0) {
			long lCurTime = MIDIClock_GetTickCount (pSekaijuDoc->m_pMIDIClock);
			pSekaijuApp->m_theCriticalSection.Lock ();
			pSekaijuApp->ResetTempMIDIStatusArray ();
			pSekaijuDoc->TimeMIDIStatus (lCurTime, pSekaijuApp->m_pTempMIDIStatus);
			long lFlags;
			// ĐȂ΃m[ĝݕ
			if (pSekaijuApp->m_bPlaying) {
				lFlags = SDS_NOTE;
				pSekaijuApp->m_bIgnoreNoteEvent = 1;
			}
			// ~ȂΉȂ 
			else {
				lFlags = 0;
				pSekaijuApp->m_bIgnoreNoteEvent = 0;
			}
			pSekaijuApp->SendDifferentStatus (lFlags);
			pSekaijuApp->m_theCriticalSection.Unlock ();
		}
		// oOFFONɂȂꍇ
		else {
			long lCurTime = MIDIClock_GetTickCount (pSekaijuDoc->m_pMIDIClock);
			pSekaijuApp->m_theCriticalSection.Lock ();
			pSekaijuApp->ResetTempMIDIStatusArray ();
			pSekaijuDoc->TimeMIDIStatus (lCurTime, pSekaijuApp->m_pTempMIDIStatus);
			long lFlags;
			// ĐȂ(a)ׂĖ(b)m[ĝ݂𕜌
			if (pSekaijuApp->m_bPlaying) {
				lFlags = pSekaijuApp->m_theGeneralOption.m_bSearchUpdate ? SDS_ALL : SDS_NOTE;
				pSekaijuApp->m_bIgnoreNoteEvent = 1;
			}
			// ~Ȃ(a)m[gׂĂ𕜌邩(b)Ȃ 
			else {
				lFlags = pSekaijuApp->m_theGeneralOption.m_bSearchUpdate ? (SDS_ALL & ~SDS_NOTE) : 0;
				pSekaijuApp->m_bIgnoreNoteEvent = 0;
			}
			pSekaijuApp->SendDifferentStatus (lFlags);
			pSekaijuApp->m_theCriticalSection.Unlock ();
		}
		break;
	// \[h(ʏ/h)
	case TRACKLISTFRAME_VIEWMODE:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_VIEWMODE));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
		pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
		if (pTempTrack == NULL) {
			return FALSE;
		}
		// ێ̂ߌgbNւ
		ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pTempTrack));
		VERIFY (pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pTempTrack));
		// ʏ/h؂ւ
		lValue = MIDITrack_GetViewMode (pCloneTrack);
		MIDITrack_SetViewMode (pCloneTrack, !lValue);
		// L^
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack));
		break;	
	}
	return TRUE;
}

// F̑I
BOOL CTrackListTrackModeView::DoColorEditing () {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*) GetParent ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;
	long lTrackCount = MIDIData_CountTrack (pMIDIData);
	long lFormat = MIDIData_GetFormat (pMIDIData);
	MIDITrack* pTempTrack = NULL;
	MIDITrack* pCloneTrack = NULL;
	MIDIEvent* pTempEvent = NULL;
	// ̗p
	CHistoryUnit* pCurHistoryUnit = NULL;
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_MODIFY_COLOR));
	VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
	// ݂̃gbNւ̃|C^擾
	pSekaijuDoc->AddTrack (m_lCurRow + 1, 0x000F, pCurHistoryUnit);
	pTempTrack = pSekaijuDoc->GetTrack (m_lCurRow);
	if (pTempTrack == NULL) {
		return FALSE;
	}
	// Fݒ_CAO̕\
	long lColor = 0;
	long lRet = 0;
	CColorDialog theDlg;
	ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
	long lColumnContent = pTrackListFrame->GetColumnContent (m_lCurColumn);
	switch (lColumnContent & 0xFFFF) {
	// OiF
	case TRACKLISTFRAME_FORECOLOR:
		lColor = MIDITrack_GetForeColor (pTempTrack);
		theDlg.m_cc.rgbResult = lColor;
		theDlg.m_cc.Flags |= (CC_FULLOPEN | CC_RGBINIT);
		pSekaijuDoc->m_theCriticalSection.Unlock ();
		lRet = theDlg.DoModal ();
		pSekaijuDoc->m_theCriticalSection.Lock ();
		if (lRet == IDOK) {
			lColor = (theDlg.GetColor () & 0x00FFFFFF);
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pTempTrack));
			VERIFY (pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pTempTrack));
			MIDITrack_SetForeColor (pCloneTrack, lColor);
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack));
			pSekaijuDoc->UpdateAllViews (NULL, SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIEVENTCHANGED);
			return TRUE;
		}
		break;
	// wiF(gp)
	case TRACKLISTFRAME_BACKCOLOR:
		break;
	}
	return FALSE;
}

// Z̕擾
CString CTrackListTrackModeView::GetCellString (long lRow, long lColumn) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParent ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	ASSERT (0 <= lRow && lRow < MAXMIDITRACKNUM);
	ASSERT (0 <= lColumn && lColumn < TRACKLISTFRAME_NUMCOLUMN);
	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;
	MIDITrack* pMIDITrack = pSekaijuDoc->GetTrack (lRow);
	MIDIEvent* pMIDIEvent = NULL;
	CString strText;
	long lFormat = MIDIData_GetFormat (pMIDIData);
	long lValue = 0;
	long lNumber = 0;
	MIDIIn* pMIDIIn = NULL;
	MIDIOut* pMIDIOut = NULL;
	CString strNone;
	VERIFY (strNone.LoadString (IDS_NONE));
	if (pMIDITrack) {
		long lColumnContent = pTrackListFrame->GetColumnContent (lColumn);
		TCHAR szBuf2[2048];
		memset (szBuf2, 0, sizeof (szBuf2));
		switch (lColumnContent & 0xFFFF) {
		// gbN
		case TRACKLISTFRAME_TRACKNAME:
			strText = pSekaijuDoc->GetTrackName (pMIDITrack);
			codestr2str ((LPTSTR)(LPCTSTR)strText, strText.GetLength (), szBuf2, TSIZEOF (szBuf2) - 1);
			strText = szBuf2;
			break;
		// (gp)
		case TRACKLISTFRAME_VISIBLE:
			if (pSekaijuDoc->GetTrackVisible (pMIDITrack)) {
				VERIFY (strText.LoadString (IDS_SHOW));
			}
			else {
				VERIFY (strText.LoadString (IDS_HIDE));	
			}
			break;
		// Cl[u(gp)
		case TRACKLISTFRAME_ENABLE:
			if (pSekaijuDoc->GetTrackEnable (pMIDITrack)) {
				VERIFY (strText.LoadString (IDS_ENABLE));
			}
			else {
				VERIFY (strText.LoadString (IDS_LOCK));	
			}
			break;
		// ON
		case TRACKLISTFRAME_INPUTON:
			if (MIDITrack_GetInputOn (pMIDITrack)) {
				VERIFY (strText.LoadString (IDS_ON));
			}
			else {
				VERIFY (strText.LoadString (IDS_OFF));	
			}
			break;
		// oON
		case TRACKLISTFRAME_OUTPUTON:
			if (MIDITrack_GetOutputOn (pMIDITrack)) {			
				VERIFY (strText.LoadString (IDS_ON));
			}
			else {
				VERIFY (strText.LoadString (IDS_OFF));	
			}
			break;
		// ̓|[gԍ
		case TRACKLISTFRAME_INPUTPORT:
			lValue = MIDITrack_GetInputPort (pMIDITrack);
			ASSERT (0 <= lValue && lValue < MAXMIDIINDEVICENUM);
			pSekaijuApp->m_theCriticalSection.Lock ();
			pMIDIIn = pSekaijuApp->m_pMIDIIn[lValue];
			if (pMIDIIn) {
				strText.Format (_T("%3d-%s"), lValue + 1, pMIDIIn->m_pDeviceName);
			}
			else {
				strText.Format (_T("%3d-%s"), lValue + 1, strNone);
			}
			pSekaijuApp->m_theCriticalSection.Unlock ();
			break;
		// ̓`l
		case TRACKLISTFRAME_INPUTCHANNEL:
			lValue = MIDITrack_GetInputChannel (pMIDITrack);
			if (0 <= lValue && lValue <= 15) {
				strText.Format (_T("%3d"), lValue + 1);
			}
			else {
				VERIFY (strText.LoadString (IDS_N_A));
			}
			break;
		// o̓|[gԍ
		case TRACKLISTFRAME_OUTPUTPORT:
			lValue = MIDITrack_GetOutputPort (pMIDITrack);
			ASSERT (0 <= lValue && lValue < MAXMIDIOUTDEVICENUM);
			pSekaijuApp->m_theCriticalSection.Lock ();
			pMIDIOut = pSekaijuApp->m_pMIDIOut[lValue];
			if (pMIDIOut) {
				strText.Format (_T("%3d-%s"), lValue + 1, pMIDIOut->m_pDeviceName);
			}
			else {
				strText.Format (_T("%3d-%s"), lValue + 1, strNone);
			}
			pSekaijuApp->m_theCriticalSection.Unlock ();
			break;
		// o̓`l
		case TRACKLISTFRAME_OUTPUTCHANNEL:
			lValue = MIDITrack_GetOutputChannel (pMIDITrack);
			if (0 <= lValue && lValue <= 15) {
				strText.Format (_T("%3d"), lValue + 1);
			}
			else {
				VERIFY (strText.LoadString (IDS_N_A));
			}
			break;
		// \[h(ʏ^h)
		case TRACKLISTFRAME_VIEWMODE:
			if (MIDITrack_GetViewMode (pMIDITrack)) {
				VERIFY (strText.LoadString (IDS_DRUM));
			}
			else {
				VERIFY (strText.LoadString (IDS_NORM));
			}
			break;
		// Rg[`FW
		case TRACKLISTFRAME_CONTROLCHANGE:
			lValue = -1;
			lNumber = pTrackListFrame->GetColumnContent (lColumn) >> 16;
			forEachEvent (pMIDITrack, pMIDIEvent) {
				if (MIDIEvent_IsControlChange (pMIDIEvent)) {
					if (MIDIEvent_GetNumber (pMIDIEvent) == lNumber) {
						lValue = MIDIEvent_GetValue (pMIDIEvent);
						break;
					}
				}
			}
			if (0 <= lValue && lValue <= 127) {
				strText.Format (_T("%3d"), lValue);
			}
			else {
				strText = _T("---");
			}
			break;
		// vO`FW
		case TRACKLISTFRAME_PROGRAMCHANGE:
			lValue = -1;
			forEachEvent (pMIDITrack, pMIDIEvent) {
				if (MIDIEvent_IsProgramChange (pMIDIEvent)) {
					lValue = MIDIEvent_GetNumber (pMIDIEvent);
					break;
				}
			}
			if (0 <= lValue && lValue <= 127 && pMIDIEvent) {
				long lTrackOutputPort = MIDITrack_GetOutputPort (pMIDITrack);
				ASSERT (0 <= lTrackOutputPort && lTrackOutputPort < 16);
				long lTrackOutputChannel = MIDITrack_GetOutputChannel (pMIDITrack);
				ASSERT (-1 <= lTrackOutputChannel && lTrackOutputChannel < 16);
				if (lTrackOutputChannel == -1) {
					lTrackOutputChannel = MIDIEvent_GetChannel (pMIDIEvent);
				}
				ASSERT (0 <= lTrackOutputChannel && lTrackOutputChannel < 16);
				long lTrackViewMode  = MIDITrack_GetViewMode (pMIDITrack);
				TCHAR szBuf[256];
				memset (szBuf, 0, sizeof (szBuf));
				long lBankMSB = MIDIEvent_GetBankMSB (pMIDIEvent);
				long lBankLSB = MIDIEvent_GetBankLSB (pMIDIEvent);
				long lBank = (lBankMSB << 7) | lBankLSB; //MIDIEvent_GetBank (pMIDIEvent);
				MIDIInstrumentDefinition* pInstDef = NULL;
				// ̃gbN̕\[huʏv̏ꍇ
				if (lTrackViewMode == 0) {
					pInstDef = pSekaijuApp->m_pMIDIInstDefNorm[lTrackOutputPort];
				}
				// ̃gbN̕\[huhv̏ꍇ
				else {
					pInstDef = pSekaijuApp->m_pMIDIInstDefDrum[lTrackOutputPort];
				}
				// ̃gbÑCXgDg`
				if (pInstDef) {
					MIDIPatchNameTable* pPatchNameTable =
						MIDIInstrumentDefinition_GetPatchNameTable (pInstDef, lBank);
					// ̃CXgDg`̎woNPatchNameTable
					if (pPatchNameTable) {
						TCHAR szBuf[256];
						memset (szBuf, 0, 256);
						MIDIPatchNameTable_GetName 
							(pPatchNameTable, lValue, szBuf, 255);
						strText.Format (_T("%d-%s"), lValue, szBuf);
					}
					else {
						strText.Format (_T("%d"), lValue);
					}
				}
				else {
					strText.Format (_T("%d"), lValue);
				}
			}
			else {
				strText = _T("---");
			}
			break;
		// ^C+
		case TRACKLISTFRAME_TIMEPLUS:
			if (lFormat == 1 && lRow == 0) {
				strText.Format (_T("---"));
			}
			else {
				lValue = MIDITrack_GetTimePlus (pMIDITrack);
				strText.Format (_T("%3d"), lValue);
			}
			break;
		// L[+
		case TRACKLISTFRAME_KEYPLUS:
			if (lFormat == 1 && lRow == 0) {
				strText.Format (_T("---"));
			}
			else {
				lValue = MIDITrack_GetKeyPlus (pMIDITrack);
				strText.Format (_T("%3d"), lValue);
			}
			break;
		// xVeB+
		case TRACKLISTFRAME_VELOCITYPLUS:
			if (lFormat == 1 && lRow == 0) {
				strText.Format (_T("---"));
			}
			else {
				lValue = MIDITrack_GetVelocityPlus (pMIDITrack);
				strText.Format (_T("%3d"), lValue);
			}
			break;
		// Cxg
		case TRACKLISTFRAME_NUMEVENT:
			lValue = MIDITrack_CountEvent (pMIDITrack);
			strText.Format (_T("%8d"), lValue);
			break;
		}
	}
	return strText;
}

// Z̕ݒ
BOOL CTrackListTrackModeView::SetCellString (long lRow, long lColumn, CString strText) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParent ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	m_bSettingCellString = 1;
	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pTempTrack = NULL;
	MIDIEvent* pTempEvent = NULL;
	MIDITrack* pCloneTrack = NULL;
	MIDIEvent* pCloneEvent = NULL;
	long lFormat = MIDIData_GetFormat (pMIDIData);
	CHistoryUnit* pCurHistoryUnit = NULL;
	CString strHistoryName;
	long lValue = 0;
	long lNumber = 0;
	MIDIIn* pMIDIIn = NULL;
	MIDIOut* pMIDIOut = NULL;
	ASSERT (0 <= lColumn && lColumn < TRACKLISTFRAME_NUMCOLUMN);
	ASSERT (0 <= lRow && lRow < MAXMIDITRACKNUM);
	long lColumnContent = pTrackListFrame->GetColumnContent (lColumn);
	switch (lColumnContent & 0xFFFF) {
	// gbN
	case TRACKLISTFRAME_TRACKNAME:
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_TRACKNAME));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (lRow + 1, 0x000F, pCurHistoryUnit);
		pMIDITrack = pSekaijuDoc->GetTrack (lRow);
		if (pMIDITrack == NULL) {
			return FALSE;
		}
		// ŏ̃gbNCxgT
		forEachEvent (pMIDITrack, pTempEvent) {
			if (MIDIEvent_GetKind (pTempEvent) == MIDIEVENT_TRACKNAME) {
				break;
			}
		}
		// ŏ̃gbNCxgȂꍇ
		if (pTempEvent == NULL) {
			TCHAR szBuf2[2048];
			memset (szBuf2, 0, sizeof (szBuf2));
			str2codestr ((LPTSTR)(LPCTSTR)(strText), strText.GetLength (), szBuf2, TSIZEOF (szBuf2) - 1);
			VERIFY (pTempEvent = MIDIEvent_CreateTrackName (0, szBuf2));
			VERIFY (MIDITrack_InsertEvent (pMIDITrack, pTempEvent));
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pTempEvent));
		}
		// ŏ̃gbNꍇ
		else {
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pTempEvent));
			VERIFY (pCloneEvent = pSekaijuDoc->ReplaceMIDIEvent (pTempEvent));
			TCHAR szBuf2[2048];
			memset (szBuf2, 0, sizeof (szBuf2));
			str2codestr ((LPTSTR)(LPCTSTR)(strText), strText.GetLength (), szBuf2, TSIZEOF (szBuf2) - 1);
			MIDIEvent_SetText (pCloneEvent, szBuf2);
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
		}
		break;
	// ̓|[gԍ
	case TRACKLISTFRAME_INPUTPORT:
		strText.TrimLeft ();
		if (IsNumeric (strText) == 0) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_1_TO_16));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		lValue = _ttol (strText);
		if (lValue <= 0 || lValue > 16) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_1_TO_16));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		pSekaijuApp->m_theCriticalSection.Lock ();
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_INPUTPORT));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (lRow + 1, 0x000F, pCurHistoryUnit);
		pMIDITrack = pSekaijuDoc->GetTrack (lRow);
		if (pMIDITrack == NULL) {
			return FALSE;
		}
		// ̓|[gԍ̐ݒ
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack);
		pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pMIDITrack);
		MIDITrack_SetInputPort (pCloneTrack, CLIP (0, lValue - 1, 15));
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack);
		pSekaijuApp->m_theCriticalSection.Unlock ();
		m_bSettingCellString = 0;
		return TRUE;
	// ̓`l
	case TRACKLISTFRAME_INPUTCHANNEL:
		strText.TrimLeft ();
		if (strText == _T("n/a")) {
			strText = _T("0");
		}
		if (IsNumeric (strText) == 0) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_0_TO_16));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		lValue = _ttol (strText);
		if (lValue <= -1 || lValue > 16) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_0_TO_16));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		pSekaijuApp->m_theCriticalSection.Lock ();
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_INPUTCHANNEL));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (lRow + 1, 0x000F, pCurHistoryUnit);
		pMIDITrack = pSekaijuDoc->GetTrack (lRow);
		if (pMIDITrack == NULL) {
			return FALSE;
		}
		// ̓`l̐ݒ
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack);
		pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pMIDITrack);
		MIDITrack_SetInputChannel (pCloneTrack, CLIP (-1, lValue - 1, 15));
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack);
		pSekaijuApp->m_theCriticalSection.Unlock ();
		m_bSettingCellString = 0;
		return TRUE;
	// o̓|[gԍ
	case TRACKLISTFRAME_OUTPUTPORT:
		strText.TrimLeft ();
		if (IsNumeric (strText) == 0) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_1_TO_16));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		lValue = _ttol (strText);
		if (lValue <= 0 || lValue > 16) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_1_TO_16));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		pSekaijuApp->m_theCriticalSection.Lock ();
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_OUTPUTPORT));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (lRow + 1, 0x000F, pCurHistoryUnit);
		pMIDITrack = pSekaijuDoc->GetTrack (lRow);
		if (pMIDITrack == NULL) {
			return FALSE;
		}
		// o̓|[gԍ̐ݒ
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack);
		pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pMIDITrack);
		MIDITrack_SetOutputPort (pCloneTrack, CLIP (0, lValue - 1, 15));
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack);
		pSekaijuApp->m_theCriticalSection.Unlock ();
		m_bSettingCellString = 0;
		return TRUE;
	// o̓`l
	case TRACKLISTFRAME_OUTPUTCHANNEL:
		strText.TrimLeft ();
		if (strText == _T("n/a")) {
			strText = _T("0");
		}
		if (IsNumeric (strText) == 0) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_0_TO_16));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		lValue = _ttol (strText);
		if (lValue <= -1 || lValue > 16) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_0_TO_16));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		pSekaijuApp->m_theCriticalSection.Lock ();
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_OUTPUTCHANNEL));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (lRow + 1, 0x000F, pCurHistoryUnit);
		pMIDITrack = pSekaijuDoc->GetTrack (lRow);
		if (pMIDITrack == NULL) {
			return FALSE;
		}
		// o̓`l̐ݒ
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack);
		pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pMIDITrack);
		MIDITrack_SetOutputChannel (pCloneTrack, CLIP (-1, lValue - 1, 15));
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack);
		pSekaijuApp->m_theCriticalSection.Unlock ();
		m_bSettingCellString = 0;
		return TRUE;
	// Rg[`FW(CC#0, CC#32, {[, p, o[u, R[X, fBCȂ)
	case TRACKLISTFRAME_CONTROLCHANGE:
		if (lFormat == 1 && lRow == 0) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_CONTROLCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		lNumber = pTrackListFrame->GetColumnContent (lColumn) >> 16;
		strText.TrimLeft ();
		if (IsNumeric (strText) == 0) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_0_TO_127));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		lValue = _ttol (strText);
		if (lValue < 0 || lValue > 127) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_0_TO_127));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_CONTROLCHANGE));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (lRow + 1, 0x000F, pCurHistoryUnit);
		pMIDITrack = pSekaijuDoc->GetTrack (lRow);
		if (pMIDITrack == NULL) {
			return FALSE;
		}
		// ŏCC#lNumberCxgT
		forEachEvent (pMIDITrack, pTempEvent) {
			if (MIDIEvent_IsControlChange (pTempEvent)) {
				if (MIDIEvent_GetNumber (pTempEvent) == lNumber) {
					break;
				}
			}
		}
		// ŏCC#lNumberCxgȂꍇ
		if (pTempEvent == NULL) {
			long lChannel = MIDITrack_GetOutputChannel (pMIDITrack);
			VERIFY (pTempEvent = MIDIEvent_CreateControlChange (0, lChannel, lNumber, lValue));
			VERIFY (MIDITrack_InsertEvent (pMIDITrack, pTempEvent));
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pTempEvent));
		}
		// ŏCC#lNumberꍇ
		else {
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pTempEvent));
			VERIFY (pCloneEvent = pSekaijuDoc->ReplaceMIDIEvent (pTempEvent));
			VERIFY (MIDIEvent_SetValue (pCloneEvent, lValue));
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
		}
		m_bSettingCellString = 0;
		return TRUE;
	// vO`FW
	case TRACKLISTFRAME_PROGRAMCHANGE:
		if (lFormat == 1 && lRow == 0) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_PROGRAMCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		strText.TrimLeft ();
		if (IsNumeric (strText) == 0) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_0_TO_127));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		lValue = _ttol (strText);
		if (lValue < 0 || lValue > 127) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_0_TO_127));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_PROGRAMCHANGE));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pMIDITrack = pSekaijuDoc->GetTrack (lRow);
		// Ώۂ̃gbNȂꍇ́AKvȐgbNǉB
		pSekaijuDoc->AddTrack (lRow + 1, 0x000F, pCurHistoryUnit);
		pMIDITrack = pSekaijuDoc->GetTrack (lRow);
		if (pMIDITrack == NULL) {
			return FALSE;
		}
		// ŏ̃vO`FWCxgT
		forEachEvent (pMIDITrack, pTempEvent) {
			if (MIDIEvent_IsProgramChange (pTempEvent)) {
				break;
			}
		}
		// ŏ̃vO`FWCxgȂꍇ
		if (pTempEvent == NULL) {
			long lChannel = MIDITrack_GetOutputChannel (pMIDITrack);
			VERIFY (pTempEvent = MIDIEvent_CreateProgramChange (0, lChannel, lValue));
			VERIFY (MIDITrack_InsertEvent (pMIDITrack, pTempEvent));
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pTempEvent));
		}
		// ŏ̃vO`FWCxgꍇ
		else {
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pTempEvent));
			VERIFY (pCloneEvent = pSekaijuDoc->ReplaceMIDIEvent (pTempEvent));
			VERIFY (MIDIEvent_SetValue (pCloneEvent, lValue));
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
		}
		m_bSettingCellString = 0;
		return TRUE;

	// ^C+
	case TRACKLISTFRAME_TIMEPLUS:
		strText.TrimLeft ();
		if (IsNumeric (strText) == 0) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_M127_TO_127));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		lValue = _ttol (strText);
		if (lValue < -127 || lValue > 127) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_M127_TO_127));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_TIMEPLUS));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (lRow + 1, 0x000F, pCurHistoryUnit);
		pMIDITrack = pSekaijuDoc->GetTrack (lRow);
		if (pMIDITrack == NULL) {
			return FALSE;
		}
		// ^C+̐ݒ
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack);
		pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pMIDITrack);
		MIDITrack_SetTimePlus (pCloneTrack, CLIP (-127, lValue, 127));
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack);
		m_bSettingCellString = 0;
		return TRUE;
	// L[+
	case TRACKLISTFRAME_KEYPLUS:
		strText.TrimLeft ();
		if (IsNumeric (strText) == 0) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_M127_TO_127));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		lValue = _ttol (strText);
		if (lValue < -127 || lValue > 127) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_M127_TO_127));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_KEYPLUS));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (lRow + 1, 0x000F, pCurHistoryUnit);
		pMIDITrack = pSekaijuDoc->GetTrack (lRow);
		if (pMIDITrack == NULL) {
			return FALSE;
		}
		// L[+̐ݒ
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack);
		pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pMIDITrack);
		MIDITrack_SetKeyPlus (pCloneTrack, CLIP (-127, lValue, 127));
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack);
		m_bSettingCellString = 0;
		return TRUE;
	// xVeB+
	case TRACKLISTFRAME_VELOCITYPLUS:
		strText.TrimLeft ();
		if (IsNumeric (strText) == 0) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_M127_TO_127));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		lValue = _ttol (strText);
		if (lValue < -127 || lValue > 127) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_INPUT_HALF_WIDTH_NUMBER_FROM_M127_TO_127));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
			m_bSettingCellString = 0;
			return FALSE;
		}
		// V̗p
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_VELPLUS));
		VERIFY (pSekaijuDoc->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = pSekaijuDoc->GetCurHistoryUnit ());
		// ݂̃gbNւ̃|C^擾
		pSekaijuDoc->AddTrack (lRow + 1, 0x000F, pCurHistoryUnit);
		pMIDITrack = pSekaijuDoc->GetTrack (lRow);
		if (pMIDITrack == NULL) {
			return FALSE;
		}
		// xVeB+̐ݒ
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack);
		pCloneTrack = pSekaijuDoc->ReplaceMIDITrack (pMIDITrack);
		MIDITrack_SetVelocityPlus (pCloneTrack, CLIP (-127, lValue, 127));
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack);
		m_bSettingCellString = 0;
		return TRUE;
	// Cxg
	case TRACKLISTFRAME_NUMEVENT:
		return FALSE;
	}
	m_bSettingCellString = 0;
	return TRUE;
}

// ݂̃Z̒``
BOOL CTrackListTrackModeView::DrawCurFrame (CDC* pDC) {
	CRect rcCurFrame = GetRectFromCell (m_lCurRow, m_lCurColumn);
	rcCurFrame.left -= 1;
	rcCurFrame.right -= 1;
	rcCurFrame.top -= 1;
	rcCurFrame.bottom -= 1;
	CPen thePen (PS_SOLID, 3, RGB (0, 0, 0));
	CPen* pOldPen = pDC->SelectObject (&thePen);
	int nOldDrawMode = pDC->SetROP2 (R2_NOT);
	pDC->MoveTo (rcCurFrame.left, rcCurFrame.top);
	pDC->LineTo (rcCurFrame.left, rcCurFrame.bottom);
	pDC->LineTo (rcCurFrame.right, rcCurFrame.bottom);
	pDC->LineTo (rcCurFrame.right, rcCurFrame.top);
	pDC->LineTo (rcCurFrame.left, rcCurFrame.top);
	pDC->SetROP2 (nOldDrawMode);
	pDC->SelectObject (pOldPen);
	return TRUE;

}

// Z̒`擾
CRect CTrackListTrackModeView::GetRectFromCell (long lRow, long lColumn) {
	long j;
	CRect rcCell (0, 0, 0 ,0);
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParentFrame ();
	for (j = 0; j < lColumn; j++) {
		rcCell.left += pTrackListFrame->GetColumnWidth (j);
	}
	rcCell.right = rcCell.left + pTrackListFrame->GetColumnWidth (j);
	rcCell.top = lRow * pTrackListFrame->GetRowZoom ();
	rcCell.bottom = (lRow + 1) * pTrackListFrame->GetRowZoom ();
	return rcCell;
}

// eLXg{bNẌړ(VISIBLE==FALSE܂)
BOOL CTrackListTrackModeView::MoveTextBox (long lRow, long lColumn) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*) GetParent ();
	ASSERT (0 <= lRow && lRow < MAXMIDITRACKNUM);
	ASSERT (0 <= lColumn && lColumn < TRACKLISTFRAME_NUMCOLUMN);
	CRect rcNewCell = GetRectFromCell (lRow, lColumn);
	rcNewCell -= CSize (pTrackListFrame->GetColumnScrollPos(), pTrackListFrame->GetRowScrollPos ());
	long lButtonWidth = 12;//::GetSystemMetrics (SM_CXVSCROLL);
	ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
	long lColumnContent = pTrackListFrame->GetColumnContent (m_lCurColumn);
	if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTPORT ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTCHANNEL ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTPORT ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTCHANNEL ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_CONTROLCHANGE ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_PROGRAMCHANGE ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
	}
	else {
		lButtonWidth = 1;
	}
	m_theTextBox.MoveWindow 
		(rcNewCell.left, rcNewCell.top + pTrackListFrame->GetRowZoom () / 2 - 6, 
		rcNewCell.Width () - lButtonWidth, 13);
	return TRUE;
}




//------------------------------------------------------------------------------
// I[o[Ch
//------------------------------------------------------------------------------

// _̈ړI[o[Ch
void CTrackListTrackModeView::OnPrepareDC (CDC* pDC, CPrintInfo* pInfo) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*) GetParent ();
	pDC->SetWindowOrg (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
}

// `
void CTrackListTrackModeView::OnDraw (CDC* pDC) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*) GetParent ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	pSekaijuDoc->m_theCriticalSection.Lock ();

	CRect rcClient;
	GetClientRect (&rcClient);
	rcClient += CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos());
	CFont* pOldFont = pDC->SelectObject (&(pTrackListFrame->m_theFont));

	long lButtonWidth = 12;//::GetSystemMetrics (SM_CXVSCROLL);
	long lColorBlack = RGB (0, 0, 0);
	long lColorWhite = RGB (255, 255, 255);
	long lColorBtnFace = ::GetSysColor (COLOR_BTNFACE);
	long lColorBtnShadow = ::GetSysColor (COLOR_BTNSHADOW);
	long lColorBtnHighlight = ::GetSysColor (COLOR_BTNHIGHLIGHT);
	long lColorBtnText = ::GetSysColor (COLOR_BTNTEXT);
	long lColorGrayText = ::GetSysColor (COLOR_GRAYTEXT);

	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;
	MIDITrack* pMIDITrack = NULL;

	long i, j;
	long lRowZoom = pTrackListFrame->GetRowZoom ();
	long lColumnZoom = pTrackListFrame->GetColumnZoom ();
	// s̔wiF`
	long lTrackCount = MIDIData_CountTrack (pMIDIData);
	long lVisibleTopRow = pTrackListFrame->GetVisibleTopRow ();
	long lVisibleBottomRow = pTrackListFrame->GetVisibleBottomRow ();
	for (i = lVisibleTopRow; i <= lVisibleBottomRow; i++) {
		long lNormalColor = pSekaijuApp->m_theColorOption.m_lBackColor[i % 2];
		long lSelectedColor = 
			(CLIP (0x00, ((lNormalColor >> 16) & 0xFF) - 0x00, 0xFF) << 16) |
			(CLIP (0x00, ((lNormalColor >> 8) & 0xFF) - 0x20, 0xFF) << 8) |
			(CLIP (0x00, ((lNormalColor >> 0) & 0xFF) - 0x20, 0xFF) << 0);		
		if (0 <= i && i < lTrackCount) {
			pMIDITrack = pSekaijuDoc->GetTrack (i);
		}
		else {
			pMIDITrack = NULL;
		}
		long lBackColor = lNormalColor;
		if (pMIDITrack) {
			if (pSekaijuDoc->IsTrackSelected (pMIDITrack)) {
				lBackColor = lSelectedColor;
			}
		}
		pDC->FillSolidRect 
			(rcClient.left, i * lRowZoom, 
			rcClient.Width (), (i + 1) * lRowZoom, 
			lBackColor);
	}
	// ̕`
	CPen penTrack (PS_SOLID, 1, pSekaijuApp->m_theColorOption.m_lHorzColor [0]);
	CPen* pOldPen = pDC->SelectObject (&penTrack);
	for (i = lVisibleTopRow; i <= lVisibleBottomRow; i++) {
		long y = i * lRowZoom;
		pDC->MoveTo (rcClient.left, y - 1);
		pDC->LineTo (rcClient.right, y - 1);
	}
	pDC->SelectObject (pOldPen);
	// c̕`
	CPen penColumn (PS_SOLID, 1, pSekaijuApp->m_theColorOption.m_lVertColor [0]);
	pOldPen = pDC->SelectObject (&penColumn);
	long x = 0;
	for (j = 0; j < TRACKLISTFRAME_NUMCOLUMN; j++) {
		pDC->MoveTo (x - 1, rcClient.top);
		pDC->LineTo (x - 1, rcClient.bottom);
		x += pTrackListFrame->GetColumnBaseWidth (j) * lColumnZoom;
	}
	pDC->SelectObject (pOldPen);


	// ̕`
	CRect rcText (0, 0, 0, 0);
	pDC->SetBkMode (TRANSPARENT);
	i = 0;
	j = 0;
	// `悷ׂJnsƏIšvZ
	long lStartRow = __max (lVisibleTopRow, 0);
	long lEndRow = __min (MAXMIDITRACKNUM, lVisibleBottomRow + 1);
	// eZ̕Ȃǂ̕`
	for (i = lStartRow; i < lEndRow; i++) {
		if (i < lTrackCount) {
			pMIDITrack = pSekaijuDoc->GetTrack (i);
		}
		else {
			pMIDITrack = NULL;
		}
		if (pMIDITrack) {
			long lTrackForeColor = MIDITrack_GetForeColor (pMIDITrack);
			pDC->SetTextColor (lTrackForeColor);
			// eɂ
			for (j = 0; j < TRACKLISTFRAME_NUMCOLUMN; j++) {
				CRect rcCell = GetRectFromCell (i, j);
				CRect rcText = rcCell;
				long lColumnContent = pTrackListFrame->GetColumnContent (j);
				if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTPORT ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTCHANNEL ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTPORT ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTCHANNEL ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_CONTROLCHANGE ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_PROGRAMCHANGE ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
					rcText.right -= 10;
				}
				// eZ̕`
				CString strCellString;
				CRect rcColor;
				switch (lColumnContent & 0xFFFF) {
				case TRACKLISTFRAME_FORECOLOR:
					rcColor.left = rcCell.left + 2;
					rcColor.right = rcCell.right - 3;
					rcColor.top = rcCell.top + lRowZoom / 2 - 6;
					rcColor.bottom = rcCell.top + lRowZoom / 2 + 6;
					pDC->FillSolidRect (&rcColor, lTrackForeColor); 
					break;
				case TRACKLISTFRAME_TRACKNAME:
				case TRACKLISTFRAME_VISIBLE:
				case TRACKLISTFRAME_ENABLE:
				case TRACKLISTFRAME_INPUTON:
				case TRACKLISTFRAME_INPUTPORT:
				case TRACKLISTFRAME_INPUTCHANNEL:
				case TRACKLISTFRAME_OUTPUTON:
				case TRACKLISTFRAME_OUTPUTPORT:
				case TRACKLISTFRAME_OUTPUTCHANNEL:
				case TRACKLISTFRAME_VIEWMODE:
				case TRACKLISTFRAME_CONTROLCHANGE:
				case TRACKLISTFRAME_PROGRAMCHANGE:
				case TRACKLISTFRAME_TIMEPLUS:
				case TRACKLISTFRAME_KEYPLUS:
				case TRACKLISTFRAME_VELOCITYPLUS:
				case TRACKLISTFRAME_NUMEVENT:
					strCellString = GetCellString (i, j);
					pDC->DrawText (strCellString, &rcText, DT_LEFT | DT_VCENTER | DT_SINGLELINE);
					break;
				}
			}
		}
	}	

	// eZ̃{^ނ̕`
	CPen penColorBtnText (PS_SOLID, 1, lColorBtnText);
	CPen penColorGrayText (PS_SOLID, 1, lColorGrayText);
	CBrush brsColorBtnText;
	CBrush brsColorGrayText;
	brsColorBtnText.CreateSolidBrush (lColorBtnText);
	brsColorGrayText.CreateSolidBrush (lColorGrayText);
	CBrush* pOldBrush = NULL;

	CRect rcButton;
	CRect rcCell;
	POINT pt[3];
	pOldPen = pDC->SelectObject (&penColorBtnText);
	pOldBrush = pDC->SelectObject (&brsColorBtnText);
	
	for (i = lVisibleTopRow; i <= lVisibleBottomRow; i++) {
		for (j = 0; j < TRACKLISTFRAME_NUMCOLUMN; j++) {
			long lColumnContent = pTrackListFrame->GetColumnContent (j);
			if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTPORT ||
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTCHANNEL ||
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTPORT ||
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTCHANNEL ||
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_CONTROLCHANGE ||
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_PROGRAMCHANGE ||
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS ||
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS ||
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
				rcCell = GetRectFromCell (i, j);
				rcButton = rcCell;
				// {^
				rcButton.left = rcCell.right - lButtonWidth;
				rcButton.bottom = rcCell.top + lRowZoom / 2;
				pDC->FillSolidRect (&rcButton, ::GetSysColor (COLOR_3DFACE));
				if (i == m_lCurRow && j == m_lCurColumn && (m_lCurButtonState & 0x01) == 0x01) {
					pDC->Draw3dRect (&rcButton, lColorBtnShadow, lColorBtnHighlight);
				}
				else {
					pDC->Draw3dRect (&rcButton, lColorBtnHighlight, lColorBtnShadow);
				}
				pt[0].x = rcCell.right - lButtonWidth / 2;
				pt[0].y = rcCell.top + lRowZoom * 1 / 4 - 1;
				pt[1].x = pt[0].x - 2;
				pt[1].y = pt[0].y + 2;
				pt[2].x = pt[0].x + 2;
				pt[2].y = pt[0].y + 2;
				pDC->Polygon (pt, 3);
				// {^
				rcButton.top = rcCell.top + lRowZoom / 2;
				rcButton.bottom = rcCell.bottom;
				pDC->FillSolidRect (&rcButton, ::GetSysColor (COLOR_3DFACE));
				if (i == m_lCurRow && j == m_lCurColumn && (m_lCurButtonState & 0x02) == 0x02) {
					pDC->Draw3dRect (&rcButton, lColorBtnShadow, lColorBtnHighlight);
				}
				else {
					pDC->Draw3dRect (&rcButton, lColorBtnHighlight, lColorBtnShadow);
				}
				pt[0].x = rcCell.right - lButtonWidth / 2;
				pt[0].y = rcCell.top + lRowZoom * 3 / 4 + 1;
				pt[1].x = pt[0].x - 2;
				pt[1].y = pt[0].y - 2;
				pt[2].x = pt[0].x + 2;
				pt[2].y = pt[0].y - 2;
				pDC->Polygon (pt, 3);
			}
		}
	}
	pDC->SelectObject (pOldPen);
	pDC->SelectObject (pOldBrush);

	// JgZ̘g`
	DrawCurFrame (pDC);

	pSekaijuDoc->m_theCriticalSection.Unlock ();
	::Sleep (0);
}

// R}h[eBÕI[o[Ch
BOOL CTrackListTrackModeView::OnCmdMsg (UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) {
	// :pHandlerInfo==NULL̎̓R}hsANULLłȂƂ
	// R}h͎spHandlerInfo̒gݒ肷邱ƂӖB
	if (nCode == CN_COMMAND && pHandlerInfo == NULL) {
	}
	return CView::OnCmdMsg (nID, nCode, pExtra, pHandlerInfo);
}


//------------------------------------------------------------------------------
// bZ[W}bv
//------------------------------------------------------------------------------

// EBhE
BOOL CTrackListTrackModeView::OnCreate (LPCREATESTRUCT lpcs) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParentFrame ();
	ASSERT (pTrackListFrame);
	m_theTextBox.Create (WS_CHILD /*| WS_VISIBLE | WS_BORDER*/ | ES_AUTOHSCROLL, 
		CRect (0, pTrackListFrame->GetRowZoom () / 2 - 6, 
		pTrackListFrame->GetColumnWidth (0), 13), this, IDC_TEXTBOX);
	m_theTextBox.SetFont (&(pTrackListFrame->m_theFont));
	return CSekaijuView::OnCreate (lpcs);
	
}

// tH[JXƂ
void CTrackListTrackModeView::OnKillFocus (CWnd* pNewWnd) {
	_RPTF1 (_CRT_WARN, "CTrackListTrackModeView::OnKillFocus (pNewWnd=0x%08x)\n", (long)pNewWnd);
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParent ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	pSekaijuDoc->m_theCriticalSection.Lock ();
	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;
	// Cv[XeLXg{bNXɃtH[JXڂꍇ
	if (pNewWnd != &m_theTextBox && !m_bSettingCellString) {
		// eLXgҏW̏ꍇ͂̓em
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		// }EXő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x00F0) {
			ReleaseCapture ();
			KillTimer (1);
			EndValueUpDown ();
			m_lCurButtonState &= 0xFF00;
			pSekaijuDoc->SetModifiedFlag (TRUE);
			pSekaijuDoc->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		}
		// L[{[hő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x0F00) {
			ReleaseCapture ();
			EndValueUpDown ();
			m_lCurButtonState &= 0xF0F0;
			pSekaijuDoc->SetModifiedFlag (TRUE);
			pSekaijuDoc->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		}
	}
	pSekaijuDoc->m_theCriticalSection.Unlock ();
	CView::OnKillFocus (pNewWnd);
}

// L[
void CTrackListTrackModeView::OnKeyDown (UINT nChar, UINT nRepCnt, UINT nFlags) {

	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParent ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	pSekaijuDoc->m_theCriticalSection.Lock ();
	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;

	CRect rcClient;
	GetClientRect (&rcClient);
	rcClient += CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos());
	
	// ÂZ̍ĕ`(20100128:h~̂ߏǉ)
	if (IsTextEditing () == FALSE && nChar != VK_CONTROL && nChar != VK_SHIFT && nChar != VK_MENU) {
		CRect rcOldCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
		rcOldCell -= CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos());
		rcOldCell.InflateRect (2, 2);
		InvalidateRect (&rcOldCell);
	}

	ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
	long lColumnContent = pTrackListFrame->GetColumnContent (m_lCurColumn);
	long lFormat = MIDIData_GetFormat (pMIDIData);

	switch (nChar) {
	// L[
	case VK_UP:
		// eLXgҏW̏ꍇ͂̓em
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		// }EXő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x00F0) {
			ReleaseCapture ();
			KillTimer (1);
			EndValueUpDown ();
			m_lCurButtonState &= 0xFF00;
		}
		// L[{[hő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x0F00) {
			ReleaseCapture ();
			EndValueUpDown ();
			m_lCurButtonState &= 0xF0F0;
		}
		// JgZЂƂֈړ
		m_lCurRow = CLIP (0, m_lCurRow - 1, MAXMIDITRACKNUM - 1);
		AutoScrolltoShowCell (m_lCurRow, m_lCurColumn);
		MoveTextBox (m_lCurRow, m_lCurColumn);
		break;
	// L[
	case VK_LEFT:
		// eLXgҏW̏ꍇ͂̓em
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		// }EXő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x00F0) {
			ReleaseCapture ();
			KillTimer (1);
			EndValueUpDown ();
			m_lCurButtonState &= 0xFF00;
		}
		// L[{[hő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x0F00) {
			ReleaseCapture ();
			EndValueUpDown ();
			m_lCurButtonState &= 0xF0F0;
		}
		// JgZЂƂֈړ
		m_lCurColumn = CLIP (0, m_lCurColumn - 1, TRACKLISTFRAME_NUMCOLUMN - 1);
		AutoScrolltoShowCell (m_lCurRow, m_lCurColumn);
		MoveTextBox (m_lCurRow, m_lCurColumn);
		break;
	// EL[
	case VK_RIGHT:
		// eLXgҏW̏ꍇ͂̓em
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		// }EXő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x00F0) {
			ReleaseCapture ();
			KillTimer (1);
			EndValueUpDown ();
			m_lCurButtonState &= 0xFF00;
		}
		// L[{[hő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x0F00) {
			ReleaseCapture ();
			EndValueUpDown ();
			m_lCurButtonState &= 0xF0F0;
		}
		// JgZЂƂEֈړ
		m_lCurColumn = CLIP (0, m_lCurColumn + 1, TRACKLISTFRAME_NUMCOLUMN - 1);
		AutoScrolltoShowCell (m_lCurRow, m_lCurColumn);
		MoveTextBox (m_lCurRow, m_lCurColumn);
		break;
	// L[
	case VK_DOWN:
		// eLXgҏW̏ꍇ͂̓em
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		// }EXő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x00F0) {
			ReleaseCapture ();
			KillTimer (1);
			EndValueUpDown ();
			m_lCurButtonState &= 0xFF00;
		}
		// L[{[hő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x0F00) {
			ReleaseCapture ();
			EndValueUpDown ();
			m_lCurButtonState &= 0xF0F0;
		}
		// JgZЂƂֈړ
		m_lCurRow = CLIP (0, m_lCurRow + 1, MAXMIDITRACKNUM - 1);
		AutoScrolltoShowCell (m_lCurRow, m_lCurColumn);
		MoveTextBox (m_lCurRow, m_lCurColumn);
		break;
	// s(Enter)L[
	case VK_RETURN:
		// }EXő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x00F0) {
			ReleaseCapture ();
			KillTimer (1);
			EndValueUpDown ();
			m_lCurButtonState &= 0xFF00;
		}
		// L[{[hő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x0F00) {
			ReleaseCapture ();
			EndValueUpDown ();
			m_lCurButtonState &= 0xF0F0;
		}
		// eLXgҏWłȂꍇ
		if (IsTextEditing () == FALSE) {
			// A^C͕͒ҏW֎~
			if (pSekaijuApp->m_bRecording) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				return;
			}
			// bNĂꍇ͕ҏW֎~
			if (pSekaijuDoc->m_bEditLocked) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				return;
			}
			// tH[}bg0̏ꍇ͍ŏ̃gbNȊOs\
			if (lFormat == 0 && m_lCurRow >= 1) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_EDIT_THIS_TRACK_IN_FORMAT0_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃRg[`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_CONTROLCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_CONTROLCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃvO`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_PROGRAMCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_PROGRAMCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃ^C+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_TIMEPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃL[+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_KEYPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃxVeB+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_VELPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// ݂̃Z𑀍\ȏꍇ
			else {
				// 񖔂͐l̗
				if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_TRACKNAME ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTPORT ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTCHANNEL ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTPORT ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTCHANNEL ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_CONTROLCHANGE ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_PROGRAMCHANGE ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
					BeginTextEditing ();
				}
				// F
				else if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_FORECOLOR ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_BACKCOLOR) {
					if (DoColorEditing () == TRUE) {
						pSekaijuDoc->SetModifiedFlag (TRUE);
						pSekaijuDoc->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
					}
				}
				// BOOL^
				else if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_VISIBLE ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_ENABLE ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTON ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTON ||
					(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VIEWMODE) {
					ToggleValueOfCurCell ();
					pSekaijuDoc->SetModifiedFlag (TRUE);
					pSekaijuDoc->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
				}
			}
		}
		// eLXgҏW̏ꍇ(CInplaceEditNXPostMessageB)
		else {
			EndTextEditingOK ();
			pSekaijuDoc->SetModifiedFlag (TRUE);
			pSekaijuDoc->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		}
		break;
	// GXP[v(Esc)L[(CInplaceEditNXPostMessageB)
	case VK_ESCAPE:
		EndTextEditingCancel ();
		break;
	// +L[
	case VK_ADD:
	case 187:
		// }EXő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x00F0) {
			KillTimer (1);
			ReleaseCapture ();
			EndValueUpDown ();
			m_lCurButtonState &= 0xFF00;
		}
		// CtrlĂꍇ̓Y[Abv
		if (GetCapture () == NULL && GetKeyState (VK_CONTROL) < 0) {
			pTrackListFrame->PostMessage (WM_KEYDOWN, nChar, (nFlags << 16) | nRepCnt);
		}
		// ڂl̏ꍇ̂ݒl̏㏸
		else if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTPORT ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTCHANNEL ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTPORT ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTCHANNEL ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_CONTROLCHANGE ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_PROGRAMCHANGE ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
			// A^C͕͒ҏW֎~
			if (pSekaijuApp->m_bRecording) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				return;
			}
			// bNĂꍇ͕ҏW֎~
			if (pSekaijuDoc->m_bEditLocked) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				return;
			}
			// tH[}bg0̏ꍇ͍ŏ̃gbNȊOs\
			if (lFormat == 0 && m_lCurRow >= 1) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_EDIT_THIS_TRACK_IN_FORMAT0_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃRg[`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_CONTROLCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_CONTROLCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃvO`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_PROGRAMCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_PROGRAMCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃ^C+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_TIMEPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃL[+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_KEYPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃxVeB+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_VELPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// ݂̃Z𑀍\ȏꍇ
			else { // 20091126elseǉ
				// 񉟂̂݃L[{[hJn
				if (m_lCurButtonState == 0x0000) {
					BeginValueUpDown ();
					SetCapture ();
					m_lCurButtonState |= 0x0101;
				}
				// l̑
				if (::GetKeyState (VK_SHIFT) < 0) {
					AddValueOfCurCell (10);
				}
				else {
					AddValueOfCurCell (1);
				}
			}
		}
		break;
	// -L[
	case VK_SUBTRACT:
	case 189:
		// }EXő쒆̏ꍇ͂̑~
		if (m_lCurButtonState & 0x00F0) {
			KillTimer (1);
			ReleaseCapture ();
			EndValueUpDown ();
			m_lCurButtonState &= 0xFF00;
		}
		// CtrlĂꍇ̓Y[_E
		if (GetCapture () == NULL && GetKeyState (VK_CONTROL) < 0) {
			pTrackListFrame->PostMessage (WM_KEYDOWN, nChar, (nFlags << 16) | nRepCnt);
		}
		// ڂl̏ꍇ̂ݒl̉
		else if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTPORT ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTCHANNEL ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTPORT ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTCHANNEL ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_CONTROLCHANGE ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_PROGRAMCHANGE ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
			// A^C͕͒ҏW֎~
			if (pSekaijuApp->m_bRecording) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				return;
			}
			// bNĂꍇ͕ҏW֎~
			if (pSekaijuDoc->m_bEditLocked) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				return;
			}
			// tH[}bg0̏ꍇ͍ŏ̃gbNȊOs\
			if (lFormat == 0 && m_lCurRow >= 1) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_EDIT_THIS_TRACK_IN_FORMAT0_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃRg[`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_CONTROLCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_CONTROLCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃvO`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_PROGRAMCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_PROGRAMCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃ^C+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_TIMEPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃL[+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_KEYPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃxVeB+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_VELPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// ݂̃Z𑀍\ȏꍇ
			else { // 20091126elseǉ
				// 񉟂̂݃L[{[hJn
				if (m_lCurButtonState == 0x0000) {
					BeginValueUpDown ();
					SetCapture ();
					m_lCurButtonState |= 0x0202;
				}
				// l̑
				if (::GetKeyState (VK_SHIFT) < 0) {
					AddValueOfCurCell (-10);
				}
				else {
					AddValueOfCurCell (-1);
				}
			}
		}
		break;
	// DeleteL[ (20090823ǉ)
	case VK_DELETE:
		pTrackListFrame->PostMessage (WM_COMMAND, ID_TRACKLIST_DELETETRACK, NULL);
		break;
	// InsertL[ (20090823ǉ)
	case VK_INSERT:
		// CtrlĂ
		if (GetKeyState (VK_CONTROL) < 0) { 
			pTrackListFrame->PostMessage (WM_COMMAND, ID_TRACKLIST_DUPLICATETRACK, NULL);
		}
		// CtrlĂȂ
		else {
			pTrackListFrame->PostMessage (WM_COMMAND, ID_TRACKLIST_INSERTTRACK, NULL);
		}
		break;
	}
	
	// VZ̕`(20100128:h~̂ߏǉ)
	if (IsTextEditing () == FALSE && nChar != VK_CONTROL && nChar != VK_SHIFT && nChar != VK_MENU) {
		CRect rcNewCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
		rcNewCell -= CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
		rcNewCell.InflateRect (2, 2);
		InvalidateRect (&rcNewCell);
	}

	pSekaijuDoc->m_theCriticalSection.Unlock ();
	::Sleep (0);
}

// L[グ
void CTrackListTrackModeView::OnKeyUp (UINT nChar, UINT nRepCnt, UINT nFlags) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParent ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	pSekaijuDoc->m_theCriticalSection.Lock ();

	switch (nChar) {
	// +L[
	case VK_ADD:
	case 187:
		// L[{[hő쒆̏ꍇ
		if (m_lCurButtonState & 0x0F00) {
			// +L[̂ݒ~
			m_lCurButtonState &= ~0x0101;
			// ͂≽̑sĂȂȂ
			if (m_lCurButtonState == 0x0000) {
				ReleaseCapture ();
				EndValueUpDown ();
				pSekaijuDoc->SetModifiedFlag (TRUE);
				pSekaijuDoc->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
			}
		}
		break;
	// -L[
	case VK_SUBTRACT:
	case 189:
		// L[{[hő쒆̏ꍇ
		if (m_lCurButtonState & 0x0F00) {
			// -L[̂ݒ~
			m_lCurButtonState &= ~0x0202;
			// ͂≽̑sĂȂȂ
			if (m_lCurButtonState == 0x0000) {
				ReleaseCapture ();
				EndValueUpDown ();
				pSekaijuDoc->SetModifiedFlag (TRUE);
				pSekaijuDoc->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
			}
		}
		break;
	}

	pSekaijuDoc->m_theCriticalSection.Unlock ();
	::Sleep (0);
}

// ͎
void CTrackListTrackModeView::OnChar (UINT nChar, UINT nRepCnt, UINT nFlags) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*) GetParent ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();

	// ^͉Ȃ
	if (pSekaijuApp->m_bRecording) {
		::SetCursor (pSekaijuApp->m_hCursorNo);
		return;
	}
	// MIDIf[^bNĂꍇ͉Ȃ
	if (pSekaijuDoc->m_bEditLocked) {
		::SetCursor (pSekaijuApp->m_hCursorNo);
		return;
	}
	
	pSekaijuDoc->m_theCriticalSection.Lock ();

	ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
	long lColumnContent = pTrackListFrame->GetColumnContent (m_lCurColumn);
	if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_TRACKNAME && 32 <= nChar && nChar <= 126 ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTPORT && 48 <= nChar && nChar <= 57 ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTCHANNEL && 48 <= nChar && nChar <= 57 ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTPORT && 48 <= nChar && nChar <= 57 ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTCHANNEL && 48 <= nChar && nChar <= 57 ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_CONTROLCHANGE && 48 <= nChar && nChar <= 57 ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_PROGRAMCHANGE && 48 <= nChar && nChar <= 57 ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS && (48 <= nChar && nChar <= 57 || nChar == '-') ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS && (48 <= nChar && nChar <= 57 || nChar == '-') ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS && (48 <= nChar && nChar <= 57 || nChar == '-')) {
		BeginTextEditing ();
		//m_theTextBox.PostMessage (WM_CHAR, nChar, (nRepCnt << 16) | nFlags);
		m_theTextBox.PostMessage (WM_CHAR, nChar, (nFlags & 0xFFFF0000) | (nRepCnt & 0x0000FFFF));
		// 20080722F̍sWindows2000ΉB
	}
	pSekaijuDoc->m_theCriticalSection.Unlock ();

	::Sleep (0);
}

// }EX{^ꂽ  
void CTrackListTrackModeView::OnLButtonDown (UINT nFlags, CPoint point) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*) GetParent ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();

	pSekaijuDoc->m_theCriticalSection.Lock ();

	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;

	CRect rcClient;
	GetClientRect (&rcClient);
	rcClient += CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
	point += CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());

	long lButtonWidth = 12;//::GetSystemMetrics (SM_CXVSCROLL);
	BOOL bOldTextEditing = FALSE;
	// eLXgҏW̏I
	if (IsTextEditing ()) {
		EndTextEditingOK ();
		pSekaijuDoc->SetModifiedFlag (TRUE);
		bOldTextEditing = TRUE;
	}
	
	// ÂZ̕`
	CRect rcOldCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
	rcOldCell -= CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
	rcOldCell.InflateRect (2, 2);
	InvalidateRect (&rcOldCell);

	// VZ̐ݒ
	if (m_lCurButtonState == 0x0000) {
		long i, j;
		GetCellFromPoint (point, &i, &j);
		if (0 <= i && i < MAXMIDITRACKNUM && 0 <= j && j < TRACKLISTFRAME_NUMCOLUMN) {
			m_lCurRow = i;
			m_lCurColumn = j;
		}
		AutoScrolltoShowCell (m_lCurRow, m_lCurColumn);
		MoveTextBox (m_lCurRow, m_lCurColumn);
	}
	CRect rcNewCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
	
	// {^̉𔻕
	ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
	long lColumnContent = pTrackListFrame->GetColumnContent (m_lCurColumn);
	if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTPORT ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTCHANNEL ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTPORT ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTCHANNEL ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_CONTROLCHANGE ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_PROGRAMCHANGE ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
		// 㖔͉̃{^ꂽꍇ
		if (point.x > rcNewCell.right - lButtonWidth) {
			long lFormat = MIDIData_GetFormat (pMIDIData);
			// ^͉Ȃ
			if (pSekaijuApp->m_bRecording) {
				;
			}
			// MIDIf[^bNĂꍇ͉Ȃ
			else if (pSekaijuDoc->m_bEditLocked) {
				;
			}
			// tH[}bg0̏ꍇ͍ŏ̃gbNȊOs\
			else if (lFormat == 0 && m_lCurRow >= 1) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_EDIT_THIS_TRACK_IN_FORMAT0_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃRg[`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_CONTROLCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_CONTROLCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃvO`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_PROGRAMCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_PROGRAMCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃ^C+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_TIMEPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃL[+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_KEYPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃxVeB+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_VELPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// ݂̃Z𑀍\ȏꍇ
			else {
				// }EXɂ鑀Jnłꍇ
				if (m_lCurButtonState == 0x0000) {
					BeginValueUpDown ();
					// ̃{^ꂽꍇ
					if (point.y < rcNewCell.top + pTrackListFrame->GetRowZoom () / 2) {
						m_lCurButtonState |= 0x0011;
						AddValueOfCurCell (1);
					}
					// ̃{^ꂽꍇ
					else {
						m_lCurButtonState |= 0x0012;
						AddValueOfCurCell (-1);
					}
					m_lCurButtonInterval = 200;
					SetTimer (1, m_lCurButtonInterval, NULL);
					SetCapture ();
				}
				// Ƀ}EX삪ȂĂꍇ
				else if (m_lCurButtonState & 0x00F0) {
					m_lCurButtonState |= 0x0010;
				}
			}
		}
	}

	// VZ̕`
	rcNewCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
	rcNewCell -= CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
	rcNewCell.InflateRect (2, 2);
	InvalidateRect (&rcNewCell);

	pSekaijuDoc->m_theCriticalSection.Unlock ();
	::Sleep (0);

}

// }EXE{^ꂽ  
void CTrackListTrackModeView::OnRButtonDown (UINT nFlags, CPoint point) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*) GetParent ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();

	pSekaijuDoc->m_theCriticalSection.Lock ();
	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;

	CPoint ptMenu (point);
	ClientToScreen (&ptMenu);
	
	CRect rcClient;
	GetClientRect (&rcClient);
	rcClient += CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
	point += CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());

	long lButtonWidth = 12;//::GetSystemMetrics (SM_CXVSCROLL);
	BOOL bOldTextEditing = FALSE;
	// eLXgҏW̏I
	if (IsTextEditing ()) {
		EndTextEditingOK ();
		pSekaijuDoc->SetModifiedFlag (TRUE);
		bOldTextEditing = TRUE;
	}
	
	// ÂZ̕`
	CRect rcOldCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
	rcOldCell -= CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
	rcOldCell.InflateRect (2, 2);
	InvalidateRect (&rcOldCell);
	
	// VZ̐ݒ
	if (m_lCurButtonState == 0x0000) {
		long i, j;
		GetCellFromPoint (point, &i, &j);
		if (0 <= i && i < MAXMIDITRACKNUM && 0 <= j && j < TRACKLISTFRAME_NUMCOLUMN) {
			m_lCurRow = i;
			m_lCurColumn = j;
		}
		MoveTextBox (m_lCurRow, m_lCurColumn);
		AutoScrolltoShowCell (m_lCurRow, m_lCurColumn);
	}
	CRect rcNewCell = GetRectFromCell (m_lCurRow, m_lCurColumn);

	// {^̉𔻕
	ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
	long lColumnContent = pTrackListFrame->GetColumnContent (m_lCurColumn);
	if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTPORT ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTCHANNEL ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTPORT ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTCHANNEL ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_CONTROLCHANGE ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_PROGRAMCHANGE ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
		// 㖔͉̃{^ꂽꍇ
		if (point.x > rcNewCell.right - lButtonWidth) {
			long lFormat = MIDIData_GetFormat (pMIDIData);
			// ^͉Ȃ
			if (pSekaijuApp->m_bRecording) {
				;
			}
			// MIDIf[^bNĂꍇ͉Ȃ
			else if (pSekaijuDoc->m_bEditLocked) {
				;
			}
			// tH[}bg0̏ꍇ͍ŏ̃gbNȊOs\
			else if (lFormat == 0 && m_lCurRow >= 1) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_EDIT_THIS_TRACK_IN_FORMAT0_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃRg[`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_CONTROLCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_CONTROLCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃvO`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_PROGRAMCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_PROGRAMCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃ^C+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_TIMEPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃL[+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_KEYPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃxVeB+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_VELPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// ݂̃Z𑀍\ȏꍇ
			else {
				// }EXɂ鑀Jnłꍇ
				if (m_lCurButtonState == 0x0000) {
					BeginValueUpDown ();
					// ̃{^ꂽꍇ
					if (point.y < rcNewCell.top + pTrackListFrame->GetRowZoom () / 2) {
						m_lCurButtonState |= 0x0021;
						AddValueOfCurCell (10);
					}
					// ̃{^ꂽꍇ
					else {
						m_lCurButtonState |= 0x0022;
						AddValueOfCurCell (-10);
					}
					m_lCurButtonInterval = 200;
					SetTimer (1, m_lCurButtonInterval, NULL);
					SetCapture ();
				}
				// Ƀ}EX삪ȂĂꍇ
				else if (m_lCurButtonState & 0x00F0) {
					m_lCurButtonState |= 0x0020;
				}
			}
		}
		// {^͉ĂȂꍇ
		else {
			long lTrackIndex = pTrackListFrame->YtoRow (point.y);
			pSekaijuDoc->m_lTempTime = pTrackListFrame->XtoTime (point.x);
			pSekaijuDoc->m_pTempTrack = pSekaijuDoc->GetTrack (lTrackIndex);
			pSekaijuDoc->m_pTempEvent = NULL;
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			::Sleep (0);

			CMenu theMenu;
			VERIFY (theMenu.LoadMenu (IDR_POPUPMENU01));
			CMenu* pContextMenu = theMenu.GetSubMenu (0);
			pContextMenu->TrackPopupMenu (TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
				ptMenu.x, ptMenu.y, pTrackListFrame);
			
			pSekaijuDoc->m_theCriticalSection.Lock ();
		}
	}
	// {^̂ȂZ̏ꍇ
	else {
		long lTrackIndex = pTrackListFrame->YtoRow (point.y);
		pSekaijuDoc->m_lTempTime = pTrackListFrame->XtoTime (point.x);
		pSekaijuDoc->m_pTempTrack = pSekaijuDoc->GetTrack (lTrackIndex);
		pSekaijuDoc->m_pTempEvent = NULL;
		pSekaijuDoc->m_theCriticalSection.Unlock ();
		::Sleep (0);
		
		CMenu theMenu;
		VERIFY (theMenu.LoadMenu (IDR_POPUPMENU01));
		CMenu* pContextMenu = theMenu.GetSubMenu (0);
		pContextMenu->TrackPopupMenu (TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
			ptMenu.x, ptMenu.y, pTrackListFrame);
		
		pSekaijuDoc->m_theCriticalSection.Lock ();
	}

	// VZ̕`
	rcNewCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
	rcNewCell -= CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
	rcNewCell.InflateRect (2, 2);
	InvalidateRect (&rcNewCell);

	pSekaijuDoc->m_theCriticalSection.Unlock ();
	::Sleep (0);
}

// }EX{^ꂽƂ
void CTrackListTrackModeView::OnLButtonUp (UINT nFlags, CPoint point) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*) GetParent ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();

	// ^͉Ȃ
	if (pSekaijuApp->m_bRecording) {
		::SetCursor (pSekaijuApp->m_hCursorNo);
		return;
	}
	// MIDIf[^bNĂꍇ͉Ȃ
	if (pSekaijuDoc->m_bEditLocked) {
		::SetCursor (pSekaijuApp->m_hCursorNo);
		return;
	}
	
	point += CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());

	pSekaijuDoc->m_theCriticalSection.Lock ();
	
	// }EXő쒆̏ꍇ̂
	if (m_lCurButtonState & 0x0010) {
		// }EX̏I
		m_lCurButtonState &= ~0x0010;
		// ͂}EXő삳ĂȂꍇ
		if ((m_lCurButtonState & 0x00F0) == 0x0000) {
			EndValueUpDown ();
			m_lCurButtonState = 0x0000;
			KillTimer (1);
			ReleaseCapture ();
			pSekaijuDoc->SetModifiedFlag (TRUE);
			pSekaijuDoc->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		}
	}

	// VZ̕`
	CRect rcNewCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
	rcNewCell -= CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
	rcNewCell.InflateRect (2, 2);
	InvalidateRect (&rcNewCell);

	pSekaijuDoc->m_theCriticalSection.Unlock ();
	::Sleep (0);
}

// }EXE{^ꂽƂ
void CTrackListTrackModeView::OnRButtonUp (UINT nFlags, CPoint point) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*) GetParent ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();

	// ^͉Ȃ
	if (pSekaijuApp->m_bRecording) {
		::SetCursor (pSekaijuApp->m_hCursorNo);
		return;
	}
	// MIDIf[^bNĂꍇ͉Ȃ
	if (pSekaijuDoc->m_bEditLocked) {
		::SetCursor (pSekaijuApp->m_hCursorNo);
		return;
	}

	point += CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
	
	pSekaijuDoc->m_theCriticalSection.Lock ();

	// E}EXő쒆̏ꍇ̂
	if (m_lCurButtonState & 0x0020) {
		// E}EX̏I
		m_lCurButtonState &= ~0x0020;
		// ͂}EXő삳ĂȂꍇ
		if ((m_lCurButtonState & 0x00F0) == 0x0000) {
			EndValueUpDown ();
			m_lCurButtonState = 0x0000;
			KillTimer (1);
			ReleaseCapture ();
			pSekaijuDoc->SetModifiedFlag (TRUE);
			pSekaijuDoc->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		}
	}

	// VZ̕`
	CRect rcNewCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
	rcNewCell -= CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
	rcNewCell.InflateRect (2, 2);
	InvalidateRect (&rcNewCell);

	pSekaijuDoc->m_theCriticalSection.Unlock ();
	::Sleep (0);
}

// }EXꂽƂ
void CTrackListTrackModeView::OnMouseMove (UINT nFlags, CPoint point) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*) GetParent ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();

	// ^͉Ȃ
	if (pSekaijuApp->m_bRecording) {
		::SetCursor (pSekaijuApp->m_hCursorNo);
		return;
	}
	// MIDIf[^bNĂꍇ͉Ȃ
	if (pSekaijuDoc->m_bEditLocked) {
		::SetCursor (pSekaijuApp->m_hCursorNo);
		return;
	}

}

// }EX{^_uNbNꂽƂ
void CTrackListTrackModeView::OnLButtonDblClk (UINT nFlags, CPoint point) {

	CTrackListFrame* pTrackListFrame = (CTrackListFrame*) GetParent ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();

	// ^͉Ȃ
	if (pSekaijuApp->m_bRecording) {
		::SetCursor (pSekaijuApp->m_hCursorNo);
		return;
	}
	// MIDIf[^bNĂꍇ͉Ȃ
	if (pSekaijuDoc->m_bEditLocked) {
		::SetCursor (pSekaijuApp->m_hCursorNo);
		return;
	}
	
	MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;
	long lFormat = MIDIData_GetFormat (pMIDIData);

	long lButtonWidth = 12;//::GetSystemMetrics (SM_CXVSCROLL);
	// OnLButtonDownsAݕҏW̃Z߁AVtH[JXɃZړ
	SendMessage (WM_LBUTTONDOWN, nFlags, ((point.y  & 0x0000FFFF) << 16) | (point.x & 0x0000FFFF));
	if (IsTextEditing () == TRUE) {
		return;
	}
	if (m_lCurButtonState != 0x0000) {
		return;
	}

	pSekaijuDoc->m_theCriticalSection.Lock ();

	CRect rcClient;
	GetClientRect (&rcClient);
	rcClient += CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
	point += CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());

	// VZ̎擾
	long i, j;
	GetCellFromPoint (point, &i, &j);
	if (0 <= i && i < MAXMIDITRACKNUM && 0 <= j && j < TRACKLISTFRAME_NUMCOLUMN) {
		m_lCurRow = i;
		m_lCurColumn = j;
	}
	CRect rcCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
	
	ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
	long lColumnContent = pTrackListFrame->GetColumnContent (m_lCurColumn);
	if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_TRACKNAME ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTPORT ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTCHANNEL ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTPORT ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTCHANNEL ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_CONTROLCHANGE ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_PROGRAMCHANGE ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
		// Z̃{^ȊO̕
		if (point.x < rcCell.right - lButtonWidth) {
			// tH[}bg0̏ꍇ͍ŏ̃gbNȊOs\
			if (lFormat == 0 && m_lCurRow >= 1) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_EDIT_THIS_TRACK_IN_FORMAT0_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃRg[`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_CONTROLCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_CONTROLCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃvO`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_PROGRAMCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_PROGRAMCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃ^C+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_TIMEPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃL[+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_KEYPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃxVeB+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_VELPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// ݂̃Z𑀍\ȏꍇ
			else {
				// eLXgҏW[hɓ˓
				BeginTextEditing ();
			}
		}
	}
	else if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_FORECOLOR ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_BACKCOLOR) {
		// tH[}bg0̏ꍇ͍ŏ̃gbNȊOs\
		if (lFormat == 0 && m_lCurRow >= 1) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_UNABLE_TO_EDIT_THIS_TRACK_IN_FORMAT0_MIDIDATA));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
		}
		// ݂̃Z𑀍\ȏꍇ
		else {
			// J[_CAO\
			if (DoColorEditing () == TRUE) {
				pSekaijuDoc->SetModifiedFlag (TRUE);
				pSekaijuDoc->UpdateAllViews (NULL); // TODO
			}
		}
	}
	else if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_VISIBLE ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_ENABLE ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTON ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTON ||
		(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VIEWMODE) {
		// tH[}bg0̏ꍇ͍ŏ̃gbNȊOs\
		if (lFormat == 0 && m_lCurRow >= 1) {
			pSekaijuDoc->m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_UNABLE_TO_EDIT_THIS_TRACK_IN_FORMAT0_MIDIDATA));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			pSekaijuDoc->m_theCriticalSection.Lock ();
		}
		// ݂̃Z𑀍\ȏꍇ
		else {
			// l̔]
			ToggleValueOfCurCell ();
			pSekaijuDoc->SetModifiedFlag (TRUE);
			pSekaijuDoc->UpdateAllViews (NULL); // TODO
		}
	}

	pSekaijuDoc->m_theCriticalSection.Unlock ();
	::Sleep (0);
}

// }EXE{^_uNbNꂽƂ
void CTrackListTrackModeView::OnRButtonDblClk (UINT nFlags, CPoint point) {

}

// ^C}[
void CTrackListTrackModeView::OnTimer (UINT nIDEvent) {	
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*) GetParent ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	pSekaijuDoc->m_theCriticalSection.Lock ();
	
	if (nIDEvent == 1) {
		// ^C}[̉
		if (m_lCurButtonInterval > 50) {
			KillTimer (1);
			m_lCurButtonInterval = 50;
			SetTimer (1, m_lCurButtonInterval, NULL);
		}
		// {^NbNŉĂꍇ
		if ((m_lCurButtonState & 0x00FF) == 0x0011) {
			AddValueOfCurCell (1);
		}
		// {^NbNŉĂꍇ
		else if ((m_lCurButtonState & 0x00FF) == 0x0012) {
			AddValueOfCurCell (-1);
		}
		// {^ENbNŉĂꍇ
		if ((m_lCurButtonState & 0x00FF) == 0x0021) {
			AddValueOfCurCell (10);
		}
		// {^ENbNŉĂꍇ
		else if ((m_lCurButtonState & 0x00FF) == 0x0022) {
			AddValueOfCurCell (-10);
		}
		// {^NbNŉĂꍇ
		if ((m_lCurButtonState & 0x00FF) == 0x0031) {
			AddValueOfCurCell (10);
		}
		// {^NbNŉĂꍇ
		else if ((m_lCurButtonState & 0x00FF) == 0x0032) {
			AddValueOfCurCell (-10);
		}
	}
	// Z̍ĕ`
	CRect rcNewCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
	rcNewCell -= CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
	rcNewCell.InflateRect (2, 2);
	InvalidateRect (&rcNewCell, FALSE);

	pSekaijuDoc->m_theCriticalSection.Unlock ();
	::Sleep (0);

}

// }EXzC[񂳂ꂽ
void CTrackListTrackModeView::OnMouseWheel40 (UINT nFlags, CPoint point) {
	CTrackListFrame* pTrackListFrame = (CTrackListFrame*)GetParent ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CSekaijuDoc* pSekaijuDoc = GetDocument ();
	long lDelta = (short)HIWORD (nFlags);
	long lFlags = LOWORD (nFlags);
	// tʒüړ
	if (lFlags & MK_CONTROL) {
		if (lDelta > 0 && pSekaijuApp->m_theGeneralOption.m_bInvertCtrlMouseWheel == 0 ||
			lDelta < 0 && pSekaijuApp->m_theGeneralOption.m_bInvertCtrlMouseWheel != 0) {
			pTrackListFrame->PostMessage (WM_COMMAND, ID_CONTROL_PREVMEASURE);
		}
		else {
			pTrackListFrame->PostMessage (WM_COMMAND, ID_CONTROL_NEXTMEASURE);
		}
	}
	// JgZ̒l̑
	else if (GetKeyState (VK_MENU) < 0) {
		// ^͉Ȃ
		if (pSekaijuApp->m_bRecording) {
			::SetCursor (pSekaijuApp->m_hCursorNo);
			return;
		}
		// MIDIf[^bNĂꍇ͉Ȃ
		if (pSekaijuDoc->m_bEditLocked) {
			::SetCursor (pSekaijuApp->m_hCursorNo);
			return;
		}

		pSekaijuDoc->m_theCriticalSection.Lock ();

		MIDIData* pMIDIData = pSekaijuDoc->m_pMIDIData;

		CRect rcClient;
		GetClientRect (&rcClient);
		rcClient += CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
		point += CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());

		// eLXgҏW̏I
		if (IsTextEditing ()) {
			EndTextEditingOK ();
			pSekaijuDoc->SetModifiedFlag (TRUE);
		}
		
		// ÂZ̕`
		CRect rcOldCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
		rcOldCell -= CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
		rcOldCell.InflateRect (2, 2);
		InvalidateRect (&rcOldCell);

		// VZ̐ݒ
		AutoScrolltoShowCell (m_lCurRow, m_lCurColumn);
		MoveTextBox (m_lCurRow, m_lCurColumn);
		CRect rcNewCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
		
		// {^̉𔻕
		ASSERT (0 <= m_lCurColumn && m_lCurColumn < TRACKLISTFRAME_NUMCOLUMN);
		long lColumnContent = pTrackListFrame->GetColumnContent (m_lCurColumn);
		if ((lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTPORT ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_INPUTCHANNEL ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTPORT ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_OUTPUTCHANNEL ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_CONTROLCHANGE ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_PROGRAMCHANGE ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS ||
			(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
			long lFormat = MIDIData_GetFormat (pMIDIData);
			// tH[}bg0̏ꍇ͍ŏ̃gbNȊOs\
			if (lFormat == 0 && m_lCurRow >= 1) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_EDIT_THIS_TRACK_IN_FORMAT0_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃRg[`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_CONTROLCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_CONTROLCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃvO`FW̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == MIDIEVENT_PROGRAMCHANGE) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_INSERT_PROGRAMCHANGE_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃ^C+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_TIMEPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_TIMEPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃL[+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_KEYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_KEYPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// tH[}bg1̏ꍇ͍ŏ̃gbNŃxVeB+̎gps
			else if (lFormat == 1 && m_lCurRow == 0 &&
				(lColumnContent & 0xFFFF) == TRACKLISTFRAME_VELOCITYPLUS) {
				pSekaijuDoc->m_theCriticalSection.Unlock ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_UNABLE_TO_SET_VELPLUS_TO_THE_FIRST_TRACK_IN_FORMAT1_MIDIDATA));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				pSekaijuDoc->m_theCriticalSection.Lock ();
			}
			// ݂̃Z𑀍\ȏꍇ
			else {
				// }EXɂ鑀Jnłꍇ
				if (m_lCurButtonState == 0x0000) {
					long lDeltaValue = GetKeyState (VK_SHIFT) < 0 ? 10 : 1;
					BeginValueUpDown ();
					// 񂵂̏ꍇ
					if (lDelta > 0) {
						AddValueOfCurCell (lDeltaValue);
					}
					// 񂵂̏ꍇ
					else {
						AddValueOfCurCell (-lDeltaValue);
					}
					EndValueUpDown ();
					pSekaijuDoc->SetModifiedFlag (TRUE);
					pSekaijuDoc->UpdateAllViews 
						(NULL, SEKAIJUDOC_MIDIEVENTCHANGED | SEKAIJUDOC_MIDITRACKCHANGED);
				}
			}
		}

		// VZ̕`
		rcNewCell = GetRectFromCell (m_lCurRow, m_lCurColumn);
		rcNewCell -= CSize (pTrackListFrame->GetColumnScrollPos (), pTrackListFrame->GetRowScrollPos ());
		rcNewCell.InflateRect (2, 2);
		InvalidateRect (&rcNewCell);

		pSekaijuDoc->m_theCriticalSection.Unlock ();
		::Sleep (0);
	}
	// ʃXN[
	else {
		long lRowScrollPos = pTrackListFrame->GetRowScrollPos ();
		long lRowZoom = pTrackListFrame->GetRowZoom ();
		lRowScrollPos -= lRowZoom * lDelta / WHEELDELTA;
		pTrackListFrame->SetRowScrollPos (lRowScrollPos);
	}
}
