//******************************************************************************
// MIDIV[PT[\tgwEx
// EhLgNX
// (C)2002-2013 [ՂMIDIՂ낶Ɓ^
//******************************************************************************

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "winver.h"
#include <afxwin.h>
#include <afxext.h>
#include <afxcmn.h>
#include <afxmt.h>
#include "common.h"
#include "..\\..\\MIDIIO\\MIDIIO.h"
#include "..\\..\\MIDIData\\MIDIData.h"
#include "..\\..\\MIDIClock\\MIDIClock.h"
#include "..\\..\\MIDIStatus\\MIDIStatus.h"
#include "..\\..\\MIDIInstrument\\MIDIInstrument.h"
#include "ColorfulComboBox.h"
#include "ColorfulCheckListBox.h"
#include "HistoryRecord.h"
#include "HistoryUnit.h"
#include "SekaijuApp.h"
#include "SekaijuDocTemplate.h"
#include "SekaijuDoc.h"
#include "SekaijuView.h"
#include "SekaijuToolBar.h"
#include "SekaijuStatusBar.h"
#include "MainFrame.h"
#include "ChildFrame.h"
#include "FilePropertyDlg.h"
#include "EditTrackDlg.h"
#include "EditTimeDlg.h"
#include "EditTimeSmpDlg.h"
#include "EditChannelDlg.h"
#include "EditKeyDlg.h"
#include "EditVelocityDlg.h"
#include "EditDurationDlg.h"
#include "EditValueDlg.h"
#include "EditBreakupAndTrillDlg.h"
#include "EditQuantizeDlg.h"
#include "EditBeatScanDlg.h"
#include "EditStrokeDlg.h"
#include "EditInsertMeasureDlg.h"
#include "EditRemoveMeasureDlg.h"
#include "PropertyTempoDlg.h"
#include "PropertyTimeSignatureDlg.h"
#include "PropertyKeySignatureDlg.h"
#include "PropertyMarkerDlg.h"


#include "HistoryRecord.h"
#include "HistoryUnit.h"

#include "TrackListFrame.h"
#include "PianoRollFrame.h"
#include "EventListFrame.h"
#include "MusicalScoreFrame.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE (CSekaijuDoc, CDocument)

// bZ[W}bv
BEGIN_MESSAGE_MAP (CSekaijuDoc, CDocument)
	ON_UPDATE_COMMAND_UI (ID_FILE_SAVE, OnUpdateFileSaveUI)
	ON_UPDATE_COMMAND_UI (ID_FILE_SAVE_AS,OnUpdateFileSaveAsUI)
	ON_COMMAND (ID_FILE_PROPERTY, OnFileProperty)
	ON_UPDATE_COMMAND_UI (ID_FILE_PROPERTY,OnUpdateFilePropertyUI)
	ON_COMMAND (ID_EDIT_UNDO, OnEditUndo)

	ON_UPDATE_COMMAND_UI (ID_EDIT_UNDO, OnUpdateEditUndoUI)
	ON_COMMAND (ID_EDIT_REDO, OnEditRedo)
	ON_UPDATE_COMMAND_UI (ID_EDIT_REDO, OnUpdateEditRedoUI)
	ON_COMMAND (ID_EDIT_INITHISTORY, OnEditInitHistory)
	ON_UPDATE_COMMAND_UI (ID_EDIT_INITHISTORY, OnUpdateEditInitHistoryUI)
	ON_COMMAND (ID_EDIT_CUT, OnEditCut)
	ON_UPDATE_COMMAND_UI (ID_EDIT_CUT, OnUpdateEditCutUI)
	ON_COMMAND (ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI (ID_EDIT_COPY, OnUpdateEditCopyUI)
	ON_COMMAND (ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI (ID_EDIT_PASTE, OnUpdateEditPasteUI)
	ON_COMMAND (ID_EDIT_DELETE, OnEditDelete)
	ON_UPDATE_COMMAND_UI (ID_EDIT_DELETE, OnUpdateEditDeleteUI)
	ON_COMMAND (ID_EDIT_SELECTALL, OnEditSelectAll)
	ON_UPDATE_COMMAND_UI (ID_EDIT_SELECTALL, OnUpdateEditSelectAllUI)
	ON_COMMAND (ID_EDIT_SELECTNONE,OnEditSelectNone)
	ON_UPDATE_COMMAND_UI (ID_EDIT_SELECTNONE, OnUpdateEditSelectNoneUI)
	ON_COMMAND (ID_EDIT_SELECTBEFORE,OnEditSelectBefore)
	ON_UPDATE_COMMAND_UI (ID_EDIT_SELECTBEFORE, OnUpdateEditSelectBeforeUI)
	ON_COMMAND (ID_EDIT_DESELECTBEFORE,OnEditDeselectBefore)
	ON_UPDATE_COMMAND_UI (ID_EDIT_DESELECTBEFORE, OnUpdateEditDeselectBeforeUI)
	ON_COMMAND (ID_EDIT_SELECTAFTER,OnEditSelectAfter)
	ON_UPDATE_COMMAND_UI (ID_EDIT_SELECTAFTER, OnUpdateEditSelectAfterUI)
	ON_COMMAND (ID_EDIT_DESELECTAFTER,OnEditDeselectAfter)
	ON_UPDATE_COMMAND_UI (ID_EDIT_DESELECTAFTER, OnUpdateEditDeselectAfterUI)

	ON_COMMAND (ID_EDIT_TRACK, OnEditTrack)
	ON_UPDATE_COMMAND_UI (ID_EDIT_TRACK, OnUpdateEditTrackUI)
	ON_COMMAND (ID_EDIT_TIME, OnEditTime)
	ON_UPDATE_COMMAND_UI (ID_EDIT_TIME, OnUpdateEditTimeUI)
	ON_COMMAND (ID_EDIT_CHANNEL, OnEditChannel)
	ON_UPDATE_COMMAND_UI (ID_EDIT_CHANNEL, OnUpdateEditChannelUI)
	ON_COMMAND (ID_EDIT_KEY, OnEditKey)
	ON_UPDATE_COMMAND_UI (ID_EDIT_KEY, OnUpdateEditKeyUI)
	ON_COMMAND (ID_EDIT_VELOCITY, OnEditVelocity)
	ON_UPDATE_COMMAND_UI (ID_EDIT_VELOCITY, OnUpdateEditVelocityUI)
	ON_COMMAND (ID_EDIT_DURATION, OnEditDuration)
	ON_UPDATE_COMMAND_UI (ID_EDIT_DURATION, OnUpdateEditDurationUI)
	ON_COMMAND (ID_EDIT_VALUE, OnEditValue)
	ON_UPDATE_COMMAND_UI (ID_EDIT_VALUE, OnUpdateEditValueUI)
	ON_COMMAND (ID_EDIT_QUANTIZE, OnEditQuantize)
	ON_UPDATE_COMMAND_UI (ID_EDIT_QUANTIZE, OnUpdateEditQuantizeUI)
	ON_COMMAND (ID_EDIT_BREAKUPANDTRILL, OnEditBreakupAndTrill)
	ON_UPDATE_COMMAND_UI (ID_EDIT_BREAKUPANDTRILL, OnUpdateEditBreakupAndTrillUI)
	ON_COMMAND (ID_EDIT_BEATSCAN, OnEditBeatScan)
	ON_UPDATE_COMMAND_UI (ID_EDIT_BEATSCAN, OnUpdateEditBeatScanUI)
	ON_COMMAND (ID_EDIT_STROKE, OnEditStroke)
	ON_UPDATE_COMMAND_UI (ID_EDIT_STROKE, OnUpdateEditStrokeUI)

	ON_COMMAND (ID_EDIT_INSERTMEASURE, OnEditInsertMeasure)
	ON_UPDATE_COMMAND_UI (ID_EDIT_INSERTMEASURE, OnUpdateEditInsertMeasureUI)
	ON_COMMAND (ID_EDIT_REMOVEMEASURE, OnEditRemoveMeasure)
	ON_UPDATE_COMMAND_UI (ID_EDIT_REMOVEMEASURE, OnUpdateEditRemoveMeasureUI)

	ON_COMMAND (ID_VIEW_REDRAW, OnViewRedraw)
	ON_COMMAND (ID_VIEW_TRACKLIST, OnViewTrackList)
	ON_COMMAND (ID_VIEW_PIANOROLL, OnViewPianoRoll)
	ON_COMMAND (ID_VIEW_EVENTLIST, OnViewEventList)
	ON_COMMAND (ID_VIEW_MUSICALSCORE, OnViewMusicalScore)

	ON_COMMAND (ID_POPUP_SHOWTRACKLIST, OnPopupShowTrackList)
	ON_UPDATE_COMMAND_UI (ID_POPUP_SHOWTRACKLIST, OnUpdatePopupShowTrackListUI)
	ON_COMMAND (ID_POPUP_SHOWPIANOROLL, OnPopupShowPianoRoll)
	ON_UPDATE_COMMAND_UI (ID_POPUP_SHOWPIANOROLL, OnUpdatePopupShowPianoRollUI)
	ON_COMMAND (ID_POPUP_SHOWEVENTLIST, OnPopupShowEventList)
	ON_UPDATE_COMMAND_UI (ID_POPUP_SHOWEVENTLIST, OnUpdatePopupShowEventListUI)
	ON_COMMAND (ID_POPUP_SHOWMUSICALSCORE, OnPopupShowMusicalScore)
	ON_UPDATE_COMMAND_UI (ID_POPUP_SHOWMUSICALSCORE, OnUpdatePopupShowMusicalScoreUI)
	
	ON_COMMAND (ID_POPUP_TRACKINPUTON, OnPopupTrackInputOn)
	ON_UPDATE_COMMAND_UI (ID_POPUP_TRACKINPUTON, OnUpdatePopupTrackInputOnUI)
	ON_COMMAND (ID_POPUP_TRACKINPUTOFF, OnPopupTrackInputOff)
	ON_UPDATE_COMMAND_UI (ID_POPUP_TRACKINPUTOFF, OnUpdatePopupTrackInputOffUI)
	ON_COMMAND (ID_POPUP_TRACKINPUTALL, OnPopupTrackInputAll)
	ON_UPDATE_COMMAND_UI (ID_POPUP_TRACKINPUTALL, OnUpdatePopupTrackInputAllUI)
	ON_COMMAND (ID_POPUP_TRACKOUTPUTON, OnPopupTrackOutputOn)
	ON_UPDATE_COMMAND_UI (ID_POPUP_TRACKOUTPUTON, OnUpdatePopupTrackOutputOnUI)
	ON_COMMAND (ID_POPUP_TRACKOUTPUTOFF, OnPopupTrackOutputOff)
	ON_UPDATE_COMMAND_UI (ID_POPUP_TRACKOUTPUTOFF, OnUpdatePopupTrackOutputOffUI)
	ON_COMMAND (ID_POPUP_TRACKOUTPUTALL, OnPopupTrackOutputAll)
	ON_UPDATE_COMMAND_UI (ID_POPUP_TRACKOUTPUTALL, OnUpdatePopupTrackOutputAllUI)

	ON_COMMAND (ID_POPUP_CUT, OnPopupCut)
	ON_UPDATE_COMMAND_UI (ID_POPUP_CUT, OnUpdatePopupCutUI)
	ON_COMMAND (ID_POPUP_COPY, OnPopupCopy)
	ON_UPDATE_COMMAND_UI (ID_POPUP_COPY, OnUpdatePopupCopyUI)
	ON_COMMAND (ID_POPUP_PASTE, OnPopupPaste)
	ON_UPDATE_COMMAND_UI (ID_POPUP_PASTE, OnUpdatePopupPasteUI)

	ON_COMMAND (ID_POPUP_INSERTTEMPO, OnPopupInsertTempo)
	ON_UPDATE_COMMAND_UI (ID_POPUP_INSERTTEMPO, OnUpdatePopupInsertTempoUI)
	ON_COMMAND (ID_POPUP_INSERTTIMESIGNATURE, OnPopupInsertTimeSignature)
	ON_UPDATE_COMMAND_UI (ID_POPUP_INSERTTIMESIGNATURE, OnUpdatePopupInsertTimeSignatureUI)
	ON_COMMAND (ID_POPUP_INSERTKEYSIGNATURE, OnPopupInsertKeySignature)
	ON_UPDATE_COMMAND_UI (ID_POPUP_INSERTKEYSIGNATURE, OnUpdatePopupInsertKeySignatureUI)
	ON_COMMAND (ID_POPUP_INSERTMARKER, OnPopupInsertMarker)
	ON_UPDATE_COMMAND_UI (ID_POPUP_INSERTMARKER, OnUpdatePopupInsertMarkerUI)

	ON_COMMAND (ID_POPUP_MODIFYTEMPO, OnPopupModifyTempo)
	ON_UPDATE_COMMAND_UI (ID_POPUP_MODIFYTEMPO, OnUpdatePopupModifyTempoUI)
	ON_COMMAND (ID_POPUP_MODIFYTIMESIGNATURE, OnPopupModifyTimeSignature)
	ON_UPDATE_COMMAND_UI (ID_POPUP_MODIFYTIMESIGNATURE, OnUpdatePopupModifyTimeSignatureUI)
	ON_COMMAND (ID_POPUP_MODIFYKEYSIGNATURE, OnPopupModifyKeySignature)
	ON_UPDATE_COMMAND_UI (ID_POPUP_MODIFYKEYSIGNATURE, OnUpdatePopupModifyKeySignatureUI)
	ON_COMMAND (ID_POPUP_MODIFYMARKER, OnPopupModifyMarker)
	ON_UPDATE_COMMAND_UI (ID_POPUP_MODIFYMARKER, OnUpdatePopupModifyMarkerUI)

	ON_COMMAND (ID_POPUP_DELETETEMPO, OnPopupDeleteTempo)
	ON_UPDATE_COMMAND_UI (ID_POPUP_DELETETEMPO, OnUpdatePopupDeleteTempoUI)
	ON_COMMAND (ID_POPUP_DELETETIMESIGNATURE, OnPopupDeleteTimeSignature)
	ON_UPDATE_COMMAND_UI (ID_POPUP_DELETETIMESIGNATURE, OnUpdatePopupDeleteTimeSignatureUI)
	ON_COMMAND (ID_POPUP_DELETEKEYSIGNATURE, OnPopupDeleteKeySignature)
	ON_UPDATE_COMMAND_UI (ID_POPUP_DELETEKEYSIGNATURE, OnUpdatePopupDeleteKeySignatureUI)
	ON_COMMAND (ID_POPUP_DELETEMARKER, OnPopupDeleteMarker)
	ON_UPDATE_COMMAND_UI (ID_POPUP_DELETEMARKER, OnUpdatePopupDeleteMarkerUI)
	

END_MESSAGE_MAP ()


//------------------------------------------------------------------------------
// \zƔj
//------------------------------------------------------------------------------

// RXgN^
CSekaijuDoc::CSekaijuDoc () {
	m_pMIDIClock = NULL;
	m_pMIDIData = NULL;
	m_lOldTime = 0L;
	m_lNewTime = 0L;
	m_bEditLocked = FALSE;
	m_bSaveLocked = FALSE;
	m_lCurHistoryPosition = 0L;
	m_tmFileOpenTime = 0L;
	m_tmLastAutoSaveTime = 0L;
	m_lTempTime = 0;
	m_pTempTrack = NULL;
	m_pTempEvent = NULL;
	m_pTempTempoEvent = NULL;
	m_pTempTimeSignatureEvent = NULL;
	m_pTempMarkerEvent = NULL;
	m_pTempKeySignatureEvent = NULL;
}

// fXgN^
CSekaijuDoc::~CSekaijuDoc() {
	// NeBJZNṼbN
	m_theCriticalSection.Lock ();
	// ̍폜
	DeleteAllHistoryUnit ();	
	// MIDIf[^̍폜
	if (m_pMIDIData) {
		MIDIData_Delete (m_pMIDIData);
	}
	m_pMIDIData = NULL;
	// MIDINbN̍폜
	if (m_pMIDIClock) {
		MIDIClock_Stop (m_pMIDIClock);
		MIDIClock_Delete (m_pMIDIClock);
	}
	m_pMIDIClock = NULL;
	// AvP[VɋhLgłƂ`B
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	pSekaijuApp->m_pOldDocument = NULL;
	// NeBJZNV̉
	m_theCriticalSection.Unlock ();
	// r[̍XV
	UpdateAllViews (NULL);
}



//------------------------------------------------------------------------------
// I[o[Ch
//------------------------------------------------------------------------------

// hLgVK쐬Ƃ̃I[o[Ch
BOOL CSekaijuDoc::OnNewDocument () {
	if (!CDocument::OnNewDocument()) {
		return FALSE;
	}
	// OnNewDocumentFALSEԂƂ̔eXg
	// TODO:FALSEԂƂłɓ삷悤ɂB
	// return FALSE;

	BeginWaitCursor ();
	CString strMsg;
	// NeBJZNṼbN
	m_theCriticalSection.Lock ();
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	// MIDIf[^̍폜
	if (m_pMIDIData != NULL) {
		MIDIData_Delete (m_pMIDIData);
		m_pMIDIData = NULL;
	}
	// MIDINbN̍폜
	if (m_pMIDIClock != NULL) {
		MIDIClock_Delete (m_pMIDIClock);
		m_pMIDIClock = NULL;
	}
	// VKMIDIf[^̍쐬
	m_pMIDIData = MIDIData_Create (MIDIDATA_FORMAT1, 17, MIDIDATA_TPQNBASE, 120);
	if (m_pMIDIData == NULL) {
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
		VERIFY (strMsg.LoadString (IDS_MIDIDATA_CREATE_FAILED));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return FALSE;
	}
	// egbÑftHg̑ݒ
	long i = 0;
	MIDITrack* pMIDITrack;
	MIDIEvent* pMIDIEvent;
	m_pMIDIData->m_lUser1 = m_lOldTime;
	m_pMIDIData->m_lUser2 = MIDIData_GetFormat (m_pMIDIData) == 1 ? 1 : 0;
	m_pMIDIData->m_lUser3 = 0;
	m_pMIDIData->m_lUserFlag = MIDIDATA_VISIBLE | MIDITRACK_ENABLE;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		MIDITrack_SetInputOn (pMIDITrack, 1);
		MIDITrack_SetInputPort (pMIDITrack, 0);
		MIDITrack_SetInputChannel (pMIDITrack, i == 0 ? - 1 : ((i + 15) % 16));	
		MIDITrack_SetOutputOn (pMIDITrack, 1);
		MIDITrack_SetOutputPort (pMIDITrack, 0);
		MIDITrack_SetOutputChannel (pMIDITrack, i == 0 ? -1 : ((i + 15) % 16));	
		MIDITrack_SetViewMode (pMIDITrack, (i == 10 ? 1 : 0));
		MIDITrack_SetForeColor (pMIDITrack, pSekaijuApp->m_theColorOption.m_lForeColor[i % 8]);
		MIDITrack_SetBackColor (pMIDITrack, 0x00FFFFFF);
		pMIDITrack->m_lUser1 = 0;
		pMIDITrack->m_lUser2 = 0;
		pMIDITrack->m_lUser3 = 0;
		pMIDITrack->m_lUserFlag = MIDITRACK_VISIBLE | MIDITRACK_ENABLE;
		this->AddDefaultEventToTrack (pMIDITrack, i == 0 ? 0x000B : 0x0007, NULL);
		i++;
	}

	// tȌ
	m_pMIDIData->m_lUserFlag |= MIDIDATA_ALIVE;
	m_pMIDIData->m_lUserFlag &= ~MIDIDATA_DEAD;
	m_pMIDIData->m_lUserFlag &= ~MIDIDATA_RESISTEREDASINSERTED;
	m_pMIDIData->m_lUserFlag &= ~MIDIDATA_RESISTEREDASREMOVED;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		pMIDITrack->m_lUserFlag |= MIDITRACK_ALIVE;
		pMIDITrack->m_lUserFlag &= ~MIDITRACK_DEAD;
		pMIDITrack->m_lUserFlag &= ~MIDITRACK_RESISTEREDASINSERTED;
		pMIDITrack->m_lUserFlag &= ~MIDITRACK_RESISTEREDASREMOVED;
		forEachEvent (pMIDITrack, pMIDIEvent) {
			pMIDIEvent->m_lUserFlag |= MIDIEVENT_ALIVE;
			pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_DEAD;
			pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_RESISTEREDASINSERTED;
			pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_RESISTEREDASREMOVED;
		}
	}
	
	long lTimeMode, lTimeResolution;
	MIDIData_GetTimeBase (m_pMIDIData, &lTimeMode, &lTimeResolution);
	// MIDINbN̐
	m_pMIDIClock = MIDIClock_Create (MIDICLOCK_MASTERTPQNBASE, 120, 60000000 / 120);
	if (m_pMIDIClock == NULL) {
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
		VERIFY (strMsg.LoadString (IDS_MIDICLOCK_CREATE_FAILED));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return FALSE;
	}
	// MIDINbÑ^C[hƑxAvP[Vɍ킹(20090625ǉ)
	ApplyAppCurSpeedIndex ();

	// Ԃ̏
	m_lOldTime = 0L;
	m_lNewTime = 0L;
	time (&m_tmFileOpenTime);
	time (&m_tmLastAutoSaveTime);
	m_lCurHistoryPosition = -1;
	// NeBJZNV̉
	m_theCriticalSection.Unlock ();
	// r[̍XV
	UpdateAllViews (NULL, 0xFFFFFFFF);
	EndWaitCursor ();
	::Sleep (0);
	return TRUE;
}

// hLgJ̃I[o[Ch
BOOL CSekaijuDoc::OnOpenDocument (LPCTSTR lpszPathName) {
	BeginWaitCursor ();
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	// NeBJZNṼbN
	m_theCriticalSection.Lock ();
	// MIDIData͂͂ȂA΍폜B
	if (m_pMIDIData) {
		MIDIData_Delete (m_pMIDIData);
		m_pMIDIData = NULL;
	}
	// MIDIClock͂͂ȂA΍폜B
	if (m_pMIDIClock) {
		MIDIClock_Delete (m_pMIDIClock);
		m_pMIDIClock = NULL;
	}
	// AvP[VIuWFNgւ̃|C^擾
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	// MIDIf[^̓ǂݍ
	CString strPathName = lpszPathName;
	CString strExt = strPathName.Right (4);
	// EV[PXt@C(*.skj)̏ꍇ
	if (strExt.CompareNoCase (_T(".skj")) == 0) {
		m_pMIDIData = MIDIData_LoadFromBinary (lpszPathName);
		if (m_pMIDIData == NULL) {
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			CString strFormat;
			VERIFY (strFormat.LoadString (IDS_S_N_FILE_LOAD_FAILED));
			CString strMsg;
			strMsg.Format (strFormat, lpszPathName);
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			return FALSE;
		}
		// tȌ
		m_pMIDIData->m_lUser1 = m_lOldTime;
		m_pMIDIData->m_lUser2 = MIDIData_GetFormat (m_pMIDIData) == 1 ? 1 : 0;
		m_pMIDIData->m_lUser3 = 0;
		m_pMIDIData->m_lUserFlag |= MIDIDATA_VISIBLE | MIDITRACK_ENABLE;
		m_pMIDIData->m_lUserFlag |= MIDIDATA_ALIVE;
		m_pMIDIData->m_lUserFlag &= ~MIDIDATA_DEAD;
		m_pMIDIData->m_lUserFlag &= ~MIDIDATA_RESISTEREDASINSERTED;
		m_pMIDIData->m_lUserFlag &= ~MIDIDATA_RESISTEREDASREMOVED;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			pMIDITrack->m_lUserFlag |= MIDITRACK_ALIVE;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_DEAD;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_RESISTEREDASINSERTED;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_RESISTEREDASREMOVED;
			forEachEvent (pMIDITrack, pMIDIEvent) {
				pMIDIEvent->m_lUserFlag |= MIDIEVENT_ALIVE;
				pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_DEAD;
				pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_RESISTEREDASINSERTED;
				pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_RESISTEREDASREMOVED;
			}
		}
	}
	// CherryV[PXt@C̏ꍇ(*.chy)̏ꍇ
	else if (strExt.CompareNoCase (_T(".chy")) == 0) {
		m_pMIDIData = MIDIData_LoadFromCherry (lpszPathName);
		if (m_pMIDIData == NULL) {
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			CString strFormat;
			VERIFY (strFormat.LoadString (IDS_S_N_FILE_LOAD_FAILED));
			CString strMsg;
			strMsg.Format (strFormat, lpszPathName);
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			return FALSE;
		}
		// egbÑftHg̑ݒ
		long i = 0;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDITrack_SetForeColor (pMIDITrack, pSekaijuApp->m_theColorOption.m_lForeColor[i % 8]);
			pMIDITrack->m_lUser1 = 0;
			pMIDITrack->m_lUser2 = 0;
			pMIDITrack->m_lUser3 = 0;
			pMIDITrack->m_lUserFlag = MIDITRACK_VISIBLE | MIDITRACK_ENABLE;
			i++;
		}
		// tȌ
		m_pMIDIData->m_lUser1 = m_lOldTime;
		m_pMIDIData->m_lUser2 = MIDIData_GetFormat (m_pMIDIData) == 1 ? 1 : 0;
		m_pMIDIData->m_lUser3 = 0;
		m_pMIDIData->m_lUserFlag |= MIDIDATA_VISIBLE | MIDITRACK_ENABLE;
		m_pMIDIData->m_lUserFlag |= MIDIDATA_ALIVE;
		m_pMIDIData->m_lUserFlag &= ~MIDIDATA_DEAD;
		m_pMIDIData->m_lUserFlag &= ~MIDIDATA_RESISTEREDASINSERTED;
		m_pMIDIData->m_lUserFlag &= ~MIDIDATA_RESISTEREDASREMOVED;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			pMIDITrack->m_lUserFlag |= MIDITRACK_ALIVE;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_DEAD;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_RESISTEREDASINSERTED;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_RESISTEREDASREMOVED;
			forEachEvent (pMIDITrack, pMIDIEvent) {
				pMIDIEvent->m_lUserFlag |= MIDIEVENT_ALIVE;
				pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_DEAD;
				pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_RESISTEREDASINSERTED;
				pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_RESISTEREDASREMOVED;
			}
		}
	}
	// X^_[hMIDIt@C(*.mid)̏ꍇ
	else if (strExt.CompareNoCase (_T(".mid")) == 0 ||
		strExt.CompareNoCase (_T(".vsq")) == 0) {
		m_pMIDIData = MIDIData_LoadFromSMF (lpszPathName);
		if (m_pMIDIData == NULL) {
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			CString strFormat;
			VERIFY (strFormat.LoadString (IDS_S_N_FILE_LOAD_FAILED));
			CString strMsg;
			strMsg.Format (strFormat, lpszPathName);
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			return FALSE;
		}
		// tH[}bg0MIDIf[^̏ꍇAtH[}bg1ɕϊB
		if (MIDIData_GetFormat (m_pMIDIData) == 0) {
			m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_THIS_MIDIDATA_IS_FORMAT0_N_CONVERT_TO_FORMAT1));
			long lRet = AfxMessageBox (strMsg, MB_ICONQUESTION | MB_YESNO);
			m_theCriticalSection.Lock ();
			if (lRet == IDYES) {
				VERIFY (MIDIData_SetFormat (m_pMIDIData, 1));
			}
		}
		// TPQNx[Xŕ\961TPQNȏ̏ꍇA960TPQNɏCB
		if (MIDIData_GetTimeMode (m_pMIDIData) == MIDIDATA_TPQNBASE &&
			MIDIData_GetTimeResolution (m_pMIDIData) > 960) {
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			CString strFormat;
			VERIFY (strFormat.LoadString (IDS_THIS_MIDIDATA_TIMERESOLUTION_IS_TOO_HIGH_D_N_MODIFY_TO_960));
			CString strMsg;
			strMsg.Format (strFormat, MIDIData_GetTimeResolution (m_pMIDIData));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION | MB_OK);
			m_theCriticalSection.Lock ();
			VERIFY (MIDIData_SetTimeBase (m_pMIDIData, MIDIDATA_TPQNBASE, 960));
		}
		// ̓|[gԍEo̓|[gԍ̒l0x00`0x0F͈̔͂ɏCB
		forEachTrack (m_pMIDIData, pMIDITrack) {
			if (pMIDITrack->m_lInputPort >= 16 || pMIDITrack->m_lOutputPort >= 16) {
				pMIDITrack->m_lInputPort = 0;
				pMIDITrack->m_lOutputPort = 0;
			}
		}
		// egbÑftHg̑ݒ
		long i = 0;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDITrack_SetForeColor (pMIDITrack, pSekaijuApp->m_theColorOption.m_lForeColor[i % 8]);
			pMIDITrack->m_lUser1 = 0;
			pMIDITrack->m_lUser2 = 0;
			pMIDITrack->m_lUser3 = 0;
			pMIDITrack->m_lUserFlag = MIDITRACK_VISIBLE | MIDITRACK_ENABLE;
			i++;
		}
		// m[gCxǧ
		forEachTrack (m_pMIDIData, pMIDITrack) {
			forEachEvent (pMIDITrack, pMIDIEvent) {
				if (MIDIEvent_IsNoteOn (pMIDIEvent)) {
					MIDIEvent_Combine (pMIDIEvent);
				}
			}
		}
		// tȌ
		m_pMIDIData->m_lUser1 = m_lOldTime;
		m_pMIDIData->m_lUser2 = MIDIData_GetFormat (m_pMIDIData) == 1 ? 1 : 0;
		m_pMIDIData->m_lUser3 = 0;
		m_pMIDIData->m_lUserFlag |= MIDIDATA_VISIBLE | MIDITRACK_ENABLE;
		m_pMIDIData->m_lUserFlag |= MIDIDATA_ALIVE;
		m_pMIDIData->m_lUserFlag &= ~MIDIDATA_DEAD;
		m_pMIDIData->m_lUserFlag &= ~MIDIDATA_RESISTEREDASINSERTED;
		m_pMIDIData->m_lUserFlag &= ~MIDIDATA_RESISTEREDASREMOVED;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			pMIDITrack->m_lUserFlag |= MIDITRACK_ALIVE;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_DEAD;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_RESISTEREDASINSERTED;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_RESISTEREDASREMOVED;
			forEachEvent (pMIDITrack, pMIDIEvent) {
				pMIDIEvent->m_lUserFlag |= MIDIEVENT_ALIVE;
				pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_DEAD;
				pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_RESISTEREDASINSERTED;
				pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_RESISTEREDASREMOVED;
			}
		}
	}
	// MIDICSVt@C(*.csv)̏ꍇ
	else if (strExt.CompareNoCase (_T(".csv")) == 0) {
		m_pMIDIData = MIDIData_LoadFromMIDICSV (lpszPathName);
		if (m_pMIDIData == NULL) {
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			CString strFormat;
			VERIFY (strFormat.LoadString (IDS_S_N_FILE_LOAD_FAILED));
			CString strMsg;
			strMsg.Format (strFormat, lpszPathName);
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			return FALSE;
		}
		// tH[}bg0MIDIf[^̏ꍇAtH[}bg1ɕϊB
		if (MIDIData_GetFormat (m_pMIDIData) == 0) {
			m_theCriticalSection.Unlock ();
			CString strMsg;
			VERIFY (strMsg.LoadString (IDS_THIS_MIDIDATA_IS_FORMAT0_N_CONVERT_TO_FORMAT1));
			long lRet = AfxMessageBox (strMsg, MB_ICONQUESTION | MB_YESNO);
			m_theCriticalSection.Lock ();
			if (lRet == IDYES) {
				VERIFY (MIDIData_SetFormat (m_pMIDIData, 1));
			}
		}
		// TPQNx[Xŕ\961TPQNȏ̏ꍇA960TPQNɏCB
		if (MIDIData_GetTimeMode (m_pMIDIData) == MIDIDATA_TPQNBASE &&
			MIDIData_GetTimeResolution (m_pMIDIData) > 960) {
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			CString strFormat;
			VERIFY (strFormat.LoadString (IDS_THIS_MIDIDATA_TIMERESOLUTION_IS_TOO_HIGH_D_N_MODIFY_TO_960));
			CString strMsg;
			strMsg.Format (strFormat, MIDIData_GetTimeResolution (m_pMIDIData));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION | MB_OK);
			m_theCriticalSection.Lock ();
			VERIFY (MIDIData_SetTimeBase (m_pMIDIData, MIDIDATA_TPQNBASE, 960));
		}
		// ̓|[gԍEo̓|[gԍ̒l0x00`0x0F͈̔͂ɏCB
		forEachTrack (m_pMIDIData, pMIDITrack) {
			if (pMIDITrack->m_lInputPort >= 16 || pMIDITrack->m_lOutputPort >= 16) {
				pMIDITrack->m_lInputPort = 0;
				pMIDITrack->m_lOutputPort = 0;
			}
		}
		// egbÑftHg̑ݒ
		long i = 0;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDITrack_SetForeColor (pMIDITrack, pSekaijuApp->m_theColorOption.m_lForeColor[i % 8]);
			pMIDITrack->m_lUser1 = 0;
			pMIDITrack->m_lUser2 = 0;
			pMIDITrack->m_lUser3 = 0;
			pMIDITrack->m_lUserFlag = MIDITRACK_VISIBLE | MIDITRACK_ENABLE;
			i++;
		}
		// m[gCxǧ
		forEachTrack (m_pMIDIData, pMIDITrack) {
			forEachEvent (pMIDITrack, pMIDIEvent) {
				if (MIDIEvent_IsNoteOn (pMIDIEvent)) {
					MIDIEvent_Combine (pMIDIEvent);
				}
			}
		}
		// tȌ
		m_pMIDIData->m_lUser1 = m_lOldTime;
		m_pMIDIData->m_lUser2 = MIDIData_GetFormat (m_pMIDIData) == 1 ? 1 : 0;
		m_pMIDIData->m_lUser3 = 0;
		m_pMIDIData->m_lUserFlag |= MIDIDATA_VISIBLE | MIDITRACK_ENABLE;
		m_pMIDIData->m_lUserFlag |= MIDIDATA_ALIVE;
		m_pMIDIData->m_lUserFlag &= ~MIDIDATA_DEAD;
		m_pMIDIData->m_lUserFlag &= ~MIDIDATA_RESISTEREDASINSERTED;
		m_pMIDIData->m_lUserFlag &= ~MIDIDATA_RESISTEREDASREMOVED;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			pMIDITrack->m_lUserFlag |= MIDITRACK_ALIVE;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_DEAD;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_RESISTEREDASINSERTED;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_RESISTEREDASREMOVED;
			forEachEvent (pMIDITrack, pMIDIEvent) {
				pMIDIEvent->m_lUserFlag |= MIDIEVENT_ALIVE;
				pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_DEAD;
				pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_RESISTEREDASINSERTED;
				pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_RESISTEREDASREMOVED;
			}
		}
	}
	// `̃tH[}bg̏ꍇ
	else {
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		CString strFormat;
		VERIFY (strFormat.LoadString (IDS_S_N_INVALID_EXT_N_FILE_LOAD_FAILED));
		CString strMsg;
		strMsg.Format (strFormat, lpszPathName);
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return FALSE;
	}

	long lTimeMode, lTimeResolution;
	MIDIData_GetTimeBase (m_pMIDIData, &lTimeMode, &lTimeResolution);
	// MIDINbN̐
	m_pMIDIClock = MIDIClock_Create (lTimeMode, lTimeResolution, 60000000 / 120);
	if (m_pMIDIClock == NULL) {
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		CString strMsg;
		VERIFY (strMsg.LoadString (IDS_MIDICLOCK_CREATE_FAILED));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return FALSE;
	}
	// MIDINbÑ^C[hƑxAvP[Vɍ킹(20090625ǉ)
	ApplyAppCurSpeedIndex ();

	// Ԃ̏
	m_lOldTime = 0L;
	m_lNewTime = 0L;
	time (&m_tmFileOpenTime);
	time (&m_tmLastAutoSaveTime);
	m_lCurHistoryPosition = -1;

	// tH[}bg1̏ꍇMIDIf[^̐`FbN(1)(20100128ǉ)
	if (MIDIData_GetFormat (m_pMIDIData) == 1) {
		long lNumErrorEvent = 0;
		CPtrArray theErrorEventArray;
		// ŏ̃gbNMIDI`lCxgĂȂ`FbN
		pMIDITrack = MIDIData_GetFirstTrack (m_pMIDIData);
		if (pMIDITrack) {
			forEachEvent (pMIDITrack, pMIDIEvent) {
				if (MIDIEvent_IsMIDIEvent (pMIDIEvent)) {
					lNumErrorEvent++;
					if (pMIDIEvent->m_pPrevCombinedEvent == NULL) {
						theErrorEventArray.Add (pMIDIEvent);
					}
				}
			}
		}
		// ŏ̃gbNMIDI`lCxgĂꍇ
		if (lNumErrorEvent > 0) {
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			CString strFormat;
			VERIFY (strFormat.LoadString (IDS_D_MIDICHANNELEVENTS_ARE_IN_THE_FIRST_TRACK_ARE_YOU_SURE_TO_REPAIR_THEM));
			CString strMsg;
			strMsg.Format (strFormat, lNumErrorEvent);
			long lRet = AfxMessageBox (strMsg, MB_ICONQUESTION | MB_YESNO);
			BeginWaitCursor ();
			m_theCriticalSection.Lock ();
			// ُMIDI`lCxg𑼂̃gbNɈړ
			if (lRet == IDYES) {
				long i = 0;
				long j = 0;
				MIDITrack* pNewTrack[16] = {NULL};
				for (i = 0; i < 16; i++) {
					VERIFY (pNewTrack[i] = MIDITrack_Create ());
				}
				for (j = 0; j < theErrorEventArray.GetSize (); j++) {
					MIDIEvent* pErrorEvent =  (MIDIEvent*)(theErrorEventArray.GetAt (j));
					VERIFY (MIDITrack_RemoveEvent (pMIDITrack, pErrorEvent));
					long lChannel = MIDIEvent_GetChannel (pErrorEvent);
					if (0 <= lChannel && lChannel < 16) {
						VERIFY (MIDITrack_InsertEvent (pNewTrack[lChannel], pErrorEvent));
					}
				}
				MIDITrack* pPrevTrack = MIDIData_GetFirstTrack (m_pMIDIData);
				for (i = 0; i < 16; i++) {
					MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pNewTrack[i]);
					if (pLastEvent) {
						if (!MIDIEvent_IsEndofTrack (pLastEvent)) {
							long lLastTime = MIDIEvent_GetTime (pLastEvent);
							VERIFY (MIDITrack_InsertEndofTrack (pNewTrack[i], lLastTime));
						}
						VERIFY (MIDITrack_SetForeColor (pNewTrack[i], pSekaijuApp->m_theColorOption.m_lForeColor[i % 8]));
						VERIFY (MIDITrack_SetInputPort (pNewTrack[i], 0)); // 20120109ǉ
						VERIFY (MIDITrack_SetInputChannel (pNewTrack[i], i)); // 20120109ǉ
						VERIFY (MIDITrack_SetOutputPort (pNewTrack[i], 0)); // 20120109ǉ
						VERIFY (MIDITrack_SetOutputChannel (pNewTrack[i], i)); // 20120109ǉ
						pNewTrack[i]->m_lUser1 = 0;
						pNewTrack[i]->m_lUser2 = 0;
						pNewTrack[i]->m_lUser3 = 0;
						pNewTrack[i]->m_lUserFlag = MIDITRACK_VISIBLE | MIDITRACK_ENABLE;
						VERIFY (MIDIData_InsertTrackAfter (m_pMIDIData, pNewTrack[i], pPrevTrack));
						pPrevTrack = pNewTrack[i];
					}
				}
				VERIFY (MIDITrack_SetInputPort (pMIDITrack, 0)); // 20120109ǉ
				VERIFY (MIDITrack_SetInputChannel (pMIDITrack, -1)); // 20120109ǉ
				VERIFY (MIDITrack_SetOutputPort (pMIDITrack, 0)); // 20120109ǉ
				VERIFY (MIDITrack_SetOutputChannel (pMIDITrack, -1)); // 20120109ǉ
			}
			// ُȂ܂ܓǂݍޏꍇAҏWEۑƂsƂ
			else {
				m_bEditLocked = TRUE;
				m_bSaveLocked = TRUE;
				m_theCriticalSection.Unlock ();
				EndWaitCursor ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_THIS_MIDIDATA_CANT_BE_EDITED_OR_SAVED_BECAUSE_IT_IS_ABNORMAL));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				BeginWaitCursor ();
				m_theCriticalSection.Lock ();
			}
		}
	}

	// tH[}bg1̏ꍇMIDIf[^̐`FbN(2)(20100128ǉ)
	if (MIDIData_GetFormat (m_pMIDIData) == 1) {
		long i = 0;
		long lNumErrorEvent = 0;
		CPtrArray theErrorEventArray;
		// 2Ԗڈȍ~̃gbNɃe|ESMPTEItZbgEqLELCxgĂȂ`FbN
		forEachTrack (m_pMIDIData, pMIDITrack) {
			if (i >= 1) {
				forEachEvent (pMIDITrack, pMIDIEvent) {
					if (MIDIEvent_IsTempo (pMIDIEvent) ||
						MIDIEvent_IsSMPTEOffset (pMIDIEvent) ||
						MIDIEvent_IsTimeSignature (pMIDIEvent) ||
						MIDIEvent_IsKeySignature (pMIDIEvent)) {
						lNumErrorEvent++;
						if (pMIDIEvent->m_pPrevCombinedEvent == NULL) {
							theErrorEventArray.Add (pMIDIEvent);
						}
					}
				}
			}
			i++;
		}
		// 2Ԗڈȍ~̃gbNɃe|ESMPTEItZbgEqLELCxgĂꍇ
		if (lNumErrorEvent > 0) {
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			CString strFormat;
			VERIFY (strFormat.LoadString (IDS_D_TEMPOEVENTS_ARE_IN_THE_SECOND_TRACK_ARE_YOU_SURE_TO_REPAIR_THEM));
			CString strMsg;
			strMsg.Format (strFormat, lNumErrorEvent);
			long lRet = AfxMessageBox (strMsg, MB_ICONQUESTION | MB_YESNO);
			BeginWaitCursor ();
			m_theCriticalSection.Lock ();
			// ُMIDI`lCxg𑼂̃gbNɈړ
			if (lRet == IDYES) {
				long j = 0;
				MIDITrack* pMIDITrack = MIDIData_GetFirstTrack (m_pMIDIData);
				for (j = 0; j < theErrorEventArray.GetSize (); j++) {
					MIDIEvent* pErrorEvent = (MIDIEvent*)(theErrorEventArray.GetAt (j));
					MIDITrack* pErrorTrack = (MIDITrack*)MIDIEvent_GetParent (pErrorEvent);
					VERIFY (MIDITrack_RemoveEvent (pErrorTrack, pErrorEvent));
					VERIFY (MIDITrack_InsertEvent (pMIDITrack, pErrorEvent));
				}
			}
			// ُȂ܂ܓǂݍޏꍇAҏWEۑƂsƂ
			else {
				m_bEditLocked = TRUE;
				m_bSaveLocked = TRUE;
				m_theCriticalSection.Unlock ();
				EndWaitCursor ();
				CString strMsg;
				VERIFY (strMsg.LoadString (IDS_THIS_MIDIDATA_CANT_BE_EDITED_OR_SAVED_BECAUSE_IT_IS_ABNORMAL));
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				BeginWaitCursor ();
				m_theCriticalSection.Lock ();
			}
		}
	}

	// r[̍XV
	UpdateAllViews (NULL, 0xFFFFFFFF);

	// ŌɊJt@C̍XV
	pSekaijuApp->m_strLastOpenFileName[0] = lpszPathName;

	// tJn
	if (pSekaijuApp->m_theGeneralOption.m_bOpenPlay == TRUE &&
		pSekaijuApp->m_bPlaying == FALSE) {
		AfxGetMainWnd ()->PostMessage (WM_COMMAND, ID_CONTROL_PLAY, 0);
	}
	
	// NeBJZNV̉
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	::Sleep (0);
	return TRUE;
}

// hLgۑƂ̃I[o[Ch
BOOL CSekaijuDoc::OnSaveDocument (LPCTSTR lpszPathName) {
	BeginWaitCursor ();
	CString strPathName (lpszPathName);
	CString strExt = strPathName.Right (4);
	CString strMsg1;
	CString strMsg2;
	long lRet = 0;

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	m_theCriticalSection.Lock ();
	// ^̏ꍇ͘^~ 
	if (pSekaijuApp->m_bRecording) {
		pSekaijuApp->StopRecording (this);
	}

	if (m_bSaveLocked) {
		return FALSE;
	}


	// EV[PXt@C(*.skj)̏ꍇ
	if (strExt.CompareNoCase (_T(".skj")) == 0) {
		lRet = MIDIData_SaveAsBinary (m_pMIDIData, lpszPathName);
		if (lRet == 0) {
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			::Sleep (0);
			VERIFY (strMsg1.LoadString (IDS_S_N_MIDIDATA_SAVE_FAILED));
			strMsg2.Format (strMsg1, lpszPathName);
			AfxMessageBox (strMsg2, MB_ICONEXCLAMATION);
			return FALSE;
		}
	}
	// CherryV[PXt@C(*.chy)̏ꍇ
	else if (strExt.CompareNoCase (_T(".chy")) == 0) {
		lRet = MIDIData_SaveAsCherry (m_pMIDIData, lpszPathName);
		if (lRet == 0) {
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			::Sleep (0);
			VERIFY (strMsg1.LoadString (IDS_S_N_MIDIDATA_SAVE_FAILED));
			strMsg2.Format (strMsg1, lpszPathName);
			AfxMessageBox (strMsg2, MB_ICONEXCLAMATION);
			return FALSE;
		}
	}
	// X^_[hMIDIt@C(*.mid)̏ꍇ
	else if (strExt.CompareNoCase (_T(".mid")) == 0 ||
		strExt.CompareNoCase (_T(".vsq")) == 0) {
		// MIDICxg̃`l`FbN
		long lCount = 0;
		MIDITrack* pMIDITrack;
		MIDIEvent* pMIDIEvent;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			long lOutputChannel = MIDITrack_GetOutputChannel (pMIDITrack);
			// o͐gbNԍ1`16̂ꂩɎw肳ĂȂ
			if (0 <= lOutputChannel && lOutputChannel < 16) {
				forEachEvent (pMIDITrack, pMIDIEvent) {
					if (MIDIEvent_IsMIDIEvent (pMIDIEvent)) {
						long lChannel = MIDIEvent_GetChannel (pMIDIEvent);
						if (lOutputChannel != lChannel) {
							lCount++;
						}
					}
				}
			}
		}
		if (lCount > 0) {
			VERIFY (strMsg1.LoadString (IDS_D_MIDIEVENTS_CHANNEL_IS_CONFLICTED_N_CONVERT_TO_MIDITRACKS_CHANNEL));
			strMsg2.Format (strMsg1, lCount);
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			lRet = AfxMessageBox (strMsg2, MB_ICONINFORMATION | MB_YESNO);
			BeginWaitCursor ();
			m_theCriticalSection.Lock ();
			if (lRet == IDYES) {
				MIDIEvent* pCloneEvent = NULL;
				CHistoryUnit* pCurHistoryUnit = NULL;
				CString strHistoryName;
				VERIFY (strHistoryName.LoadString (IDS_MODIFY_MIDICHANNEL));
				VERIFY (this->AddHistoryUnit (strHistoryName));
				VERIFY (pCurHistoryUnit = GetCurHistoryUnit ());
				forEachTrack (m_pMIDIData, pMIDITrack) {
					long lOutputChannel = MIDITrack_GetOutputChannel (pMIDITrack);
					// o͐gbNԍ1`16̂ꂩɎw肳ĂȂ
					if (0 <= lOutputChannel && lOutputChannel < 16) {
						forEachEvent (pMIDITrack, pMIDIEvent) {
							// MIDI`lCxgőOɔ񌋍CxgȂ
							if (MIDIEvent_IsMIDIEvent (pMIDIEvent) && 
								pMIDIEvent->m_pPrevCombinedEvent == NULL) {
								// gbN̏o̓`lMIDI`lقȂĂȂ
								if (MIDIEvent_GetChannel (pMIDIEvent) != lOutputChannel) {
									VERIFY (pCurHistoryUnit->AddHistoryRecord 
										(HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
									pCloneEvent = ReplaceMIDIEvent (pMIDIEvent);
									MIDIEvent_SetChannel (pCloneEvent, lOutputChannel);
									VERIFY (pCurHistoryUnit->AddHistoryRecord 
										(HISTORYRECORD_INSERTEVENT, pCloneEvent));
									pMIDIEvent = pCloneEvent;
								}
							}
						}
					}
				}
			}
		}
		// m[gCxg̒>0ł邱Ƃ̃`FbN
		lCount = 0;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			forEachEvent (pMIDITrack, pMIDIEvent) {
				if (MIDIEvent_IsNoteOn (pMIDIEvent) && MIDIEvent_IsNote (pMIDIEvent)) {
					long lDuration = MIDIEvent_GetDuration (pMIDIEvent);
					if (lDuration <= 0) {
						lCount++;
					}
				}
			}
		}
		if (lCount > 0) {
			VERIFY (strMsg1.LoadString (IDS_D_MIDIEVENTS_DURATION_IS_LESS_THAN_0_N_DELETE_THESE_MIDIEVENTS));
			strMsg2.Format (strMsg1,lCount);
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			lRet = AfxMessageBox (strMsg2, MB_ICONINFORMATION | MB_YESNO);
			BeginWaitCursor ();
			m_theCriticalSection.Lock ();
			if (lRet == IDYES) {
				CHistoryUnit* pCurHistoryUnit = NULL;
				CString strHistoryName;
				VERIFY (strHistoryName.LoadString (IDS_DELETE_NOTEEVENT));
				VERIFY (this->AddHistoryUnit (strHistoryName));
				VERIFY (pCurHistoryUnit = GetCurHistoryUnit ());
				forEachTrack (m_pMIDIData, pMIDITrack) {
					CPtrArray theEventArray;
					theEventArray.RemoveAll ();
					forEachEvent (pMIDITrack, pMIDIEvent) {
						if (MIDIEvent_IsNoteOn (pMIDIEvent) && 
							MIDIEvent_IsNote (pMIDIEvent)) {
							long lDuration = MIDIEvent_GetDuration (pMIDIEvent);
							if (lDuration <= 0) {
								theEventArray.Add (pMIDIEvent);
							}
						}
					}
					long j;
					for (j = 0; j < theEventArray.GetSize (); j++) {
						pMIDIEvent = (MIDIEvent*)theEventArray.GetAt (j);
						VERIFY (pCurHistoryUnit->AddHistoryRecord
							(HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						MIDITrack_RemoveEvent (pMIDITrack, pMIDIEvent);
					}
				}
			}
		}
		// gbN̍Ōł͂ȂGhIugbNCxg̃`FbN
		lCount = 0;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			forEachEvent (pMIDITrack, pMIDIEvent) {
				if (MIDIEvent_IsEndofTrack (pMIDIEvent) && pMIDIEvent != pLastEvent) {
					lCount++;
				}
			}
		}
		if (lCount > 0) {
			VERIFY (strMsg1.LoadString (IDS_D_ENDOFTRACKEVENT_IS_NOT_LAST_PLACE_N_DELETE_THESE_ENDOFTRACKEVENTS));
			strMsg2.Format (strMsg1, lCount);
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			lRet = AfxMessageBox (strMsg2, MB_ICONINFORMATION | MB_YESNO);
			BeginWaitCursor ();
			m_theCriticalSection.Lock ();
			if (lRet == IDYES) {
				CHistoryUnit* pCurHistoryUnit = NULL;
				CString strHistoryName;
				VERIFY (strHistoryName.LoadString (IDS_DELETE_ENDOFTRACKEVENT));
				VERIFY (this->AddHistoryUnit (strHistoryName));
				VERIFY (pCurHistoryUnit = GetCurHistoryUnit ());
				forEachTrack (m_pMIDIData, pMIDITrack) {
					MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
					forEachEvent (pMIDITrack, pMIDIEvent) {
						if (MIDIEvent_IsEndofTrack (pMIDIEvent) && pMIDIEvent != pLastEvent) {
							MIDIEvent* pTempEvent = MIDIEvent_GetPrevEvent (pMIDIEvent);
							VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
							VERIFY (MIDITrack_RemoveEvent (pMIDITrack, pMIDIEvent));
							pMIDIEvent = pTempEvent;
						}
					}
				}
			}
		}
		// gbN̍Ō̃GhIugbNCxg̕tY`FbN
		lCount = 0;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			if (!MIDIEvent_IsEndofTrack (pLastEvent)) {
				lCount++;
			}
		}
		if (lCount > 0) {
			VERIFY (strMsg1.LoadString (IDS_D_MIDITRACK_DOESNT_HAVE_ENDOFTRACKEVENT_N_INSERT_ENDOFTRACKEVENTS));
			strMsg2.Format (strMsg1, lCount);
			EndWaitCursor ();
			m_theCriticalSection.Unlock ();
			lRet = AfxMessageBox (strMsg2, MB_ICONINFORMATION | MB_YESNO);
			m_theCriticalSection.Lock ();
			BeginWaitCursor ();
			if (lRet == IDYES) {
				CHistoryUnit* pCurHistoryUnit = NULL;
				CString strHistoryName;
				VERIFY (strHistoryName.LoadString (IDS_ADD_ENDOFTRACKEVENT));
				VERIFY (this->AddHistoryUnit (strHistoryName));
				VERIFY (pCurHistoryUnit = GetCurHistoryUnit ());
				forEachTrack (m_pMIDIData, pMIDITrack) {
					MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
					if (!MIDIEvent_IsEndofTrack (pLastEvent)) {
						long lTime = (pLastEvent ? MIDIEvent_GetTime (pLastEvent) : 0);
						VERIFY (pMIDIEvent = MIDIEvent_CreateEndofTrack (lTime));
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pMIDIEvent));
						VERIFY (MIDITrack_InsertEvent (pMIDITrack, pMIDIEvent));
					}
				}
			}
		}

		// ۑ
		lRet = MIDIData_SaveAsSMF (m_pMIDIData, lpszPathName);
		if (lRet == 0) {
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			::Sleep (0);
			VERIFY (strMsg1.LoadString (IDS_S_N_MIDIDATA_SAVE_FAILED));
			strMsg2.Format (strMsg1, lpszPathName);
			AfxMessageBox (strMsg2, MB_ICONEXCLAMATION);
			return FALSE;
		}
	}

	// MIDICSVt@C(*.csv)̏ꍇ
	else if (strExt.CompareNoCase (_T(".csv")) == 0) {
		// MIDICxg̃`l`FbN
		long lCount = 0;
		MIDITrack* pMIDITrack;
		MIDIEvent* pMIDIEvent;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			long lOutputChannel = MIDITrack_GetOutputChannel (pMIDITrack);
			// o͐gbNԍ1`16̂ꂩɎw肳ĂȂ
			if (0 <= lOutputChannel && lOutputChannel < 16) {
				forEachEvent (pMIDITrack, pMIDIEvent) {
					if (MIDIEvent_IsMIDIEvent (pMIDIEvent)) {
						long lChannel = MIDIEvent_GetChannel (pMIDIEvent);
						if (lOutputChannel != lChannel) {
							lCount++;
						}
					}
				}
			}
		}
		if (lCount > 0) {
			VERIFY (strMsg1.LoadString (IDS_D_MIDIEVENTS_CHANNEL_IS_CONFLICTED_N_CONVERT_TO_MIDITRACKS_CHANNEL));
			strMsg2.Format (strMsg1, lCount);
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			lRet = AfxMessageBox (strMsg2, MB_ICONINFORMATION | MB_YESNO);
			BeginWaitCursor ();
			m_theCriticalSection.Lock ();
			if (lRet == IDYES) {
				MIDIEvent* pCloneEvent = NULL;
				CHistoryUnit* pCurHistoryUnit = NULL;
				CString strHistoryName;
				VERIFY (strHistoryName.LoadString (IDS_MODIFY_MIDICHANNEL));
				VERIFY (this->AddHistoryUnit (strHistoryName));
				VERIFY (pCurHistoryUnit = GetCurHistoryUnit ());
				forEachTrack (m_pMIDIData, pMIDITrack) {
					long lOutputChannel = MIDITrack_GetOutputChannel (pMIDITrack);
					// o͐gbNԍ1`16̂ꂩɎw肳ĂȂ
					if (0 <= lOutputChannel && lOutputChannel < 16) {
						forEachEvent (pMIDITrack, pMIDIEvent) {
							// MIDI`lCxgőOɔ񌋍CxgȂ
							if (MIDIEvent_IsMIDIEvent (pMIDIEvent) && 
								pMIDIEvent->m_pPrevCombinedEvent == NULL) {
								// gbN̏o̓`lMIDI`lقȂĂȂ
								if (MIDIEvent_GetChannel (pMIDIEvent) != lOutputChannel) {
									VERIFY (pCurHistoryUnit->AddHistoryRecord 
										(HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
									pCloneEvent = ReplaceMIDIEvent (pMIDIEvent);
									MIDIEvent_SetChannel (pCloneEvent, lOutputChannel);
									VERIFY (pCurHistoryUnit->AddHistoryRecord 
										(HISTORYRECORD_INSERTEVENT, pCloneEvent));
									pMIDIEvent = pCloneEvent;
								}
							}
						}
					}
				}
			}
		}
		// m[gCxg̒>0ł邱Ƃ̃`FbN
		lCount = 0;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			forEachEvent (pMIDITrack, pMIDIEvent) {
				if (MIDIEvent_IsNoteOn (pMIDIEvent) && MIDIEvent_IsNote (pMIDIEvent)) {
					long lDuration = MIDIEvent_GetDuration (pMIDIEvent);
					if (lDuration <= 0) {
						lCount++;
					}
				}
			}
		}
		if (lCount > 0) {
			VERIFY (strMsg1.LoadString (IDS_D_MIDIEVENTS_DURATION_IS_LESS_THAN_0_N_DELETE_THESE_MIDIEVENTS));
			strMsg2.Format (strMsg1,lCount);
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			lRet = AfxMessageBox (strMsg2, MB_ICONINFORMATION | MB_YESNO);
			BeginWaitCursor ();
			m_theCriticalSection.Lock ();
			if (lRet == IDYES) {
				CHistoryUnit* pCurHistoryUnit = NULL;
				CString strHistoryName;
				VERIFY (strHistoryName.LoadString (IDS_DELETE_NOTEEVENT));
				VERIFY (this->AddHistoryUnit (strHistoryName));
				VERIFY (pCurHistoryUnit = GetCurHistoryUnit ());
				forEachTrack (m_pMIDIData, pMIDITrack) {
					CPtrArray theEventArray;
					theEventArray.RemoveAll ();
					forEachEvent (pMIDITrack, pMIDIEvent) {
						if (MIDIEvent_IsNoteOn (pMIDIEvent) && 
							MIDIEvent_IsNote (pMIDIEvent)) {
							long lDuration = MIDIEvent_GetDuration (pMIDIEvent);
							if (lDuration <= 0) {
								theEventArray.Add (pMIDIEvent);
							}
						}
					}
					long j;
					for (j = 0; j < theEventArray.GetSize (); j++) {
						pMIDIEvent = (MIDIEvent*)theEventArray.GetAt (j);
						VERIFY (pCurHistoryUnit->AddHistoryRecord
							(HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						MIDITrack_RemoveEvent (pMIDITrack, pMIDIEvent);
					}
				}
			}
		}
		// gbN̍Ōł͂ȂGhIugbNCxg̃`FbN
		lCount = 0;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			forEachEvent (pMIDITrack, pMIDIEvent) {
				if (MIDIEvent_IsEndofTrack (pMIDIEvent) && pMIDIEvent != pLastEvent) {
					lCount++;
				}
			}
		}
		if (lCount > 0) {
			VERIFY (strMsg1.LoadString (IDS_D_ENDOFTRACKEVENT_IS_NOT_LAST_PLACE_N_DELETE_THESE_ENDOFTRACKEVENTS));
			strMsg2.Format (strMsg1, lCount);
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			lRet = AfxMessageBox (strMsg2, MB_ICONINFORMATION | MB_YESNO);
			BeginWaitCursor ();
			m_theCriticalSection.Lock ();
			if (lRet == IDYES) {
				CHistoryUnit* pCurHistoryUnit = NULL;
				CString strHistoryName;
				VERIFY (strHistoryName.LoadString (IDS_DELETE_ENDOFTRACKEVENT));
				VERIFY (this->AddHistoryUnit (strHistoryName));
				VERIFY (pCurHistoryUnit = GetCurHistoryUnit ());
				forEachTrack (m_pMIDIData, pMIDITrack) {
					MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
					forEachEvent (pMIDITrack, pMIDIEvent) {
						if (MIDIEvent_IsEndofTrack (pMIDIEvent) && pMIDIEvent != pLastEvent) {
							MIDIEvent* pTempEvent = MIDIEvent_GetPrevEvent (pMIDIEvent);
							VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
							VERIFY (MIDITrack_RemoveEvent (pMIDITrack, pMIDIEvent));
							pMIDIEvent = pTempEvent;
						}
					}
				}
			}
		}
		// gbN̍Ō̃GhIugbNCxg̕tY`FbN
		lCount = 0;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			if (!MIDIEvent_IsEndofTrack (pLastEvent)) {
				lCount++;
			}
		}
		if (lCount > 0) {
			VERIFY (strMsg1.LoadString (IDS_D_MIDITRACK_DOESNT_HAVE_ENDOFTRACKEVENT_N_INSERT_ENDOFTRACKEVENTS));
			strMsg2.Format (strMsg1, lCount);
			EndWaitCursor ();
			m_theCriticalSection.Unlock ();
			lRet = AfxMessageBox (strMsg2, MB_ICONINFORMATION | MB_YESNO);
			m_theCriticalSection.Lock ();
			BeginWaitCursor ();
			if (lRet == IDYES) {
				CHistoryUnit* pCurHistoryUnit = NULL;
				CString strHistoryName;
				VERIFY (strHistoryName.LoadString (IDS_ADD_ENDOFTRACKEVENT));
				VERIFY (this->AddHistoryUnit (strHistoryName));
				VERIFY (pCurHistoryUnit = GetCurHistoryUnit ());
				forEachTrack (m_pMIDIData, pMIDITrack) {
					MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
					if (!MIDIEvent_IsEndofTrack (pLastEvent)) {
						long lTime = (pLastEvent ? MIDIEvent_GetTime (pLastEvent) : 0);
						VERIFY (pMIDIEvent = MIDIEvent_CreateEndofTrack (lTime));
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pMIDIEvent));
						VERIFY (MIDITrack_InsertEvent (pMIDITrack, pMIDIEvent));
					}
				}
			}
		}

		// ۑ
		lRet = MIDIData_SaveAsMIDICSV (m_pMIDIData, lpszPathName);
		if (lRet == 0) {
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			::Sleep (0);
			VERIFY (strMsg1.LoadString (IDS_S_N_MIDIDATA_SAVE_FAILED));
			strMsg2.Format (strMsg1, lpszPathName);
			AfxMessageBox (strMsg2, MB_ICONEXCLAMATION);
			return FALSE;
		}

	}
	// `̃tH[}bg̏ꍇ
	else {
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
		VERIFY (strMsg1.LoadString (IDS_S_N_INVALID_EXT_N_FILE_SAVE_FAILED));
		strMsg2.Format (strMsg1, lpszPathName);
		AfxMessageBox (strMsg2, MB_ICONEXCLAMATION);
		return FALSE;
	}
	SetModifiedFlag (0);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
	UpdateAllViews (NULL, 
		SEKAIJUDOC_MIDIDATACHANGED | SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIEVENTCHANGED);
	EndWaitCursor ();
	return TRUE;
}

// hLg鎞̃I[o[Ch
void CSekaijuDoc::OnCloseDocument () {
	_RPTF0 (_CRT_WARN, ("CSekaijuDoc::OnCloseDocument ()\n"));
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	m_theCriticalSection.Lock ();
	// ^̏ꍇ͘^~ 
	// ӁF^ɓˑRꂽꍇACSekaijuDoc::OnSaveDocumentĂяo邱ƂB
	// āACSekaijuDoc::OnSaveDocument̖`StopRecordingĂяoĂƁB
	if (pSekaijuApp->m_bRecording) {
		pSekaijuApp->StopRecording (this);
	}
	m_theCriticalSection.Unlock ();
	CDocument::OnCloseDocument ();
	// CDocument::OnCloseDocument ()delete thisA̍ۃfXgN^ĂяoB
}






//------------------------------------------------------------------------------
// CSekaijuDoc NX̐ff
//------------------------------------------------------------------------------

#ifdef _DEBUG
void CSekaijuDoc::AssertValid () const {
	CDocument::AssertValid ();
}

void CSekaijuDoc::Dump (CDumpContext& dc) const {
	CDocument::Dump (dc);
}
#endif


//------------------------------------------------------------------------------
// Iy[V
//------------------------------------------------------------------------------

// AvP[ṼXs[hCfbNXKp
BOOL CSekaijuDoc::ApplyAppCurSpeedIndex () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	// [h̎擾
	long lSyncInputPort = 0;
	long lSyncInputMode = 0;
	pSekaijuApp->GetCurSyncInputPortAndMode (&lSyncInputPort, &lSyncInputMode);
	// ^Cx[X̎擾
	long lTimeMode, lTimeResolution;
	MIDIData_GetTimeBase (m_pMIDIData, &lTimeMode, &lTimeResolution);
	// MIDIClock삵Ăꍇ͋~
	MIDIClock_Stop (m_pMIDIClock);
	// MIDINbÑ^C[hƑxAvP[Vɍ킹(20090625ǉ)
	switch (pSekaijuApp->m_lCurSpeedIndex) {
	case 0: // Xs[h=Î~
		MIDIClock_SetTimeBase (m_pMIDIClock, lTimeMode, lTimeResolution);
		MIDIClock_SetSpeed (m_pMIDIClock, 0);
		MIDIClock_SetMIDIInSyncMode (m_pMIDIClock, MIDICLOCK_MASTER);
		break;
	case 1: // Xs[h=ᑬ
		MIDIClock_SetTimeBase (m_pMIDIClock, lTimeMode, lTimeResolution);
		MIDIClock_SetSpeed (m_pMIDIClock, pSekaijuApp->m_theGeneralOption.m_lSpeedSlow);
		MIDIClock_SetMIDIInSyncMode (m_pMIDIClock, MIDICLOCK_MASTER);
		break;
	case 2: // Xs[h=W
		MIDIClock_SetTimeBase (m_pMIDIClock, lTimeMode, lTimeResolution);
		MIDIClock_SetSpeed (m_pMIDIClock, pSekaijuApp->m_theGeneralOption.m_lSpeedNormal);
		MIDIClock_SetMIDIInSyncMode (m_pMIDIClock, MIDICLOCK_MASTER);
		break;
	case 3: // Xs[h=
		MIDIClock_SetTimeBase (m_pMIDIClock, lTimeMode, lTimeResolution);
		MIDIClock_SetSpeed (m_pMIDIClock, pSekaijuApp->m_theGeneralOption.m_lSpeedFast);
		MIDIClock_SetMIDIInSyncMode (m_pMIDIClock, MIDICLOCK_MASTER);
		break;
	case 4: // Xs[h=@ɃX[u
		if (lSyncInputMode == 1) { // MIDI^C~ONbNɃX[u
			MIDIClock_SetTimeBase (m_pMIDIClock, MIDICLOCK_SLAVEMIDITIMINGCLOCK, lTimeResolution);
			MIDIClock_SetMIDIInSyncMode (m_pMIDIClock, MIDICLOCK_SLAVEMIDITIMINGCLOCK);
		}
		else if (lSyncInputMode == 2) { // SMPTE/MTCɃX[u
			MIDIClock_SetTimeBase (m_pMIDIClock, MIDICLOCK_SLAVESMPTEMTC, lTimeResolution);
			MIDIClock_SetMIDIInSyncMode (m_pMIDIClock, MIDICLOCK_SLAVESMPTEMTC);
		}
		else {
			ASSERT (FALSE);
			// TODO:
		}
		MIDIClock_SetSpeed (m_pMIDIClock, 10000);
		break;
	}
	return TRUE;
}



// w莞MIDIXe[^X()vZAŎw肳ꂽpMIDIStatus[]Ɋi[B
void CSekaijuDoc::TimeMIDIStatus (long lTargetTime, MIDIStatus* pMIDIStatus[]) {
	MIDITrack* pMIDITrack;
	MIDIEvent* pMIDIEvent;
	lTargetTime = CLIP (0, lTargetTime, 0x7FFFFFFF);
	// 20120106 VXeGNXN[VCxg͂ǂ̃gbNɑ}邩Ȃ̂ŁA
	// MIDI`lCxgɐ旧ČvZ悤ɏCB
	// VXeGNXN[VCxgɂԂ̌vZ
	forEachTrack (m_pMIDIData, pMIDITrack) {
		if (MIDITrack_GetOutputOn (pMIDITrack)) {
			long lOutputOn = MIDITrack_GetOutputOn (pMIDITrack);
			long lOutputPort = MIDITrack_GetOutputPort (pMIDITrack);
			long lOutputChannel = MIDITrack_GetOutputChannel (pMIDITrack);
			if (lOutputOn) {
				forEachEvent (pMIDITrack, pMIDIEvent) {
					long lTime = MIDIEvent_GetTime (pMIDIEvent);
					lTime = CLIP (0, lTime + MIDITrack_GetTimePlus (pMIDITrack), 0x7FFFFFFF);
					if (lTime > lTargetTime) { // 20111010
						break;
					}
					// VXeGNXN[VuCxg̏ꍇ
					if (MIDIEvent_IsSysExEvent (pMIDIEvent)) {
						BYTE byMsg[256];
						memset (byMsg, 0, sizeof (byMsg));
						long lLen = MIDIEvent_GetLen (pMIDIEvent);
						MIDIEvent_GetData (pMIDIEvent, byMsg, __min (lLen, sizeof (byMsg)));
						// o̓|[g݂ꍇ̂
						if (pMIDIStatus[lOutputPort] != NULL) {
							MIDIStatus_PutMIDIMessage (pMIDIStatus[lOutputPort], byMsg, lLen);
						}
					}
				}
			}
		}
	}
	// MIDI`lCxgɂԂ̌vZ
	forEachTrack (m_pMIDIData, pMIDITrack) {
		if (MIDITrack_GetOutputOn (pMIDITrack)) {
			long lOutputOn = MIDITrack_GetOutputOn (pMIDITrack);
			long lOutputPort = MIDITrack_GetOutputPort (pMIDITrack);
			long lOutputChannel = MIDITrack_GetOutputChannel (pMIDITrack);
			if (lOutputOn) {
				forEachEvent (pMIDITrack, pMIDIEvent) {
					long lTime = MIDIEvent_GetTime (pMIDIEvent);
					lTime = CLIP (0, lTime + MIDITrack_GetTimePlus (pMIDITrack), 0x7FFFFFFF);
					if (lTime > lTargetTime) { // 20111010
						break;
					}
					// MIDI`lCxg̏ꍇ
					if (MIDIEvent_IsMIDIEvent (pMIDIEvent)) {
						BYTE byMsg[256];
						memset (byMsg, 0, sizeof (byMsg));
						long lLen = MIDIEvent_GetLen (pMIDIEvent);
						MIDIEvent_GetData (pMIDIEvent, byMsg, __min (lLen, sizeof (byMsg)));
						// gbNŐݒ肳ꂽo̓`l̔f
						if (0 <= lOutputChannel && lOutputChannel < 16) {
							byMsg[0] &= 0xF0;
							byMsg[0] |= (BYTE)lOutputChannel;
						}
						// L[+ƃxVeB+̔f
						if (MIDIEvent_IsNoteOn (pMIDIEvent)) {
							byMsg[1] = (BYTE)CLIP (0, byMsg[1] + MIDITrack_GetKeyPlus (pMIDITrack), 127);
							byMsg[2] = (BYTE)CLIP (1, byMsg[2] + MIDITrack_GetVelocityPlus (pMIDITrack), 127);
						}
						else if (MIDIEvent_IsNoteOff (pMIDIEvent) || MIDIEvent_IsKeyAftertouch (pMIDIEvent)) {
							byMsg[1] = (BYTE)CLIP (0, byMsg[1] + MIDITrack_GetKeyPlus (pMIDITrack), 127);
						}
						// o̓|[g݂ꍇ̂
						if (pMIDIStatus[lOutputPort] != NULL) {
							MIDIStatus_PutMIDIMessage (pMIDIStatus[lOutputPort], byMsg, lLen);
						}
					}
				}
			}
		}
	}
}

// Nbv{[hɓƎeLXgݒ
BOOL CSekaijuDoc::SetClipboardTextPrivate9 (CString& strData) {
	TCHAR* p = NULL;
	HGLOBAL hGlobalMem = NULL;
	if ((hGlobalMem = GlobalAlloc (GHND, (strData.GetLength() + 1) * sizeof (TCHAR))) == NULL) {
		//_RPTF0 (_CRT_WARN, "۰؊mەs\B͎߰s܂B\n");
		return FALSE;
	}
	if ((p = (TCHAR*)GlobalLock(hGlobalMem)) == NULL) {
		//_RPTF0 (_CRT_WARN, "۰،Œs\B͎߰s܂B\n");
		GlobalFree(hGlobalMem);
		return FALSE;
	}
	_tcscpy (p, (LPCTSTR)strData);
	if (GlobalUnlock(hGlobalMem) == TRUE) {
		//܂ۯĂTRUE,ꂽorװFALSEB
		//_RPTF0 (_CRT_WARN, "۰،ŒُB͎߰s܂B\n");
		GlobalFree(hGlobalMem);
		return FALSE;
	}
	if(::OpenClipboard (AfxGetMainWnd()->m_hWnd) == FALSE) {
		//_RPTF0 (_CRT_WARN, "دް޵ݕs\B͎߰s܂B\n");
		GlobalFree (hGlobalMem);
		return FALSE;
	}
	if (::EmptyClipboard() == FALSE) {
		::CloseClipboard();//ɕȂ޲۸ޕ\ɂB
		//_RPTF0 (_CRT_WARN, "دްޏs\B͎߰s܂B\n");
		GlobalFree (hGlobalMem);
		return FALSE;
	}
	if (::SetClipboardData(CF_PRIVATEFIRST + 9, hGlobalMem) == FALSE) {
		::CloseClipboard();
		//_RPTF0 (_CRT_WARN, "دްޓ]s\B͎߰s܂B\n");
		GlobalFree (hGlobalMem);
	}
	CloseClipboard();
	// hGlobalMem͂͂₱۸т̂̂ł͂ȂB
	// ]āAGlobalFree(hGlobalMem)ȂB
	return TRUE;
}

// Nbv{[h̓ƎeLXg擾
BOOL CSekaijuDoc::GetClipboardTextPrivate9 (CString& strText) {
	if (IsClipboardFormatAvailable (CF_PRIVATEFIRST + 9) == FALSE) {
		//_RPTF0 (_CRT_WARN, "دްނLȌ`ł͂܂B\tɎs܂B\n");
		return FALSE;
	}
	if (::OpenClipboard (AfxGetMainWnd()->m_hWnd) == FALSE) {
		//_RPTF0 (_CRT_WARN, "دްނJ܂B\tɎs܂B\n");
		return FALSE;
	}
	HGLOBAL hData = NULL;
	if ((hData = GetClipboardData(CF_PRIVATEFIRST + 9)) == NULL) {
		CloseClipboard (); // ɕȂ޲۸ޕ\ɂB
		//_RPTF0 (_CRT_WARN, "دްނ]s\B\tɎs܂B\n");
		return FALSE;
	}
	TCHAR* p = NULL; // ]ޯ̧B
	if ((p = (TCHAR*)GlobalLock(hData)) == NULL) {
		CloseClipboard ();
		//_RPTF0 (_CRT_WARN, "۰،Œs\B\tɎs܂B\n");
		return FALSE;
	}
	CString strData = p;
	if ((GlobalUnlock (hData)) == TRUE) {
		// ܂ۯĂTRUE,ꂽorװFALSEB
		// 20121103C:WindowsɊǗϑ̃bNJEgɂĂ͊֗^ȂB
		//CloseClipboard();
		//_RPTF0 (_CRT_WARN, "۰،Œُ(vI)B\tɎs܂B\n");
		//return FALSE;
	}
	//dvIvO~OWindows95(AXL[) P.929@Ɉȉ̂悤ɋLqB
	//wدްނ۰ނOްۯۯ͂Bx
	if (::CloseClipboard () == FALSE) {
		//_RPTF0 (_CRT_WARN, "دްނ܂B𑱂܂B\n");
	}
	strText = strData;
	return TRUE;
}

// Nbv{[hƎeLXgǂׂ
BOOL CSekaijuDoc::IsClipboardTextPrivate9 () {
	if (IsClipboardFormatAvailable (CF_PRIVATEFIRST + 9) == FALSE) {
		return FALSE;
	}
	return TRUE;
}

// Rs[p쐬
long CSekaijuDoc::MakeCopyString (CString& strText, long lTempCopyMode, CHistoryUnit* pHistoryUnit) {
	long i, j, k;
	long lFormat;
	long lTimeMode;
	long lTimeResolution;
	long lBeginTime = 0x7FFFFFFF;
	long lEndTime = 0;
	long lBeginTrack = 0x7FFFFFFF;
	long lEndTrack = 0;
	long lCopiedEventCount = 0;
	MIDITrack* pMIDITrack;
	MIDIEvent* pMIDIEvent;

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();

	//m_theCriticalSection.Lock ();
	lFormat = MIDIData_GetFormat (m_pMIDIData);
	MIDIData_GetTimeBase (m_pMIDIData, &lTimeMode, &lTimeResolution);
	i = 0;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		pMIDITrack->m_lUserFlag &= ~MIDITRACK_SELECTED;
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				pMIDITrack->m_lUserFlag |= MIDITRACK_SELECTED;
				if (i < lBeginTrack) {
					lBeginTrack = i;
				}
				lEndTrack = i;
				long lTime = MIDIEvent_GetTime (pMIDIEvent);
				if (lTime < lBeginTime) {
					lBeginTime = lTime;
				}
				if (lTime > lEndTime) {
					lEndTime = lTime;
				}
			}
		}
		i++;
	}
	if (lBeginTime == 0x7FFFFFFF || lBeginTrack == 0x7FFFFFFF) {
		//m_theCriticalSection.Unlock ();
		//AfxMessageBox ("CxgIĂ܂B", MB_ICONEXCLAMATION);
		//m_theCriticalSection.Lock ();
		ASSERT (FALSE);
		return 0;
	}
	long lMeasure, lBeat, lTick;
	MIDIData_BreakTime (m_pMIDIData, lBeginTime, &lMeasure, &lBeat, &lTick);
	MIDIData_MakeTime (m_pMIDIData, lMeasure, 0, 0, &lBeginTime);

	// MIDIf[^strDataɐݒ
	CString strData;
	CString strTextLine;
	CString strTextTemp;
	
	strTextLine.Format (_T("MDa2 %X %X %X %X %X %X %X %X %X %X\n"),
		(m_pMIDIData->m_lFormat == 0 ? 0 : 2),
		(lTempCopyMode ? lEndTrack - lBeginTrack + 1 : lEndTrack + 1),
		m_pMIDIData->m_lTimeBase,
		m_pMIDIData->m_lReserved1,
		m_pMIDIData->m_lReserved2,
		m_pMIDIData->m_lReserved3,
		m_pMIDIData->m_lReserved4,
		m_pMIDIData->m_lUser1,
		m_pMIDIData->m_lUser2,
		m_pMIDIData->m_lUser3,
		m_pMIDIData->m_lUserFlag);
	strData += strTextLine;

	forEachTrack (m_pMIDIData, pMIDITrack) {
		if (pMIDITrack->m_lUserFlag & MIDITRACK_SELECTED) {
			MIDITrack_CountEvent (pMIDITrack);
			strTextLine.Format (_T("MTr2 %X %X %X %X %X %X %X %X %X %X %X %X %X %X %X %X %X %X %X %X %X %X\n"),
				pMIDITrack->m_lTempIndex - (lTempCopyMode ? lBeginTrack : 0),
				pMIDITrack->m_lNumEvent,
				pMIDITrack->m_lInputOn,
				pMIDITrack->m_lInputPort,
				pMIDITrack->m_lInputChannel,
				pMIDITrack->m_lOutputOn,
				pMIDITrack->m_lOutputPort,
				pMIDITrack->m_lOutputChannel,
				pMIDITrack->m_lViewMode,
				pMIDITrack->m_lForeColor,
				pMIDITrack->m_lBackColor,
				pMIDITrack->m_lTimePlus,
				pMIDITrack->m_lKeyPlus,
				pMIDITrack->m_lVelocityPlus,
				pMIDITrack->m_lReserved1,
				pMIDITrack->m_lReserved2,
				pMIDITrack->m_lReserved3,
				pMIDITrack->m_lReserved4,
				pMIDITrack->m_lUser1,
				pMIDITrack->m_lUser2,
				pMIDITrack->m_lUser3,
				pMIDITrack->m_lUserFlag);
			j = 0;
			strData += strTextLine;

			forEachEvent (pMIDITrack, pMIDIEvent) {
				strTextLine = _T("");
				if (IsEventSelected (pMIDIEvent)) {
					strTextTemp.Format (_T("MEvt %X %X %X %X"),
						pMIDIEvent->m_lTempIndex,
						pMIDIEvent->m_lTime - lBeginTime,
						pMIDIEvent->m_lKind,
						pMIDIEvent->m_lLen);
					strTextLine += strTextTemp;
					for (k = 0; k < pMIDIEvent->m_lLen; k++) {
						strTextTemp.Format (_T(" %X"), *(pMIDIEvent->m_pData + k));
						strTextLine += strTextTemp;
					}
					strTextTemp.Format (_T(" %X %X %X %X %X %X\n"),
						pMIDIEvent->m_pPrevCombinedEvent ? pMIDIEvent->m_pPrevCombinedEvent->m_lTempIndex : -1,
						pMIDIEvent->m_pNextCombinedEvent ? pMIDIEvent->m_pNextCombinedEvent->m_lTempIndex : -1,
						pMIDIEvent->m_lUser1,
						pMIDIEvent->m_lUser2,
						pMIDIEvent->m_lUser3,
						pMIDIEvent->m_lUserFlag);
					strTextLine += strTextTemp;
					strData += strTextLine;
					lCopiedEventCount++;
				}
				j++;
			}
		}
		i++;
	}

	strText = strData;
	return lCopiedEventCount;
}

// ƎeLXgWJē\t
long CSekaijuDoc::ParsePasteString
(CString& strData, long lBeginTrackIndex, long lBeginTime, CHistoryUnit* pHistoryUnit) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	CString strMsg;
	CString strTextLine;
	long lFormat;
	long lNumTrack;
	long lTimeBase;
	long lTimeMode;
	long lTimeResolution;
	long lNumEvent;
	long lTrackIndex;
	long lEventIndex;
	long lTime;
	long lKind;
	long lLen;
	BYTE byData[1024];
	long lPrevCombinedEvent;
	long lNextCombinedEvent;
	long lInputOn;
	long lInputPort;
	long lInputChannel;
	long lOutputOn;
	long lOutputPort;
	long lOutputChannel;
	long lViewMode;
	long lForeColor;
	long lBackColor;
	long lTimePlus;
	long lKeyPlus;
	long lVelocityPlus;
	long lReserved1;
	long lReserved2;
	long lReserved3;
	long lReserved4;
	long lUser1;
	long lUser2;
	long lUser3;
	long lUserFlag;
	TCHAR szType[256];
	long i = 0;
	long j = 0;
	long k = 0;
	long ret = 0;
	long lErrorNo = 0;
	long lDeletedEventCount = 0;
	long lInsertedEventCount = 0;
	MIDITrack* pClipTrack = NULL;
	MIDIEvent* pClipEvent = NULL;
	MIDIData* pClipData = NULL;

	// Nbv{[h̓eVMIDIDataIuWFNg쐬
	while (1) {
		int n = strData.Find(_T('\n'));
		if (n < 0) {
			break;
		}
		strTextLine = strData.Left (n + 1);
		strData = strData.Mid (n + 1);
		// MDa2s̏ꍇ
		if (strTextLine.Left (4) == _T("MDa2")) {
			// 2ȏMDatꂽꍇ
			if (pClipData != NULL) {
				break;
			}
			// MDat̓ǂݎ
			_stscanf (strTextLine, _T("%s %x %x %x %x %x %x %x %x\n"),
				szType,
				&lFormat, 
				&lNumTrack, 
				&lTimeBase,
				&lReserved1,
				&lReserved2,
				&lReserved3,
				&lReserved4,
				&lUser1, 
				&lUser2, 
				&lUser3, 
				&lUserFlag);
			if (lFormat < 0 || lFormat > 2) {
				VERIFY (strMsg.LoadString (IDS_ABNORMAL_FORMAT_MIDIDATA_IN_THE_CLIPBOARD));
				m_theCriticalSection.Unlock ();
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				m_theCriticalSection.Lock ();
				return -1;
			}
			if (lTimeBase & 0x00008000) {
				lTimeMode = 256 - ((lTimeBase & 0x0000FF00) >> 8);
				lTimeResolution = lTimeBase & 0x000000FF;
			}
			else {
				lTimeMode =  MIDIDATA_TPQNBASE;
				lTimeResolution = lTimeBase & 0x00007FFF;
			}
			if (lTimeMode != MIDIDATA_TPQNBASE &&
				lTimeMode != MIDIDATA_SMPTE24BASE &&
				lTimeMode != MIDIDATA_SMPTE25BASE &&
				lTimeMode != MIDIDATA_SMPTE29BASE &&
				lTimeMode != MIDIDATA_SMPTE30BASE) {
				VERIFY (strMsg.LoadString (IDS_TIMEMODE_OF_CLIPBOARD_IS_ABNORMAL));
				m_theCriticalSection.Unlock ();
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				m_theCriticalSection.Lock ();
				return -1;
			}
			// MIDIData̐
			pClipData = MIDIData_Create 
				(2, lNumTrack, lTimeMode, lTimeResolution);
			if (pClipData == NULL) {
				VERIFY (strMsg.LoadString (IDS_INSUFFICIENT_MEMORY));
				m_theCriticalSection.Unlock ();
				AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
				m_theCriticalSection.Lock ();
				return -1;
			}
		}
		// MTr2s̏ꍇ
		else if (strTextLine.Left (4) == _T("MTr2")) {
			_stscanf (strTextLine, _T("%s %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x %x\n"),
				szType, 
				&lTrackIndex, 
				&lNumEvent,
				&lInputOn,
				&lInputPort,
				&lInputChannel,
				&lOutputOn,
				&lOutputPort,
				&lOutputChannel,
				&lViewMode,
				&lForeColor,
				&lBackColor,
				&lTimePlus,
				&lKeyPlus,
				&lVelocityPlus,
				&lReserved1,
				&lReserved2,
				&lReserved3,
				&lReserved4,
				&lUser1,
				&lUser2,
				&lUser3,
				&lUserFlag);
			// }gbNpClipTrackɌ
			long i = 0;
			forEachTrack (pClipData, pClipTrack) {
				if (i == lTrackIndex) {
					break;
				}
				i++;
			}
		}
		// MEvts̏ꍇ
		else if (strTextLine.Left (4) == _T("MEvt")) {
			if (pClipTrack == NULL) {
				break;
			}
			TCHAR* p = (TCHAR*)(LPCTSTR)strTextLine;
			_stscanf (p, _T("%s %x %x %x %x"),
				szType, &lEventIndex, &lTime, &lKind, &lLen);
			memset (byData, 0, sizeof (byData));
			for (k = 0; k < 5; k++) {
				p = _tcschr (p, _T(' '));
				if (p == NULL) {
					break;
				}
				while (*p == _T(' ')) {
					p++;
				}
			}
			for (k = 0; k < lLen; k++) {
				_stscanf (p, _T("%x"), &byData[k]);
				p = _tcschr (p, ' ');
				if (p == NULL) {
					break;
				}
				while (*p == ' ') {
					p++;
				}
			}

			_stscanf (p, _T("%x %x %x %x %x %d\n"), 
				&lPrevCombinedEvent, &lNextCombinedEvent,
				&lUser1, &lUser2, &lUser3, &lUserFlag);

			// VMIDICxg̐
			pClipEvent = MIDIEvent_Create (lTime, lKind, byData, lLen);
			if (pClipEvent == NULL) {
				continue;
			}
			pClipEvent->m_lUserFlag |= MIDIEVENT_SELECTED;
			pClipEvent->m_lTempIndex = lEventIndex;

			// gbNɃCxg}
			ret = MIDITrack_InsertEvent (pClipTrack, pClipEvent);
			if (ret <= 0) {
				MIDIEvent_Delete (pClipEvent);
				continue;
			}
			
			// Cxgłꍇ̌(1)
			if (lPrevCombinedEvent != -1) {
				MIDIEvent* pTempEvent;
				forEachEvent (pClipTrack, pTempEvent) {
					if (pTempEvent->m_lTempIndex == lPrevCombinedEvent) {
						pClipEvent->m_pPrevCombinedEvent = pTempEvent;
						pTempEvent->m_pNextCombinedEvent = pClipEvent;
						break;
					}
				}
			}

			// Cxgłꍇ̌(2)
			if (lNextCombinedEvent != -1) {
				MIDIEvent* pTempEvent;
				forEachEvent (pClipTrack, pTempEvent) {
					if (pTempEvent->m_lTempIndex == lNextCombinedEvent) {
						pClipEvent->m_pNextCombinedEvent = pTempEvent;
						pTempEvent->m_pPrevCombinedEvent = pClipEvent;
						break;
					}
				}
			}
		}
	}

	// ݂MIDIf[^ׂ̂ĂMIDICxgI
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pNewMIDIEvent = NULL;
	MIDIEvent* pLastEvent = NULL;
	MIDIEvent* pNewLastEvent = NULL;
	SelectNoObject (pHistoryUnit);

	// ݂MIDIf[^ɃNbv{[hMIDIf[^}[W
	//long lCurTime = MIDIClock_GetTickCount (m_pMIDIClock);
	long lNumClipTrack = MIDIData_CountTrack (pClipData);
	
	// }[WpMIDIf[^̃tH[}bgMIDIf[^̃tH[}bgɍ킹B
	if(m_pMIDIData->m_lFormat== 0) {
		MIDIData_SetFormat (pClipData, 0);
	}

	// }[WpMIDIf[^̃^Cx[XMIDIf[^̃^Cx[Xɍ킹B
	MIDIData_GetTimeBase (m_pMIDIData, &lTimeMode, &lTimeResolution);
	if (m_pMIDIData->m_lTimeBase != pClipData->m_lTimeBase) {
		MIDIData_SetTimeBase (pClipData, lTimeMode, lTimeResolution);
	}

	// KvȐgbNǉ
	if (MIDIData_GetFormat (m_pMIDIData) != 0) {
		long lClipTrackCount = MIDIData_CountTrack (pClipData);
		long lNeedTrackCount = lBeginTrackIndex + lClipTrackCount;
		this->AddTrack (lNeedTrackCount, 0x0002, pHistoryUnit);
	}

	// ׂẴgbNEOTCxg̗L^
	forEachTrack (m_pMIDIData, pMIDITrack) {
		pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
		if (pLastEvent) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				pHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent);
				pNewLastEvent = this->ReplaceMIDIEvent (pLastEvent);
			}
		}
	}

	// }[WpMIDIf[^CxgAMIDIf[^ɑ}
	if (MIDIData_GetFormat (m_pMIDIData) == 0) {
		pMIDITrack = MIDIData_GetFirstTrack (m_pMIDIData);
	}
	else {
		pMIDITrack = GetTrack (lBeginTrackIndex);
	}
	forEachTrack (pClipData, pClipTrack) {
		ASSERT (pMIDITrack);
		pClipEvent = pClipTrack->m_pFirstEvent;
		while (pClipEvent) {
			ret = MIDITrack_RemoveEvent (pClipTrack, pClipEvent);
			ret = MIDIEvent_SetTime (pClipEvent, pClipEvent->m_lTime + lBeginTime);
			ret = MIDITrack_InsertEvent (pMIDITrack, pClipEvent);
			if (ret > 0) {
				VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pClipEvent));
			}
			lInsertedEventCount += ret;
			pClipEvent = pClipTrack->m_pFirstEvent;
		}
		pMIDITrack = pMIDITrack->m_pNextTrack;
	}

	// ׂẴgbNEOTCxg̗L^
	forEachTrack (m_pMIDIData, pMIDITrack) {
		pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
		if (pLastEvent) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent);
			}
		}
	}

	// NbvMIDIf[^̍폜
	MIDIData_Delete (pClipData);
	pClipData = NULL;
	return lInsertedEventCount;
}

// IĂCxg̍폜
BOOL CSekaijuDoc::DeleteSelectedEvent (CHistoryUnit* pHistoryUnit) {
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	MIDIEvent* pPrevEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		// 폜̂Ō
		pMIDIEvent = MIDITrack_GetLastEvent (pMIDITrack);
		while (pMIDIEvent) {
			pPrevEvent = MIDIEvent_GetPrevEvent (pMIDIEvent);
			// IĂȂ
			if (this->IsEventSelected (pMIDIEvent)) {
				// Cxg̓rłȂȂ
				if (pMIDIEvent->m_pPrevCombinedEvent == NULL) {
					// ŌEndofTrackCxgłȂȂ
					if (!(MIDIEvent_IsEndofTrack (pMIDIEvent) && 
						MIDIEvent_GetNextEvent (pMIDIEvent) == NULL)) {
						pHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent);
						MIDITrack_RemoveEvent (pMIDITrack, pMIDIEvent);
					}
				}
			}
			pMIDIEvent = pPrevEvent;
		}
	}
	return TRUE;
}

// MIDICxgI𖔂͔IԂɂB
long CSekaijuDoc::SetEventSelected (MIDIEvent* pMIDIEvent, BOOL bSelected) {
	ASSERT (pMIDIEvent);
	ASSERT (bSelected == 0 || bSelected == 1);
	long lCount = 0;
	MIDIEvent* pTempEvent = MIDIEvent_GetFirstCombinedEvent (pMIDIEvent);
	while (pTempEvent) {
		if (bSelected) {
			pTempEvent->m_lUserFlag |= MIDIEVENT_SELECTED;
		}
		else {
			pTempEvent->m_lUserFlag &= ~MIDIEVENT_SELECTED;
		}
		pTempEvent = pTempEvent->m_pNextCombinedEvent;
		lCount++;
	}
	return lCount;
}

// MIDICxgIԂׂ
long CSekaijuDoc::IsEventSelected (MIDIEvent* pMIDIEvent) {
	MIDITrack* pMIDITrack = MIDIEvent_GetParent (pMIDIEvent);
	ASSERT (pMIDITrack);
	return pMIDIEvent->m_lUserFlag & MIDIEVENT_SELECTED ? 1 : 0;
}

// ׂĂMIDICxgIԂɂAɋL^B
long CSekaijuDoc::SelectNoObject (CHistoryUnit* pHistoryUnit) {
	long lCount = 0;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	MIDITrack* pCloneTrack = NULL;
	MIDIEvent* pCloneEvent = NULL;
	ASSERT (pHistoryUnit);	

	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (pMIDIEvent->m_pPrevCombinedEvent == NULL) {
				pCloneEvent = this->SelectEvent (pMIDIEvent, 0, pHistoryUnit);
				if (pCloneEvent) {
					pMIDIEvent = pCloneEvent;
					lCount++;
				}
			}
		}
	}
	_RPTF1 (_CRT_WARN, "SelectNoObject returns %d.\n", lCount);
	return lCount;
}

// ׂĂMIDICxgIԂɂAɋL^B
long CSekaijuDoc::SelectAllObject (CHistoryUnit* pHistoryUnit) {
	return 1; // TODO;
}

// wMIDICxgIԖ͔IԂɂAɋL^B
// IԂωꍇAVMIDICxgԂBωȂꍇANULLԂB
MIDIEvent* CSekaijuDoc::SelectEvent (MIDIEvent* pMIDIEvent, long bSelected,
									 CHistoryUnit* pHistoryUnit) {
	ASSERT (pMIDIEvent);
	MIDITrack* pMIDITrack = MIDIEvent_GetParent (pMIDIEvent);
	ASSERT (pMIDITrack);
	MIDIEvent* pCloneEvent = NULL;
	MIDIEvent* pFirstCombinedEvent = NULL;
	ASSERT (pHistoryUnit);
	// ƈقȂIԂwꍇ̂
	if (this->IsEventSelected (pMIDIEvent) != bSelected) {// &&
		//pMIDIEvent->m_pPrevCombinedEvent == NULL) {
		VERIFY (pFirstCombinedEvent = MIDIEvent_GetFirstCombinedEvent (pMIDIEvent));
		VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pFirstCombinedEvent));
		VERIFY (pCloneEvent = this->ReplaceMIDIEvent (pFirstCombinedEvent));
		// Cxg擪珇ɑIԖ͔IԂɂB
		MIDIEvent* pTempEvent = pCloneEvent;
		while (pTempEvent) {
			if (bSelected) {
				pTempEvent->m_lUserFlag |= MIDIEVENT_SELECTED;
			}
			else {
				pTempEvent->m_lUserFlag &= ~MIDIEVENT_SELECTED;
			}
			pTempEvent = pTempEvent->m_pNextCombinedEvent;
		}
		VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
		return pCloneEvent;
	}
	return NULL;
}

// MIDIgbNIԖ͔IԂɂAɋL^
MIDITrack* CSekaijuDoc::SelectTrack (MIDITrack* pMIDITrack, long bSelected,
									 CHistoryUnit* pHistoryUnit) {
	ASSERT (pMIDITrack);
	ASSERT (pHistoryUnit);
	MIDIEvent* pMIDIEvent = NULL;
	MIDIEvent* pCloneEvent = NULL;
	// gbNׂ̂ẴCxgIԖ͔IԂɂB
	forEachEvent (pMIDITrack, pMIDIEvent) {
		pCloneEvent = this->SelectEvent (pMIDIEvent, bSelected, pHistoryUnit);
		if (pCloneEvent) {
			pMIDIEvent = pCloneEvent;
		}
	}
	return NULL;
}

// MIDIgbNIԂׂ
long CSekaijuDoc::IsTrackSelected (MIDITrack* pMIDITrack) {
	ASSERT (pMIDITrack);
	// gbNׂ̂ẴCxgIĂ1AłȂ0ԂB
	MIDIEvent* pMIDIEvent = NULL;
	forEachEvent (pMIDITrack, pMIDIEvent) {
		if ((pMIDIEvent->m_lUserFlag & MIDIEVENT_SELECTED) == 0) {
			return 0;
		}
	}
	return 1;
}


// wgbN̎w菬߂IԖ͔IԂɂAɋL^
long CSekaijuDoc::SelectTrackMeasure (MIDITrack* pMIDITrack, long lMeasure, long bSelected,
									  CHistoryUnit* pHistoryUnit) {
	ASSERT (pMIDITrack);
	MIDIEvent* pMIDIEvent;
	MIDIEvent* pCloneEvent;
	// w菬߂̊Jn^CƏI^CvZ
	long lMinTime, lMaxTime;
	MIDIData_MakeTime (m_pMIDIData, lMeasure, 0, 0, &lMinTime);
	MIDIData_MakeTime (m_pMIDIData, lMeasure + 1, 0, 0, &lMaxTime);
	ASSERT (pHistoryUnit);
	// wgbN̎w菬ߓׂ̂ĂMIDICxgIԖ͔IԂɂ
	forEachEvent (pMIDITrack, pMIDIEvent) {
		long lTime = MIDIEvent_GetTime (pMIDIEvent);
		if (lMinTime <= lTime && lTime < lMaxTime) {
			if (pMIDIEvent->m_pPrevCombinedEvent == NULL) { // 20081102:O߂̃m[gIt͏O
				pCloneEvent = this->SelectEvent (pMIDIEvent, bSelected, pHistoryUnit);
				if (pCloneEvent) {
					pMIDIEvent = pCloneEvent;
				}
			}
		}
	}
	return 1;
}

// wgbN̎w菬߂IԂׂ(20100517dlC)
long CSekaijuDoc::IsTrackMeasureSelected (MIDITrack* pMIDITrack, long lMeasure) {
	ASSERT (pMIDITrack);
	MIDIEvent* pMIDIEvent;
	// w菬߂̊Jn^CƏI^CvZ
	long lMinTime, lMaxTime;
	MIDIData_MakeTime (m_pMIDIData, lMeasure, 0, 0, &lMinTime);
	MIDIData_MakeTime (m_pMIDIData, lMeasure + 1, 0, 0, &lMaxTime);
	long lEventNum = 0; // 20100517ǉ
	long lSelectedEventNum = 0; // 20100517ǉ
	forEachEvent (pMIDITrack, pMIDIEvent) {
		long lTime = MIDIEvent_GetTime (pMIDIEvent);
		if (lMinTime <= lTime && lTime < lMaxTime) {
			if (pMIDIEvent->m_pPrevCombinedEvent == NULL) { // 20081102:O߂̃m[gIt͏O
				lEventNum++;
				if ((pMIDIEvent->m_lUserFlag & MIDIEVENT_SELECTED) != 0) {
					lSelectedEventNum++;
				}
			}
		}
	}
	// Cxg݂Ȃꍇ0ԂB
	if (lEventNum == 0) {
		return 0;
	}
	// IĂCxg݂Ȃꍇ1ԂB
	if (lSelectedEventNum == 0) {
		return 1;
	}
	// ꕔ̃CxgIĂꍇ2ԂB
	else if (lEventNum > lSelectedEventNum) {
		return 2;
	}
	// ׂẴCxgIĂꍇ3ԂB
	else { // if (lEventNum == lSelectedEventNum) {
		return 3;
	}
}


// wCfbNX̃gbN擾
MIDITrack* CSekaijuDoc::GetTrack (long lIndex) {
	ASSERT (0 <= lIndex && lIndex < MAXMIDITRACKNUM);
	long i = 0;
	MIDITrack* pMIDITrack = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		if (i == lIndex) {
			return pMIDITrack;
		}
		i++;
	}
	return NULL;	
}

// gbNɃftHg̃CxgǉB
// lMode͈ȉ̒lOR
// 0001:gbNɃgbNCxg}
// 0002:gbNEOTCxg}
// 0004:gbNɃRg[`FWEvO`FW}
// 0008:gbNɃe|EqLEL}(ׂă^C0)
long CSekaijuDoc::AddDefaultEventToTrack (MIDITrack* pMIDITrack, long lMode, CHistoryUnit* pHistoryUnit) {
	ASSERT (pMIDITrack);
	long lCurTrackCount = MIDIData_CountTrack (m_pMIDIData);
	long lTimeResolution = MIDIData_GetTimeResolution (m_pMIDIData);
	long lChannel = MIDITrack_GetOutputChannel (pMIDITrack);
	MIDIEvent* pNewEvent = NULL;
	// gbNCxg̑}
	if (lMode & 0x0001) {
		VERIFY (pNewEvent = MIDIEvent_CreateTrackName (lTimeResolution * 0 / 120, _T("")));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
	}
	// e|EqLEL
	if (lMode & 0x0008) {
		VERIFY (pNewEvent = MIDIEvent_CreateTempo (0, 60000000 / 120));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
		VERIFY (pNewEvent = MIDIEvent_CreateTimeSignature (0, 4, 2, 24, 8));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
		VERIFY (pNewEvent = MIDIEvent_CreateKeySignature (0, 0, 0));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
	}
	// Rg[`FWEvO`FW̑}
	if (lMode & 0x0004 && 0 <= lChannel && lChannel <= 15) {
		VERIFY (pNewEvent = MIDIEvent_CreateControlChange (lTimeResolution * 120 / 120, lChannel, 0, 0));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
		VERIFY (pNewEvent = MIDIEvent_CreateControlChange (lTimeResolution * 130 / 120, lChannel, 32, 0));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
		VERIFY (pNewEvent = MIDIEvent_CreateProgramChange (lTimeResolution * 140 / 120, lChannel, 0));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
		VERIFY (pNewEvent = MIDIEvent_CreateControlChange (lTimeResolution * 150 / 120, lChannel, 1, 0));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
		VERIFY (pNewEvent = MIDIEvent_CreateControlChange (lTimeResolution * 160 / 120, lChannel, 7, 100));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
		VERIFY (pNewEvent = MIDIEvent_CreateControlChange (lTimeResolution * 170 / 120, lChannel, 10, 64));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
		VERIFY (pNewEvent = MIDIEvent_CreateControlChange (lTimeResolution * 180 / 120, lChannel, 11, 127));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
		VERIFY (pNewEvent = MIDIEvent_CreateControlChange (lTimeResolution * 190 / 120, lChannel, 64, 0));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
		VERIFY (pNewEvent = MIDIEvent_CreateControlChange (lTimeResolution * 200 / 120, lChannel, 91, 40));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
		VERIFY (pNewEvent = MIDIEvent_CreateControlChange (lTimeResolution * 210 / 120, lChannel, 93, 0));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
		VERIFY (pNewEvent = MIDIEvent_CreateControlChange (lTimeResolution * 220 / 120, lChannel, 94, 0));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
	}
	// GhIugbNCxg̑}
	if (lMode & 0x0002) {
		VERIFY (pNewEvent = MIDIEvent_CreateEndofTrack (lTimeResolution * 4));
		VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
		if (pHistoryUnit) {
			VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
		}
	}
	return 1;
}

// KvȐgbNǉAɋL^B
// lNeedTrackCount͍ŏIIȃgbN̑BǉꂽgbN̐ԂB
// lMode͈ȉ̒lOR
// 0001:ǉꂽgbNɃgbNCxg}
// 0002:ǉꂽgbNEOTCxg}
// 0004:ǉꂽgbNɃRg[`FWEvO`FW}
// 0008:ǉꂽgbNɃe|EqLEL}(^C0)
long CSekaijuDoc::AddTrack (long lNeedTrackCount, long lMode, CHistoryUnit* pHistoryUnit) {
	ASSERT (0 <= lNeedTrackCount && lNeedTrackCount < MAXMIDITRACKNUM);
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	long lFormat = MIDIData_GetFormat (m_pMIDIData);
	// tH[}bg1̓tH[}bg2̏ꍇȊO̓gbNǉłȂB
	if (!(lFormat == 1 || lFormat == 2)) {
		return 0;
	}
	long i = 0;
	long lCount = 0;
	MIDITrack* pTempTrack = NULL;
	MIDIEvent* pTempEvent = NULL;
	long lCurTrackCount = MIDIData_CountTrack (m_pMIDIData);
	long lTimeResolution = MIDIData_GetTimeResolution (m_pMIDIData);
	long lMode2 = lMode;
	for (i = lCurTrackCount; i < lNeedTrackCount; i++) {
		VERIFY (pTempTrack = MIDITrack_Create ());
		pTempTrack->m_lTempIndex = i;
		MIDITrack_SetViewMode (pTempTrack, 0);
		MIDITrack_SetForeColor (pTempTrack, pSekaijuApp->m_theColorOption.m_lForeColor[i % 8]);
		MIDITrack_SetBackColor (pTempTrack, 0x00FFFFFF);
		MIDITrack_SetInputOn (pTempTrack, 1);
		MIDITrack_SetInputPort (pTempTrack, 0);
		MIDITrack_SetInputChannel (pTempTrack, (i + 15) % 16);
		MIDITrack_SetOutputOn (pTempTrack, 1);
		MIDITrack_SetOutputPort (pTempTrack, 0);
		MIDITrack_SetOutputChannel (pTempTrack, (i + 15) % 16);
		VERIFY (MIDIData_AddTrack (m_pMIDIData, pTempTrack));
		VERIFY (pHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pTempTrack));
		// tH[}bg1̏ꍇlMode𒲐
		if (lFormat == 1 && i == 0) {
			lMode2 = lMode & ~0x0004; // ŏ̃gbNɃRg[`FWEvO`FW֎~
		}
		else if (lFormat == 1 && i != 0) {
			lMode2 = lMode & ~0x0008; // 2Ԗڈȍ~̃gbNɃe|EqLEL֎~
		}
		VERIFY (this->AddDefaultEventToTrack (pTempTrack, lMode2, pHistoryUnit));
		lCount++;
	}
	return lCount;
}


// gbN̖O擾
CString CSekaijuDoc::GetTrackName (MIDITrack* pMIDITrack) {
	TCHAR szBuf[1024];
	memset (szBuf, 0, sizeof (szBuf));
	MIDITrack_GetName (pMIDITrack, szBuf, TSIZEOF (szBuf) - 1);
	return CString (szBuf);
}

// gbN̖Oݒ
BOOL CSekaijuDoc::SetTrackName (MIDITrack* pMIDITrack, CString strTrackName) {
	CHistoryUnit* pCurHistoryUnit = NULL;
	VERIFY (pCurHistoryUnit = GetCurHistoryUnit ());
	MIDIEvent* pTempEvent = MIDITrack_GetFirstKindEvent (pMIDITrack, MIDIEVENT_TRACKNAME);
	MIDIEvent* pCloneEvent = NULL;
	// ɃgbNCxgꍇ
	if (pTempEvent) {
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pTempEvent);
		VERIFY (pCloneEvent = ReplaceMIDIEvent (pTempEvent));
		VERIFY (MIDIEvent_SetText (pCloneEvent, (LPCTSTR)strTrackName));
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent);
	}
	// ̃gbNɃgbNCxgȂꍇ
	else {
		VERIFY (pCloneEvent = MIDIEvent_CreateTrackName (0, strTrackName));
		MIDITrack_InsertEvent (pMIDITrack, pCloneEvent);
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent);
	}
	return MIDITrack_SetName (pMIDITrack, (LPCTSTR)strTrackName);
}


// gbÑCfbNX擾
long CSekaijuDoc::GetTrackIndex (MIDITrack* pMIDITrack) {
	ASSERT (pMIDITrack);
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	MIDITrack* pTempTrack;
	long i = 0;
	forEachTrack (m_pMIDIData, pTempTrack) {
		if (pTempTrack == pMIDITrack) {
			return i;
		}
		i++;
	}
	ASSERT (FALSE);
	return -1;
}


// gbN̉擾
long CSekaijuDoc::GetTrackVisible (MIDITrack* pMIDITrack) {
	ASSERT (pMIDITrack);
	return pMIDITrack->m_lUserFlag & MIDITRACK_VISIBLE ? 1 : 0;
}

// gbN̉ݒ
BOOL CSekaijuDoc::SetTrackVisible (MIDITrack* pMIDITrack, long lVisible) {
	ASSERT (pMIDITrack);
	ASSERT (0 <= lVisible && lVisible <= 1);
	if (lVisible) {
		pMIDITrack->m_lUserFlag |= MIDITRACK_VISIBLE;
	}
	else {
		pMIDITrack->m_lUserFlag &= ~MIDITRACK_VISIBLE;
	}
	return TRUE;
}

// gbÑCl[uON/OFF擾
long CSekaijuDoc::GetTrackEnable (MIDITrack* pMIDITrack) {
	ASSERT (pMIDITrack);
	return pMIDITrack->m_lUserFlag & MIDITRACK_ENABLE ? 1 : 0;
}

// gbÑCl[uON/OFFݒ
BOOL CSekaijuDoc::SetTrackEnable (MIDITrack* pMIDITrack, long lEnable) {
	ASSERT (pMIDITrack);
	ASSERT (0 <= lEnable && lEnable <= 1);
	if (lEnable) {
		pMIDITrack->m_lUserFlag |= MIDITRACK_ENABLE;
	}
	else {
		pMIDITrack->m_lUserFlag &= ~MIDITRACK_ENABLE;
	}
	return TRUE;
}

// gbN̑IԂ̎擾
long CSekaijuDoc::GetTrackSelected (MIDITrack* pMIDITrack) {
	ASSERT (pMIDITrack);
	return pMIDITrack->m_lUserFlag & MIDITRACK_SELECTED ? 1 : 0;
}

// gbN̑IԂ̐ݒ
BOOL CSekaijuDoc::SetTrackSelected (MIDITrack* pMIDITrack, long lSelected) {
	ASSERT (pMIDITrack);
	ASSERT (0 <= lSelected && lSelected <= 1);
	if (lSelected) {
		pMIDITrack->m_lUserFlag |= MIDITRACK_SELECTED;
	}
	else {
		pMIDITrack->m_lUserFlag &= ~MIDITRACK_SELECTED;
	}
	return TRUE;
}


// ŏ̃Rg[`FWCxg̎擾
MIDIEvent* CSekaijuDoc::GetTrackFirstControlChange (MIDITrack* pMIDITrack, long lNumber) {
	_ASSERT (pMIDITrack);
	_ASSERT (0 <= lNumber && lNumber < 128);
	MIDIEvent* pMIDIEvent = NULL;
	forEachEvent (pMIDITrack, pMIDIEvent) {
		if (MIDIEvent_IsControlChange (pMIDIEvent)) {
			if (MIDIEvent_GetNumber (pMIDIEvent) == lNumber) {
				return pMIDIEvent;
			}
		}
	}
	return NULL;
}

// ŏ̃vO`FWCxg̎擾
MIDIEvent* CSekaijuDoc::GetTrackFirstProgramChange (MIDITrack* pMIDITrack) {
	ASSERT (pMIDITrack);
	MIDIEvent* pMIDIEvent = NULL;
	forEachEvent (pMIDITrack, pMIDIEvent) {
		if (MIDIEvent_IsProgramChange (pMIDIEvent)) {
			return pMIDIEvent;
		}
	}
	return NULL;
}

MIDIEvent* CSekaijuDoc::FindBankMSB (MIDIEvent* pMIDIEvent) {
	ASSERT (pMIDIEvent);
	MIDITrack* pMIDITrack = MIDIEvent_GetParent (pMIDIEvent);
	ASSERT (pMIDITrack);
	if (MIDIEvent_IsControlChange (pMIDIEvent)) {
		long lNumber = MIDIEvent_GetNumber (pMIDIEvent);
		if (lNumber == 32) {
			while (pMIDIEvent) { // 20110508C
				if (MIDIEvent_IsControlChange (pMIDIEvent)) {
					if (MIDIEvent_GetNumber (pMIDIEvent) == 0) {
						return pMIDIEvent;
					}
				}
				pMIDIEvent = MIDIEvent_GetPrevEvent (pMIDIEvent); // 20110508ǉ
			}
		}
	}
	else if (MIDIEvent_IsProgramChange (pMIDIEvent)) {
		while (pMIDIEvent) { // 20110508C
			if (MIDIEvent_IsControlChange (pMIDIEvent)) {
				if (MIDIEvent_GetNumber (pMIDIEvent) == 0) {
					return pMIDIEvent;
				}
			}
			pMIDIEvent = MIDIEvent_GetPrevEvent (pMIDIEvent); // 20110508ǉ
		}
	}
	return NULL;
}

MIDIEvent* CSekaijuDoc::FindBankLSB (MIDIEvent* pMIDIEvent) {
	ASSERT (pMIDIEvent);
	MIDITrack* pMIDITrack = MIDIEvent_GetParent (pMIDIEvent);
	ASSERT (pMIDITrack);
	if (MIDIEvent_IsControlChange (pMIDIEvent)) {
		long lNumber = MIDIEvent_GetNumber (pMIDIEvent);
		if (lNumber == 0) {
			while (pMIDIEvent) { // 20110508C
				if (MIDIEvent_IsControlChange (pMIDIEvent)) {
					if (MIDIEvent_GetNumber (pMIDIEvent) == 32) {
						return pMIDIEvent;
					}
				}
				pMIDIEvent = MIDIEvent_GetNextEvent (pMIDIEvent); // 20110508ǉ
			}
		}
	}
	else if (MIDIEvent_IsProgramChange (pMIDIEvent)) {
		while (pMIDIEvent) { // 20110508C
			if (MIDIEvent_IsControlChange (pMIDIEvent)) {
				if (MIDIEvent_GetNumber (pMIDIEvent) == 32) {
					return pMIDIEvent;
				}
			}
			pMIDIEvent = MIDIEvent_GetPrevEvent (pMIDIEvent); // 20110508ǉ
		}
	}
	return NULL;
}

MIDIEvent* CSekaijuDoc::FindProgramChange (MIDIEvent* pMIDIEvent) {
	ASSERT (pMIDIEvent);
	MIDITrack* pMIDITrack = MIDIEvent_GetParent (pMIDIEvent);
	ASSERT (pMIDITrack);
	if (MIDIEvent_IsControlChange (pMIDIEvent)) {
		long lNumber = MIDIEvent_GetNumber (pMIDIEvent);
		if (lNumber == 0 || lNumber == 32) {
			while (pMIDIEvent) { // 20110508C
				if (MIDIEvent_IsProgramChange (pMIDIEvent)) {
					return pMIDIEvent;
				}
				pMIDIEvent = MIDIEvent_GetNextEvent (pMIDIEvent); // 20110508ǉ
			}
		}
	}
	return NULL;
}

// wgbNlTimeɂlKey̖(F"C#6")擾 // 20090501ǉ
CString CSekaijuDoc::GetKeyName (MIDITrack* pMIDITrack, long lTime, long lKey) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	long lTrackViewMode = MIDITrack_GetViewMode (pMIDITrack);
	// ̃gbN̕\[h́uʏv̏ꍇ
	if (lTrackViewMode == 0) {
		long lsf, lmi;
		long lOctaveSignature = pSekaijuApp->m_theGeneralOption.m_lOctaveSignature;
		MIDIData_FindKeySignature (m_pMIDIData, lTime, &lsf, &lmi);
		long lIndex = (lsf & 0x0000000F) * 16 + (lKey % 12);
		CString strKeyName;
		strKeyName.Format (_T("%s%d"), 
			pSekaijuApp->m_strNoteKeyName[lIndex], 
			lKey / 12 + lOctaveSignature - 5);
		return strKeyName;
	}
	// ̃gbN̕\[h́uhv̏ꍇ
	else {
		long lTrackOutputPort = MIDITrack_GetOutputPort (pMIDITrack);
		MIDIInstrumentDefinition* pMIDIInstDef = pSekaijuApp->m_pMIDIInstDefDrum[lTrackOutputPort];
		// ̃gbN̎w肷|[g̃CXgDg`
		if (pMIDIInstDef) {
			long lTrackCC0, lTrackCC32, lTrackPC;
			MIDIEvent* pCC0Event = GetTrackFirstControlChange (pMIDITrack, 0);
			if (pCC0Event) {
				lTrackCC0 = MIDIEvent_GetValue (pCC0Event);
			}
			else {
				lTrackCC0 = 0;
			}
			MIDIEvent* pCC32Event = GetTrackFirstControlChange (pMIDITrack, 32);
			if (pCC32Event) {
				lTrackCC32 = MIDIEvent_GetValue (pCC32Event);
			}
			else {
				lTrackCC32 = 0;
			}
			MIDIEvent* pPCEvent = GetTrackFirstProgramChange (pMIDITrack);
			if (pPCEvent) {
				lTrackPC = MIDIEvent_GetNumber (pPCEvent);
			}
			else {
				lTrackPC = 0;
			}
			MIDINoteNameTable* pNoteNameTable = 
				MIDIInstrumentDefinition_GetNoteNameTable 
				(pSekaijuApp->m_pMIDIInstDefDrum[lTrackOutputPort], 
				(lTrackCC0 << 7) | (lTrackCC32), lTrackPC);
			// ̃CXgDg`͎woN/vO
			// NoteNameTableĂ
			if (pNoteNameTable) {
				TCHAR szKeyName[256];
				memset (szKeyName, 0, sizeof (szKeyName));
				MIDINoteNameTable_GetName 
					(pNoteNameTable, lKey, szKeyName, TSIZEOF (szKeyName) - 1);
				CString strKeyName (szKeyName);
				return strKeyName;
			}
			// ̃CXgDg`͎woN/vO
			// NoteNameTableĂȂ
			else {
				return _T("");
			}
		}
		// ̃gbN̎w肷|[g̃CXgDg`Ȃ
		else {
			return _T("");
		}
	}
}

// ^C::b:~bɕϊ // 20100502ǉ
BOOL CSekaijuDoc::LongTimeToStringMillisec (MIDIData* pMIDIData, long lTime, CString* pstrText) {
	long lMilliSec, lHour, lMinute, lSec, lMSec;
	lMilliSec = MIDIData_TimeToMillisec (pMIDIData, lTime);
	lHour = lMilliSec / 3600000;
	lMinute = (lMilliSec % 3600000) / 60000;
	lSec = (lMilliSec % 60000) / 1000;
	lMSec = (lMilliSec % 1000);
	pstrText->Format (_T("%02d:%02d:%02d:%03d"), lHour, lMinute, lSec, lMSec);
	return TRUE;
}

// ^C::eBbN  t[ԍ:eBbNɕϊ // 20100502ǉ
BOOL CSekaijuDoc::LongTimeToStringTime (MIDIData* pMIDIData, long lTime, CString* pstrText) {
	long lTimeMode = MIDIData_GetTimeMode (pMIDIData);
	long lTimeResolution = MIDIData_GetTimeResolution (pMIDIData);
	// TPQNx[X̏ꍇ(W)clong"::eBbN"
	if (lTimeMode == MIDIDATA_TPQNBASE) {
		long lMeasure, lBeat, lTick;
		MIDIData_BreakTime (pMIDIData, lTime, &lMeasure, &lBeat, &lTick);
		pstrText->Format (_T("%05d:%02d:%03d"), lMeasure + 1, lBeat + 1, lTick);
		return TRUE;
	}
	// SMPTE24x[XASMPTE25x[XASMPTE29.97x[XASMPTE30x[X̏ꍇclong"t[:Tut["
	else if (lTimeMode == MIDIDATA_SMPTE24BASE || lTimeMode == MIDIDATA_SMPTE25BASE ||
		lTimeMode == MIDIDATA_SMPTE29BASE || lTimeMode == MIDIDATA_SMPTE30BASE) {
		long lFrameNumber, lTick;
		lFrameNumber = lTime / lTimeResolution;
		lTick = lTime % lTimeResolution;
		pstrText->Format (_T("%08d:%03d"), lFrameNumber, lTick);
		return TRUE;
	}
	return FALSE;
}

// ::eBbN  t[ԍ:eBbN^Cɕϊ // 20100502ǉ
// ߂lF=0, ُ=G[bZ[W񃊃\[XID(1`)
long CSekaijuDoc::StringTimeToLongTime (MIDIData* pMIDIData, CString strText, long* pTime) {
	long lTimeMode = MIDIData_GetTimeMode (pMIDIData);
	long lTimeResolution = MIDIData_GetTimeResolution (pMIDIData);
	long lTemp = 0;
	CString strToken;
	// TPQNx[X̏ꍇ(W)c"::eBbN"long
	if (lTimeMode == MIDIDATA_TPQNBASE) {
		long lMeasure, lBeat, lTick;
		// ߂Ɣ̊Ԃ̃Zp[^`FbN
		lTemp = strText.Find (_T(":"));
		if (lTemp < 0) {
			return IDS_A_SEPARATOR_BETWEEN_MEASURE_AND_BEAT_IS_NOT_FOUND;
		}
		// ߕ`FbN
		strToken = strText.Left (lTemp);
		if (IsNumeric (strToken) <= 0) {
			return IDS_MEASURE_MUST_BE_HALF_WIDTH_NUMBER;
		}
		// ߒl`FbN
		lMeasure = _ttol (strToken) - 1;
		if (lMeasure < 0 || lMeasure >= 65535) {
			return IDS_MEASURE_VALUE_IS_OUT_OF_RANGE;
		}
		// ƃeBbN̊Ԃ̃Zp[^`FbN
		strText = strText.Mid (lTemp + 1);
		lTemp = strText.Find (_T(":"));
		if (lTemp < 0) {
			return IDS_A_SEPARATOR_BETWEEN_BEAT_AND_TICK_IS_NOT_FOUND;
		}
		// `FbN
		strToken = strText.Left (lTemp);
		if (IsNumeric (strToken) <= 0) {
			return IDS_BEAT_MUST_BE_HALF_WIDTH_NUMBER;
		}
		// l`FbN
		lBeat = _ttol (strToken) - 1;
		if (lBeat < 0 || lBeat >= 100) {
			return IDS_BEAT_VALUE_IS_OUT_OF_RANGE;
		}
		// eBbN`FbN
		strText = strText.Mid (lTemp + 1);
		if (IsNumeric (strToken) <= 0) {
			return IDS_TICK_MUST_BE_HALF_WIDTH_NUMBER;
		}
		// eBbNl`FbN
		lTick = _ttol (strText);
		if (lTick < 0 || lTick > 960) {
			return IDS_TICK_VALUE_IS_OUT_OF_RANGE;
		}
		MIDIData_MakeTime (pMIDIData, lMeasure, lBeat, lTick, pTime);
		*pTime = CLIP (0x00000000, *pTime, 0x7FFFFFFF);
		return 0;
	}
	// SMPTE24x[XASMPTE25x[XASMPTE29.97x[XASMPTE30x[X̏ꍇc"t[:Tut["long
	else if (lTimeMode == MIDIDATA_SMPTE24BASE || lTimeMode == MIDIDATA_SMPTE25BASE ||
		lTimeMode == MIDIDATA_SMPTE29BASE || lTimeMode == MIDIDATA_SMPTE30BASE) {
		long lFrame, lSubFrame;
		// t[ƃTut[̊Ԃ̃Zp[^`FbN
		lTemp = strText.Find (_T(":"));
		if (lTemp < 0) {
			return IDS_A_SEPARATOR_BETWEEN_FRAME_AND_TICK_IS_NOT_FOUND;
		}
		// t[`FbN
		strToken = strText.Left (lTemp);
		if (IsNumeric (strToken) <= 0) {
			return IDS_FRAME_MUST_BE_HALF_WIDTH_NUMBER;
		}
		// t[l`FbN
		lFrame = _ttol (strToken);
		if (lFrame < 0 || lFrame > 99999999) {
			return IDS_FRAME_VALUE_IS_OUT_OF_RANGE;
		}
		// Tut[`FbN
		strText = strText.Mid (lTemp + 1);
		if (IsNumeric (strToken) <= 0) {
			return IDS_SUBFRAME_MUST_BE_HALF_WIDTH_NUMBER;
		}
		// Tut[l`FbN
		lSubFrame = _ttol (strText);
		if (lSubFrame < 0 || lSubFrame > 960) {
			return IDS_SUBFRAME_VALUE_IS_OUT_OF_RANGE;
		}
		*pTime = lFrame * lTimeResolution + lSubFrame;
		*pTime = CLIP (0x00000000, *pTime, 0x7FFFFFFF);
		return 0;
	}
	else {
		return 0;
	}
}

// VKgbNXg\
void CSekaijuDoc::ShowTrackListFrame () {
	CSekaijuDocTemplate* pDocTemplate = (CSekaijuDocTemplate*)GetDocTemplate ();
	CTrackListFrame* pTrackListFrame = 
		(CTrackListFrame*)(pDocTemplate->CreateTrackListFrame (this));
	pDocTemplate->InitialUpdateFrame (pTrackListFrame, this);
}

// VKsAm[\
void CSekaijuDoc::ShowPianoRollFrame () {
	CSekaijuDocTemplate* pDocTemplate = (CSekaijuDocTemplate*)GetDocTemplate ();
	CPianoRollFrame* pPianoRollFrame = 
		(CPianoRollFrame*)(pDocTemplate->CreatePianoRollFrame (this));
	pDocTemplate->InitialUpdateFrame (pPianoRollFrame, this);

}

// VKCxgXg\
void CSekaijuDoc::ShowEventListFrame () {
	CSekaijuDocTemplate* pDocTemplate = (CSekaijuDocTemplate*)GetDocTemplate ();
	CEventListFrame* pEventListFrame = 
		(CEventListFrame*)(pDocTemplate->CreateEventListFrame (this));
	pDocTemplate->InitialUpdateFrame (pEventListFrame, this);

}

// VKʕ\
void CSekaijuDoc::ShowMusicalScoreFrame () {
	CSekaijuDocTemplate* pDocTemplate = (CSekaijuDocTemplate*)GetDocTemplate ();
	CMusicalScoreFrame* pMusicalScoreFrame = 
		(CMusicalScoreFrame*)(pDocTemplate->CreateMusicalScoreFrame (this));
	pDocTemplate->InitialUpdateFrame (pMusicalScoreFrame, this);

}





// MIDIEvent𓯂MIDICxgŒuAVMIDICxgԂB
// MIDIEvent̃vpeBύXۂɂ͕K̊֐ĂяoAԂۑB
// (1)pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent);
// (2)pCloneEvent = ReplaceMIDIevent (pMIDITrack, pMIDIEvent);
// (3)MIDIEvent_Set* (pCloneEvent, *);
// (4)pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent);
MIDIEvent* CSekaijuDoc::ReplaceMIDIEvent (MIDIEvent* pMIDIEvent) {
	long lCount = 0;
	long lPosition = 0;
	ASSERT (pMIDIEvent);
	MIDITrack* pMIDITrack = MIDIEvent_GetParent (pMIDIEvent);
	ASSERT (pMIDITrack);
	MIDIEvent* pTargetEvent = MIDIEvent_GetFirstCombinedEvent (pMIDIEvent);
	MIDIEvent* pCloneEvent = MIDIEvent_CreateClone (pMIDIEvent);
	if (pCloneEvent == NULL) {
		return NULL;
	}
	MIDIEvent* pInsertEvent = MIDIEvent_GetFirstCombinedEvent (pCloneEvent);
	while (pTargetEvent && pInsertEvent) {
		MIDIEvent* pTargetPrevEvent = pTargetEvent->m_pPrevEvent;
		MIDIEvent* pTargetNextEvent = pTargetEvent->m_pNextEvent;
		pInsertEvent->m_lUserFlag &= ~MIDIEVENT_ALIVE; // tOAddHistoryRecordŌ
		pInsertEvent->m_lUserFlag &= ~MIDIEVENT_DEAD; // tOAddHistoryRecordŌ
		VERIFY (MIDITrack_RemoveSingleEvent (pMIDITrack, pTargetEvent));
		VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pInsertEvent, pTargetPrevEvent));
		pTargetEvent = pTargetEvent->m_pNextCombinedEvent;
		pInsertEvent = pInsertEvent->m_pNextCombinedEvent;
		lCount++;
	}
	ASSERT (pTargetEvent == NULL && pInsertEvent == NULL);
	return pCloneEvent;
}

// MIDICxg̕sBCxg͕Cxg̒ɑ}ĂB
// ӁFEOTȂǂ𕡐ĂNULLԂB
MIDIEvent* CSekaijuDoc::DuplicateMIDIEvent (MIDIEvent* pMIDIEvent) {
	ASSERT (pMIDIEvent);
	MIDITrack* pMIDITrack = MIDIEvent_GetParent (pMIDIEvent);
	ASSERT (pMIDITrack);
	long lCount = 0;
	long lRet = 0;
	MIDIEvent* pTargetEvent = MIDIEvent_GetFirstCombinedEvent (pMIDIEvent);
	MIDIEvent* pCloneEvent = MIDIEvent_CreateClone (pMIDIEvent);
	if (pCloneEvent == NULL) {
		return NULL;
	}
	MIDIEvent* pInsertEvent = pCloneEvent;
	while (pTargetEvent && pInsertEvent) {
		pInsertEvent->m_lUserFlag &= ~MIDIEVENT_ALIVE;
		pInsertEvent->m_lUserFlag &= ~MIDIEVENT_DEAD;
		lRet = MIDITrack_InsertSingleEventAfter (pMIDITrack, pInsertEvent, pTargetEvent);
		if (lRet == 0) {
			MIDIEvent_Delete (pCloneEvent);
			pCloneEvent = NULL;
			return NULL;
		}
		pTargetEvent = pTargetEvent->m_pNextCombinedEvent;
		pInsertEvent = pInsertEvent->m_pNextCombinedEvent;
		lCount++;
	}
	ASSERT (pTargetEvent == NULL && pInsertEvent == NULL);
	return pCloneEvent;
}

// MIDITrackIuWFNgւAVMIDITrackIuWFNgԂB
// MIDIEventIuWFNǵAVMIDITrack̏LƂȂB
MIDITrack* CSekaijuDoc::ReplaceMIDITrack (MIDITrack* pMIDITrack) {
	ASSERT (pMIDITrack);
	MIDIData* pMIDIData = MIDITrack_GetParent (pMIDITrack);
	ASSERT (pMIDIData);
	// Cxg0̋MIDITrack쐬
	MIDITrack* pCloneTrack = NULL;
	pCloneTrack = MIDITrack_Create ();
	if (pCloneTrack == NULL) {
		return NULL;
	}
	pCloneTrack->m_lInputOn = pMIDITrack->m_lInputOn;
	pCloneTrack->m_lInputPort = pMIDITrack->m_lInputPort;
	pCloneTrack->m_lInputChannel = pMIDITrack->m_lInputChannel;
	pCloneTrack->m_lOutputOn = pMIDITrack->m_lOutputOn;
	pCloneTrack->m_lOutputPort = pMIDITrack->m_lOutputPort;
	pCloneTrack->m_lOutputChannel = pMIDITrack->m_lOutputChannel;
	pCloneTrack->m_lTimePlus = pMIDITrack->m_lTimePlus;
	pCloneTrack->m_lKeyPlus = pMIDITrack->m_lKeyPlus;
	pCloneTrack->m_lVelocityPlus = pMIDITrack->m_lVelocityPlus;
	pCloneTrack->m_lViewMode = pMIDITrack->m_lViewMode;
	pCloneTrack->m_lForeColor = pMIDITrack->m_lForeColor;
	pCloneTrack->m_lBackColor = pMIDITrack->m_lBackColor;
	pCloneTrack->m_lUser1 = pMIDITrack->m_lUser1;
	pCloneTrack->m_lUser2 = pMIDITrack->m_lUser2;
	pCloneTrack->m_lUser3 = pMIDITrack->m_lUser3;
	pCloneTrack->m_lUserFlag = pMIDITrack->m_lUserFlag;
	// ÕgbNƎ̃gbNێĂ(ȂNULL)B
	MIDITrack* pTargetPrevTrack = pMIDITrack->m_pPrevTrack;
	MIDITrack* pTargetNextTrack = pMIDITrack->m_pNextTrack;
	// ւMIDIgbNMIDICxgׂčւMIDIgbNɈړB
	MIDITrack_CountEvent (pMIDITrack);
	MIDIEvent* pMIDIEvent = MIDITrack_GetFirstEvent (pMIDITrack);
	while (pMIDIEvent) {
		VERIFY (MIDITrack_RemoveEvent (pMIDITrack, pMIDIEvent));
		VERIFY (MIDITrack_InsertEvent (pCloneTrack, pMIDIEvent));
		pMIDIEvent = MIDITrack_GetFirstEvent (pMIDITrack);
	}
	// MIDIf[^ÂMIDITrackAVMIDITrackǉ
	VERIFY (MIDIData_RemoveTrack (pMIDIData, pMIDITrack));
	VERIFY (MIDIData_InsertTrackAfter (pMIDIData, pCloneTrack, pTargetPrevTrack));
	return pCloneTrack;
}

// MIDIDataIuWFNgւAVMIDIDataIuWFNgԂB
// MIDITrackIuWFNǵAVMIDIDatȁLƂȂB
MIDIData* CSekaijuDoc::ReplaceMIDIData (MIDIData* pMIDIData) {
	ASSERT (pMIDIData);
	// gbN0̋MIDIf[^쐬
	MIDIData* pCloneData = NULL;
	long lFormat = MIDIData_GetFormat (pMIDIData);
	long lTimeMode = MIDIData_GetTimeMode (pMIDIData);
	long lTimeResolution = MIDIData_GetTimeResolution (pMIDIData);
	pCloneData = MIDIData_Create (lFormat, 0, lTimeMode, lTimeResolution);
	if (pCloneData == NULL) {
		return NULL;
	}
	pCloneData->m_lUser1 = pMIDIData->m_lUser1;
	pCloneData->m_lUser2 = pMIDIData->m_lUser2;
	pCloneData->m_lUser3 = pMIDIData->m_lUser3;
	pCloneData->m_lUserFlag = pMIDIData->m_lUserFlag;
	// ւMIDIf[^MIDIgbNׂčւMIDIf[^ɈړB
	MIDIData_CountTrack (pMIDIData);
	MIDITrack* pMIDITrack = MIDIData_GetFirstTrack (pMIDIData);
	while (pMIDITrack) {
		VERIFY (MIDIData_RemoveTrack (pMIDIData, pMIDITrack));
		VERIFY (MIDIData_AddTrack (pCloneData, pMIDITrack));
		pMIDITrack = MIDIData_GetFirstTrack (pMIDIData);
	}
	// ÂMIDIDataAVMIDIDataݒ
	this->m_pMIDIData = pCloneData;
	return pCloneData;
}

// VKjbg̒ǉ(jbg)
BOOL CSekaijuDoc::AddHistoryUnit (CString strName) {
	// ݂̗jbgȍ~ɂsvȗjbg폜
	long lNumHistoryUnit = m_theHistoryUnitArray.GetSize ();
	for (long i = lNumHistoryUnit - 1; i > m_lCurHistoryPosition; i--) {
		CHistoryUnit* pHistoryUnit = (CHistoryUnit*)m_theHistoryUnitArray.GetAt (i);
		m_theHistoryUnitArray.RemoveAt (i);
		delete pHistoryUnit;
	}
	// VKjbg쐬
	CHistoryUnit* pHistoryUnit = new CHistoryUnit ();
	pHistoryUnit->m_strName = strName;
	pHistoryUnit->m_theTime = CTime::GetCurrentTime ();
	// jbgzɒǉ
	m_theHistoryUnitArray.Add (pHistoryUnit);
	// ̗jbg̃CfbNX݂̗jbgƂB
	m_lCurHistoryPosition = m_theHistoryUnitArray.GetSize () - 1;

	//for Debug
	//FILE* pFile = fopen ("history.txt", "at");
	//fprintf (pFile, "// AddHistoryUnit Index=%d, Name=%s, Time=%d\n", i+1, strName, pHistoryUnit->m_theTime);
	//fclose (pFile);
	
	return TRUE;
}

// ݂̗jbg擾
CHistoryUnit* CSekaijuDoc::GetCurHistoryUnit () {
	// ݂̗jbgԍm_lCurHistoryPositionێĂB
	// ̒ĺAuɖ߂vŃfNgAu蒼vŃCNgB
	long lNumHistoryUnit = m_theHistoryUnitArray.GetSize ();
	if (0 <= m_lCurHistoryPosition && m_lCurHistoryPosition < lNumHistoryUnit) {
		return (CHistoryUnit*)m_theHistoryUnitArray.GetAt (m_lCurHistoryPosition);
	}
	ASSERT (FALSE);
	return NULL;
}

// jbg̊S
BOOL CSekaijuDoc::DeleteAllHistoryUnit () {
	long lNumHistoryUnit = m_theHistoryUnitArray.GetSize ();
	for (long i = lNumHistoryUnit - 1; i >= 0; i--) {
		CHistoryUnit* pHistoryUnit = (CHistoryUnit*)m_theHistoryUnitArray.GetAt (i);
		m_theHistoryUnitArray.RemoveAt (i);
		delete pHistoryUnit;
	}
	m_lCurHistoryPosition = -1;
	return TRUE;
}





//------------------------------------------------------------------------------
// bZ[W}bv
//------------------------------------------------------------------------------

// wt@C(&F)x-w㏑ۑ(&S)x
void CSekaijuDoc::OnUpdateFileSaveUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

}

// wt@C(&F)x-wOtĕۑ(&A)x
void CSekaijuDoc::OnUpdateFileSaveAsUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
}


// wt@C(&F)x-wvpeB(&R)x
void CSekaijuDoc::OnFileProperty () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	// 20120107 '\t''\r''\n''\\'̍ɑΉ
	CString strFormat;
	CFilePropertyDlg theDlg;
	TCHAR szBuf1[2048];
	TCHAR szBuf2[2048];
	memset (szBuf1, 0, sizeof (szBuf1));
	memset (szBuf2, 0, sizeof (szBuf2));
	MIDIData_GetTitle (m_pMIDIData, szBuf1, TSIZEOF (szBuf1) - 1);
	codestr2str (szBuf1, TCSLEN (szBuf1), szBuf2, TSIZEOF (szBuf2) - 1);
	theDlg.m_strTitle = szBuf2;
	memset (szBuf1, 0, sizeof (szBuf1));
	memset (szBuf2, 0, sizeof (szBuf2));
	MIDIData_GetSubTitle (m_pMIDIData, szBuf1, TSIZEOF (szBuf1) - 1);
	codestr2str (szBuf1, TCSLEN (szBuf1), szBuf2, TSIZEOF (szBuf2) - 1);
	theDlg.m_strSubTitle = szBuf2;
	memset (szBuf1, 0, sizeof (szBuf1));
	memset (szBuf2, 0, sizeof (szBuf2));
	MIDIData_GetCopyright (m_pMIDIData, szBuf1, TSIZEOF (szBuf1) - 1);
	codestr2str (szBuf1, TCSLEN (szBuf1), szBuf2, TSIZEOF (szBuf2) - 1);
	theDlg.m_strCopyright = szBuf2;
	memset (szBuf1, 0, sizeof (szBuf1));
	memset (szBuf2, 0, sizeof (szBuf2));
	MIDIData_GetComment (m_pMIDIData, szBuf1, TSIZEOF (szBuf1) - 1);
	codestr2str (szBuf1, TCSLEN (szBuf1), szBuf2, TSIZEOF (szBuf2) - 1);
	theDlg.m_strComment1 = szBuf2;
	long lNumTrack = MIDIData_CountTrack (m_pMIDIData);
	theDlg.m_strNumTrack.Format (_T("%d"), lNumTrack);
	long lNumEvent = 0;
	MIDITrack* pMIDITrack = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		lNumEvent += MIDITrack_CountEvent (pMIDITrack);
	}
	theDlg.m_strNumEvent.Format (_T("%d"), lNumEvent);
	
	long lSMFFormat = MIDIData_GetFormat (m_pMIDIData);
	theDlg.m_nSMFFormat = (int)lSMFFormat;	
	long lTimeMode = MIDIData_GetTimeMode (m_pMIDIData);
	switch (lTimeMode) {
	case MIDIDATA_TPQNBASE:
		theDlg.m_nTimeMode = 0;
		break;
	case MIDIDATA_SMPTE24BASE:
		theDlg.m_nTimeMode = 1;
		break;
	case MIDIDATA_SMPTE25BASE:
		theDlg.m_nTimeMode = 2;
		break;
	case MIDIDATA_SMPTE29BASE:
		theDlg.m_nTimeMode = 3;
		break;
	case MIDIDATA_SMPTE30BASE:
		theDlg.m_nTimeMode = 4;
		break;
	}
	long lTimeResolution = MIDIData_GetTimeResolution (m_pMIDIData);
	theDlg.m_nResolution = (int)lTimeResolution;

	long lEndTime = MIDIData_GetEndTime (m_pMIDIData);
	if (lTimeMode == MIDIDATA_TPQNBASE) {
		long lMeasure, lBeat, lTick;
		MIDIData_BreakTime (m_pMIDIData, lEndTime, &lMeasure, &lBeat, &lTick);
		VERIFY (strFormat.LoadString (IDS_05D_02D_03D_MEASURE_BEAT_TICK));
		theDlg.m_strEndTime.Format (strFormat, lMeasure + 1, lBeat + 1, lTick);
	}
	else if (lTimeMode == MIDIDATA_SMPTE24BASE ||
		lTimeMode == MIDIDATA_SMPTE25BASE ||
		lTimeMode == MIDIDATA_SMPTE29BASE ||
		lTimeMode == MIDIDATA_SMPTE30BASE) {
		long lFrameNumber, lTick;
		lFrameNumber = lEndTime / lTimeResolution;
		lTick = lEndTime % lTimeResolution;
		VERIFY (strFormat.LoadString (IDS_08D_03D_FRAME_TICK));
		theDlg.m_strEndTime.Format (strFormat, lFrameNumber, lTick);
	}
	long lEndMillisec = MIDIData_TimeToMillisec (m_pMIDIData, lEndTime);
	long lHour = (lEndMillisec / 3600000) % 3600000;
	long lMinute = (lEndMillisec / 60000) % 60;
	long lSec = (lEndMillisec / 1000) % 60;
	long lMillisec = lEndMillisec % 1000;
	VERIFY (strFormat.LoadString (IDS_02D_02D_02D_03D_HOUR_MINUTE_SECOND_MILLISEC));
	theDlg.m_strEndMillisec.Format (strFormat, lHour, lMinute, lSec, lMillisec);


	
	if (theDlg.DoModal () == IDOK) {

		if (m_bEditLocked) {
			return;
		}
		
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDITrack* pMIDITrack = NULL;
		MIDIEvent* pMIDIEvent = NULL;
		MIDIEvent* pTempEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		MIDITrack* pCloneTrack = NULL;
		MIDIData* pCloneData = NULL;

		// Vjbg̗p
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_FILE_MODIFY_PROPERTY));
		VERIFY (this->AddHistoryUnit (strHistoryName));
		CHistoryUnit* pCurHistoryUnit = NULL;
		VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
		VERIFY (pMIDITrack = MIDIData_GetFirstTrack (m_pMIDIData));
		
		// ^Cgݒ
		// ŏ̃gbNCxgT
		forEachEvent (pMIDITrack, pTempEvent) {
			if (MIDIEvent_GetKind (pTempEvent) == MIDIEVENT_TRACKNAME) {
				break;
			}
		}
		// ŏ̃gbNCxgȂꍇ
		if (pTempEvent == NULL) {
			memset (szBuf2, 0, sizeof (szBuf2));
			str2codestr ((LPTSTR)(LPCTSTR)theDlg.m_strTitle, 
				theDlg.m_strTitle.GetLength (), szBuf2, TSIZEOF (szBuf2) - 1);
			VERIFY (pTempEvent = MIDIEvent_CreateTrackName (0, szBuf2));
			VERIFY (MIDITrack_InsertEvent (pMIDITrack, pTempEvent));
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pTempEvent));
		}
		// ŏ̃gbNꍇ
		else {
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pTempEvent));
			VERIFY (pCloneEvent = this->ReplaceMIDIEvent (pTempEvent));
			memset (szBuf2, 0, sizeof (szBuf2));
			str2codestr ((LPTSTR)(LPCTSTR)theDlg.m_strTitle, 
				theDlg.m_strTitle.GetLength (), szBuf2, TSIZEOF (szBuf2) - 1);
			MIDIEvent_SetText (pCloneEvent, szBuf2);
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
		}

		// Tu^Cg̐ݒ(󕶎񎞂̓Tu^Cg폜)
		// 2Ԗڂ̃gbNCxgT
		long lCount = 0;
		forEachEvent (pMIDITrack, pTempEvent) {
			if (MIDIEvent_GetKind (pTempEvent) == MIDIEVENT_TRACKNAME) {
				if (lCount == 1) {
					break;
				}
				lCount++;
			}
		}
		// Tu^Cgݒ肷ꍇ
		if (theDlg.m_strSubTitle != _T("")) {
			// 2Ԗڂ̃gbNCxgȂꍇ
			if (pTempEvent == NULL) {
				memset (szBuf2, 0, sizeof (szBuf2));
				str2codestr ((LPTSTR)(LPCTSTR)theDlg.m_strSubTitle, 
					theDlg.m_strSubTitle.GetLength (), szBuf2, TSIZEOF (szBuf2) - 1);
				VERIFY (pTempEvent = MIDIEvent_CreateTrackName (0, szBuf2));
				VERIFY (MIDITrack_InsertEvent (pMIDITrack, pTempEvent));
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pTempEvent));
			}
			// 2Ԗڂ̃gbNꍇ
			else {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pTempEvent));
				VERIFY (pCloneEvent = this->ReplaceMIDIEvent (pTempEvent));
				memset (szBuf2, 0, sizeof (szBuf2));
				str2codestr ((LPTSTR)(LPCTSTR)theDlg.m_strSubTitle, 
					theDlg.m_strSubTitle.GetLength (), szBuf2, TSIZEOF (szBuf2) - 1);
				MIDIEvent_SetText (pCloneEvent, szBuf2);
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
			}
		}
		// Tu^Cg폜ꍇ
		else {
			// 2Ԗڂ̃gbNꍇ
			if (pTempEvent) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pTempEvent));
				VERIFY (MIDITrack_RemoveEvent (pMIDITrack, pTempEvent));
			}
		}

		// 쌠ݒ(󕶎͒쌠Cxg폜)
		// ŏ̒쌠CxgT
		forEachEvent (pMIDITrack, pTempEvent) {
			if (MIDIEvent_GetKind (pTempEvent) == MIDIEVENT_COPYRIGHTNOTICE) {
				break;
			}
		}
		// 쌠ݒ肷ꍇ
		if (theDlg.m_strCopyright != _T("")) {
			// ŏ̒쌠CxgȂꍇ
			if (pTempEvent == NULL) {
				memset (szBuf2, 0, sizeof (szBuf2));
				str2codestr ((LPTSTR)(LPCTSTR)theDlg.m_strCopyright, 
					theDlg.m_strCopyright.GetLength (), szBuf2, TSIZEOF (szBuf2) - 1);
				VERIFY (pTempEvent = MIDIEvent_CreateCopyrightNotice (0, szBuf2));
				VERIFY (MIDITrack_InsertEvent (pMIDITrack, pTempEvent));
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pTempEvent));
			}
			// ŏ̒쌠Cxgꍇ
			else {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pTempEvent));
				VERIFY (pCloneEvent = this->ReplaceMIDIEvent (pTempEvent));
				memset (szBuf2, 0, sizeof (szBuf2));
				str2codestr ((LPTSTR)(LPCTSTR)theDlg.m_strCopyright, 
					theDlg.m_strCopyright.GetLength (), szBuf2, TSIZEOF (szBuf2) - 1);
				MIDIEvent_SetText (pCloneEvent, szBuf2);
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
			}
		}
		// 쌠폜ꍇ
		else {
			// ŏ̒쌠Cxgꍇ
			if (pTempEvent) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pTempEvent));
				VERIFY (MIDITrack_RemoveEvent (pMIDITrack, pTempEvent));
			}
		}

		// Rg1ݒ(󕶎͍ŏ̃eLXgCxg폜)
		// ŏ̃eLXgCxgT
		forEachEvent (pMIDITrack, pTempEvent) {
			if (MIDIEvent_GetKind (pTempEvent) == MIDIEVENT_TEXTEVENT) {
				break;
			}
		}
		// Rg1ݒ肷ꍇ
		if (theDlg.m_strComment1 != _T("")) {
			// ŏ̃eLXgCxgȂꍇ
			if (pTempEvent == NULL) {
				memset (szBuf2, 0, sizeof (szBuf2));
				str2codestr ((LPTSTR)(LPCTSTR)theDlg.m_strComment1, 
					theDlg.m_strComment1.GetLength (), szBuf2, TSIZEOF (szBuf2) - 1);
				VERIFY (pTempEvent = MIDIEvent_CreateTextEvent (0, szBuf2));
				VERIFY (MIDITrack_InsertEvent (pMIDITrack, pTempEvent));
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pTempEvent));
			}
			// ŏ̃eLXgCxgꍇ
			else {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pTempEvent));
				VERIFY (pCloneEvent = this->ReplaceMIDIEvent (pTempEvent));
				memset (szBuf2, 0, sizeof (szBuf2));
				str2codestr ((LPTSTR)(LPCTSTR)theDlg.m_strComment1, 
					theDlg.m_strComment1.GetLength (), szBuf2, TSIZEOF (szBuf2) - 1);
				MIDIEvent_SetText (pCloneEvent, szBuf2);
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
			}
		}
		// Rg1폜ꍇ
		else {
			// ŏ̃eLXgCxgꍇ
			if (pTempEvent) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pTempEvent));
				VERIFY (MIDITrack_RemoveEvent (pMIDITrack, pTempEvent));
			}
		}

		// VSMFtH[}bgo
		long lNewSMFFormat = theDlg.m_nSMFFormat;
		// SMFtH[}bgύXꂽꍇ
		if (lNewSMFFormat != lSMFFormat) {
			// SIuWFNg̗L^(20090116L^@C)
			forEachTrackInverse (m_pMIDIData, pMIDITrack) {
				if (MIDITrack_GetFirstEvent (pMIDITrack)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord 
					(HISTORYRECORD_REMOVEEVENTALL, MIDITrack_GetFirstEvent (pMIDITrack)));
				}
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack));
			}
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEDATA, m_pMIDIData));

			// SIuWFNǧ
			forEachTrackInverse (m_pMIDIData, pMIDITrack) {
				forEachEventInverse (pMIDITrack, pMIDIEvent) {
					if (pMIDIEvent->m_pPrevCombinedEvent == NULL) {
						VERIFY (pCloneEvent = this->ReplaceMIDIEvent (pMIDIEvent));
						pMIDIEvent = pCloneEvent;
					}
				}
				VERIFY (pCloneTrack = this->ReplaceMIDITrack (pMIDITrack));
				pMIDITrack = pCloneTrack;
			}
			VERIFY (m_pMIDIData = this->ReplaceMIDIData (m_pMIDIData));

			// tH[}bg0/1/2ϊ
			MIDIData_SetFormat (m_pMIDIData, lNewSMFFormat);
			MIDIData_CountTrack (m_pMIDIData);
			long i = 0;
			forEachTrack (m_pMIDIData, pMIDITrack) {
				MIDITrack_SetForeColor (pMIDITrack, pSekaijuApp->m_theColorOption.m_lForeColor[i % 8]);
				i++;
			}

			// SIuWFNg̗L^(20090116L^@C)
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTDATA, m_pMIDIData));
			forEachTrack (m_pMIDIData, pMIDITrack) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pMIDITrack));
				if (MIDITrack_GetFirstEvent (pMIDITrack)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENTALL, 
					MIDITrack_GetFirstEvent (pMIDITrack)));
				}
			}
		}
		
		// V^C[hƕ\o
		long lNewTimeMode = 0;
		switch (theDlg.m_nTimeMode) {
		case 0:
			lNewTimeMode = MIDIDATA_TPQNBASE;
			break;
		case 1:
			lNewTimeMode = MIDIDATA_SMPTE24BASE;
			break;
		case 2:
			lNewTimeMode = MIDIDATA_SMPTE25BASE;
			break;
		case 3:
			lNewTimeMode = MIDIDATA_SMPTE29BASE;
			break;
		case 4:
			lNewTimeMode = MIDIDATA_SMPTE30BASE;
			break;
		}
		long lNewTimeResolution = theDlg.m_nResolution;
		// ^C[h͕\ύXꂽꍇ
		if (lNewTimeMode != lTimeMode ||
			lNewTimeResolution != lTimeResolution) {
			CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
			
			// t̏ꍇAẗꎞ~
			pSekaijuApp->SendAllNoteOff ();
			pSekaijuApp->SendAllHold1Off ();
			pSekaijuApp->SendAllSostenutoOff ();
			pSekaijuApp->SendAllHold2Off ();
			if (pSekaijuApp->m_bPlaying) {
				MIDIClock_Stop (m_pMIDIClock);
			}
			long lTempo = MIDIEVENT_DEFTEMPO;
			VERIFY (MIDIData_FindTempo (m_pMIDIData, 0, &lTempo));

			// SIuWFNg̗L^(20090116L^@C)
			forEachTrackInverse (m_pMIDIData, pMIDITrack) {
				if (MIDITrack_GetFirstEvent (pMIDITrack)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord 
					(HISTORYRECORD_REMOVEEVENTALL, MIDITrack_GetFirstEvent (pMIDITrack)));
				}
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack));
			}
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEDATA, m_pMIDIData));

			// SIuWFNǧ
			forEachTrackInverse (m_pMIDIData, pMIDITrack) {
				forEachEventInverse (pMIDITrack, pMIDIEvent) {
					if (pMIDIEvent->m_pPrevCombinedEvent == NULL) {
						VERIFY (pCloneEvent = this->ReplaceMIDIEvent (pMIDIEvent));
						pMIDIEvent = pCloneEvent;
					}
				}
				VERIFY (pCloneTrack = this->ReplaceMIDITrack (pMIDITrack));
				pMIDITrack = pCloneTrack;
			}
			VERIFY (m_pMIDIData = this->ReplaceMIDIData (m_pMIDIData));
			
			// ^Cx[X(^C[hyѕ\)̕ϊ
			MIDIData_SetTimeBase (m_pMIDIData, lNewTimeMode, lNewTimeResolution);

			// SIuWFNg̗L^(20090116L^@C)
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTDATA, m_pMIDIData));
			forEachTrack (m_pMIDIData, pMIDITrack) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pMIDITrack));
				if (MIDITrack_GetFirstEvent (pMIDITrack)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord 
					(HISTORYRECORD_INSERTEVENTALL, MIDITrack_GetFirstEvent (pMIDITrack)));
				}
			}
			
			// MIDINbÑ^C[hƑxAvP[Vɍ킹(20090625ǉ)
			ApplyAppCurSpeedIndex ();

			MIDIClock_Reset (m_pMIDIClock);
			MIDIClock_SetTempo (m_pMIDIClock, lTempo);

			// tꍇAt̑s
			if (pSekaijuApp->m_bPlaying) {
				MIDIClock_Start (m_pMIDIClock);
			}
		}
		SetModifiedFlag (TRUE);
		UpdateAllViews (NULL, SEKAIJUDOC_MIDIDATACHANGED | SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIEVENTCHANGED);
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
	}
}

// wt@C(&F)x-wvpeB(&R)x
void CSekaijuDoc::OnUpdateFilePropertyUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}

}


// wҏW(&E)x-wɖ߂(&U)x
void CSekaijuDoc::OnEditUndo () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	CString strMsg;
	this->m_theCriticalSection.Lock ();
	long lNumHistoryUnit = m_theHistoryUnitArray.GetSize ();
	// ݂̗jbgȂꍇ
	if (m_lCurHistoryPosition <= -1) {
		this->m_theCriticalSection.Unlock ();
		VERIFY (strMsg.LoadString (IDS_UNABLE_TO_UNDO_ANYMORE));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return;
	}
	
	BeginWaitCursor ();
	// ݂̗jbg擾
	CHistoryUnit* pHistoryUnit = 
		(CHistoryUnit*)m_theHistoryUnitArray.GetAt (m_lCurHistoryPosition);
	long lHistoryRecordCount = pHistoryUnit->m_theHistoryRecordArray.GetSize ();
	long i;
	MIDIData* pMIDIData = NULL;
	MIDITrack* pPrevTrack = NULL;
	MIDITrack* pNextTrack = NULL;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pPrevEvent = NULL;
	MIDIEvent* pNextEvent = NULL;
	MIDIEvent* pFirstEvent = NULL;
	MIDIEvent* pLastEvent = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	MIDITrack* pTempTrack = NULL;
	MIDIEvent* pTempEvent = NULL;
	MIDITrack* pFirstTrack = NULL;
	MIDITrack* pLastTrack = NULL;
	MIDIData* pTempData = NULL;
	
	// jbgɂ邷ׂĂ̋L^ɂāA]
	for (i = lHistoryRecordCount - 1; i >= 0; i--) {
		CHistoryRecord* pHistoryRecord = 
			(CHistoryRecord*)(pHistoryUnit->m_theHistoryRecordArray.GetAt (i));
		switch (pHistoryRecord->m_lType) {
		// MIDIEventIuWFNg̑}L^MIDIEventIuWFNg̔r
		case HISTORYRECORD_INSERTEVENT:
			pMIDIEvent = (MIDIEvent*)(pHistoryRecord->m_pObject);
			pPrevEvent = (MIDIEvent*)(pHistoryRecord->m_pPrevObject);
			pNextEvent = (MIDIEvent*)(pHistoryRecord->m_pNextObject);
			pMIDITrack = (MIDITrack*)(pHistoryRecord->m_pParent);
			pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_ALIVE;
			pMIDIEvent->m_lUserFlag |= MIDIEVENT_DEAD;
			VERIFY (MIDITrack_RemoveSingleEvent (pMIDITrack, pMIDIEvent));
			break;
		// MIDIEventIuWFNg̏L^MIDIEventIuWFNg̕
		case HISTORYRECORD_REMOVEEVENT:
			pMIDIEvent = (MIDIEvent*)(pHistoryRecord->m_pObject);
			pPrevEvent = (MIDIEvent*)(pHistoryRecord->m_pPrevObject);
			pNextEvent = (MIDIEvent*)(pHistoryRecord->m_pNextObject);
			pFirstEvent = (MIDIEvent*)(pHistoryRecord->m_pFirstChild);
			pLastEvent = (MIDIEvent*)(pHistoryRecord->m_pLastChild);
			pMIDITrack = (MIDITrack*)(pHistoryRecord->m_pParent);
			pMIDIEvent->m_lUserFlag |= MIDIEVENT_ALIVE;
			pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_DEAD;
			// 20090116 MIDIEvent̑}ʒu@ύX
			if (pNextEvent == NULL) {
				VERIFY (MIDITrack_InsertSingleEventBefore (pMIDITrack, pMIDIEvent, pNextEvent));
			}
			else if (MIDIEvent_GetParent (pNextEvent) != NULL) {
				VERIFY (MIDITrack_InsertSingleEventBefore (pMIDITrack, pMIDIEvent, pNextEvent));
			}
			else if (pPrevEvent == NULL) {
				VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pPrevEvent));
			}
			else if (MIDIEvent_GetParent (pPrevEvent) != NULL) {
				VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pPrevEvent));
			}
			else {
				long lInsertTime = MIDIEvent_GetTime (pMIDIEvent);
				pTempEvent = pMIDITrack->m_pLastEvent;
				// gbŇ}ʒuT
				while (1) {
					// gbNɃf[^ȂA̓gbN̐擪Ă悢
					if (pTempEvent == NULL) {
						VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, NULL));
						break;
					}
					// pTempEvent̒ɓĂ悢
					else {
						// }̂m[gItCxg̏ꍇ(xVeB0̃m[gI܂)
						if (MIDIEvent_IsNoteOff (pMIDIEvent)) {
							// Ήm[gICxgOɂ͐΂ɗȂ (20090111ǉ)
							if (pTempEvent == pMIDIEvent->m_pPrevCombinedEvent) {
								VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pTempEvent));
								break;
							}
							// ̃Cxgꍇ͓̑̃m[gIt̒ɑ}
							else if (pTempEvent->m_lTime == lInsertTime && MIDIEvent_IsNoteOff (pTempEvent)) {
								VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pTempEvent));
								break;
							}
							else if (pTempEvent->m_lTime < lInsertTime) {
								VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pTempEvent));
								break;
							}
						}
						// ̑̃Cxg̏ꍇ
						else {
							if (pTempEvent->m_lTime <= lInsertTime) {
								VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pTempEvent));
								break;
							}
						}
					}
					pTempEvent = pTempEvent->m_pPrevEvent;
				}
			}
			break;
		// MIDIEventIuWFNg̑S}L^SMIDIEventIuWFNg̔r
		case HISTORYRECORD_INSERTEVENTALL:
			pMIDIEvent = (MIDIEvent*)(pHistoryRecord->m_pObject);
			pPrevEvent = (MIDIEvent*)(pHistoryRecord->m_pPrevObject);
			pNextEvent = (MIDIEvent*)(pHistoryRecord->m_pNextObject);
			pMIDITrack = (MIDITrack*)(pHistoryRecord->m_pParent);
			pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_ALIVE;
			pMIDIEvent->m_lUserFlag |= MIDIEVENT_DEAD;
			VERIFY (MIDITrack_RemoveSingleEvent (pMIDITrack, pMIDIEvent));
			break;
		// MIDIEventIuWFNg̑SL^SMIDIEventIuWFNg̕
		case HISTORYRECORD_REMOVEEVENTALL:
			pMIDIEvent = (MIDIEvent*)(pHistoryRecord->m_pObject);
			pPrevEvent = (MIDIEvent*)(pHistoryRecord->m_pPrevObject);
			pNextEvent = (MIDIEvent*)(pHistoryRecord->m_pNextObject);
			pFirstEvent = (MIDIEvent*)(pHistoryRecord->m_pFirstChild);
			pLastEvent = (MIDIEvent*)(pHistoryRecord->m_pLastChild);
			pMIDITrack = (MIDITrack*)(pHistoryRecord->m_pParent);
			pMIDIEvent->m_lUserFlag |= MIDIEVENT_ALIVE;
			pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_DEAD;
			// 20090116 MIDIEvent̑}ʒu@ύX
			if (pNextEvent == NULL) {
				VERIFY (MIDITrack_InsertSingleEventBefore (pMIDITrack, pMIDIEvent, pNextEvent));
			}
			else if (MIDIEvent_GetParent (pNextEvent) != NULL) {
				VERIFY (MIDITrack_InsertSingleEventBefore (pMIDITrack, pMIDIEvent, pNextEvent));
			}
			else if (pPrevEvent == NULL) {
				VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pPrevEvent));
			}
			else if (MIDIEvent_GetParent (pPrevEvent) != NULL) {
				VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pPrevEvent));
			}
			else {
				ASSERT (FALSE);
			}
			break;
		// MIDITrackIuWFNg̑}L^MIDITrackIuWFNg̔r
		case HISTORYRECORD_INSERTTRACK:
			pMIDITrack = (MIDITrack*)(pHistoryRecord->m_pObject);
			pPrevTrack = (MIDITrack*)(pHistoryRecord->m_pPrevObject);
			pNextTrack = (MIDITrack*)(pHistoryRecord->m_pNextObject);
			pMIDIData = (MIDIData*)(pHistoryRecord->m_pParent);
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_ALIVE;
			pMIDITrack->m_lUserFlag |= MIDITRACK_DEAD;
			VERIFY (MIDIData_RemoveTrack (pMIDIData, pMIDITrack));
			break;
		// MIDITrackIuWFNg̏L^MIDITrackIuWFNg̕
		case HISTORYRECORD_REMOVETRACK:
			pMIDITrack = (MIDITrack*)(pHistoryRecord->m_pObject);
			pPrevTrack = (MIDITrack*)(pHistoryRecord->m_pPrevObject);
			pNextTrack = (MIDITrack*)(pHistoryRecord->m_pNextObject);
			pFirstEvent = (MIDIEvent*)(pHistoryRecord->m_pFirstChild);
			pLastEvent = (MIDIEvent*)(pHistoryRecord->m_pLastChild);
			pMIDIData = (MIDIData*)(pHistoryRecord->m_pParent);
			pMIDITrack->m_lUserFlag |= MIDITRACK_ALIVE;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_DEAD;
			if (pFirstEvent || pLastEvent) {
				VERIFY (pTempEvent = pFirstEvent);
				pTempTrack = MIDIEvent_GetParent (pFirstEvent);
				if (pTempTrack != NULL && pTempTrack != pMIDITrack) {
					while (pTempEvent) {
						VERIFY (MIDITrack_RemoveEvent (pTempTrack, pTempEvent));
						VERIFY (MIDITrack_InsertEvent (pMIDITrack, pTempEvent));
						pTempEvent = MIDITrack_GetFirstEvent (pTempTrack);
					}
				}
			}
			// 20090116 MIDITrack̑}ʒu@ύX
			if (pNextTrack == NULL) {
				VERIFY (MIDIData_InsertTrackBefore (pMIDIData, pMIDITrack, pNextTrack));
			}
			else if (MIDITrack_GetParent (pNextTrack) == pMIDIData) {
				VERIFY (MIDIData_InsertTrackBefore (pMIDIData, pMIDITrack, pNextTrack));
			}
			else if (pPrevTrack == NULL) {
				VERIFY (MIDIData_InsertTrackAfter (pMIDIData, pMIDITrack, pPrevTrack));
			}
			else if (MIDITrack_GetParent (pPrevTrack) == pMIDIData) {
				VERIFY (MIDIData_InsertTrackAfter (pMIDIData, pMIDITrack, pPrevTrack));
			}
			else {
				ASSERT (FALSE);
			}
			break;
		// MIDIDataIuWFNg̑}L^MIDIDataIuWFNg̔r
		case HISTORYRECORD_INSERTDATA:
			pMIDIData = (MIDIData*)(pHistoryRecord->m_pObject);
			pMIDIData->m_lUserFlag &= ~MIDIDATA_ALIVE;
			pMIDIData->m_lUserFlag |= MIDIDATA_DEAD;
			this->m_pMIDIData = NULL;
			break;
		// MIDIDataIuWFNg̏L^MIDIDataIuWFNg̕
		case HISTORYRECORD_REMOVEDATA:
			pMIDIData = (MIDIData*)(pHistoryRecord->m_pObject);
			pFirstTrack = (MIDITrack*)(pHistoryRecord->m_pFirstChild);
			pLastTrack = (MIDITrack*)(pHistoryRecord->m_pLastChild);
			pMIDIData->m_lUserFlag |= MIDIDATA_ALIVE;
			pMIDIData->m_lUserFlag &= ~MIDIDATA_DEAD;
			if (pFirstTrack || pLastTrack) {
				VERIFY (pTempTrack = pFirstTrack);
				pTempData = MIDITrack_GetParent (pFirstTrack);
				if (pTempData != NULL && pTempData != pMIDIData) {
					while (pTempTrack) {
						VERIFY (MIDIData_RemoveTrack (pTempData, pTempTrack));
						VERIFY (MIDIData_AddTrack (pMIDIData, pTempTrack));
						pTempTrack = MIDIData_GetFirstTrack (pTempData);
					}
				}
			}
			this->m_pMIDIData = pMIDIData;
			break;
		}
	}

	// KvɉMIDIClock̕␳
	long lMIDIClockTimeMode;
	long lMIDIClockTimeResolution;
	MIDIClock_GetTimeBase (m_pMIDIClock, &lMIDIClockTimeMode, &lMIDIClockTimeResolution);
	long lMIDIDataTimeMode;
	long lMIDIDataTimeResolution;
	MIDIData_GetTimeBase (m_pMIDIData, &lMIDIDataTimeMode, &lMIDIDataTimeResolution);
	if (lMIDIClockTimeMode != lMIDIDataTimeMode || 
		lMIDIClockTimeResolution != lMIDIDataTimeResolution) {
		// t̏ꍇAẗꎞ~
		pSekaijuApp->SendAllNoteOff ();
		pSekaijuApp->SendAllHold1Off ();
		pSekaijuApp->SendAllSostenutoOff ();
		pSekaijuApp->SendAllHold2Off ();
		if (pSekaijuApp->m_bPlaying) {
			MIDIClock_Stop (m_pMIDIClock);
		}
		long lTempo = MIDIEVENT_DEFTEMPO;
		VERIFY (MIDIData_FindTempo (m_pMIDIData, 0, &lTempo));
		MIDIClock_Reset (m_pMIDIClock);
		MIDIClock_SetTimeBase (m_pMIDIClock, lMIDIDataTimeMode, lMIDIDataTimeResolution);
		MIDIClock_SetTempo (m_pMIDIClock, lTempo);
		if (pSekaijuApp->m_bPlaying) {
			MIDIClock_Start (m_pMIDIClock);
		}
	}

	// ݂̗jbgԍfNg
	this->m_lCurHistoryPosition--;
	this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIDATACHANGED | 
		SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIEVENTCHANGED);
	this->SetModifiedFlag (TRUE);
	this->m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	return;
}

// wҏW(&E)x-wɖ߂(&U)x
void CSekaijuDoc::OnUpdateEditUndoUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	m_theCriticalSection.Lock ();
	long lNumHistoryUnit = m_theHistoryUnitArray.GetSize ();
	// ɖ߂Ȃꍇ
	if (m_lCurHistoryPosition <= -1) {
		CString strText;
		VERIFY (strText.LoadString (IDS_UNABLE_TO_UNDO_T_CTRL_Z));
		pCmdUI->SetText (strText);
		pCmdUI->Enable (FALSE);
	}
	// ɖ߂ꍇ
	else {
		CHistoryUnit* pHistoryUnit = 
			(CHistoryUnit*)m_theHistoryUnitArray.GetAt (m_lCurHistoryPosition);
		CString strFormat;
		CString strText;
		VERIFY (strFormat.LoadString (IDS_UNDO_02D_02D_02D_S_T_CTRL_Z));
		strText.Format (strFormat,
			pHistoryUnit->m_theTime.GetHour (),
			pHistoryUnit->m_theTime.GetMinute (),
			pHistoryUnit->m_theTime.GetSecond (),
			pHistoryUnit->m_strName);
		pCmdUI->SetText (strText);
		pCmdUI->Enable (TRUE);
	}
	m_theCriticalSection.Unlock ();
}


// wҏW(&E)x-w蒼(&R)x
void CSekaijuDoc::OnEditRedo () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	
	this->m_theCriticalSection.Lock ();
	long lNumHistoryUnit = m_theHistoryUnitArray.GetSize ();
	// ̗jbgȂꍇ
	if (m_lCurHistoryPosition >= lNumHistoryUnit - 1) {
		this->m_theCriticalSection.Unlock ();
		CString strText;
		VERIFY (strText.LoadString (IDS_UNABLE_TO_REDO_ANYMORE));
		AfxMessageBox (strText, MB_ICONEXCLAMATION);
		return;
	}
	
	BeginWaitCursor ();
	// ̗jbg擾
	CHistoryUnit* pHistoryUnit = 
		(CHistoryUnit*)m_theHistoryUnitArray.GetAt (m_lCurHistoryPosition + 1);

	long lHistoryRecordCount = pHistoryUnit->m_theHistoryRecordArray.GetSize ();
	long i;
	MIDIData* pMIDIData = NULL;
	MIDITrack* pPrevTrack = NULL;
	MIDITrack* pNextTrack = NULL;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pPrevEvent = NULL;
	MIDIEvent* pNextEvent = NULL;
	MIDIEvent* pFirstEvent = NULL;
	MIDIEvent* pLastEvent = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	MIDITrack* pTempTrack = NULL;
	MIDIEvent* pTempEvent = NULL;
	MIDITrack* pFirstTrack = NULL;
	MIDITrack* pLastTrack = NULL;
	MIDIData* pTempData = NULL;

	// jbgɂ邷ׂĂ̋L^ɂāAO]
	for (i = 0; i < lHistoryRecordCount; i++) {
		CHistoryRecord* pHistoryRecord = 
			(CHistoryRecord*)(pHistoryUnit->m_theHistoryRecordArray.GetAt (i));
		switch (pHistoryRecord->m_lType) {
		// MIDIEventIuWFNg̑}L^MIDIEventIuWFNg̕
		case HISTORYRECORD_INSERTEVENT:
			pMIDITrack = (MIDITrack*)(pHistoryRecord->m_pParent);
			pMIDIEvent = (MIDIEvent*)(pHistoryRecord->m_pObject);
			pPrevEvent = (MIDIEvent*)(pHistoryRecord->m_pPrevObject);
			pNextEvent = (MIDIEvent*)(pHistoryRecord->m_pNextObject);
			pMIDIEvent->m_lUserFlag |= MIDIEVENT_ALIVE;
			pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_DEAD;
			// 20090116 MIDIEvent̑}ʒu@ύX
			if (pPrevEvent == NULL) {
				VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pPrevEvent));
			}
			else if (MIDIEvent_GetParent (pPrevEvent) != NULL) {
				VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pPrevEvent));
			}
			else if (pNextEvent == NULL) {
				VERIFY (MIDITrack_InsertSingleEventBefore (pMIDITrack, pMIDIEvent, pNextEvent));
			}
			else if (MIDIEvent_GetParent (pNextEvent) != NULL) {
				VERIFY (MIDITrack_InsertSingleEventBefore (pMIDITrack, pMIDIEvent, pNextEvent));
			}
			else {
				long lInsertTime = MIDIEvent_GetTime (pMIDIEvent);
				pTempEvent = pMIDITrack->m_pLastEvent;
				// gbŇ}ʒuT
				while (1) {
					// gbNɃf[^ȂA̓gbN̐擪Ă悢
					if (pTempEvent == NULL) {
						VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, NULL));
						break;
					}
					// pTempEvent̒ɓĂ悢
					else {
						// }̂m[gItCxg̏ꍇ(xVeB0̃m[gI܂)
						if (MIDIEvent_IsNoteOff (pMIDIEvent)) {
							// Ήm[gICxgOɂ͐΂ɗȂ (20090111ǉ)
							if (pTempEvent == pMIDIEvent->m_pPrevCombinedEvent) {
								VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pTempEvent));
								break;
							}
							// ̃Cxgꍇ͓̑̃m[gIt̒ɑ}
							else if (pTempEvent->m_lTime == lInsertTime && MIDIEvent_IsNoteOff (pTempEvent)) {
								VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pTempEvent));
								break;
							}
							else if (pTempEvent->m_lTime < lInsertTime) {
								VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pTempEvent));
								break;
							}
						}
						// ̑̃Cxg̏ꍇ
						else {
							if (pTempEvent->m_lTime <= lInsertTime) {
								VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pTempEvent));
								break;
							}
						}
					}
					pTempEvent = pTempEvent->m_pPrevEvent;
				}
			}
			//if (MIDIEvent_IsNoteOff (pMIDIEvent)) {
			//	if (pMIDIEvent->m_pPrevEvent) {
			//		if (pMIDIEvent->m_pPrevEvent->m_lTime == pMIDIEvent->m_lTime) {
			//			ASSERT (MIDIEvent_IsNoteOff (pMIDIEvent->m_pPrevEvent));
			//		}
			//	}
			//}
			break;
		// MIDIEventIuWFNg̏L^MIDIEventIuWFNg̔r
		case HISTORYRECORD_REMOVEEVENT:
			pMIDITrack = (MIDITrack*)(pHistoryRecord->m_pParent);
			pMIDIEvent = (MIDIEvent*)(pHistoryRecord->m_pObject);
			pPrevEvent = (MIDIEvent*)(pHistoryRecord->m_pPrevObject);
			pNextEvent = (MIDIEvent*)(pHistoryRecord->m_pNextObject);
			pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_ALIVE;
			pMIDIEvent->m_lUserFlag |= MIDIEVENT_DEAD;
			VERIFY (MIDITrack_RemoveSingleEvent (pMIDITrack, pMIDIEvent));
			break;

		// MIDIEventIuWFNg̑S}L^SMIDIEventIuWFNg̕
		case HISTORYRECORD_INSERTEVENTALL:
			pMIDITrack = (MIDITrack*)(pHistoryRecord->m_pParent);
			pMIDIEvent = (MIDIEvent*)(pHistoryRecord->m_pObject);
			pPrevEvent = (MIDIEvent*)(pHistoryRecord->m_pPrevObject);
			pNextEvent = (MIDIEvent*)(pHistoryRecord->m_pNextObject);
			pMIDIEvent->m_lUserFlag |= MIDIEVENT_ALIVE;
			pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_DEAD;
			// 20090116 MIDIEvent̑}ʒu@ύX
			if (pPrevEvent == NULL) {
				VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pPrevEvent));
			}
			else if (MIDIEvent_GetParent (pPrevEvent) != NULL) {
				VERIFY (MIDITrack_InsertSingleEventAfter (pMIDITrack, pMIDIEvent, pPrevEvent));
			}
			else if (pNextEvent == NULL) {
				VERIFY (MIDITrack_InsertSingleEventBefore (pMIDITrack, pMIDIEvent, pNextEvent));
			}
			else if (MIDIEvent_GetParent (pNextEvent) != NULL) {
				VERIFY (MIDITrack_InsertSingleEventBefore (pMIDITrack, pMIDIEvent, pNextEvent));
			}
			else {
				ASSERT (FALSE);
			}
			break;
		// MIDIEventIuWFNg̑SL^SMIDIEventIuWFNg̔r
		case HISTORYRECORD_REMOVEEVENTALL:
			pMIDITrack = (MIDITrack*)(pHistoryRecord->m_pParent);
			pMIDIEvent = (MIDIEvent*)(pHistoryRecord->m_pObject);
			pPrevEvent = (MIDIEvent*)(pHistoryRecord->m_pPrevObject);
			pNextEvent = (MIDIEvent*)(pHistoryRecord->m_pNextObject);
			pMIDIEvent->m_lUserFlag &= ~MIDIEVENT_ALIVE;
			pMIDIEvent->m_lUserFlag |= MIDIEVENT_DEAD;
			VERIFY (MIDITrack_RemoveSingleEvent (pMIDITrack, pMIDIEvent));
			break;

		// MIDITrackIuWFNg̑}L^MIDITrackIuWFNg̕
		case HISTORYRECORD_INSERTTRACK:
			pMIDIData = (MIDIData*)(pHistoryRecord->m_pParent);
			pMIDITrack = (MIDITrack*)(pHistoryRecord->m_pObject);
			pPrevTrack = (MIDITrack*)(pHistoryRecord->m_pPrevObject);
			pNextTrack = (MIDITrack*)(pHistoryRecord->m_pNextObject);
			pFirstEvent = (MIDIEvent*)(pHistoryRecord->m_pFirstChild);
			pLastEvent = (MIDIEvent*)(pHistoryRecord->m_pLastChild);
			pMIDITrack->m_lUserFlag |= MIDITRACK_ALIVE;
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_DEAD;
			if (pFirstEvent || pLastEvent) {
				VERIFY (pTempEvent = pFirstEvent);
				pTempTrack = MIDIEvent_GetParent (pFirstEvent);
				if (pTempTrack != NULL && pTempTrack != pMIDITrack) {
					while (pTempEvent) {
						VERIFY (MIDITrack_RemoveEvent (pTempTrack, pTempEvent));
						VERIFY (MIDITrack_InsertEvent (pMIDITrack, pTempEvent));
						pTempEvent = MIDITrack_GetFirstEvent (pTempTrack);
					}
				}
			}
			// 20090116 MIDITrack̑}ʒu@ύX
			if (pPrevTrack == NULL) {
				VERIFY (MIDIData_InsertTrackAfter (pMIDIData, pMIDITrack, pPrevTrack));
			}
			else if (MIDITrack_GetParent (pPrevTrack) == pMIDIData) {
				VERIFY (MIDIData_InsertTrackAfter (pMIDIData, pMIDITrack, pPrevTrack));
			}
			else if (pNextTrack == NULL) {
				VERIFY (MIDIData_InsertTrackBefore (pMIDIData, pMIDITrack, pNextTrack));
			}
			else if (MIDITrack_GetParent (pNextTrack) == pMIDIData) {
				VERIFY (MIDIData_InsertTrackBefore (pMIDIData, pMIDITrack, pNextTrack));
			}
			else {
				ASSERT (FALSE);
			}
			break;
		// MIDITrackIuWFNg̏L^MIDITrackIuWFNg̔r
		case HISTORYRECORD_REMOVETRACK:
			pMIDIData = (MIDIData*)(pHistoryRecord->m_pParent);
			pMIDITrack = (MIDITrack*)(pHistoryRecord->m_pObject);
			pPrevTrack = (MIDITrack*)(pHistoryRecord->m_pPrevObject);
			pNextTrack = (MIDITrack*)(pHistoryRecord->m_pNextObject);
			pFirstEvent = (MIDIEvent*)(pHistoryRecord->m_pFirstChild);
			pLastEvent = (MIDIEvent*)(pHistoryRecord->m_pLastChild);
			pMIDITrack->m_lUserFlag &= ~MIDITRACK_ALIVE;
			pMIDITrack->m_lUserFlag |= MIDITRACK_DEAD;
			VERIFY (MIDIData_RemoveTrack (pMIDIData, pMIDITrack));
			break;
		// MIDIDataIuWFNg̑}L^MIDIDataIuWFNg̕
		case HISTORYRECORD_INSERTDATA:
			pMIDIData = (MIDIData*)(pHistoryRecord->m_pObject);
			pFirstTrack = (MIDITrack*)(pHistoryRecord->m_pFirstChild);
			pLastTrack = (MIDITrack*)(pHistoryRecord->m_pLastChild);
			pMIDIData->m_lUserFlag |= MIDIDATA_ALIVE;
			pMIDIData->m_lUserFlag &= ~MIDIDATA_DEAD;
			if (pFirstTrack || pLastTrack) {
				VERIFY (pTempTrack = pFirstTrack);
				pTempData = MIDITrack_GetParent (pFirstTrack);
				if (pTempData != NULL && pTempData != pMIDIData) {
					while (pTempTrack) {
						VERIFY (MIDIData_RemoveTrack (pTempData, pTempTrack));
						VERIFY (MIDIData_AddTrack (pMIDIData, pTempTrack));
						pTempTrack = MIDIData_GetFirstTrack (pTempData);
					}
				}
			}
			this->m_pMIDIData = pMIDIData;
			break;
		// MIDIDataIuWFNg̏L^MIDIDataIuWFNg̔r
		case HISTORYRECORD_REMOVEDATA:
			pMIDIData = (MIDIData*)(pHistoryRecord->m_pObject);
			pFirstTrack = (MIDITrack*)(pHistoryRecord->m_pFirstChild);
			pLastTrack = (MIDITrack*)(pHistoryRecord->m_pLastChild);
			pMIDIData->m_lUserFlag &= ~MIDIDATA_ALIVE;
			pMIDIData->m_lUserFlag |= MIDIDATA_DEAD;
			this->m_pMIDIData = NULL;
			break;
		}
	}

	// KvɉMIDIClock̕␳
	long lMIDIClockTimeMode;
	long lMIDIClockTimeResolution;
	MIDIClock_GetTimeBase (m_pMIDIClock, &lMIDIClockTimeMode, &lMIDIClockTimeResolution);
	long lMIDIDataTimeMode;
	long lMIDIDataTimeResolution;
	MIDIData_GetTimeBase (m_pMIDIData, &lMIDIDataTimeMode, &lMIDIDataTimeResolution);
	if (lMIDIClockTimeMode != lMIDIDataTimeMode || 
		lMIDIClockTimeResolution != lMIDIDataTimeResolution) {
		// t̏ꍇAẗꎞ~
		pSekaijuApp->SendAllNoteOff ();
		pSekaijuApp->SendAllHold1Off ();
		pSekaijuApp->SendAllSostenutoOff ();
		pSekaijuApp->SendAllHold2Off ();
		if (pSekaijuApp->m_bPlaying) {
			MIDIClock_Stop (m_pMIDIClock);
		}
		long lTempo = MIDIEVENT_DEFTEMPO;
		VERIFY (MIDIData_FindTempo (m_pMIDIData, 0, &lTempo));
		MIDIClock_Reset (m_pMIDIClock);
		MIDIClock_SetTimeBase (m_pMIDIClock, lMIDIDataTimeMode, lMIDIDataTimeResolution);
		MIDIClock_SetTempo (m_pMIDIClock, lTempo);
		if (pSekaijuApp->m_bPlaying) {
			MIDIClock_Start (m_pMIDIClock);
		}
	}
	
	// ݂̗jbgԍCNg
	this->m_lCurHistoryPosition++;
	this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIDATACHANGED | 
		SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIEVENTCHANGED);
	this->SetModifiedFlag (TRUE);
	this->m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	return;
}

// wҏW(&E)x-w蒼(&R)x
void CSekaijuDoc::OnUpdateEditRedoUI (CCmdUI* pCmdUI) {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	m_theCriticalSection.Lock ();
	long lNumHistoryUnit = m_theHistoryUnitArray.GetSize ();
	// 蒼łȂꍇ
	if (m_lCurHistoryPosition >= lNumHistoryUnit - 1) {
		CString strText;
		VERIFY (strText.LoadString (IDS_UNABLE_TO_REDO_T_CTRL_Y));
		pCmdUI->SetText (strText);
		pCmdUI->Enable (FALSE);
	}
	// 蒼łꍇ
	else {
		CHistoryUnit* pHistoryUnit = 
			(CHistoryUnit*)m_theHistoryUnitArray.GetAt (m_lCurHistoryPosition + 1);
		CString strFormat;
		CString strText;
		VERIFY (strFormat.LoadString (IDS_REDO_02D_02D_02D_S_T_CTRL_Y));
		strText.Format (strFormat,
			pHistoryUnit->m_theTime.GetHour (),
			pHistoryUnit->m_theTime.GetMinute (),
			pHistoryUnit->m_theTime.GetSecond (),
			pHistoryUnit->m_strName);
		pCmdUI->SetText (strText);
		pCmdUI->Enable (TRUE);
	}
	m_theCriticalSection.Unlock ();
}


// wҏW(&E)x-wƗ̏x
void CSekaijuDoc::OnEditInitHistory () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	
	CString strMsg;
	VERIFY (strMsg.LoadString (IDS_INITIALIZE_HISTORY));
	int nRet = AfxMessageBox (strMsg, MB_ICONINFORMATION | MB_YESNO);

	if (nRet == IDYES) {
		BeginWaitCursor ();
		this->m_theCriticalSection.Lock ();
		this->DeleteAllHistoryUnit ();
		this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIDATACHANGED | 
			SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIEVENTCHANGED);
		this->SetModifiedFlag (TRUE);
		this->m_theCriticalSection.Unlock ();
		EndWaitCursor ();
	}

}



// wҏW(&E)x-wƗ̏x
void CSekaijuDoc::OnUpdateEditInitHistoryUI (CCmdUI* pCmdUI) {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	long lNumHistoryUnit = m_theHistoryUnitArray.GetSize ();
	if (lNumHistoryUnit <= 0) {
		pCmdUI->Enable (FALSE);
	}
}




// wҏW(E)x-w؂(T)x
void CSekaijuDoc::OnEditCut () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	long lRet = 0;
	long lCopiedEventCount = 0;
	BeginWaitCursor ();

	// Nbv{[hɓ]镶쐬
	CString strText;
	m_theCriticalSection.Lock ();
	lCopiedEventCount = this->MakeCopyString (strText, 0x0000, NULL);
	UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
	if (lCopiedEventCount == 0) {
		EndWaitCursor ();
		return;
	}

	// Nbv{[hɓƎeLXg]
	lRet = this->SetClipboardTextPrivate9 (strText);
	if (lRet == FALSE) {
		EndWaitCursor ();
		CString strMsg;
		VERIFY (strMsg.LoadString (IDS_UNABLE_TO_WRITE_TO_CLIPBOARD));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return;
	}

	// ICxg폜
	CHistoryUnit* pCurHistoryUnit = NULL;
	m_theCriticalSection.Lock ();
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_EDIT_CUT));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = GetCurHistoryUnit ());

	this->DeleteSelectedEvent (pCurHistoryUnit);
	
	SetModifiedFlag (TRUE);
	UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	::Sleep (0);

}

// wҏW(E)x-w؂(T)x
void CSekaijuDoc::OnUpdateEditCutUI (CCmdUI* pCmdUI) {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}


	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack;
	MIDIEvent* pMIDIEvent;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		if (this->IsTrackSelected (pMIDITrack)) {
			lEnable = 1;
		}
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
}


// wҏW(E)x-wRs[(C)x
void CSekaijuDoc::OnEditCopy () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}


	long lRet = 0;
	long lCopiedEventCount = 0;
	BeginWaitCursor ();

	// Nbv{[hɓ]镶쐬
	CString strText;
	m_theCriticalSection.Lock ();
	lCopiedEventCount = this->MakeCopyString (strText, 0x0000, NULL);
	UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
	if (lCopiedEventCount == 0) {
		EndWaitCursor ();
		return;
	}

	// Nbv{[hɓƎeLXg]
	lRet = this->SetClipboardTextPrivate9 (strText);
	if (lRet == FALSE) {
		EndWaitCursor ();
		CString strMsg;
		VERIFY (strMsg.LoadString (IDS_UNABLE_TO_WRITE_TO_CLIPBOARD));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return;
	}
	EndWaitCursor ();
}

// wҏW(E)x-wRs[(C)x
void CSekaijuDoc::OnUpdateEditCopyUI (CCmdUI* pCmdUI) {
	
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	// ЂƂłMIDICxgIĂEnable
	// łȂDisableƂ
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack;
	MIDIEvent* pMIDIEvent;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);

}


// wҏW(E)x-w\t(P)x
void CSekaijuDoc::OnEditPaste () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}


	BeginWaitCursor ();
	CString strMsg;

	// Nbv{[h̃eLXg擾
	CString strText;
	long lRet = this->GetClipboardTextPrivate9 (strText);
	if (lRet == FALSE) {
		EndWaitCursor ();
		VERIFY (strMsg.LoadString (IDS_UNABLE_TO_READ_FROM_CLIPBOARD));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return;
	}
	
	// eLXgtH[}bg
	if (strText.Left(5) != _T("MDa2 ")) {
		EndWaitCursor ();
		VERIFY (strMsg.LoadString (IDS_NO_AVAILABLE_MIDIDATA_IN_THE_CLIPBOARD));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return;
	}
	
	// \t
	CHistoryUnit* pCurHistoryUnit = NULL;
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_EDIT_PASTE));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	m_theCriticalSection.Lock ();
	m_lTempTrackIndex = 0;
	long lMeasure, lBeat, lTick;
	long lTime = m_lNewTime;
	MIDIData_BreakTime (m_pMIDIData, lTime, &lMeasure, &lBeat, &lTick);
	MIDIData_MakeTime (m_pMIDIData, lMeasure, 0, 0, &lTime);
	m_lTempTime = lTime;
	long lInsertedEventCount = this->ParsePasteString (strText, m_lTempTrackIndex, m_lTempTime, pCurHistoryUnit);
	this->SetModifiedFlag (TRUE);
	this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED |
		SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIDATACHANGED);
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	::Sleep (0);

	// ʂ̃bZ[W{bNX\
	if (lInsertedEventCount == -1) {
		VERIFY (strMsg.LoadString (IDS_PASTE_FAILED));
	}
	else {
		CString strFormat;
		VERIFY (strFormat.LoadString (IDS_D_MIDIEVENTS_WERE_INSERTED));
		strMsg.Format (strFormat, lInsertedEventCount);
	}
	AfxMessageBox (strMsg, MB_ICONINFORMATION);
}

// wҏW(E)x-w\t(P)x
void CSekaijuDoc::OnUpdateEditPasteUI (CCmdUI* pCmdUI) {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	
	// Nbv{[ȟ`ƎeLXgׂ
	pCmdUI->Enable (this->IsClipboardTextPrivate9 ());
}

// wҏW(E)x-w폜(D)x
void CSekaijuDoc::OnEditDelete () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	
	BeginWaitCursor ();
	CHistoryUnit* pCurHistoryUnit = NULL;
	m_theCriticalSection.Lock ();
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_EDIT_DELETE));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = GetCurHistoryUnit ());

	this->DeleteSelectedEvent (pCurHistoryUnit);

	SetModifiedFlag (TRUE);
	UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	::Sleep (0);
}

// wҏW(E)x-w폜(D)x
void CSekaijuDoc::OnUpdateEditDeleteUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}


	// MIDICxgЂƂłIԂȂEnable
	// łȂDisable
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
}


// wҏW(E)x-wׂđI(A)x
void CSekaijuDoc::OnEditSelectAll () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	
	// ׂĂMIDICxgIԂɂ
	BeginWaitCursor ();
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	MIDIEvent* pCloneEvent = NULL;
	CHistoryUnit* pCurHistoryUnit = NULL;
	m_theCriticalSection.Lock ();
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_EDIT_SELECT_ALL));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (pMIDIEvent->m_pPrevCombinedEvent == NULL) {
				pCloneEvent = this->SelectEvent (pMIDIEvent, 1, pCurHistoryUnit);
				if (pCloneEvent) {
					pMIDIEvent = pCloneEvent;
				}
			}
		}
	}
	this->SetModifiedFlag (TRUE);
	this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED | 
		SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIDATACHANGED);
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	::Sleep (0);
}

// wҏW(E)x-wׂđI(A)x
void CSekaijuDoc::OnUpdateEditSelectAllUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}


	// ׂẴCxgIĂ΂̍ڂ`FbN
	m_theCriticalSection.Lock ();
	long lCheck = 1;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent) == 0) {
				lCheck = 0;
				break;
			}
		}
		if (lCheck == 0) {
			break;
		}
	}
	pCmdUI->SetCheck (lCheck);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
	
}

// wҏW(E)x-wׂđI(N)x
void CSekaijuDoc::OnEditSelectNone () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}


	
	// ׂĂMIDICxgIԂɂ
	BeginWaitCursor ();
	CHistoryUnit* pCurHistoryUnit = NULL;
	m_theCriticalSection.Lock ();
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_EDIT_DESELECT_ALL));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	this->SelectNoObject (pCurHistoryUnit);
	this->SetModifiedFlag (TRUE);
	this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED | 
		SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIDATACHANGED);
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	::Sleep (0);
}

// wҏW(E)x-wׂđI(N)x
void CSekaijuDoc::OnUpdateEditSelectNoneUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	// ׂẴCxgIł΂̍ڂ`FbN
	m_theCriticalSection.Lock ();
	long lCheck = 1;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent) != 0) {
				lCheck = 0;
				break;
			}
		}
		if (lCheck == 0) {
			break;
		}
	}
	pCmdUI->SetCheck (lCheck);
	m_theCriticalSection.Unlock ();
	::Sleep (0);

}

// wҏW(E)x-w݈ʒuÕCxgǉIx
void CSekaijuDoc::OnEditSelectBefore () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	// ݈ʒuÕCxgIԂɂ
	BeginWaitCursor ();
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	MIDIEvent* pCloneEvent = NULL;
	CHistoryUnit* pCurHistoryUnit = NULL;
	m_theCriticalSection.Lock ();
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_EDIT_SELECT_BEFORE));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (pMIDIEvent->m_pPrevCombinedEvent == NULL) {
				long lTime = MIDIEvent_GetTime (pMIDIEvent);
				if (lTime < m_lNewTime) {
					pCloneEvent = this->SelectEvent (pMIDIEvent, 1, pCurHistoryUnit);
					if (pCloneEvent) {
						pMIDIEvent = pCloneEvent;
					}
				}
			}
		}
	}
	this->SetModifiedFlag (TRUE);
	this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED | 
		SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIDATACHANGED);
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	::Sleep (0);
}

// wҏW(E)x-w݈ʒuÕCxgǉIx
void CSekaijuDoc::OnUpdateEditSelectBeforeUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
}

// wҏW(E)x-w݈ʒuÕCxgIx
void CSekaijuDoc::OnEditDeselectBefore () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	
	// ݈ʒuÕCxgIɂ
	BeginWaitCursor ();
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	MIDIEvent* pCloneEvent = NULL;
	CHistoryUnit* pCurHistoryUnit = NULL;
	m_theCriticalSection.Lock ();
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_EDIT_DESELECT_BEFORE));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (pMIDIEvent->m_pPrevCombinedEvent == NULL) {
				long lTime = MIDIEvent_GetTime (pMIDIEvent);
				if (lTime < m_lNewTime) {
					pCloneEvent = this->SelectEvent (pMIDIEvent, 0, pCurHistoryUnit);
					if (pCloneEvent) {
						pMIDIEvent = pCloneEvent;
					}
				}
			}
		}
	}
	this->SetModifiedFlag (TRUE);
	this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED | 
		SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIDATACHANGED);
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	::Sleep (0);}

// wҏW(E)x-w݈ʒuÕCxgIx
void CSekaijuDoc::OnUpdateEditDeselectBeforeUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
}

// wҏW(E)x-w݈ʒũCxgǉIx
void CSekaijuDoc::OnEditSelectAfter () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	// ݈ʒũCxgIԂɂ
	BeginWaitCursor ();
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	MIDIEvent* pCloneEvent = NULL;
	CHistoryUnit* pCurHistoryUnit = NULL;
	m_theCriticalSection.Lock ();
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_EDIT_SELECT_AFTER));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (pMIDIEvent->m_pPrevCombinedEvent == NULL) {
				long lTime = MIDIEvent_GetTime (pMIDIEvent);
				if (lTime >= m_lNewTime) {
					pCloneEvent = this->SelectEvent (pMIDIEvent, 1, pCurHistoryUnit);
					if (pCloneEvent) {
						pMIDIEvent = pCloneEvent;
					}
				}
			}
		}
	}
	this->SetModifiedFlag (TRUE);
	this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED | 
		SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIDATACHANGED);
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	::Sleep (0);
}

// wҏW(E)x-w݈ʒũCxgǉIx
void CSekaijuDoc::OnUpdateEditSelectAfterUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
}

// wҏW(E)x-w݈ʒũCxgIx
void CSekaijuDoc::OnEditDeselectAfter () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	
	// ݈ʒũCxgIɂ
	BeginWaitCursor ();
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	MIDIEvent* pCloneEvent = NULL;
	CHistoryUnit* pCurHistoryUnit = NULL;
	m_theCriticalSection.Lock ();
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_EDIT_DESELECT_AFTER));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (pMIDIEvent->m_pPrevCombinedEvent == NULL) {
				long lTime = MIDIEvent_GetTime (pMIDIEvent);
				if (lTime >= m_lNewTime) {
					pCloneEvent = this->SelectEvent (pMIDIEvent, 0, pCurHistoryUnit);
					if (pCloneEvent) {
						pMIDIEvent = pCloneEvent;
					}
				}
			}
		}
	}
	this->SetModifiedFlag (TRUE);
	this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED | 
		SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIDATACHANGED);
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	::Sleep (0);
}

// wҏW(E)x-w݈ʒũCxgIx
void CSekaijuDoc::OnUpdateEditDeselectAfterUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
}

// wҏW(E)x-wgbN̕ύX...x
void CSekaijuDoc::OnEditTrack () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}	
	if (m_bEditLocked) {
		return;
	}

	long lTimeMode, lTimeResolution;
	MIDIData_GetTimeBase (m_pMIDIData, &lTimeMode, &lTimeResolution);

	CEditTrackDlg theDlg;
	theDlg.m_nAmount = pSekaijuApp->m_theEditTrackDlgStatus.m_nAmount;
	theDlg.m_nUnit = CLIP (0, pSekaijuApp->m_theEditTrackDlgStatus.m_nUnit, 1);
	theDlg.m_nFitChannel = pSekaijuApp->m_theEditTrackDlgStatus.m_nFitChannel;
	if (theDlg.DoModal () == IDOK) {
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		long i, j;
		long lErrorCount = 0;
		long lFormat = MIDIData_GetFormat (m_pMIDIData);
		long lTrackCount = MIDIData_CountTrack (m_pMIDIData);
		MIDITrack* pMIDITrack = NULL;
		MIDIEvent* pMIDIEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		BOOL bTrackZeroOrigin = pSekaijuApp->m_theGeneralOption.m_bTrackZeroOrigin;
		CHistoryUnit* pCurHistoryUnit = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_EDIT_MODIFY_TRACKINDEX));
		VERIFY (this->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
		
		// Cxg2ړȂ悤ɁAIĂCxgꎞzɓo^B
		CPtrArray theTempSelectedEventArray;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			forEachEvent (pMIDITrack, pMIDIEvent) {
				// IĂCxĝ
				if (this->IsEventSelected (pMIDIEvent)) {
					// 񌋍Cxĝ݁ACxg̏ꍇ͑O񌋍̂݁AŌEOT͏O
					if (MIDIEvent_IsCombined (pMIDIEvent) && pMIDIEvent->m_pPrevCombinedEvent == NULL ||
						!MIDIEvent_IsCombined (pMIDIEvent) &&
						!(MIDIEvent_IsEndofTrack (pMIDIEvent) &&
						MIDITrack_GetLastEvent (pMIDITrack) == pMIDIEvent)) {
						theTempSelectedEventArray.Add (pMIDIEvent);
					}
				}
			}
		}

		// ׂĂ̈ړ\ȑIĂCxgɂ
		long lTempSelectedEventCount = theTempSelectedEventArray.GetSize ();
		for (j = 0; j < lTempSelectedEventCount; j++) {
			pMIDIEvent = (MIDIEvent*)(theTempSelectedEventArray.GetAt (j));
			long lKind = MIDIEvent_GetKind (pMIDIEvent);
			pMIDITrack = MIDIEvent_GetParent (pMIDIEvent);
			ASSERT (pMIDITrack);

			// ړgbNvZ
			long lTargetTrackIndex = 0;
			if (theDlg.m_nUnit == 0) {
				lTargetTrackIndex = (theDlg.m_nAmount - (bTrackZeroOrigin ? 0 : 1));
			}
			else {
				long lTrackIndex = GetTrackIndex (pMIDITrack);
				lTargetTrackIndex = lTrackIndex + theDlg.m_nAmount;
			}
			lTargetTrackIndex = CLIP (0, lTargetTrackIndex, (MAXMIDITRACKNUM - 1));
			MIDITrack* pTargetTrack = this->GetTrack (lTargetTrackIndex);

			// ړ\ȃCxg̏ꍇ̂
			if (lFormat == 1 && !MIDIEvent_IsMIDIEvent (pMIDIEvent) && lTargetTrackIndex == 0 ||
				lFormat == 1 && (lKind & 0xF0) != 0x50 && lTargetTrackIndex != 0 ||
				lFormat == 2) {
	
				// gbNȂꍇAgbN̒ǉyEOT̒ǉ
				MIDITrack* pNewTrack = NULL;
				MIDIEvent* pNewEvent = NULL;
				long lTrackCount = MIDIData_CountTrack (m_pMIDIData);
				for (i = lTrackCount; i <= lTargetTrackIndex; i++) { 
					VERIFY (pNewTrack = MIDITrack_Create ());
					VERIFY (MIDITrack_SetForeColor (pNewTrack, pSekaijuApp->m_theColorOption.m_lForeColor[i % 8]));
					VERIFY (MIDITrack_SetInputOn (pNewTrack, TRUE)); 
					VERIFY (MIDITrack_SetInputChannel (pNewTrack, (i + 15) % 16)); 
					VERIFY (MIDITrack_SetOutputOn (pNewTrack, TRUE)); 
					VERIFY (MIDITrack_SetOutputChannel (pNewTrack, (i + 15) % 16)); 
					VERIFY (MIDIData_AddTrack (m_pMIDIData, pNewTrack));
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pNewTrack));
					VERIFY (pNewEvent = MIDIEvent_CreateEndofTrack (lTimeResolution * 4));
					VERIFY (MIDITrack_InsertEvent (pNewTrack, pNewEvent));
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
				}
				if (pNewEvent) {
					VERIFY (this->SelectEvent (pNewEvent, TRUE, pCurHistoryUnit));
				}

				// ݃gbN珜ړgbNɑ}
				VERIFY (pTargetTrack = this->GetTrack (lTargetTrackIndex));
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
				VERIFY (pCloneEvent = this->ReplaceMIDIEvent (pMIDIEvent));
				VERIFY (MIDITrack_RemoveEvent (pMIDITrack, pCloneEvent));
				VERIFY (MIDITrack_InsertEvent (pTargetTrack, pCloneEvent));
				if (theDlg.m_nFitChannel) {
					long lOutputChannel = MIDITrack_GetOutputChannel (pTargetTrack);
					if (0 <= lOutputChannel && lOutputChannel < 16 && 
						MIDIEvent_IsMIDIEvent (pCloneEvent)) {
						MIDIEvent_SetChannel (pCloneEvent, lOutputChannel);
					}
				}
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
				// : EndofTrackCxgRemove邱Ƃ͂ł邪,dInsert邱Ƃ͂łȂB
				// TODO: EndofTrackCxg̐eׯȂȂĂ܂oO܂B
			}
			else {
				lErrorCount++;
			}
		}
		
		theTempSelectedEventArray.RemoveAll ();
		this->SetModifiedFlag (TRUE);
		this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
		if (lErrorCount > 0) {
			CString strMsg;
			CString strFormat;
			VERIFY (strFormat.LoadString (IDS_D_MIDIEVENTS_TRACKINDEX_ISNT_CHANGED));
			strMsg.Format (strFormat, lErrorCount);
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		}
		pSekaijuApp->m_theEditTrackDlgStatus.m_nAmount = theDlg.m_nAmount;
		pSekaijuApp->m_theEditTrackDlgStatus.m_nUnit = theDlg.m_nUnit;
		pSekaijuApp->m_theEditTrackDlgStatus.m_nFitChannel = theDlg.m_nFitChannel;
	}

}

// wҏW(E)x-wgbN̕ύX...x
void CSekaijuDoc::OnUpdateEditTrackUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	// ׂẴCxgIł΂̍ڂfBXG[u
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	long lFormat = MIDIData_GetFormat (m_pMIDIData);
	if (lFormat == 0) {
		pCmdUI->Enable (FALSE);
	}
	else {
		MIDITrack* pMIDITrack = NULL;
		MIDIEvent* pMIDIEvent = NULL;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			forEachEvent (pMIDITrack, pMIDIEvent) {
				if (this->IsEventSelected (pMIDIEvent)) {
					lEnable = 1;
					break;
				}
			}
			if (lEnable == 1) {
				break;
			}
		}
		pCmdUI->Enable (lEnable);
	}
	m_theCriticalSection.Unlock ();
	::Sleep (0);
}



// wҏW(E)x-w^C̕ύX...x
void CSekaijuDoc::OnEditTime () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	long lTimeMode, lTimeResolution;
	MIDIData_GetTimeBase (m_pMIDIData, &lTimeMode, &lTimeResolution);

	// TPQNx[X
	if (lTimeMode == 0) {
		CEditTimeDlg theDlg;
		theDlg.m_nAmount = pSekaijuApp->m_theEditTimeDlgStatus.m_nAmount;
		theDlg.m_nUnit = CLIP (0, pSekaijuApp->m_theEditTimeDlgStatus.m_nUnit, 4);
		if (theDlg.DoModal () == IDOK) {
			BeginWaitCursor ();
			m_theCriticalSection.Lock ();
			MIDITrack* pMIDITrack = NULL;
			MIDIEvent* pMIDIEvent = NULL;
			MIDIEvent* pCloneEvent = NULL;
			CHistoryUnit* pCurHistoryUnit = NULL;
			CString strHistoryName;
			VERIFY (strHistoryName.LoadString (IDS_EDIT_MODIFY_TIME));
			VERIFY (this->AddHistoryUnit (strHistoryName));
			VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
			
			// IĂCxĝAŏ̃Cxg̎߂
			long lFirstTime = 0x7FFFFFFF;
			forEachTrack (m_pMIDIData, pMIDITrack) {
				forEachEvent (pMIDITrack, pMIDIEvent) {
					if (this->IsEventSelected (pMIDIEvent)) {
						long lTime = MIDIEvent_GetTime (pMIDIEvent);
						if (lTime < lFirstTime) {
							lFirstTime = lTime;
							break;
						}
					}
				}
			}
			long lnn, ldd, lbb, lcc;
			MIDIData_FindTimeSignature (m_pMIDIData, lFirstTime, &lnn, &ldd, &lbb, &lcc);
			// Cxg2ړȂ悤ɁAIĂCxgꎞzɓo^B
			CPtrArray theTempSelectedEventArray;
			forEachTrack (m_pMIDIData, pMIDITrack) {
				pMIDITrack->m_lUser1 = 0;
				forEachEvent (pMIDITrack, pMIDIEvent) {
					// IĂCxĝ
					if (this->IsEventSelected (pMIDIEvent)) {
						// 񌋍Cxĝ݁ACxg̏ꍇ͑O񌋍̂
						if (MIDIEvent_IsCombined (pMIDIEvent) && pMIDIEvent->m_pPrevCombinedEvent == NULL ||
							!MIDIEvent_IsCombined (pMIDIEvent)) {
							theTempSelectedEventArray.Add (pMIDIEvent);
							pMIDITrack->m_lUser1++;
						}
					}
				}
			}
			// EOT̗ێ(EOTIĂȂꍇ̂)(20081102C)
			forEachTrack (m_pMIDIData, pMIDITrack) {
				MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
				if (pLastEvent && pMIDITrack->m_lUser1 > 0) {
					if (MIDIEvent_IsEndofTrack (pLastEvent) && !this->IsEventSelected (pLastEvent)) {
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
					}
				}
			}
			// ̕ύX
			// ꎞz̃Cxg1ɂ1̈ړB
			long lTempSelectedEventArrayCount = theTempSelectedEventArray.GetSize ();
			if (theDlg.m_nAmount < 0) {
				// (EOTŌɈړ邽߁A)(20081102C)
				for (long j = 0; j < lTempSelectedEventArrayCount; j++) {
					pMIDIEvent = (MIDIEvent*)(theTempSelectedEventArray.GetAt (j));
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
					VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
					long lTime = MIDIEvent_GetTime (pCloneEvent);
					if (theDlg.m_nUnit == 0) {
						lTime += theDlg.m_nAmount;
					}
					else if (theDlg.m_nUnit == 1) {
						lTime += theDlg.m_nAmount * lTimeResolution * 4 / (1 << ldd); // (20081110vZC)
					}
					else if (theDlg.m_nUnit == 2) {
						lTime += theDlg.m_nAmount * lTimeResolution * 4 * lnn / (1 << ldd);
					}
					else if (theDlg.m_nUnit == 3) {
						lTime = lFirstTime + (lTime - lFirstTime) * theDlg.m_nAmount / 100;
						// m[gItɌm[gICxg̏ꍇ́AύX
						if (MIDIEvent_IsNoteOn (pCloneEvent) && MIDIEvent_IsCombined (pCloneEvent)) {
							long lDuration = MIDIEvent_GetDuration (pCloneEvent);
							lDuration = lDuration * theDlg.m_nAmount / 100;
							lDuration = CLIP (1, lDuration, 65535);
							MIDIEvent_SetDuration (pCloneEvent, lDuration);
						}
					}
					else if (theDlg.m_nUnit == 4) {
						long lDelta = rand () % (abs (theDlg.m_nAmount * 2) + 1);
						lTime += (lDelta - abs (theDlg.m_nAmount));
					}
					lTime = CLIP (0, lTime, 0x7FFFFFFF);
					VERIFY (MIDIEvent_SetTime (pCloneEvent, lTime));
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
					pMIDIEvent = pCloneEvent;
				}
			}
			else {
				// (EOTŏɈړ邽߁At)(20081102C)
				for (long j = lTempSelectedEventArrayCount - 1; j >= 0; j--) {
					pMIDIEvent = (MIDIEvent*)(theTempSelectedEventArray.GetAt (j));
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
					VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
					long lTime = MIDIEvent_GetTime (pCloneEvent);
					if (theDlg.m_nUnit == 0) {
						lTime += theDlg.m_nAmount;
					}
					else if (theDlg.m_nUnit == 1) {
						lTime += theDlg.m_nAmount * lTimeResolution * 4 / (1 << ldd); // (20081110vZC)
					}
					else if (theDlg.m_nUnit == 2) {
						lTime += theDlg.m_nAmount * lTimeResolution * 4 * lnn / (1 << ldd);
					}
					else if (theDlg.m_nUnit == 3) {
						lTime = lFirstTime + (lTime - lFirstTime) * theDlg.m_nAmount / 100;
						// m[gItɌm[gICxg̏ꍇ́AύX
						if (MIDIEvent_IsNoteOn (pCloneEvent) && MIDIEvent_IsCombined (pCloneEvent)) {
							long lDuration = MIDIEvent_GetDuration (pCloneEvent);
							lDuration = lDuration * theDlg.m_nAmount / 100;
							lDuration = CLIP (1, lDuration, 65535);
							MIDIEvent_SetDuration (pCloneEvent, lDuration);
						}
					}
					else if (theDlg.m_nUnit == 4) {
						long lDelta = rand () % (abs (theDlg.m_nAmount * 2) + 1);
						lTime += (lDelta - abs (theDlg.m_nAmount));
					}
					lTime = CLIP (0, lTime, 0x7FFFFFFF);
					VERIFY (MIDIEvent_SetTime (pCloneEvent, lTime));
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
					pMIDIEvent = pCloneEvent;
				}
			}
			theTempSelectedEventArray.RemoveAll ();
			// EOT̗ێ(EOTIĂȂꍇ̂)(20081102C)
			forEachTrack (m_pMIDIData, pMIDITrack) {
				MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
				if (pLastEvent && pMIDITrack->m_lUser1 > 0) {
					if (MIDIEvent_IsEndofTrack (pLastEvent) && !this->IsEventSelected (pLastEvent)) {
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
					}
				}
				pMIDITrack->m_lUser1 = 0;
			}
			this->SetModifiedFlag (TRUE);
			this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			::Sleep (0);
			pSekaijuApp->m_theEditTimeDlgStatus.m_nAmount = theDlg.m_nAmount;
			pSekaijuApp->m_theEditTimeDlgStatus.m_nUnit = theDlg.m_nUnit;
		}
	}

	// SMPTEx[X
	else {
		CEditTimeSmpDlg theDlg;
		theDlg.m_nAmount = pSekaijuApp->m_theEditTimeSmpDlgStatus.m_nAmount;
		theDlg.m_nUnit = CLIP (0, pSekaijuApp->m_theEditTimeSmpDlgStatus.m_nUnit, 3);
		if (theDlg.DoModal () == IDOK) {
			BeginWaitCursor ();
			m_theCriticalSection.Lock ();
			MIDITrack* pMIDITrack = NULL;
			MIDIEvent* pMIDIEvent = NULL;
			MIDIEvent* pCloneEvent = NULL;
			CHistoryUnit* pCurHistoryUnit = NULL;
			CString strHistoryName;
			VERIFY (strHistoryName.LoadString (IDS_EDIT_MODIFY_TIME));
			VERIFY (this->AddHistoryUnit (strHistoryName));
			VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
			
			// IĂCxĝAŏ̃Cxg̎߂
			long lFirstTime = 0x7FFFFFFF;
			forEachTrack (m_pMIDIData, pMIDITrack) {
				forEachEvent (pMIDITrack, pMIDIEvent) {
					if (this->IsEventSelected (pMIDIEvent)) {
						long lTime = MIDIEvent_GetTime (pMIDIEvent);
						if (lTime < lFirstTime) {
							lFirstTime = lTime;
							break;
						}
					}
				}
			}
			long lTimeMode, lTimeResolution;
			MIDIData_GetTimeBase (m_pMIDIData, &lTimeMode, &lTimeResolution);
			long lnn, ldd, lbb, lcc;
			MIDIData_FindTimeSignature (m_pMIDIData, lFirstTime, &lnn, &ldd, &lbb, &lcc);
			// Cxg2ړȂ悤ɁAIĂCxgꎞzɓo^B
			CPtrArray theTempSelectedEventArray;
			forEachTrack (m_pMIDIData, pMIDITrack) {
				pMIDITrack->m_lUser1 = 0;
				forEachEvent (pMIDITrack, pMIDIEvent) {
					// IĂCxĝ
					if (this->IsEventSelected (pMIDIEvent)) {
						// 񌋍Cxĝ݁ACxg̏ꍇ͑O񌋍̂
						if (MIDIEvent_IsCombined (pMIDIEvent) && pMIDIEvent->m_pPrevCombinedEvent == NULL ||
							!MIDIEvent_IsCombined (pMIDIEvent)) {
							theTempSelectedEventArray.Add (pMIDIEvent);
							pMIDITrack->m_lUser1++;
						}
					}
				}
			}
			// EOT̗ێ(EOTIĂȂꍇ̂)(20081102C)
			forEachTrack (m_pMIDIData, pMIDITrack) {
				MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
				if (pLastEvent && pMIDITrack->m_lUser1 > 0) {
					if (MIDIEvent_IsEndofTrack (pLastEvent) && !this->IsEventSelected (pLastEvent)) {
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
					}
				}
			}
			// ꎞz̃Cxg1ɂ1̈ړB
			long lTempSelectedEventArrayCount = theTempSelectedEventArray.GetSize ();
			if (theDlg.m_nAmount < 0) {
				// (EOTŌɈړ邽߁A)(20081102C)
				for (long j = 0; j < lTempSelectedEventArrayCount; j++) {
					pMIDIEvent = (MIDIEvent*)(theTempSelectedEventArray.GetAt (j));
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
					VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
					long lTime = MIDIEvent_GetTime (pCloneEvent);
					if (theDlg.m_nUnit == 0) {
						lTime += theDlg.m_nAmount;
					}
					else if (theDlg.m_nUnit == 1) {
						lTime += theDlg.m_nAmount * lTimeResolution;
					}
					else if (theDlg.m_nUnit == 2) {
						lTime = lFirstTime + (lTime - lFirstTime) * theDlg.m_nAmount / 100;
						// m[gItɌm[gICxg̏ꍇ́AύX
						if (MIDIEvent_IsNoteOn (pCloneEvent) && MIDIEvent_IsCombined (pCloneEvent)) {
							long lDuration = MIDIEvent_GetDuration (pCloneEvent);
							lDuration = lDuration * theDlg.m_nAmount / 100;
							lDuration = CLIP (1, lDuration, 65535);
							MIDIEvent_SetDuration (pCloneEvent, lDuration);
						}
					}
					else if (theDlg.m_nUnit == 3) {
						long lDelta = rand () % (abs (theDlg.m_nAmount * 2) + 1);
						lTime += (lDelta - abs (theDlg.m_nAmount));
					}
					else if (theDlg.m_nUnit == 4) {
						long lDelta = rand () % (abs (theDlg.m_nAmount * 2) + 1);
						lTime += (lDelta - abs (theDlg.m_nAmount)) * lTimeResolution;
					}
					lTime = CLIP (0, lTime, 0x7FFFFFFF);
					VERIFY (MIDIEvent_SetTime (pCloneEvent, lTime));
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
					pMIDIEvent = pCloneEvent;
				}
			}
			else {
				// (EOTŏɈړ邽߁At)(20081102C)
				for (long j = lTempSelectedEventArrayCount - 1; j >= 0; j--) {
					pMIDIEvent = (MIDIEvent*)(theTempSelectedEventArray.GetAt (j));
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
					VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
					long lTime = MIDIEvent_GetTime (pCloneEvent);
					if (theDlg.m_nUnit == 0) {
						lTime += theDlg.m_nAmount;
					}
					else if (theDlg.m_nUnit == 1) {
						lTime += theDlg.m_nAmount * lTimeResolution;
					}
					else if (theDlg.m_nUnit == 2) {
						lTime = lFirstTime + (lTime - lFirstTime) * theDlg.m_nAmount / 100;
						// m[gItɌm[gICxg̏ꍇ́AύX
						if (MIDIEvent_IsNoteOn (pCloneEvent) && MIDIEvent_IsCombined (pCloneEvent)) {
							long lDuration = MIDIEvent_GetDuration (pCloneEvent);
							lDuration = lDuration * theDlg.m_nAmount / 100;
							lDuration = CLIP (1, lDuration, 65535);
							MIDIEvent_SetDuration (pCloneEvent, lDuration);
						}
					}
					else if (theDlg.m_nUnit == 3) {
						long lDelta = rand () % (abs (theDlg.m_nAmount * 2) + 1);
						lTime += (lDelta - abs (theDlg.m_nAmount));
					}
					else if (theDlg.m_nUnit == 4) {
						long lDelta = rand () % (abs (theDlg.m_nAmount * 2) + 1);
						lTime += (lDelta - abs (theDlg.m_nAmount)) * lTimeResolution;
					}
					lTime = CLIP (0, lTime, 0x7FFFFFFF);
					VERIFY (MIDIEvent_SetTime (pCloneEvent, lTime));
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
					pMIDIEvent = pCloneEvent;
				}
			}
			theTempSelectedEventArray.RemoveAll ();
			// EOT̗ێ(EOTIĂȂꍇ̂)(20081102C)
			forEachTrack (m_pMIDIData, pMIDITrack) {
				MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
				if (pLastEvent && pMIDITrack->m_lUser1 > 0) {
					if (MIDIEvent_IsEndofTrack (pLastEvent) && !this->IsEventSelected (pLastEvent)) {
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
					}
				}
				pMIDITrack->m_lUser1 = 0;
			}
			this->SetModifiedFlag (TRUE);
			this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
			m_theCriticalSection.Unlock ();
			EndWaitCursor ();
			::Sleep (0);
			pSekaijuApp->m_theEditTimeSmpDlgStatus.m_nAmount = theDlg.m_nAmount;
			pSekaijuApp->m_theEditTimeSmpDlgStatus.m_nUnit = theDlg.m_nUnit;
		}
	}
}

// wҏW(E)x-w^C̕ύX...x
void CSekaijuDoc::OnUpdateEditTimeUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	// ׂẴCxgIł΂̍ڂfBXG[u
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable == 1) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
}

// wҏW(E)x-w`l̕ύX...x
void CSekaijuDoc::OnEditChannel () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	CEditChannelDlg theDlg;
	theDlg.m_nAmount = pSekaijuApp->m_theEditChannelDlgStatus.m_nAmount;
	theDlg.m_nUnit = CLIP (0, pSekaijuApp->m_theEditChannelDlgStatus.m_nUnit, 2);
	if (theDlg.DoModal () == IDOK) {
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDITrack* pMIDITrack = NULL;
		MIDIEvent* pMIDIEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CHistoryUnit* pCurHistoryUnit = NULL;
		long lTrackOutputChannel = 0;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_EDIT_MODIFY_CHANNEL));
		VERIFY (this->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
		// `l̕ύX
		forEachTrack (m_pMIDIData, pMIDITrack) {
			lTrackOutputChannel = MIDITrack_GetOutputChannel (pMIDITrack);
			forEachEvent (pMIDITrack, pMIDIEvent) {
				// IĂCxĝ
				if (this->IsEventSelected (pMIDIEvent)) {
					// MIDI`lCxg
					// (m[gItEm[gIEL[At^[ERg[`FWE
					// vO`FWE`lAt^[Esb`xh)̂
					if (MIDIEvent_IsMIDIEvent (pMIDIEvent) &&
						pMIDIEvent->m_pPrevCombinedEvent == NULL) {
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
						long lChannel = MIDIEvent_GetChannel (pCloneEvent);
						if (theDlg.m_nUnit == 0) {
							if (0 <= lTrackOutputChannel && lTrackOutputChannel < 16) {
								lChannel = lTrackOutputChannel;
							}
						}
						else if (theDlg.m_nUnit == 1) {
							lChannel = theDlg.m_nAmount - 1;
						}
						else if (theDlg.m_nUnit == 2) {
							lChannel += theDlg.m_nAmount;
						}
						lChannel = CLIP (0, lChannel, 15);
						VERIFY (MIDIEvent_SetChannel (pCloneEvent, lChannel));
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
						pMIDIEvent = pCloneEvent;
					}
				}
			}
		}
		this->SetModifiedFlag (TRUE);
		this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
		pSekaijuApp->m_theEditChannelDlgStatus.m_nAmount = theDlg.m_nAmount;
		pSekaijuApp->m_theEditChannelDlgStatus.m_nUnit = theDlg.m_nUnit;
	}
}

// wҏW(E)x-w`l̕ύX...x
void CSekaijuDoc::OnUpdateEditChannelUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	// ׂẴCxgIł΂̍ڂfBXG[u
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable == 1) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
}

// wҏW(E)x-w̕ύX...x
void CSekaijuDoc::OnEditKey () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	
	CEditKeyDlg theDlg;
	theDlg.m_nAmount = pSekaijuApp->m_theEditKeyDlgStatus.m_nAmount;
	theDlg.m_nUnit = CLIP (0, pSekaijuApp->m_theEditKeyDlgStatus.m_nUnit, 2);
	theDlg.m_nTargetNote = CLIP (0, pSekaijuApp->m_theEditKeyDlgStatus.m_nTargetNote, 1);
	theDlg.m_nTargetKeyAfter = CLIP (0, pSekaijuApp->m_theEditKeyDlgStatus.m_nTargetKeyAfter, 1);
	if (theDlg.DoModal () == IDOK) {
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDITrack* pMIDITrack = NULL;
		MIDIEvent* pMIDIEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CHistoryUnit* pCurHistoryUnit = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_EDIT_MODIFY_KEY));
		VERIFY (this->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
		// ̕ύX
		forEachTrack (m_pMIDIData, pMIDITrack) {
			forEachEvent (pMIDITrack, pMIDIEvent) {
				// IĂCxĝ
				if (this->IsEventSelected (pMIDIEvent)) {
					// m[gIEm[gIt(񌋍)EL[At^[^b`̂
					if ((MIDIEvent_IsNoteOn (pMIDIEvent) && pMIDIEvent->m_pPrevCombinedEvent == NULL ||
						MIDIEvent_IsNoteOff (pMIDIEvent) && pMIDIEvent->m_pPrevCombinedEvent == NULL) &&
						theDlg.m_nTargetNote == 1 ||
						MIDIEvent_IsKeyAftertouch (pMIDIEvent) &&
						theDlg.m_nTargetKeyAfter == 1) {
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
						long lKey = MIDIEvent_GetKey (pCloneEvent);
						if (theDlg.m_nUnit == 0) {
							lKey += theDlg.m_nAmount;
						}
						else if (theDlg.m_nUnit == 1) {
							lKey += theDlg.m_nAmount * 12;
						}
						else if (theDlg.m_nUnit == 2) {
							long lDelta = rand () % (abs (theDlg.m_nAmount * 2) + 1);
							lKey += (lDelta - abs (theDlg.m_nAmount));
						}
						else if (theDlg.m_nUnit == 3) {
							long lDelta = rand () % (abs (theDlg.m_nAmount * 2) + 1);
							lKey += (lDelta - abs (theDlg.m_nAmount)) * 12;
						}
						lKey = CLIP (0, lKey, 127);
						VERIFY (MIDIEvent_SetKey (pCloneEvent, lKey));
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
						pMIDIEvent = pCloneEvent;
					}
				}
			}
		}
		this->SetModifiedFlag (TRUE);
		this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
		pSekaijuApp->m_theEditKeyDlgStatus.m_nAmount = theDlg.m_nAmount;
		pSekaijuApp->m_theEditKeyDlgStatus.m_nUnit = theDlg.m_nUnit;
		pSekaijuApp->m_theEditKeyDlgStatus.m_nTargetNote = theDlg.m_nTargetNote;
		pSekaijuApp->m_theEditKeyDlgStatus.m_nTargetKeyAfter = theDlg.m_nTargetKeyAfter;
	}
}

// wҏW(E)x-w̕ύX...x
void CSekaijuDoc::OnUpdateEditKeyUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	// ׂẴCxgIł΂̍ڂfBXG[u
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable == 1) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);

}

// wҏW(E)x-wxVeB̕ύX...x
void CSekaijuDoc::OnEditVelocity () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}	
	if (m_bEditLocked) {
		return;
	}
	
	CEditVelocityDlg theDlg;
	theDlg.m_nAmount = pSekaijuApp->m_theEditVelocityDlgStatus.m_nAmount;
	theDlg.m_nUnit = CLIP (0, pSekaijuApp->m_theEditVelocityDlgStatus.m_nUnit, 3);
	theDlg.m_nTargetNoteOn = CLIP (0, pSekaijuApp->m_theEditVelocityDlgStatus.m_nTargetNoteOn, 1);
	theDlg.m_nTargetNoteOff = CLIP (0, pSekaijuApp->m_theEditVelocityDlgStatus.m_nTargetNoteOff, 1);
	if (theDlg.DoModal () == IDOK) {
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDITrack* pMIDITrack = NULL;
		MIDIEvent* pMIDIEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CHistoryUnit* pCurHistoryUnit = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_EDIT_MODIFY_VELOCITY));
		VERIFY (this->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
		// xVeB̕ύX
		forEachTrack (m_pMIDIData, pMIDITrack) {
			forEachEvent (pMIDITrack, pMIDIEvent) {
				// IĂCxĝ
				if (this->IsEventSelected (pMIDIEvent)) {
					// m[gI(O񌋍)Em[gIt(O񌋍)̏ꍇ
					if (MIDIEvent_IsNoteOn (pMIDIEvent) && 
						pMIDIEvent->m_pPrevCombinedEvent == NULL && theDlg.m_nTargetNoteOn ||
						MIDIEvent_IsNoteOff (pMIDIEvent) && 
						pMIDIEvent->m_pPrevCombinedEvent == NULL && theDlg.m_nTargetNoteOff) {
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
						MIDIEvent* pTempEvent = pCloneEvent;
						while (pTempEvent) {
							if (MIDIEvent_IsNoteOn (pTempEvent) && theDlg.m_nTargetNoteOn ||
								MIDIEvent_IsNoteOff (pTempEvent) && theDlg.m_nTargetNoteOff) {
								long lVelocity = MIDIEvent_GetVelocity (pTempEvent);
								if (theDlg.m_nUnit == 0) {
									lVelocity = theDlg.m_nAmount;
								}
								else if (theDlg.m_nUnit == 1) {
									lVelocity += theDlg.m_nAmount;
								}
								else if (theDlg.m_nUnit == 2) {
									lVelocity = lVelocity * theDlg.m_nAmount / 100;
								}
								else if (theDlg.m_nUnit == 3) {
									long lDelta = rand () % (abs (theDlg.m_nAmount * 2) + 1);
									lVelocity += (lDelta - abs (theDlg.m_nAmount));
								}
								lVelocity = CLIP (0, lVelocity, 127);
								MIDIEvent_SetVelocity (pTempEvent, lVelocity);
							}
							pTempEvent = pTempEvent->m_pNextCombinedEvent;
						}
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
						pMIDIEvent = pCloneEvent;
					}
				}
			}
		}
		this->SetModifiedFlag (TRUE);
		this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
		pSekaijuApp->m_theEditVelocityDlgStatus.m_nAmount = theDlg.m_nAmount;
		pSekaijuApp->m_theEditVelocityDlgStatus.m_nUnit = theDlg.m_nUnit;
		pSekaijuApp->m_theEditVelocityDlgStatus.m_nTargetNoteOn = theDlg.m_nTargetNoteOn;
		pSekaijuApp->m_theEditVelocityDlgStatus.m_nTargetNoteOff = theDlg.m_nTargetNoteOff;
	}
}

// wҏW(E)x-wxVeB̕ύX...x
void CSekaijuDoc::OnUpdateEditVelocityUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	// ׂẴCxgIł΂̍ڂfBXG[u
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable == 1) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
}

// wҏW(E)x-w̕ύX...x
void CSekaijuDoc::OnEditDuration () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}	
	if (m_bEditLocked) {
		return;
	}

	CEditDurationDlg theDlg;
	theDlg.m_nAmount = pSekaijuApp->m_theEditDurationDlgStatus.m_nAmount;
	theDlg.m_nUnit = CLIP (0, pSekaijuApp->m_theEditDurationDlgStatus.m_nUnit, 3);
	if (theDlg.DoModal () == IDOK) {
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDITrack* pMIDITrack = NULL;
		MIDIEvent* pMIDIEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CHistoryUnit* pCurHistoryUnit = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_EDIT_MODIFY_DURATION));
		VERIFY (this->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
		// EOT̗ێ
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			if (pLastEvent) {
				if (MIDIEvent_IsEndofTrack (pLastEvent)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
					VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
				}
			}
		}
		// ̒ύX
		forEachTrack (m_pMIDIData, pMIDITrack) {
			forEachEvent (pMIDITrack, pMIDIEvent) {
				// IĂCxĝ
				if (this->IsEventSelected (pMIDIEvent)) {
					// m[gItɌꂽm[gICxĝ
					if (MIDIEvent_IsNoteOn (pMIDIEvent) && MIDIEvent_IsCombined (pMIDIEvent)) {
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
						long lDuration = MIDIEvent_GetDuration (pCloneEvent);
						if (theDlg.m_nUnit == 0) {
							lDuration = theDlg.m_nAmount;
						}
						else if (theDlg.m_nUnit == 1) {
							lDuration += theDlg.m_nAmount;
						}
						else if (theDlg.m_nUnit == 2) {
							lDuration = lDuration * theDlg.m_nAmount / 100;
						}
						else if (theDlg.m_nUnit == 3) {
							long lDelta = rand () % (abs (theDlg.m_nAmount * 2) + 1);
							lDuration += (lDelta - abs (theDlg.m_nAmount));
						}
						lDuration = CLIP (1, lDuration, 65535);
						VERIFY (MIDIEvent_SetDuration (pCloneEvent, lDuration));
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
						pMIDIEvent = pCloneEvent;
					}
				}
			}
		}
		// EOT̗ێ
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			if (pLastEvent) {
				if (MIDIEvent_IsEndofTrack (pLastEvent)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
				}
			}
		}
		this->SetModifiedFlag (TRUE);
		this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
		pSekaijuApp->m_theEditDurationDlgStatus.m_nAmount = theDlg.m_nAmount;
		pSekaijuApp->m_theEditDurationDlgStatus.m_nUnit = theDlg.m_nUnit;
	}
}

// wҏW(E)x-w̕ύX...x
void CSekaijuDoc::OnUpdateEditDurationUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	// ׂẴCxgIł΂̍ڂfBXG[u
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable == 1) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
}

// wҏW(E)x-wl̕ύX...x
void CSekaijuDoc::OnEditValue () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}	
	if (m_bEditLocked) {
		return;
	}
	
	CEditValueDlg theDlg;
	theDlg.m_nAmount = pSekaijuApp->m_theEditValueDlgStatus.m_nAmount;
	theDlg.m_nUnit = CLIP (0, pSekaijuApp->m_theEditValueDlgStatus.m_nUnit, 3);
	theDlg.m_nTargetKeyAfter = CLIP (0, pSekaijuApp->m_theEditValueDlgStatus.m_nTargetKeyAfter, 1);
	theDlg.m_nTargetControlChange = CLIP (0, pSekaijuApp->m_theEditValueDlgStatus.m_nTargetControlChange, 1);
	theDlg.m_nTargetChannelAfter = CLIP (0, pSekaijuApp->m_theEditValueDlgStatus.m_nTargetChannelAfter, 1);
	theDlg.m_nTargetPitchBend = CLIP (0, pSekaijuApp->m_theEditValueDlgStatus.m_nTargetPitchBend, 1);
	if (theDlg.DoModal () == IDOK) {
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDITrack* pMIDITrack = NULL;
		MIDIEvent* pMIDIEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CHistoryUnit* pCurHistoryUnit = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_EDIT_MODIFY_VALUE));
		VERIFY (this->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
		// l̕ύX
		forEachTrack (m_pMIDIData, pMIDITrack) {
			forEachEvent (pMIDITrack, pMIDIEvent) {
				// IĂCxĝ
				if (this->IsEventSelected (pMIDIEvent)) {
					// L[At^[^b`ERg[`FWE`lAt^[^b`
					if (MIDIEvent_IsKeyAftertouch (pMIDIEvent) && theDlg.m_nTargetKeyAfter ||
						MIDIEvent_IsControlChange (pMIDIEvent) && theDlg.m_nTargetControlChange ||
						MIDIEvent_IsChannelAftertouch (pMIDIEvent) && theDlg.m_nTargetChannelAfter) {	
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
						long lValue = MIDIEvent_GetValue (pMIDIEvent);
						if (theDlg.m_nUnit == 0) {
							lValue = theDlg.m_nAmount;
						}
						else if (theDlg.m_nUnit == 1) {
							lValue += theDlg.m_nAmount;
						}
						else if (theDlg.m_nUnit == 2) {
							lValue = lValue * theDlg.m_nAmount / 100;
						}
						else if (theDlg.m_nUnit == 3) {								
							long lDelta = rand () % (abs (theDlg.m_nAmount * 2) + 1);
							lValue += (lDelta - abs (theDlg.m_nAmount));
						}
						lValue = CLIP (0, lValue, 127);
						VERIFY (MIDIEvent_SetValue (pCloneEvent, lValue));
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
						pMIDIEvent = pCloneEvent;
					}
					// sb`xh
					else if (MIDIEvent_IsPitchBend (pMIDIEvent) && theDlg.m_nTargetPitchBend) {
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
						long lValue = MIDIEvent_GetValue (pMIDIEvent);
						if (theDlg.m_nUnit == 0) {
							lValue = theDlg.m_nAmount;
						}
						else if (theDlg.m_nUnit == 1) {
							lValue += theDlg.m_nAmount;
						}
						else if (theDlg.m_nUnit == 2) {
							lValue = 8192 + (lValue - 8192) * theDlg.m_nAmount / 100;
						}
						else if (theDlg.m_nUnit == 3) {
							long lDelta = rand () % (abs (theDlg.m_nAmount * 2) + 1);
							lValue += (lDelta - abs (theDlg.m_nAmount));
						}
						lValue = CLIP (0, lValue, 16383);
						VERIFY (MIDIEvent_SetValue (pCloneEvent, lValue));
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
						pMIDIEvent = pCloneEvent;
					}
				}
			}
		}
		this->SetModifiedFlag (TRUE);
		this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
		pSekaijuApp->m_theEditValueDlgStatus.m_nAmount = theDlg.m_nAmount;
		pSekaijuApp->m_theEditValueDlgStatus.m_nUnit = theDlg.m_nUnit;
		pSekaijuApp->m_theEditValueDlgStatus.m_nTargetKeyAfter = theDlg.m_nTargetKeyAfter;
		pSekaijuApp->m_theEditValueDlgStatus.m_nTargetControlChange = theDlg.m_nTargetControlChange;
		pSekaijuApp->m_theEditValueDlgStatus.m_nTargetChannelAfter = theDlg.m_nTargetChannelAfter;
		pSekaijuApp->m_theEditValueDlgStatus.m_nTargetPitchBend = theDlg.m_nTargetPitchBend;
	}
}

// wҏW(E)x-wl̕ύX...x
void CSekaijuDoc::OnUpdateEditValueUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	// ׂẴCxgIł΂̍ڂfBXG[u
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable == 1) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
}

// wҏW(E)x-wNH^CY...x
void CSekaijuDoc::OnEditQuantize () {

	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	

	CEditQuantizeDlg theDlg;
	theDlg.m_lTimeMode = MIDIData_GetTimeMode (m_pMIDIData);
	theDlg.m_lTimeResolution = MIDIData_GetTimeResolution (m_pMIDIData);
	theDlg.m_nSnapTimeIndex = CLIP (0, pSekaijuApp->m_theEditQuantizeDlgStatus.m_nSnapTimeIndex, 6);
	theDlg.m_nStrength = CLIP (0, pSekaijuApp->m_theEditQuantizeDlgStatus.m_nStrength, 100);
	theDlg.m_nTargetNoteOn = CLIP (0, pSekaijuApp->m_theEditQuantizeDlgStatus.m_nTargetNoteOn, 1);
	theDlg.m_nTargetNoteOff = CLIP (0, pSekaijuApp->m_theEditQuantizeDlgStatus.m_nTargetNoteOff, 1);
	if (theDlg.DoModal () == IDOK) {
		BeginWaitCursor ();
		long lDivision[7] = {1, 2, 3, 4, 6, 8, 12};
		long lSnapTimeIndex = CLIP (0, theDlg.m_nSnapTimeIndex, 6);
		long lSnapTime = __max (1, MIDIData_GetTimeResolution (m_pMIDIData) / lDivision[lSnapTimeIndex]);
		m_theCriticalSection.Lock ();
		MIDITrack* pMIDITrack = NULL;
		MIDIEvent* pMIDIEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CHistoryUnit* pCurHistoryUnit = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_EDIT_QUANTIZE));
		VERIFY (this->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
		
		// EOT̗ێ
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			if (pLastEvent) {
				if (MIDIEvent_IsEndofTrack (pLastEvent)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
					VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
				}
			}
		}

		// Cxg2ړȂ悤ɁAIĂCxgꎞzɓo^B
		CPtrArray theTempSelectedEventArray;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			forEachEvent (pMIDITrack, pMIDIEvent) {
				// IĂCxĝ
				if (this->IsEventSelected (pMIDIEvent)) {
					// m[gItɌꂽm[gICxĝ
					if (MIDIEvent_IsNoteOn (pMIDIEvent) && MIDIEvent_IsCombined (pMIDIEvent)) {
						theTempSelectedEventArray.Add (pMIDIEvent);
					}
				}
			}
		}

		// ꎞz̃Cxg1ɂ1̈ړB
		long lTempSelectedEventArrayCount = theTempSelectedEventArray.GetSize ();
		for (long j = 0; j < lTempSelectedEventArrayCount; j++) {
			pMIDIEvent = (MIDIEvent*)(theTempSelectedEventArray.GetAt (j));
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
			VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));

			// ̊Jnʒuړ(͕ێ)
			if (theDlg.m_nTargetNoteOn) {
				long lTime = MIDIEvent_GetTime (pCloneEvent);
				long lNewTime = (lTime + lSnapTime / 2) / lSnapTime * lSnapTime;
				long lDeltaTime = lNewTime - lTime;
				long lStDeltaTime = lDeltaTime * theDlg.m_nStrength / 100;
				long lStNewTime = CLIP (0, lTime + lStDeltaTime, 0x7FFFFFFF);
				VERIFY (MIDIEvent_SetTime (pCloneEvent, lStNewTime));
			}

			// ̏Iʒuړ(ύX邱Ƃɂ)
			if (theDlg.m_nTargetNoteOff) {
				long lBeginTime = MIDIEvent_GetTime (pCloneEvent);
				long lDuration = MIDIEvent_GetDuration (pCloneEvent);
				long lEndTime = lBeginTime + lDuration;
				long lNewEndTime = (lEndTime + lSnapTime / 2) / lSnapTime * lSnapTime;
				long lDeltaTime = lNewEndTime - lEndTime;
				long lStDeltaTime = lDeltaTime * theDlg.m_nStrength / 100;
				long lStNewEndTime = CLIP (0, lEndTime + lStDeltaTime, 0x7FFFFFFF);
				long lStNewDuration = lStNewEndTime - lBeginTime;
				while (lStNewDuration <= 1) {
					lStNewDuration += lSnapTime;
				}
				VERIFY (MIDIEvent_SetDuration (pCloneEvent, lStNewDuration));
			}
	
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
			pMIDIEvent = pCloneEvent;
		}
		theTempSelectedEventArray.RemoveAll ();

		// EOT̗ێ
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			if (pLastEvent) {
				if (MIDIEvent_IsEndofTrack (pLastEvent)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
				}
			}
		}

		this->SetModifiedFlag (TRUE);
		this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
		pSekaijuApp->m_theEditQuantizeDlgStatus.m_nSnapTimeIndex = theDlg.m_nSnapTimeIndex;
		pSekaijuApp->m_theEditQuantizeDlgStatus.m_nStrength = theDlg.m_nStrength;
		pSekaijuApp->m_theEditQuantizeDlgStatus.m_nTargetNoteOn = theDlg.m_nTargetNoteOn;
		pSekaijuApp->m_theEditQuantizeDlgStatus.m_nTargetNoteOff = theDlg.m_nTargetNoteOff;
	}
}



// wҏW(E)x-wNH^CY...x
void CSekaijuDoc::OnUpdateEditQuantizeUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	// ׂẴCxgIł΂̍ڂfBXG[u
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable == 1) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
}


// wҏW(E)x-w̍וƃg...x
void CSekaijuDoc::OnEditBreakupAndTrill () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	CEditBreakupAndTrillDlg theDlg;
	theDlg.m_lTimeMode = MIDIData_GetTimeMode (m_pMIDIData);
	theDlg.m_lTimeResolution = MIDIData_GetTimeResolution (m_pMIDIData);
	theDlg.m_nDurationIndex = pSekaijuApp->m_theEditBreakupAndTrillDlgStatus.m_nDurationIndex;
	theDlg.m_nEnableTrill = pSekaijuApp->m_theEditBreakupAndTrillDlgStatus.m_nEnableTrill;
	theDlg.m_nKeyShift = pSekaijuApp->m_theEditBreakupAndTrillDlgStatus.m_nKeyShift;

	
	if (theDlg.DoModal () == IDOK) {
		pSekaijuApp->m_theEditBreakupAndTrillDlgStatus.m_nDurationIndex = theDlg.m_nDurationIndex;
		pSekaijuApp->m_theEditBreakupAndTrillDlgStatus.m_nEnableTrill = theDlg.m_nEnableTrill;
		pSekaijuApp->m_theEditBreakupAndTrillDlgStatus.m_nKeyShift = theDlg.m_nKeyShift;

		BeginWaitCursor ();
		m_theCriticalSection.Lock ();

		// 1̒[tick]vZ
		long lDurationDiv[7] = {1, 2, 3, 4, 6, 8, 12};
		long lDuration = theDlg.m_lTimeResolution / lDurationDiv[theDlg.m_nDurationIndex];
		lDuration = CLIP (1, lDuration, 65535);
		long lKeyShift = CLIP (-127, theDlg.m_nKeyShift, 127);
		
		CHistoryUnit* pCurHistoryUnit = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_EDIT_BREAKUP_AND_TRILL));
		VERIFY (this->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
		MIDITrack* pMIDITrack = NULL;
		MIDIEvent* pMIDIEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		long i = 0;
		long j = 0;
		long lDeletedNoteEventCount = 0;
		long lInsertedNoteEventCount = 0;
		
		// EOT̗ێ
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			if (pLastEvent) {
				if (MIDIEvent_IsEndofTrack (pLastEvent)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
					VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
				}
			}
		}
		
		// zɓo^ꂽCxg폜
		forEachTrack (m_pMIDIData, pMIDITrack) {
			// IĂm[gICxgzɓo^
			CPtrArray theEventArray;
			forEachEvent (pMIDITrack, pMIDIEvent) {
				if (this->IsEventSelected (pMIDIEvent)) {
					if (MIDIEvent_IsNote (pMIDIEvent) && MIDIEvent_IsNoteOn (pMIDIEvent)) {
						theEventArray.Add (pMIDIEvent);
					}
				}
			}
			// ꂼ̑IĂm[gCxgɂ
			for (i = 0; i < theEventArray.GetSize (); i++) {
				VERIFY (pMIDIEvent = (MIDIEvent*)theEventArray.GetAt (i));
				ASSERT (MIDIEvent_IsNote (pMIDIEvent) && MIDIEvent_IsNoteOn (pMIDIEvent));
				long lOldTime = MIDIEvent_GetTime (pMIDIEvent);
				long lOldChannel = MIDIEvent_GetChannel (pMIDIEvent);
				long lOldDuration = MIDIEvent_GetDuration (pMIDIEvent);
				long lOldKey = MIDIEvent_GetKey (pMIDIEvent);
				long lOldVelocity = MIDIEvent_GetVelocity (pMIDIEvent);
				// ̃m[gCxg폜
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
				VERIFY (MIDITrack_RemoveEvent (pMIDITrack, pMIDIEvent));
				lDeletedNoteEventCount++;
				// Vm[gCxg}
				for (j = 0; j < 65536; j++) {
					long lNewTime = lOldTime + lDuration * j;
					if (lNewTime >= lOldTime + lOldDuration) {
						break;
					}
					long lNewDuration = lDuration;
					if (lNewTime + lNewDuration >= lOldTime + lOldDuration) {
						lNewDuration = lOldTime + lOldDuration - lNewTime;
						ASSERT (lNewDuration > 0);
					}
					long lNewKey = lOldKey;
					if (theDlg.m_nEnableTrill) {
						lNewKey = (j % 2 == 0 ? lOldKey : lOldKey + lKeyShift);
					}
					lNewKey = CLIP (1, lNewKey, 127);
					long lNewVelocity = lOldVelocity;
					long lNewChannel = lOldChannel;
					// Vm[gCxg쐬
					MIDIEvent* pNewEvent = MIDIEvent_CreateNote 
						(lNewTime, lNewChannel, lNewKey, lNewVelocity, lNewDuration);
					ASSERT (pNewEvent);
					// Cxg擪珇ɑIԂɂB
					MIDIEvent* pTempEvent = pNewEvent;
					while (pTempEvent) {
						pTempEvent->m_lUserFlag |= MIDIEVENT_SELECTED;
						pTempEvent = pTempEvent->m_pNextCombinedEvent;
					}
					// gbNɑ}AL^
					VERIFY (MIDITrack_InsertEvent (pMIDITrack, pNewEvent));
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent));
					lInsertedNoteEventCount++;
				}
			}
			theEventArray.RemoveAll ();
		}

		// EOT̗ێ
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			if (pLastEvent) {
				if (MIDIEvent_IsEndofTrack (pLastEvent)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
				}
			}
		}

		this->SetModifiedFlag (TRUE);
		this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);

	}
}

// wҏW(E)x-w̍וƃg...x
void CSekaijuDoc::OnUpdateEditBreakupAndTrillUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}


	// ׂẴCxgIł΂̍ڂfBXG[u
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable == 1) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
}



// wҏW(E)x-wr[goƃe|}...x
void CSekaijuDoc::OnEditBeatScan () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}


	CString strMsg;
	
	// tH[}bg`FbN
	long lFormat = MIDIData_GetFormat (m_pMIDIData);
	if (lFormat == 0) {
		VERIFY (strMsg.LoadString (IDS_UNABLE_TO_BEATSCAN_WITH_FORMAT0_MIDIDATA));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return;
	}

	// ^Cx[X`FbN
	long lTimeMode, lTimeResolution;
	MIDIData_GetTimeBase (m_pMIDIData, &lTimeMode, &lTimeResolution);
	long lTrackCount = MIDIData_CountTrack (m_pMIDIData);
	if (lTimeMode != MIDIDATA_TPQNBASE) {
		VERIFY (strMsg.LoadString (IDS_UNABLE_TO_BEATSCAN_WITH_SMPTEBASE_MIDIDATA));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return;
	}
	
	// egbÑgbN_CAONX̔zɑ
	long i = 0;
	long j = 0;
	TCHAR szTrackName[256];
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	MIDIEvent* pCloneEvent = NULL;
	CEditBeatScanDlg theDlg;
	theDlg.m_lTimeMode = lTimeMode;
	theDlg.m_lTimeResolution = lTimeResolution;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		memset (szTrackName, 0, sizeof (szTrackName));
		MIDITrack_GetName (pMIDITrack, szTrackName, TSIZEOF (szTrackName));
		theDlg.m_theTrackNameArray.Add (szTrackName);
		i++;
	}

	theDlg.m_nBeatTrackIndex = pSekaijuApp->m_theEditBeatScanDlgStatus.m_nBeatTrackIndex;
	theDlg.m_nBeatTrackIndex = CLIP (0, theDlg.m_nBeatTrackIndex, lTrackCount - 1);
	theDlg.m_nBeatIntervalIndex = pSekaijuApp->m_theEditBeatScanDlgStatus.m_nBeatIntervalIndex;
	theDlg.m_nInsertTempo = pSekaijuApp->m_theEditBeatScanDlgStatus.m_nInsertTempo;

	// _CAO\
	if (theDlg.DoModal () == IDOK) {

		pSekaijuApp->m_theEditBeatScanDlgStatus.m_nBeatTrackIndex = theDlg.m_nBeatTrackIndex;
		pSekaijuApp->m_theEditBeatScanDlgStatus.m_nBeatIntervalIndex = theDlg.m_nBeatIntervalIndex;
		pSekaijuApp->m_theEditBeatScanDlgStatus.m_nInsertTempo = theDlg.m_nInsertTempo;

		m_theCriticalSection.Lock ();
		CDWordArray theBeatTimeArray;
		CDWordArray theBeatMillisecArray;
		CDWordArray theTempoArray;

		// ̃r[gԊu[tick]vZ
		long lBeatDiv[7] = {1, 2, 3, 4, 6, 8, 12};
		long lBeatInterval = lTimeResolution / lBeatDiv[theDlg.m_nBeatIntervalIndex];
		
		// IĂer[g̎[tick]ƃ~b[msec]𒊏o
		MIDITrack* pBeatTrack = this->GetTrack (theDlg.m_nBeatTrackIndex);
		ASSERT (pBeatTrack);
		long lOldTime = 0;
		long lNumBeatCount = 0;
		theBeatTimeArray.Add (0);
		theBeatMillisecArray.Add (0);
		lNumBeatCount++;
		forEachEvent (pBeatTrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				if (MIDIEvent_IsNoteOn (pMIDIEvent)) {
					long lTime = MIDIEvent_GetTime (pMIDIEvent);
					if (lTime > lOldTime) {
						theBeatTimeArray.Add (lTime);
						long lMillisec = MIDIData_TimeToMillisec (m_pMIDIData, lTime);
						theBeatMillisecArray.Add (lMillisec);
						lNumBeatCount++;
						lOldTime = lTime;
					}
				}
			}
		}
		ASSERT (lNumBeatCount == theBeatTimeArray.GetSize ());
		ASSERT (lNumBeatCount == theBeatMillisecArray.GetSize ());
		
		// wgbNőIĂr[g̐Ȃꍇ͋p
		if (lNumBeatCount <= 3) {
			m_theCriticalSection.Unlock ();
			VERIFY (strMsg.LoadString (IDS_SELECTED_NOTEEVENT_IS_TOO_FEW_IN_THE_SPECIFIED_TRACK));
			AfxMessageBox (strMsg);
			return;
		}

		// r[gXLJn[tick]ƃr[gXLI[tick]𒊏o
		long lBeginTime = theBeatTimeArray.GetAt (1);
		long lEndTime = theBeatTimeArray.GetAt (lNumBeatCount - 1);
		long lBeginMeasure, lBeginBeat, lBeginTick;
		MIDIData_BreakTime (m_pMIDIData, lBeginTime, &lBeginMeasure, &lBeginBeat, &lBeginTick);
		long lEndMeasure, lEndBeat, lEndTick;
		MIDIData_BreakTime (m_pMIDIData, lEndTime, &lEndMeasure, &lEndBeat, &lEndTick);

		// r[gXLJnmFbZ[W
		CString strFormat;
		VERIFY (strFormat.LoadString (IDS_D_NOTEVENT_IS_DETECTED_IN_THE_SPECIFIED_TRACK_CONTINUE));
		strMsg.Format (strFormat, lNumBeatCount - 1,
			lBeginMeasure + 1, lBeginBeat + 1, lBeginTick,
			lEndMeasure + 1, lEndBeat + 1, lEndTick);
		m_theCriticalSection.Unlock ();
		long lRet = AfxMessageBox (strMsg, MB_ICONINFORMATION | MB_YESNOCANCEL);
		if (lRet == IDNO || lRet == IDCANCEL) {
			return;
		}
		m_theCriticalSection.Lock ();
		
		BeginWaitCursor ();
		
		// er[gʒuɂ␳e|[ʕb/4]vZ
		long lTempo = 0;
		MIDIData_FindTempo (m_pMIDIData, 0, &lTempo);
		theTempoArray.Add (lTempo);
		for (j = 1; j < lNumBeatCount - 1; j++) {
			lTempo = 
				(theBeatMillisecArray.GetAt (j + 1) - theBeatMillisecArray.GetAt (j)) *
				1000 * lTimeResolution / lBeatInterval;
			theTempoArray.Add (lTempo);
		}
		MIDIData_FindTempo (m_pMIDIData, lEndTime, &lTempo);
		theTempoArray.Add (lTempo);
		ASSERT (lNumBeatCount == theTempoArray.GetSize ());

		CHistoryUnit* pCurHistoryUnit = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_EDIT_BEATSCAN));
		VERIFY (this->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
		
		// EOT̗ێ
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			if (pLastEvent) {
				if (MIDIEvent_IsEndofTrack (pLastEvent)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
					VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
				}
			}
		}
		
		// ̃e|Cxg̍폜
		long lDeletedTempoEventCount = 0;
		if (theDlg.m_nInsertTempo) {
			forEachTrack (m_pMIDIData, pMIDITrack) {
				// lBeginTime`lEndTimeɂe|Cxgzɓo^
				CPtrArray theEventArray;
				forEachEvent (pMIDITrack, pMIDIEvent) {
					if (MIDIEvent_IsTempo (pMIDIEvent)) {
						long lTime = MIDIEvent_GetTime (pMIDIEvent);
						if (lBeginTime <= lTime && lTime < lEndTime) {
							theEventArray.Add (pMIDIEvent);
						}
					}
				}
				// zɓo^ꂽCxg폜
				for (i = 0; i < theEventArray.GetSize (); i++) {
					VERIFY (pMIDIEvent = (MIDIEvent*)theEventArray.GetAt (i));
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
					VERIFY (MIDITrack_RemoveEvent (pMIDITrack, pMIDIEvent));
					lDeletedTempoEventCount++;
				}
				theEventArray.RemoveAll ();
			}
		}

		// MIDICxg̎ړ
		long lMovedEventCount = 0;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			j = 0;
			// lBeginTimeȍ~ɂCxgzɓo^
			// (Cxg̏ꍇ͍ŏ̃Cxĝ)
			// (GhIugbNCxg͎ړ̂ŏ)
			CPtrArray theEventArray;
			forEachEvent (pMIDITrack, pMIDIEvent) {
				long lTime = MIDIEvent_GetTime (pMIDIEvent);
				if (lTime >= lBeginTime) {
					if (pMIDIEvent->m_pPrevCombinedEvent == NULL &&
						!MIDIEvent_IsEndofTrack (pMIDIEvent)) {
						theEventArray.Add (pMIDIEvent);
					}
				}
			}
			// zɓo^ꂽCxgʒuړ
			for (i = 0; i < theEventArray.GetSize (); i++) { 
				VERIFY (pMIDIEvent = (MIDIEvent*)theEventArray.GetAt (i));
				ASSERT (pMIDIEvent->m_pPrevCombinedEvent == NULL);
				ASSERT (MIDIEvent_GetParent (pMIDIEvent) == pMIDITrack);
				// m[gCxg(m[gI+m[gIt)̏ꍇ
				if (MIDIEvent_IsNote (pMIDIEvent)) {
					long lTime1 = MIDIEvent_GetTime (pMIDIEvent);
					long lDuration = MIDIEvent_GetDuration (pMIDIEvent);
					long lTime2 = lTime1 + lDuration;
					while (j < lNumBeatCount - 1) {
						if ((long)theBeatTimeArray.GetAt (j) <= lTime1 &&
							lTime1 < (long)theBeatTimeArray.GetAt (j + 1)) {
							break;
						}
						j++;
					}
					long k = j;
					while (k < lNumBeatCount - 1) {
						if ((long)theBeatTimeArray.GetAt (k) <= lTime2 &&
							lTime2 < (long)theBeatTimeArray.GetAt (k + 1)) {
							break;
						}
						k++;
					}
					long lNewTime1 = 0;
					long lNewTime2 = 0;
					// m[gIʒuړ
					// Jnorŏ̃r[gOɂCxg
					if (j == 0) {
						ASSERT (0 <= lTime1 && lTime1 < lBeginTime);
						ASSERT (FALSE);
					}
					// r[g(j)ƃr[g(j+1)̊ԂɂCxg
					else if (1 <= j && j < lNumBeatCount - 1) {
						ASSERT (lBeginTime <= lTime1 && lTime1 < lEndTime);
						lNewTime1 = 
							lBeginTime +
							lBeatInterval * (j - 1) +
							lBeatInterval *
							(lTime1 - theBeatTimeArray.GetAt (j)) /
							(theBeatTimeArray.GetAt (j + 1) - theBeatTimeArray.GetAt(j));
						lNewTime1 = CLIP (0, lNewTime1, 0x7FFFFFFF);
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
						MIDIEvent_SetTime (pCloneEvent, lNewTime1);
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
						pMIDIEvent = pCloneEvent;
						lMovedEventCount++;
					}
					// IorŌ̃r[gɂCxg
					else {
						ASSERT (lTime1 >= lEndTime);
						lNewTime1 =
							lBeginTime +
							lBeatInterval * (lNumBeatCount - 2) +
							lTime1 - theBeatTimeArray.GetAt (lNumBeatCount - 1);
						lNewTime1 = CLIP (0, lNewTime1, 0x7FFFFFFF);
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
						MIDIEvent_SetTime (pCloneEvent, lNewTime1);
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
						pMIDIEvent = pCloneEvent;
						lMovedEventCount++;
					}
					// m[gItʒuړ(̕ύXɂ)
					// Jnorŏ̃r[gOɂCxg
					if (k == 0) {
						ASSERT (0 <= lTime2 && lTime2 < lBeginTime);
						ASSERT (FALSE);
					}
					// r[g(k)ƃr[g(k+1)̊ԂɂCxg
					else if (1 <= k && k < lNumBeatCount - 1) {
						ASSERT (lBeginTime <= lTime2 && lTime2 < lEndTime);
						long lNewTime2 = 
							lBeginTime +
							lBeatInterval * (k - 1) +
							lBeatInterval *
							(lTime2 - theBeatTimeArray.GetAt (k)) /
							(theBeatTimeArray.GetAt (k + 1) - theBeatTimeArray.GetAt(k));
						lNewTime2 = CLIP (0, lNewTime2, 0x7FFFFFFF);
						long lNewDuration = lNewTime2 - lNewTime1;
						lNewDuration = CLIP (0, lNewDuration, 0xFFFF);
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
						MIDIEvent_SetDuration (pCloneEvent, lNewDuration);
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
						pMIDIEvent = pCloneEvent;
						lMovedEventCount++;
					}
					// IorŌ̃r[gɂCxg
					else {
						ASSERT (lTime2 >= lEndTime);
						lNewTime2 =
							lBeginTime +
							lBeatInterval * (lNumBeatCount - 2) +
							lTime2 - theBeatTimeArray.GetAt (lNumBeatCount - 1);
						lNewTime2 = CLIP (0, lNewTime2, 0x7FFFFFFF);
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						long lNewDuration = lNewTime2 - lNewTime1;
						lNewDuration = CLIP (0, lNewDuration, 0xFFFF);
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
						MIDIEvent_SetDuration (pCloneEvent, lNewDuration);
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
						pMIDIEvent = pCloneEvent;
						lMovedEventCount++;
					}
				}
				// m[gCxg(m[gI+m[gIt)ȊȌꍇ
				else {
					long lTime = MIDIEvent_GetTime (pMIDIEvent);
					while (j < lNumBeatCount - 1) {
						if ((long)theBeatTimeArray.GetAt (j) <= lTime &&
							lTime < (long)theBeatTimeArray.GetAt (j + 1)) {
							break;
						}
						j++;
					}
					// Jnorŏ̃r[gOɂCxg
					if (j == 0) {
						ASSERT (0 <= lTime && lTime < lBeginTime);
						ASSERT (FALSE);
					}
					// r[g(j)ƃr[g(j+1)̊ԂɂCxg
					else if (1 <= j && j < lNumBeatCount - 1) {
						ASSERT (lBeginTime <= lTime && lTime < lEndTime);
						long lNewTime = 
							lBeginTime +
							lBeatInterval * (j - 1) +
							lBeatInterval *
							(lTime - theBeatTimeArray.GetAt (j)) /
							(theBeatTimeArray.GetAt (j + 1) - theBeatTimeArray.GetAt(j));
						lNewTime = CLIP (0, lNewTime, 0x7FFFFFFF);
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
						MIDIEvent_SetTime (pCloneEvent, lNewTime);
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
						pMIDIEvent = pCloneEvent;
						lMovedEventCount++;
					}
					// IorŌ̃r[gɂCxg
					else {
						ASSERT (lTime >= lEndTime);
						long lNewTime =
							lBeginTime +
							lBeatInterval * (lNumBeatCount - 2) +
							lTime - theBeatTimeArray.GetAt (lNumBeatCount - 1);
						lNewTime = CLIP (0, lNewTime, 0x7FFFFFFF);
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
						VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
						MIDIEvent_SetTime (pCloneEvent, lNewTime);
						VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
						pMIDIEvent = pCloneEvent;
						lMovedEventCount++;
					}
				}
			} // for
			theEventArray.RemoveAll ();
		} // forEachTrack

		// e|Cxg̑}
		long lInsertedTempoEventCount = 0;
		if (theDlg.m_nInsertTempo) {
			VERIFY (pMIDITrack = MIDIData_GetFirstTrack (m_pMIDIData));
			for (i = 1; i < theTempoArray.GetSize (); i++) {
				lTempo = theTempoArray.GetAt (i);
				lTempo = CLIP (1, lTempo, 60000000);
				long lTime = lBeginTime + lBeatInterval * (i - 1);
				VERIFY (pMIDIEvent = MIDIEvent_CreateTempo (lTime, lTempo));
				VERIFY (MIDITrack_InsertEvent (pMIDITrack, pMIDIEvent));
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pMIDIEvent));
				lInsertedTempoEventCount++;
			}
		}

		// EOT̗ێ
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			if (pLastEvent) {
				if (MIDIEvent_IsEndofTrack (pLastEvent)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
				}
			}
		}

		this->SetModifiedFlag (TRUE);
		this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
	}
}

// wҏW(E)x-wr[goƃe|}...x
void CSekaijuDoc::OnUpdateEditBeatScanUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}


	// ׂẴCxgIł΂̍ڂfBXG[u
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable == 1) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
}




// wҏW(E)x-wXg[N...x
void CSekaijuDoc::OnEditStroke () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	CEditStrokeDlg theDlg;
	theDlg.m_nDeltaTime = pSekaijuApp->m_theEditStrokeDlgStatus.m_nDeltaTime;
	theDlg.m_nMode = CLIP (0, pSekaijuApp->m_theEditStrokeDlgStatus.m_nMode, 3);

	// _CAO\
	if (theDlg.DoModal () == IDOK) {

		pSekaijuApp->m_theEditStrokeDlgStatus.m_nDeltaTime = theDlg.m_nDeltaTime;
		pSekaijuApp->m_theEditStrokeDlgStatus.m_nMode = theDlg.m_nMode;

		m_theCriticalSection.Lock ();
		BeginWaitCursor ();

		CHistoryUnit* pCurHistoryUnit = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_EDIT_STROKE));
		VERIFY (this->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());

		MIDITrack* pMIDITrack = NULL;
		MIDIEvent* pMIDIEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;

		// EOT̗ێ
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			if (pLastEvent) {
				if (MIDIEvent_IsEndofTrack (pLastEvent)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
					VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
				}
			}
		}

		// IĂm[gICxgꎞzɕێƂƂ
		// ãO[vԍt^
		long lTrackIndex = 0;
		long lGroupIndex = 0;
		CPtrArray theTempEventArray;
		CDWordArray theTempTrackIndexArray;
		CDWordArray theTempGroupIndexArray;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			long lOldTime = -1;
			forEachEvent (pMIDITrack, pMIDIEvent) {
				if (this->IsEventSelected (pMIDIEvent)) {
					if (MIDIEvent_IsNoteOn (pMIDIEvent) && MIDIEvent_IsNote (pMIDIEvent)) {
						long lTime = MIDIEvent_GetTime (pMIDIEvent);
						if (lTime > lOldTime) {
							lGroupIndex++;
						}
						theTempTrackIndexArray.Add (lTrackIndex);
						theTempGroupIndexArray.Add (lGroupIndex);
						theTempEventArray.Add (pMIDIEvent);
						lOldTime = lTime;
					}
				}
			}
			lTrackIndex++;
			lGroupIndex = 0;
		}
		// ŌɏI[Fp̃_~[t
		theTempTrackIndexArray.Add (lTrackIndex);
		theTempGroupIndexArray.Add (lGroupIndex);
		theTempEventArray.Add (NULL);
		
		// eaO[vƂɃm[gKɕבւ(ou\[g)
		long j = 0;
		long jMax = theTempEventArray.GetSize ();
		long jSortMin = 0;
		long jSortMax = 0;
		long lOldTrackIndex = 0;
		long lOldGroupIndex = 0;
		for (j = 0; j < jMax; j++) {
			lTrackIndex = theTempTrackIndexArray.GetAt (j);
			lGroupIndex = theTempGroupIndexArray.GetAt (j);
			if (lTrackIndex > lOldTrackIndex || lGroupIndex > lOldGroupIndex) {
				jSortMax = j;
				// ou\[g()
				if (theDlg.m_nMode == 0 || 
					(theDlg.m_nMode == 2 && (lOldGroupIndex % 2) == 1) ||
					(theDlg.m_nMode == 3 && (lOldGroupIndex % 2) == 0)) {
					long jj1, jj2;
					for (jj1 = jSortMin; jj1 < jSortMax - 1; jj1++) {
						for (jj2 = jSortMin; jj2 < jSortMax - 1; jj2++) {
							long lKey1 = MIDIEvent_GetKey ((MIDIEvent*)(theTempEventArray.GetAt (jj2)));
							long lKey2 = MIDIEvent_GetKey ((MIDIEvent*)(theTempEventArray.GetAt (jj2 + 1)));
							if (lKey1 > lKey2) {
								void* pTempEvent = theTempEventArray.GetAt (jj2);
								theTempEventArray.SetAt (jj2, theTempEventArray.GetAt (jj2 + 1));
								theTempEventArray.SetAt (jj2 + 1, pTempEvent);
							}
						}
					}
				}
				// ou\[g(~)
				else {
					long jj1, jj2;
					for (jj1 = jSortMin; jj1 < jSortMax - 1; jj1++) {
						for (jj2 = jSortMin; jj2 < jSortMax - 1; jj2++) {
							long lKey1 = MIDIEvent_GetKey ((MIDIEvent*)(theTempEventArray.GetAt (jj2)));
							long lKey2 = MIDIEvent_GetKey ((MIDIEvent*)(theTempEventArray.GetAt (jj2 + 1)));
							if (lKey1 < lKey2) {
								void* pTempEvent = theTempEventArray.GetAt (jj2);
								theTempEventArray.SetAt (jj2, theTempEventArray.GetAt (jj2 + 1));
								theTempEventArray.SetAt (jj2 + 1, pTempEvent);
							}
						}
					}
				}
				jSortMin = j;
			}
			lOldGroupIndex = lGroupIndex;
			lOldTrackIndex = lTrackIndex;
		}

		// ̈ړ
		long lMovedEventCount = 0;
		long lOverlap = 0;
		lOldTrackIndex = 0;
		lOldGroupIndex = 0;
		for (j = 0; j < jMax - 1; j++) {
			lTrackIndex = theTempTrackIndexArray.GetAt (j);
			lGroupIndex = theTempGroupIndexArray.GetAt (j);
			pMIDIEvent = (MIDIEvent*)(theTempEventArray.GetAt (j));
			if (lTrackIndex > lOldTrackIndex || lGroupIndex > lOldGroupIndex) {
				lOverlap = 0;
			}
			long lTime = MIDIEvent_GetTime (pMIDIEvent);
			long lNewTime = lTime + theDlg.m_nDeltaTime * lOverlap;
			lNewTime = CLIP (0, lNewTime, 0x7FFF0000);
			long lDuration = MIDIEvent_GetDuration (pMIDIEvent);
			long lNewDuration = lDuration - (lNewTime - lTime);
			lNewDuration = CLIP (1, lNewDuration, 0x0000FFFF);
			if (lTime != lNewTime) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
				MIDIEvent_SetTime (pCloneEvent, lNewTime);
				MIDIEvent_SetDuration (pCloneEvent, lNewDuration);
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
				pMIDIEvent = pCloneEvent;
				lMovedEventCount++;
			}
			lOverlap++;
			lOldTrackIndex = lTrackIndex;
			lOldGroupIndex = lGroupIndex;
		}

		// ꎞz̉
		theTempTrackIndexArray.RemoveAll ();
		theTempGroupIndexArray.RemoveAll ();
		theTempEventArray.RemoveAll ();

		// EOT̗ێ
		forEachTrack (m_pMIDIData, pMIDITrack) {
			MIDIEvent* pLastEvent = MIDITrack_GetLastEvent (pMIDITrack);
			if (pLastEvent) {
				if (MIDIEvent_IsEndofTrack (pLastEvent)) {
					VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
				}
			}
		}

		this->SetModifiedFlag (TRUE);
		this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
	}
}

// wҏW(E)x-wXg[N...x
void CSekaijuDoc::OnUpdateEditStrokeUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	// ׂẴCxgIł΂̍ڂfBXG[u
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable == 1) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
}







// wҏW(E)x-w߂}...x(20100728ǉ)
void CSekaijuDoc::OnEditInsertMeasure () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	MIDIEvent* pCloneEvent = NULL;
	long lTimeMode = MIDIData_GetTimeMode (m_pMIDIData);

	CEditInsertMeasureDlg theDlg;
	theDlg.m_nPosition = pSekaijuApp->m_theEditInsertMeasureDlgStatus.m_nPosition;
	theDlg.m_nNumMeasure = pSekaijuApp->m_theEditInsertMeasureDlgStatus.m_nNumMeasure;
	theDlg.m_bZeroOrigin = (lTimeMode == MIDIDATA_TPQNBASE ? 0 : 1);
	if (theDlg.DoModal () == IDOK) {
		pSekaijuApp->m_theEditInsertMeasureDlgStatus.m_nPosition = theDlg.m_nPosition;
		pSekaijuApp->m_theEditInsertMeasureDlgStatus.m_nNumMeasure = theDlg.m_nNumMeasure;

		BeginWaitCursor ();
		m_theCriticalSection.Lock ();

		CHistoryUnit* pCurHistoryUnit = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_EDIT_INSERTMEASURE));
		VERIFY (this->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
		
		long lTime1, lTime2, lMeasureTime, lSlideTime;
		if (lTimeMode == MIDIDATA_TPQNBASE) {
			MIDIData_MakeTime (m_pMIDIData, theDlg.m_nPosition - 1, 0, 0, &lTime1);
			MIDIData_MakeTime (m_pMIDIData, theDlg.m_nPosition , 0, 0, &lTime2);
		}
		else {
			MIDIData_MakeTime (m_pMIDIData, theDlg.m_nPosition, 0, 0, &lTime1);
			MIDIData_MakeTime (m_pMIDIData, theDlg.m_nPosition + 1, 0, 0, &lTime2);
		}
		lMeasureTime = MAX (0, lTime2 - lTime1);
		lSlideTime = lMeasureTime * theDlg.m_nNumMeasure;
		// 㑱MIDICxg̎ړ
		// Cxg2ړȂ悤ɁA㑱̃Cxgꎞzɓo^B
		CPtrArray theTempFollowingEventArray;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			pMIDITrack->m_lUser1 = 0;
			forEachEvent (pMIDITrack, pMIDIEvent) {
				// ߑ}ʒũCxĝ
				if (MIDIEvent_GetTime (pMIDIEvent) >= lTime1) {
					// 񌋍Cxĝ݁ACxg̏ꍇ͑O񌋍̂
					if (MIDIEvent_IsCombined (pMIDIEvent) && pMIDIEvent->m_pPrevCombinedEvent == NULL ||
						!MIDIEvent_IsCombined (pMIDIEvent)) {
						theTempFollowingEventArray.Add (pMIDIEvent);
						pMIDITrack->m_lUser1++;
					}
				}
			}
		}
		// ꎞz̃Cxg1ɂ1̈ړB
		long lTempFollowingEventArrayCount = theTempFollowingEventArray.GetSize ();
		if (lSlideTime < 0) {
			// (EOTŌɈړ邽߁A)(20081102C)
			for (long j = 0; j < lTempFollowingEventArrayCount; j++) {
				pMIDIEvent = (MIDIEvent*)(theTempFollowingEventArray.GetAt (j));
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
				long lTime = MIDIEvent_GetTime (pCloneEvent);
				lTime += lSlideTime;
				lTime = CLIP (0, lTime, 0x7FFFFFFF);
				VERIFY (MIDIEvent_SetTime (pCloneEvent, lTime));
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
				pMIDIEvent = pCloneEvent;
			}
		}
		else {
			// (EOTŏɈړ邽߁At)(20081102C)
			for (long j = lTempFollowingEventArrayCount - 1; j >= 0; j--) {
				pMIDIEvent = (MIDIEvent*)(theTempFollowingEventArray.GetAt (j));
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
				long lTime = MIDIEvent_GetTime (pCloneEvent);
				lTime += lSlideTime;
				lTime = CLIP (0, lTime, 0x7FFFFFFF);
				VERIFY (MIDIEvent_SetTime (pCloneEvent, lTime));
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
				pMIDIEvent = pCloneEvent;
			}
		}
		theTempFollowingEventArray.RemoveAll ();
		this->SetModifiedFlag (TRUE);
		this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
	}
}

// wҏW(E)x-w߂}...x(20100728ǉ)
void CSekaijuDoc::OnUpdateEditInsertMeasureUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
}

// wҏW(E)x-w߂...x(20100728ǉ)
void CSekaijuDoc::OnEditRemoveMeasure () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	MIDITrack* pMIDITrack = NULL;
	MIDIEvent* pMIDIEvent = NULL;
	MIDIEvent* pCloneEvent = NULL;
	long lTimeMode = MIDIData_GetTimeMode (m_pMIDIData);

	CEditRemoveMeasureDlg theDlg;
	theDlg.m_nPosition = pSekaijuApp->m_theEditRemoveMeasureDlgStatus.m_nPosition;
	theDlg.m_nNumMeasure = pSekaijuApp->m_theEditRemoveMeasureDlgStatus.m_nNumMeasure;
	theDlg.m_bZeroOrigin = (lTimeMode == MIDIDATA_TPQNBASE ? 0 : 1);
	if (theDlg.DoModal () == IDOK) {
		pSekaijuApp->m_theEditRemoveMeasureDlgStatus.m_nPosition = theDlg.m_nPosition;
		pSekaijuApp->m_theEditRemoveMeasureDlgStatus.m_nNumMeasure = theDlg.m_nNumMeasure;

		BeginWaitCursor ();
		m_theCriticalSection.Lock ();

		CHistoryUnit* pCurHistoryUnit = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_EDIT_INSERTMEASURE));
		VERIFY (this->AddHistoryUnit (strHistoryName));
		VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
		
		long lTime1, lTime2, lSlideTime;
		if (lTimeMode == MIDIDATA_TPQNBASE) {
			MIDIData_MakeTime (m_pMIDIData, theDlg.m_nPosition - 1, 0, 0, &lTime1);
			MIDIData_MakeTime (m_pMIDIData, theDlg.m_nPosition - 1 + theDlg.m_nNumMeasure, 0, 0, &lTime2);
		}
		else {
			MIDIData_MakeTime (m_pMIDIData, theDlg.m_nPosition, 0, 0, &lTime1);
			MIDIData_MakeTime (m_pMIDIData, theDlg.m_nPosition + theDlg.m_nNumMeasure, 0, 0, &lTime2);
		}
		lSlideTime = MIN (0, lTime1 - lTime2);
		// lTime1`lTime2̃Cxg̍폜
		// Cxg2ړȂ悤ɁAlTime1`lTime2̃Cxgꎞzɓo^B
		CPtrArray theTempDuringEventArray;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			pMIDITrack->m_lUser1 = 0;
			forEachEvent (pMIDITrack, pMIDIEvent) {
				// lTime1`lTime2̃Cxĝ
				long lTime = MIDIEvent_GetTime (pMIDIEvent);
				if (lTime1 <= lTime && lTime < lTime2) {
					// 񌋍Cxĝ݁ACxg̏ꍇ͑O񌋍̂
					if (MIDIEvent_IsCombined (pMIDIEvent) && pMIDIEvent->m_pPrevCombinedEvent == NULL ||
						!MIDIEvent_IsCombined (pMIDIEvent)) {
						theTempDuringEventArray.Add (pMIDIEvent);
						pMIDITrack->m_lUser1++;
					}
				}
			}
		}
		// ꎞz̃Cxg폜(EOT)
		long lTempDuringEventArrayCount = theTempDuringEventArray.GetSize ();
		for (long j = 0; j < lTempDuringEventArrayCount; j++) {
			pMIDIEvent = (MIDIEvent*)(theTempDuringEventArray.GetAt (j));
			VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
			if (MIDIEvent_IsEndofTrack (pMIDIEvent)) {
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
				long lTime = CLIP (0, lTime1, 0x7FFFFFFF);
				MIDIEvent_SetTime (pCloneEvent, lTime);
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
				pMIDIEvent = pCloneEvent;
			}
			else {
				VERIFY (MIDITrack_RemoveEvent (MIDIEvent_GetParent (pMIDIEvent), pMIDIEvent));
			}
		}
		theTempDuringEventArray.RemoveAll ();
		
		// 㑱MIDICxg̎ړ
		// Cxg2ړȂ悤ɁA㑱̃Cxgꎞzɓo^B
		CPtrArray theTempFollowingEventArray;
		forEachTrack (m_pMIDIData, pMIDITrack) {
			pMIDITrack->m_lUser1 = 0;
			forEachEvent (pMIDITrack, pMIDIEvent) {
				// ߑ}ʒũCxĝ
				if (MIDIEvent_GetTime (pMIDIEvent) >= lTime1) {
					// 񌋍Cxĝ݁ACxg̏ꍇ͑O񌋍̂
					if (MIDIEvent_IsCombined (pMIDIEvent) && pMIDIEvent->m_pPrevCombinedEvent == NULL ||
						!MIDIEvent_IsCombined (pMIDIEvent)) {
						theTempFollowingEventArray.Add (pMIDIEvent);
						pMIDITrack->m_lUser1++;
					}
				}
			}
		}
		// ꎞz̃Cxg1ɂ1̈ړB
		long lTempFollowingEventArrayCount = theTempFollowingEventArray.GetSize ();
		if (lSlideTime < 0) {
			// (EOTŌɈړ邽߁A)(20081102C)
			for (long j = 0; j < lTempFollowingEventArrayCount; j++) {
				pMIDIEvent = (MIDIEvent*)(theTempFollowingEventArray.GetAt (j));
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
				long lTime = MIDIEvent_GetTime (pCloneEvent);
				lTime += lSlideTime;
				lTime = CLIP (0, lTime, 0x7FFFFFFF);
				VERIFY (MIDIEvent_SetTime (pCloneEvent, lTime));
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
				pMIDIEvent = pCloneEvent;
			}
		}
		else {
			// (EOTŏɈړ邽߁At)(20081102C)
			for (long j = lTempFollowingEventArrayCount - 1; j >= 0; j--) {
				pMIDIEvent = (MIDIEvent*)(theTempFollowingEventArray.GetAt (j));
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pMIDIEvent));
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pMIDIEvent));
				long lTime = MIDIEvent_GetTime (pCloneEvent);
				lTime += lSlideTime;
				lTime = CLIP (0, lTime, 0x7FFFFFFF);
				VERIFY (MIDIEvent_SetTime (pCloneEvent, lTime));
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pCloneEvent));
				pMIDIEvent = pCloneEvent;
			}
		}
		theTempFollowingEventArray.RemoveAll ();
		this->SetModifiedFlag (TRUE);
		this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		::Sleep (0);
	}
}

// wҏW(E)x-w߂...x(20100728ǉ)
void CSekaijuDoc::OnUpdateEditRemoveMeasureUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
}



// wr[(&V)x-wĕ\(&R)x
void CSekaijuDoc::OnViewRedraw () {
	//this->UpdateAllViews (NULL, 0xFFFFFFFF);
	this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIDATACHANGED | 
		SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIEVENTCHANGED);
	// TODO:2̂ǂ炪ǂB
}

// wr[(&V)x-wVKgbNXg(&T)x
void CSekaijuDoc::OnViewTrackList () {
	m_theCriticalSection.Lock ();
	m_lTempTime = m_lNewTime;
	m_pTempTrack = NULL;
	m_pTempEvent = NULL;
	m_theCriticalSection.Unlock ();
	ShowTrackListFrame ();
}

// wr[(&V)x-wVKsAm[(&P)x
void CSekaijuDoc::OnViewPianoRoll () {
	m_theCriticalSection.Lock ();
	m_lTempTime = m_lNewTime;
	m_pTempTrack = NULL;
	m_pTempEvent = NULL;
	MIDITrack* pMIDITrack = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		pMIDITrack->m_lUserFlag |= MIDITRACK_VISIBLE;
	}
	m_theCriticalSection.Unlock ();
	ShowPianoRollFrame ();
}

// wr[(&V)x-wVKCxgXg(&E)x
void CSekaijuDoc::OnViewEventList () {
	m_theCriticalSection.Lock ();
	m_lTempTime = m_lNewTime;
	m_pTempTrack = NULL;
	m_pTempEvent = NULL;
	MIDITrack* pMIDITrack = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		pMIDITrack->m_lUserFlag |= MIDITRACK_VISIBLE;
	}
	m_theCriticalSection.Unlock ();
	ShowEventListFrame ();
}

// wr[(&V)x-wVK(&S)x
void CSekaijuDoc::OnViewMusicalScore () {
	m_theCriticalSection.Lock ();
	m_lTempTime = m_lNewTime;
	m_pTempTrack = NULL;
	m_pTempEvent = NULL;
	MIDITrack* pMIDITrack = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		pMIDITrack->m_lUserFlag |= MIDITRACK_VISIBLE;
	}
	m_theCriticalSection.Unlock ();
	ShowMusicalScoreFrame ();
}


// w|bvAbvx-w̃gbN̂݃gbNXg\(&T)x
void CSekaijuDoc::OnPopupShowTrackList () {
	if (m_pTempTrack != NULL) { // 20100429ǉ
		ShowTrackListFrame ();
	}
}

// w|bvAbvx-w̃gbN̂݃gbNXg\(&T)x // 20100429ǉ
void CSekaijuDoc::OnUpdatePopupShowTrackListUI (CCmdUI* pCmdUI) {
	if (m_pTempTrack == NULL) { // 20100429ǉ
		pCmdUI->Enable (FALSE);
	}
}

// w|bvAbvx-w̃gbN̂݃sAm[\(&P)x
void CSekaijuDoc::OnPopupShowPianoRoll () {
	if (m_pTempTrack != NULL) { // 20100429ǉ
		ShowPianoRollFrame ();
	}
}

// w|bvAbvx-w̃gbN̂݃sAm[\(&P)x // 20100429ǉ
void CSekaijuDoc::OnUpdatePopupShowPianoRollUI (CCmdUI* pCmdUI) {
	if (m_pTempTrack == NULL) { // 20100429ǉ
		pCmdUI->Enable (FALSE);
	}
}

// w|bvAbvx-w̃gbN̂݃CxgXg\(&E)x
void CSekaijuDoc::OnPopupShowEventList () {
	if (m_pTempTrack != NULL) { // 20100429ǉ
		ShowEventListFrame ();
	}
}

// w|bvAbvx-w̃gbN̂݃CxgXg\(&E)x // 20100429ǉ
void CSekaijuDoc::OnUpdatePopupShowEventListUI (CCmdUI* pCmdUI) {
	if (m_pTempTrack == NULL) { // 20100429ǉ
		pCmdUI->Enable (FALSE);
	}
}

// w|bvAbvx-w̃gbN̂ݕʕ\(&S)x
void CSekaijuDoc::OnPopupShowMusicalScore () {
	if (m_pTempTrack != NULL) { // 20100429ǉ
		ShowMusicalScoreFrame ();
	}
}

// w|bvAbvx-w̃gbN̂ݕʕ\(&S)x // 20100429ǉ
void CSekaijuDoc::OnUpdatePopupShowMusicalScoreUI (CCmdUI* pCmdUI) {
	if (m_pTempTrack == NULL) { // 20100429ǉ
		pCmdUI->Enable (FALSE);
	}
}


// w|bvAbvx-w̃gbN̂ݓONx
void CSekaijuDoc::OnPopupTrackInputOn () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempTrack == NULL) {  // 20100429ǉ
		return;
	}
	
	m_theCriticalSection.Lock ();

	// ON/OFFύX(L^)
	CHistoryUnit* pCurHistoryUnit = NULL;
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_ONLY_THIS_TRACK_INPUT_ON));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	MIDITrack* pMIDITrack = NULL;
	MIDITrack* pCloneTrack = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack));
		VERIFY (pCloneTrack = this->ReplaceMIDITrack (pMIDITrack));
		if (pMIDITrack == m_pTempTrack) {
			MIDITrack_SetInputOn (pCloneTrack, 1);
		}
		else {
			MIDITrack_SetInputOn (pCloneTrack, 0);
		}
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack));
		pMIDITrack = pCloneTrack;
	}

	UpdateAllViews (NULL, SEKAIJUDOC_MIDITRACKCHANGED);
	m_theCriticalSection.Unlock ();	
	::Sleep (0);
}

// w|bvAbvx-w̃gbN̂ݓONx
void CSekaijuDoc::OnUpdatePopupTrackInputOnUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempTrack == NULL) {  // 20100429ǉ
		pCmdUI->Enable (FALSE);
		return;
	}
}

// w|bvAbvx-w̃gbN̂ݓOFFx
void CSekaijuDoc::OnPopupTrackInputOff () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempTrack == NULL) {  // 20100429ǉ
		return;
	}

	m_theCriticalSection.Lock ();

	// ON/OFFύX(L^)
	CHistoryUnit* pCurHistoryUnit = NULL;
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_ONLY_THIS_TRACK_INPUT_OFF));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	MIDITrack* pMIDITrack = NULL;
	MIDITrack* pCloneTrack = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack));
		VERIFY (pCloneTrack = this->ReplaceMIDITrack (pMIDITrack));
		if (pMIDITrack == m_pTempTrack) {
			MIDITrack_SetInputOn (pCloneTrack, 0);
		}
		else {
			MIDITrack_SetInputOn (pCloneTrack, 1);
		}
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack));
		pMIDITrack = pCloneTrack;
	}

	UpdateAllViews (NULL, SEKAIJUDOC_MIDITRACKCHANGED);
	m_theCriticalSection.Unlock ();	
	::Sleep (0);
}

// w|bvAbvx-w̃gbN̂ݓOFFx
void CSekaijuDoc::OnUpdatePopupTrackInputOffUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempTrack == NULL) {  // 20100429ǉ
		pCmdUI->Enable (FALSE);
		return;
	}
}

// w|bvAbvx-wSgbNONx
void CSekaijuDoc::OnPopupTrackInputAll () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	m_theCriticalSection.Lock ();
	// ON/OFFύX(L^)
	CHistoryUnit* pCurHistoryUnit = NULL;
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_ALL_TRACK_INPUT_ON));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	MIDITrack* pMIDITrack = NULL;
	MIDITrack* pCloneTrack = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack));
		VERIFY (pCloneTrack = this->ReplaceMIDITrack (pMIDITrack));
		MIDITrack_SetInputOn (pCloneTrack, 1);
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack));
		pMIDITrack = pCloneTrack;
	}
	UpdateAllViews (NULL, SEKAIJUDOC_MIDITRACKCHANGED);
	m_theCriticalSection.Unlock ();	
	::Sleep (0);
}

// w|bvAbvx-wSgbNONx
void CSekaijuDoc::OnUpdatePopupTrackInputAllUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
}

// w|bvAbvx-w̃gbN̂ݏoONx
void CSekaijuDoc::OnPopupTrackOutputOn () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempTrack == NULL) {  // 20100429ǉ
		return;
	}

	m_theCriticalSection.Lock ();
	// oON/OFFύX(L^)
	CHistoryUnit* pCurHistoryUnit = NULL;
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_ONLY_THIS_TRACK_OUTPUT_ON));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	MIDITrack* pMIDITrack = NULL;
	MIDITrack* pCloneTrack = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack));
		VERIFY (pCloneTrack = this->ReplaceMIDITrack (pMIDITrack));
		if (pMIDITrack == m_pTempTrack) {
			MIDITrack_SetOutputOn (pCloneTrack, 1);
		}
		else {
			MIDITrack_SetOutputOn (pCloneTrack, 0);
		}
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack));
		pMIDITrack = pCloneTrack;
	}

	// tԕ
	long lCurTime = MIDIClock_GetTickCount (m_pMIDIClock);
	pSekaijuApp->m_theCriticalSection.Lock ();
	pSekaijuApp->ResetTempMIDIStatusArray ();
	this->TimeMIDIStatus (lCurTime, pSekaijuApp->m_pTempMIDIStatus);
	long lFlags;
	// ĐȂ(a)ׂĖ(b)m[ĝ݂𕜌
	if (pSekaijuApp->m_bPlaying) {
		lFlags = pSekaijuApp->m_theGeneralOption.m_bSearchUpdate ? SDS_ALL : SDS_NOTE;
		pSekaijuApp->m_bIgnoreNoteEvent = 1;
	}
	// ~Ȃ(a)m[gׂĂ𕜌邩(b)Ȃ 
	else {
		lFlags = pSekaijuApp->m_theGeneralOption.m_bSearchUpdate ? (SDS_ALL & ~SDS_NOTE) : 0;
		pSekaijuApp->m_bIgnoreNoteEvent = 0;
	}
	pSekaijuApp->SendDifferentStatus (lFlags);
	pSekaijuApp->m_theCriticalSection.Unlock ();
	
	UpdateAllViews (NULL, SEKAIJUDOC_MIDITRACKCHANGED);
	m_theCriticalSection.Unlock ();	
	::Sleep (0);
}

// w|bvAbvx-w̃gbN̂ݏoONx
void CSekaijuDoc::OnUpdatePopupTrackOutputOnUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempTrack == NULL) { // 20100429ǉ
		pCmdUI->Enable (FALSE);
		return;
	}
}

// w|bvAbvx-w̃gbN̂ݏoOFFx
void CSekaijuDoc::OnPopupTrackOutputOff () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempTrack == NULL) {  // 20100429ǉ
		return;
	}

	m_theCriticalSection.Lock ();
	// oON/OFFύX(L^)
	CHistoryUnit* pCurHistoryUnit = NULL;
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_ONLY_THIS_TRACK_OUTPUT_OFF));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	MIDITrack* pMIDITrack = NULL;
	MIDITrack* pCloneTrack = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack));
		VERIFY (pCloneTrack = this->ReplaceMIDITrack (pMIDITrack));
		if (pMIDITrack == m_pTempTrack) {
			MIDITrack_SetOutputOn (pCloneTrack, 0);
		}
		else {
			MIDITrack_SetOutputOn (pCloneTrack, 1);
		}
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack));
		pMIDITrack = pCloneTrack;
	}

	// tԕ
	long lCurTime = MIDIClock_GetTickCount (m_pMIDIClock);
	pSekaijuApp->m_theCriticalSection.Lock ();
	pSekaijuApp->ResetTempMIDIStatusArray ();
	this->TimeMIDIStatus (lCurTime, pSekaijuApp->m_pTempMIDIStatus);
	long lFlags;
	// ĐȂ(a)ׂĖ(b)m[ĝ݂𕜌
	if (pSekaijuApp->m_bPlaying) {
		lFlags = pSekaijuApp->m_theGeneralOption.m_bSearchUpdate ? SDS_ALL : SDS_NOTE;
		pSekaijuApp->m_bIgnoreNoteEvent = 1;
	}
	// ~Ȃ(a)m[gׂĂ𕜌邩(b)Ȃ 
	else {
		lFlags = pSekaijuApp->m_theGeneralOption.m_bSearchUpdate ? (SDS_ALL & ~SDS_NOTE) : 0;
		pSekaijuApp->m_bIgnoreNoteEvent = 0;
	}
	pSekaijuApp->SendDifferentStatus (lFlags);
	pSekaijuApp->m_theCriticalSection.Unlock ();
	
	
	UpdateAllViews (NULL, SEKAIJUDOC_MIDITRACKCHANGED);
	m_theCriticalSection.Unlock ();	
	::Sleep (0);
}

// w|bvAbvx-w̃gbN̂ݏoOFFx
void CSekaijuDoc::OnUpdatePopupTrackOutputOffUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempTrack == NULL) { // 20100429ǉ
		pCmdUI->Enable (FALSE);
		return;
	}
}

// w|bvAbvx-wSgbNoONx
void CSekaijuDoc::OnPopupTrackOutputAll () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}

	m_theCriticalSection.Lock ();

	// oON/OFFύX(L^)
	CHistoryUnit* pCurHistoryUnit = NULL;
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_ALL_TRACK_OUTPUT_ON));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	MIDITrack* pMIDITrack = NULL;
	MIDITrack* pCloneTrack = NULL;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVETRACK, pMIDITrack));
		VERIFY (pCloneTrack = this->ReplaceMIDITrack (pMIDITrack));
		MIDITrack_SetOutputOn (pCloneTrack, 1);
		VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTTRACK, pCloneTrack));
		pMIDITrack = pCloneTrack;
	}

	// tԕ
	long lCurTime = MIDIClock_GetTickCount (m_pMIDIClock);
	pSekaijuApp->m_theCriticalSection.Lock ();
	pSekaijuApp->ResetTempMIDIStatusArray ();
	this->TimeMIDIStatus (lCurTime, pSekaijuApp->m_pTempMIDIStatus);
	long lFlags;
	// ĐȂ(a)ׂĖ(b)m[ĝ݂𕜌
	if (pSekaijuApp->m_bPlaying) {
		lFlags = pSekaijuApp->m_theGeneralOption.m_bSearchUpdate ? SDS_ALL : SDS_NOTE;
		pSekaijuApp->m_bIgnoreNoteEvent = 1;
	}
	// ~Ȃ(a)m[gׂĂ𕜌邩(b)Ȃ 
	else {
		lFlags = pSekaijuApp->m_theGeneralOption.m_bSearchUpdate ? (SDS_ALL & ~SDS_NOTE) : 0;
		pSekaijuApp->m_bIgnoreNoteEvent = 0;
	}
	pSekaijuApp->SendDifferentStatus (lFlags);
	pSekaijuApp->m_theCriticalSection.Unlock ();

	
	UpdateAllViews (NULL, SEKAIJUDOC_MIDITRACKCHANGED);
	m_theCriticalSection.Unlock ();	
	::Sleep (0);
}

// w|bvAbvx-wSgbNoONx
void CSekaijuDoc::OnUpdatePopupTrackOutputAllUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
}

// w|bvAbvx-w؂(&T)x
void CSekaijuDoc::OnPopupCut () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}


	long lRet = 0;
	long lCopiedEventCount = 0;
	BeginWaitCursor ();

	// Nbv{[hɓ]镶쐬
	CString strText;
	m_theCriticalSection.Lock ();
	lCopiedEventCount = this->MakeCopyString (strText, 0x0001, NULL);
	UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
	if (lCopiedEventCount == 0) {
		EndWaitCursor ();
		return;
	}

	// Nbv{[hɓƎeLXg]
	lRet = this->SetClipboardTextPrivate9 (strText);
	if (lRet == FALSE) {
		EndWaitCursor ();
		CString strMsg;
		VERIFY (strMsg.LoadString (IDS_UNABLE_TO_WRITE_TO_CLIPBOARD));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return;
	}

	// ICxg폜
	CHistoryUnit* pCurHistoryUnit = NULL;
	m_theCriticalSection.Lock ();
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_EDIT_CUT));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = GetCurHistoryUnit ());

	this->DeleteSelectedEvent (pCurHistoryUnit);
	
	SetModifiedFlag (TRUE);
	UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	::Sleep (0);
}

// w|bvAbvx-w؂(&T)x
void CSekaijuDoc::OnUpdatePopupCutUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}

	// ЂƂłMIDICxgIĂEnable
	// łȂDisableƂ
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack;
	MIDIEvent* pMIDIEvent;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);

}

// w|bvAbvx-wRs[(&C)x
void CSekaijuDoc::OnPopupCopy () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}


	long lRet = 0;
	long lCopiedEventCount = 0;
	BeginWaitCursor ();

	// Nbv{[hɓ]镶쐬
	CString strText;
	m_theCriticalSection.Lock ();
	lCopiedEventCount = this->MakeCopyString (strText, 0x0001, NULL);
	UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
	if (lCopiedEventCount == 0) {
		EndWaitCursor ();
		return;
	}

	// Nbv{[hɓƎeLXg]
	lRet = this->SetClipboardTextPrivate9 (strText);
	if (lRet == FALSE) {
		EndWaitCursor ();
		CString strMsg;
		VERIFY (strMsg.LoadString (IDS_UNABLE_TO_WRITE_TO_CLIPBOARD));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return;
	}
	EndWaitCursor ();
}

// w|bvAbvx-wRs[(&C)x
void CSekaijuDoc::OnUpdatePopupCopyUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}


	// ЂƂłMIDICxgIĂEnable
	// łȂDisableƂ
	m_theCriticalSection.Lock ();
	long lEnable = 0;
	MIDITrack* pMIDITrack;
	MIDIEvent* pMIDIEvent;
	forEachTrack (m_pMIDIData, pMIDITrack) {
		forEachEvent (pMIDITrack, pMIDIEvent) {
			if (this->IsEventSelected (pMIDIEvent)) {
				lEnable = 1;
				break;
			}
		}
		if (lEnable) {
			break;
		}
	}
	pCmdUI->Enable (lEnable);
	m_theCriticalSection.Unlock ();
	::Sleep (0);
}

// w|bvAbvx-w\t(&T)x
void CSekaijuDoc::OnPopupPaste () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}


	BeginWaitCursor ();
	CString strMsg;

	// Nbv{[h̃eLXg擾
	CString strText;
	long lRet = this->GetClipboardTextPrivate9 (strText);
	if (lRet == FALSE) {
		EndWaitCursor ();
		VERIFY (strMsg.LoadString (IDS_UNABLE_TO_READ_FROM_CLIPBOARD));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return;
	}
	
	// eLXgtH[}bg
	if (strText.Left(5) != _T("MDa2 ")) {
		EndWaitCursor ();
		VERIFY (strMsg.LoadString (IDS_NO_AVAILABLE_MIDIDATA_IN_THE_CLIPBOARD));
		AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
		return;
	}
	
	// \t
	CHistoryUnit* pCurHistoryUnit = NULL;
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_EDIT_PASTE));
	VERIFY (this->AddHistoryUnit (strHistoryName));
	VERIFY (pCurHistoryUnit = this->GetCurHistoryUnit ());
	m_theCriticalSection.Lock ();
	long lInsertedEventCount = this->ParsePasteString (strText, m_lTempTrackIndex, m_lTempTime, pCurHistoryUnit);
	this->SetModifiedFlag (TRUE);
	this->UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED |
		SEKAIJUDOC_MIDITRACKCHANGED | SEKAIJUDOC_MIDIDATACHANGED);
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	::Sleep (0);

	// ʂ̃bZ[W{bNX\
	if (lInsertedEventCount == -1) {
		VERIFY (strMsg.LoadString (IDS_PASTE_FAILED));
	}
	else {
		CString strFormat;
		VERIFY (strFormat.LoadString (IDS_D_MIDIEVENTS_WERE_INSERTED));
		strMsg.Format (strFormat, lInsertedEventCount);
	}
	AfxMessageBox (strMsg, MB_ICONINFORMATION);
}

// w|bvAbvx-w\t(&T)x
void CSekaijuDoc::OnUpdatePopupPasteUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	
	// Nbv{[ȟ`ƎeLXgׂ
	pCmdUI->Enable (this->IsClipboardTextPrivate9 ());

}



// w|bvAbvx-we|̑}...x
void CSekaijuDoc::OnPopupInsertTempo () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempTrack == NULL) {
		return;
	}

	CPropertyTempoDlg theDlg;
	long lTime = m_lTempTime;
	CString strTime;
	LongTimeToStringTime (m_pMIDIData, lTime, &strTime);
	theDlg.m_strTime = strTime;
	long lTempo = 60000000 / 120;
	double dTempoBPM = (double)60000000 / (double)lTempo;
	theDlg.m_strTempoBPM.Format (_T("%1.2lf"), dTempoBPM);
	if (theDlg.DoModal () == IDOK) {
		// ^Clong^ɕϊ
		long lErrorID = StringTimeToLongTime (m_pMIDIData, theDlg.m_strTime, &lTime);
		if (lErrorID != 0) {
			CString strMsg;
			VERIFY (strMsg.LoadString (lErrorID));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			return;
		}
		dTempoBPM = _tstof (theDlg.m_strTempoBPM);
		dTempoBPM = CLIP (1, dTempoBPM, 60000000);
		lTempo = (long)(60000000 / dTempoBPM);
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDIEvent* pNewEvent = NULL;
		MIDIEvent* pLastEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_INSERT_EVENT));
		AddHistoryUnit (strHistoryName);
		CHistoryUnit* pCurHistoryUnit = GetCurHistoryUnit ();

		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
			}
		}
			
		// Cxg̒ǉ
		VERIFY (pNewEvent = MIDIEvent_CreateTempo (lTime, lTempo));
		VERIFY (MIDITrack_InsertEvent (m_pTempTrack, pNewEvent));
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent);
		
		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
			}
		}
		
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		::Sleep (0);
	}
}

// w|bvAbvx-we|̑}...x
void CSekaijuDoc::OnUpdatePopupInsertTempoUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempTrack == NULL) {
		pCmdUI->Enable (FALSE);
		return;
	}
}

// w|bvAbvx-wqL̑}...x
void CSekaijuDoc::OnPopupInsertTimeSignature () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempTrack == NULL) {
		return;
	}

	CPropertyTimeSignatureDlg theDlg;
	long lTime = m_lTempTime;
	CString strTime;
	LongTimeToStringTime (m_pMIDIData, lTime, &strTime);
	theDlg.m_strTime = strTime;
	long lnn, ldd, lcc, lbb;
	lnn = 4;
	ldd = 2;
	lcc = 24;
	lbb = 8;
	theDlg.m_lNN = lnn;
	theDlg.m_nDDIndex = CLIP (0, ldd, 5);
	theDlg.m_lCC = lcc;
	theDlg.m_lBB = lbb;
	if (theDlg.DoModal () == IDOK) {
		// ^Clong^ɕϊ
		long lErrorID = StringTimeToLongTime (m_pMIDIData, theDlg.m_strTime, &lTime);
		if (lErrorID != 0) {
			CString strMsg;
			VERIFY (strMsg.LoadString (lErrorID));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			return;
		}
		lnn = theDlg.m_lNN;
		ldd = theDlg.m_nDDIndex;
		lcc = theDlg.m_lCC;
		lbb = theDlg.m_lBB;
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDIEvent* pNewEvent = NULL;
		MIDIEvent* pLastEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_INSERT_EVENT));
		AddHistoryUnit (strHistoryName);
		CHistoryUnit* pCurHistoryUnit = GetCurHistoryUnit ();

		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
			}
		}
			
		// Cxg̒ǉ
		VERIFY (pNewEvent = MIDIEvent_CreateTimeSignature (lTime, lnn, ldd, lcc, lbb));
		VERIFY (MIDITrack_InsertEvent (m_pTempTrack, pNewEvent));
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent);
		
		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
			}
		}
		
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		::Sleep (0);
	}
}

// w|bvAbvx-wqL̑}...x
void CSekaijuDoc::OnUpdatePopupInsertTimeSignatureUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempTrack == NULL) {
		pCmdUI->Enable (FALSE);
		return;
	}
}


// w|bvAbvx-wL̑}...x
void CSekaijuDoc::OnPopupInsertKeySignature () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempTrack == NULL) {
		return;
	}

	CPropertyKeySignatureDlg theDlg;
	long lTime = m_lTempTime;
	CString strTime;
	LongTimeToStringTime (m_pMIDIData, lTime, &strTime);
	theDlg.m_strTime = strTime;
	long lsf, lmi;
	lsf = 0;
	lmi = 0;
	theDlg.m_nSFIndex = lsf + 7;
	theDlg.m_nMiIndex = CLIP (0, lmi, 1);
	if (theDlg.DoModal () == IDOK) {
		// ^Clong^ɕϊ
		long lErrorID = StringTimeToLongTime (m_pMIDIData, theDlg.m_strTime, &lTime);
		if (lErrorID != 0) {
			CString strMsg;
			VERIFY (strMsg.LoadString (lErrorID));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			return;
		}
		lsf = theDlg.m_nSFIndex - 7;
		lmi = theDlg.m_nMiIndex;
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDIEvent* pNewEvent = NULL;
		MIDIEvent* pLastEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_INSERT_EVENT));
		AddHistoryUnit (strHistoryName);
		CHistoryUnit* pCurHistoryUnit = GetCurHistoryUnit ();

		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
			}
		}
			
		// Cxg̒ǉ
		VERIFY (pNewEvent = MIDIEvent_CreateKeySignature (lTime, lsf, lmi));
		VERIFY (MIDITrack_InsertEvent (m_pTempTrack, pNewEvent));
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent);

		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
			}
		}
		
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		::Sleep (0);
	}
}

// w|bvAbvx-wL̑}...x
void CSekaijuDoc::OnUpdatePopupInsertKeySignatureUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempTrack == NULL) {
		pCmdUI->Enable (FALSE);
		return;
	}
}


// w|bvAbvx-w}[J[̑}...x
void CSekaijuDoc::OnPopupInsertMarker () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempTrack == NULL) {
		return;
	}

	CPropertyMarkerDlg theDlg;
	long lTime = m_lTempTime;
	CString strTime;
	LongTimeToStringTime (m_pMIDIData, lTime, &strTime);
	theDlg.m_strTime = strTime;
	TCHAR szText1[1024];
	TCHAR szText2[1024];
	memset (szText1, 0, TSIZEOF (szText1));
	memset (szText2, 0, TSIZEOF (szText2));
	theDlg.m_strText = szText2;
	if (theDlg.DoModal () == IDOK) {
		// ^Clong^ɕϊ
		long lErrorID = StringTimeToLongTime (m_pMIDIData, theDlg.m_strTime, &lTime);
		if (lErrorID != 0) {
			CString strMsg;
			VERIFY (strMsg.LoadString (lErrorID));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			return;
		}
		memset (szText1, 0, TSIZEOF (szText1));
		memset (szText2, 0, TSIZEOF (szText2));
		str2codestr ((TCHAR*)(LPCTSTR)(theDlg.m_strText), theDlg.m_strText.GetLength (), szText1, 1023);
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDIEvent* pNewEvent = NULL;
		MIDIEvent* pLastEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_INSERT_EVENT));
		AddHistoryUnit (strHistoryName);
		CHistoryUnit* pCurHistoryUnit = GetCurHistoryUnit ();

		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
			}
		}
			
		// Cxg̒ǉ
		VERIFY (pNewEvent = MIDIEvent_CreateMarker (lTime, szText1));
		VERIFY (MIDITrack_InsertEvent (m_pTempTrack, pNewEvent));
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent);

		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
			}
		}
		
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		::Sleep (0);
	}
}

// w|bvAbvx-w}[J[̑}...x
void CSekaijuDoc::OnUpdatePopupInsertMarkerUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempTrack == NULL) {
		pCmdUI->Enable (FALSE);
		return;
	}
}
















// w|bvAbvx-we|̕ύX...x
void CSekaijuDoc::OnPopupModifyTempo () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempTempoEvent == NULL || m_pTempTrack == NULL) {
		return;
	}
	if (!MIDIEvent_IsTempo (m_pTempTempoEvent)) {
		return;
	}

	CPropertyTempoDlg theDlg;
	long lTime = MIDIEvent_GetTime (m_pTempTempoEvent);
	CString strTime;
	LongTimeToStringTime (m_pMIDIData, lTime, &strTime);
	theDlg.m_strTime = strTime;
	long lTempo = MIDIEvent_GetTempo (m_pTempTempoEvent);
	double dTempoBPM = (double)60000000 / (double)lTempo;
	theDlg.m_strTempoBPM.Format (_T("%1.2lf"), dTempoBPM);
	if (theDlg.DoModal () == IDOK) {
		// ^Clong^ɕϊ
		long lNewTime = lTime;
		long lErrorID = StringTimeToLongTime (m_pMIDIData, theDlg.m_strTime, &lNewTime);
		if (lErrorID != 0) {
			CString strMsg;
			VERIFY (strMsg.LoadString (lErrorID));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			return;
		}
		dTempoBPM = _tstof (theDlg.m_strTempoBPM);
		dTempoBPM = CLIP (1, dTempoBPM, 60000000);
		lTempo = (long)(60000000 / dTempoBPM);
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDIEvent* pNewEvent = NULL;
		MIDIEvent* pLastEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_EVENT));
		AddHistoryUnit (strHistoryName);
		CHistoryUnit* pCurHistoryUnit = GetCurHistoryUnit ();

		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
			}
		}
			
		// Cxg̒uƕύX
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, m_pTempTempoEvent);
		VERIFY (pNewEvent = ReplaceMIDIEvent (m_pTempTempoEvent));
		if (lNewTime != lTime) {
			MIDIEvent_SetTime (pNewEvent, lNewTime);
		}
		MIDIEvent_SetTempo (pNewEvent, lTempo);
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent);
		
		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
			}
		}
		
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		::Sleep (0);
	}
}

// w|bvAbvx-we|̕ύX...x
void CSekaijuDoc::OnUpdatePopupModifyTempoUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempTempoEvent == NULL || m_pTempTrack == NULL) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (!MIDIEvent_IsTempo (m_pTempTempoEvent)) {
		pCmdUI->Enable (FALSE);
		return;
	}
}

// w|bvAbvx-wqL̕ύX...x
void CSekaijuDoc::OnPopupModifyTimeSignature () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempTimeSignatureEvent == NULL || m_pTempTrack == NULL) {
		return;
	}
	if (!MIDIEvent_IsTimeSignature (m_pTempTimeSignatureEvent)) {
		return;
	}

	CPropertyTimeSignatureDlg theDlg;
	long lTime = MIDIEvent_GetTime (m_pTempTimeSignatureEvent);
	CString strTime;
	LongTimeToStringTime (m_pMIDIData, lTime, &strTime);
	theDlg.m_strTime = strTime;
	long lnn, ldd, lcc, lbb;
	MIDIEvent_GetTimeSignature (m_pTempTimeSignatureEvent, &lnn, &ldd, &lcc, &lbb);
	theDlg.m_lNN = lnn;
	theDlg.m_nDDIndex = CLIP (0, ldd, 5);
	theDlg.m_lCC = lcc;
	theDlg.m_lBB = lbb;
	if (theDlg.DoModal () == IDOK) {
		// ^Clong^ɕϊ
		long lNewTime = lTime;
		long lErrorID = StringTimeToLongTime (m_pMIDIData, theDlg.m_strTime, &lNewTime);
		if (lErrorID != 0) {
			CString strMsg;
			VERIFY (strMsg.LoadString (lErrorID));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			return;
		}
		lnn = theDlg.m_lNN;
		ldd = theDlg.m_nDDIndex;
		lcc = theDlg.m_lCC;
		lbb = theDlg.m_lBB;
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDIEvent* pNewEvent = NULL;
		MIDIEvent* pLastEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_EVENT));
		AddHistoryUnit (strHistoryName);
		CHistoryUnit* pCurHistoryUnit = GetCurHistoryUnit ();

		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
			}
		}
			
		// Cxg̒uƕύX
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, m_pTempTimeSignatureEvent);
		VERIFY (pNewEvent = ReplaceMIDIEvent (m_pTempTimeSignatureEvent));
		if (lNewTime != lTime) {
			MIDIEvent_SetTime (pNewEvent, lNewTime);
		}
		MIDIEvent_SetTimeSignature (pNewEvent, lnn, ldd, lbb, lcc);
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent);
		
		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
			}
		}
		
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		::Sleep (0);
	}
}

// w|bvAbvx-wqL̕ύX...x
void CSekaijuDoc::OnUpdatePopupModifyTimeSignatureUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempTimeSignatureEvent == NULL || m_pTempTrack == NULL) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (!MIDIEvent_IsTimeSignature (m_pTempTimeSignatureEvent)) {
		pCmdUI->Enable (FALSE);
		return;
	}
}


// w|bvAbvx-wL̕ύX...x
void CSekaijuDoc::OnPopupModifyKeySignature () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempKeySignatureEvent == NULL || m_pTempTrack == NULL) {
		return;
	}
	if (!MIDIEvent_IsKeySignature (m_pTempKeySignatureEvent)) {
		return;
	}

	CPropertyKeySignatureDlg theDlg;
	long lTime = MIDIEvent_GetTime (m_pTempKeySignatureEvent);
	CString strTime;
	LongTimeToStringTime (m_pMIDIData, lTime, &strTime);
	theDlg.m_strTime = strTime;
	long lsf, lmi;
	MIDIEvent_GetKeySignature (m_pTempKeySignatureEvent, &lsf, &lmi);
	theDlg.m_nSFIndex = lsf + 7;
	theDlg.m_nMiIndex = CLIP (0, lmi, 1);
	if (theDlg.DoModal () == IDOK) {
		// ^Clong^ɕϊ
		long lNewTime = lTime;
		long lErrorID = StringTimeToLongTime (m_pMIDIData, theDlg.m_strTime, &lNewTime);
		if (lErrorID != 0) {
			CString strMsg;
			VERIFY (strMsg.LoadString (lErrorID));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			return;
		}
		lsf = theDlg.m_nSFIndex - 7;
		lmi = theDlg.m_nMiIndex;
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDIEvent* pNewEvent = NULL;
		MIDIEvent* pLastEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_EVENT));
		AddHistoryUnit (strHistoryName);
		CHistoryUnit* pCurHistoryUnit = GetCurHistoryUnit ();

		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
			}
		}
			
		// Cxg̒uƕύX
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, m_pTempKeySignatureEvent);
		VERIFY (pNewEvent = ReplaceMIDIEvent (m_pTempKeySignatureEvent));
		if (lNewTime != lTime) {
			MIDIEvent_SetTime (pNewEvent, lNewTime);
		}
		MIDIEvent_SetKeySignature (pNewEvent, lsf, lmi);
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent);
		
		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
			}
		}
		
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		::Sleep (0);
	}
}

// w|bvAbvx-wL̕ύX...x
void CSekaijuDoc::OnUpdatePopupModifyKeySignatureUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempKeySignatureEvent == NULL || m_pTempTrack == NULL) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (!MIDIEvent_IsKeySignature (m_pTempKeySignatureEvent)) {
		pCmdUI->Enable (FALSE);
		return;
	}
}


// w|bvAbvx-w}[J[̕ύX...x
void CSekaijuDoc::OnPopupModifyMarker () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempMarkerEvent == NULL || m_pTempTrack == NULL) {
		return;
	}
	if (!MIDIEvent_IsMarker (m_pTempMarkerEvent)) {
		return;
	}

	CPropertyMarkerDlg theDlg;
	long lTime = MIDIEvent_GetTime (m_pTempMarkerEvent);
	CString strTime;
	LongTimeToStringTime (m_pMIDIData, lTime, &strTime);
	theDlg.m_strTime = strTime;
	TCHAR szText1[1024];
	TCHAR szText2[1024];
	memset (szText1, 0, TSIZEOF (szText1));
	memset (szText2, 0, TSIZEOF (szText2));
	MIDIEvent_GetText (m_pTempMarkerEvent, szText1, 1023);
	codestr2str (szText1, _tcslen (szText1), szText2, 1023);
	theDlg.m_strText = szText2;
	if (theDlg.DoModal () == IDOK) {
		// ^Clong^ɕϊ
		long lNewTime = lTime;
		long lErrorID = StringTimeToLongTime (m_pMIDIData, theDlg.m_strTime, &lNewTime);
		if (lErrorID != 0) {
			CString strMsg;
			VERIFY (strMsg.LoadString (lErrorID));
			AfxMessageBox (strMsg, MB_ICONEXCLAMATION);
			return;
		}
		memset (szText1, 0, TSIZEOF (szText1));
		memset (szText2, 0, TSIZEOF (szText2));
		str2codestr ((TCHAR*)(LPCTSTR)(theDlg.m_strText), theDlg.m_strText.GetLength (), szText1, 1023);
		BeginWaitCursor ();
		m_theCriticalSection.Lock ();
		MIDIEvent* pNewEvent = NULL;
		MIDIEvent* pLastEvent = NULL;
		MIDIEvent* pCloneEvent = NULL;
		CString strHistoryName;
		VERIFY (strHistoryName.LoadString (IDS_MODIFY_EVENT));
		AddHistoryUnit (strHistoryName);
		CHistoryUnit* pCurHistoryUnit = GetCurHistoryUnit ();

		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, pLastEvent));
				VERIFY (pCloneEvent = ReplaceMIDIEvent (pLastEvent));
			}
		}
			

		// Cxg̒uƕύX
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, m_pTempMarkerEvent);
		VERIFY (pNewEvent = ReplaceMIDIEvent (m_pTempMarkerEvent));
		if (lNewTime != lTime) {
			MIDIEvent_SetTime (pNewEvent, lNewTime);
		}
		MIDIEvent_SetText (pNewEvent, szText1); 
		pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pNewEvent);
		
		// EOT̗ێ
		pLastEvent = MIDITrack_GetLastEvent (m_pTempTrack);
		if (pLastEvent != NULL) {
			if (MIDIEvent_IsEndofTrack (pLastEvent)) {
				VERIFY (pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_INSERTEVENT, pLastEvent));
			}
		}
		
		m_theCriticalSection.Unlock ();
		EndWaitCursor ();
		UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
		::Sleep (0);
	}
}

// w|bvAbvx-w}[J[̕ύX...x
void CSekaijuDoc::OnUpdatePopupModifyMarkerUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempMarkerEvent == NULL || m_pTempTrack == NULL) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (!MIDIEvent_IsMarker (m_pTempMarkerEvent)) {
		pCmdUI->Enable (FALSE);
		return;
	}
}















// w|bvAbvx-we|̍폜...x
void CSekaijuDoc::OnPopupDeleteTempo () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempTempoEvent == NULL || m_pTempTrack == NULL) {
		return;
	}
	if (!MIDIEvent_IsTempo (m_pTempTempoEvent)) {
		return;
	}

	BeginWaitCursor ();
	m_theCriticalSection.Lock ();
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_DELETE_EVENT));
	AddHistoryUnit (strHistoryName);
	CHistoryUnit* pCurHistoryUnit = GetCurHistoryUnit ();

	// Cxg̍폜
	pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, m_pTempTempoEvent);
	VERIFY (MIDITrack_RemoveEvent (m_pTempTrack, m_pTempTempoEvent));
	
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
	::Sleep (0);
}

// w|bvAbvx-we|̍폜x
void CSekaijuDoc::OnUpdatePopupDeleteTempoUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempTempoEvent == NULL || m_pTempTrack == NULL) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (!MIDIEvent_IsTempo (m_pTempTempoEvent)) {
		pCmdUI->Enable (FALSE);
		return;
	}
}

// w|bvAbvx-wqL̍폜x
void CSekaijuDoc::OnPopupDeleteTimeSignature () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempTimeSignatureEvent == NULL || m_pTempTrack == NULL) {
		return;
	}
	if (!MIDIEvent_IsTimeSignature (m_pTempTimeSignatureEvent)) {
		return;
	}

	BeginWaitCursor ();
	m_theCriticalSection.Lock ();
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_DELETE_EVENT));
	AddHistoryUnit (strHistoryName);
	CHistoryUnit* pCurHistoryUnit = GetCurHistoryUnit ();

	// Cxg̒uƕύX
	pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, m_pTempTimeSignatureEvent);
	VERIFY (MIDITrack_RemoveEvent (m_pTempTrack, m_pTempTimeSignatureEvent));
	
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
	::Sleep (0);
}

// w|bvAbvx-wqL̍폜...x
void CSekaijuDoc::OnUpdatePopupDeleteTimeSignatureUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempTimeSignatureEvent == NULL || m_pTempTrack == NULL) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (!MIDIEvent_IsTimeSignature (m_pTempTimeSignatureEvent)) {
		pCmdUI->Enable (FALSE);
		return;
	}
}


// w|bvAbvx-wL̍폜...x
void CSekaijuDoc::OnPopupDeleteKeySignature () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempKeySignatureEvent == NULL || m_pTempTrack == NULL) {
		return;
	}
	if (!MIDIEvent_IsKeySignature (m_pTempKeySignatureEvent)) {
		return;
	}

	BeginWaitCursor ();
	m_theCriticalSection.Lock ();
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_DELETE_EVENT));
	AddHistoryUnit (strHistoryName);
	CHistoryUnit* pCurHistoryUnit = GetCurHistoryUnit ();

	// Cxg̒uƕύX
	pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, m_pTempKeySignatureEvent);
	VERIFY (MIDITrack_RemoveEvent (m_pTempTrack, m_pTempKeySignatureEvent));
	
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
	::Sleep (0);

}

// w|bvAbvx-wL̍폜...x
void CSekaijuDoc::OnUpdatePopupDeleteKeySignatureUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempKeySignatureEvent == NULL || m_pTempTrack == NULL) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (!MIDIEvent_IsKeySignature (m_pTempKeySignatureEvent)) {
		pCmdUI->Enable (FALSE);
		return;
	}
}


// w|bvAbvx-w}[J[̍폜...x
void CSekaijuDoc::OnPopupDeleteMarker () {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		return;
	}
	if (m_bEditLocked) {
		return;
	}
	if (m_pTempMarkerEvent == NULL || m_pTempTrack == NULL) {
		return;
	}
	if (!MIDIEvent_IsMarker (m_pTempMarkerEvent)) {
		return;
	}

	BeginWaitCursor ();
	m_theCriticalSection.Lock ();
	CString strHistoryName;
	VERIFY (strHistoryName.LoadString (IDS_DELETE_EVENT));
	AddHistoryUnit (strHistoryName);
	CHistoryUnit* pCurHistoryUnit = GetCurHistoryUnit ();

	// Cxg̍폜
	pCurHistoryUnit->AddHistoryRecord (HISTORYRECORD_REMOVEEVENT, m_pTempMarkerEvent);
	VERIFY (MIDITrack_RemoveEvent (m_pTempTrack, m_pTempMarkerEvent));
	
	m_theCriticalSection.Unlock ();
	EndWaitCursor ();
	UpdateAllViews (NULL, SEKAIJUDOC_MIDIEVENTCHANGED);
	::Sleep (0);
}

// w|bvAbvx-w}[J[̍폜...x
void CSekaijuDoc::OnUpdatePopupDeleteMarkerUI (CCmdUI* pCmdUI) {
	CSekaijuApp* pSekaijuApp = (CSekaijuApp*)AfxGetApp ();
	if (pSekaijuApp->m_bRecording ||
		pSekaijuApp->m_bInplaceEditing ||
		pSekaijuApp->m_bInplaceListing ||
		pSekaijuApp->m_bValueUpDowning) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_bEditLocked) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (m_pTempMarkerEvent == NULL || m_pTempTrack == NULL) {
		pCmdUI->Enable (FALSE);
		return;
	}
	if (!MIDIEvent_IsMarker (m_pTempMarkerEvent)) {
		pCmdUI->Enable (FALSE);
		return;
	}
}
